NEC Fortran Compiler (3.5.0) for Vector Engine   Wed Oct 19 09:08:53 2022
FILE NAME: FFT_ASL_new.f

PROCEDURE NAME: PREFFT_FFTWASL
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

     1:                 SUBROUTINE PREFFT_fftwASL(NRX,NRY,NRZ,rhog,plancfp,plancbp)
     2:           C***********************************************************
     3:           C     (FFT INIT)
     4:           C                (2005-04-13) ASL by courtesy of RIST:KOKUBO
     5:           C     INPUT :NR?
     6:           C     OUTPUT:WSAVE?,IFAC?
     7:           C
     8:                 use asl_unified
     9:                 IMPLICIT REAL*8 (A-H,O-Z)
    10:                 complex*16 rhog(*)
    11:           c     dummy
    12:                 integer*8 plancfp,plancbp
    13:           C
    14:                 integer fft
    15:                 common/ASLFFTNEW/fft
    16:           C
    17:           c   ! Library Initialization
    18:                 call asl_library_initialize()
    19:           c   ! DFT Preparation
    20:                 call asl_fft_create_complex_3d_d(fft, nrx, nry, nrz)
    21:                 call asl_fft_set_spatial_stride_3d(fft, 1, nrx, nrx * nry)
    22:                 call asl_fft_set_frequency_stride_3d(fft, 1, nrx, nrx * nry)
    23:           c
    24:                 END


NEC Fortran Compiler (3.5.0) for Vector Engine   Wed Oct 19 09:08:53 2022
FILE NAME: FFT_ASL_new.f

PROCEDURE NAME: ENDFFT_FFTWASL
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

    26:                 SUBROUTINE ENDFFT_fftwASL(NRX,NRY,NRZ)
    27:                 use asl_unified
    28:                 IMPLICIT REAL*8 (A-H,O-Z)
    29:           C
    30:                 integer fft
    31:                 common/ASLFFTNEW/fft
    32:           c         ! DFT Finalization
    33:                 call asl_fft_destroy(fft)
    34:           c   ! Library Finalization
    35:                 call asl_library_finalize()
    36:           c
    37:                 END


NEC Fortran Compiler (3.5.0) for Vector Engine   Wed Oct 19 09:08:53 2022
FILE NAME: FFT_ASL_new.f

PROCEDURE NAME: FFT3BX_FFTWASL
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

    39:                 SUBROUTINE FFT3BX_fftwASL(NRX,NRY,NRZ,NG,RHOG,WORK
    40:                &  ,plancfp,plancbp)
    41:                 use asl_unified
    42:           C***********************************************************
    43:           C     (REAL SPACE-->G-SPACE)
    44:           C                (2005-04-13) ASL by courtesy of RIST: KOKUBO
    45:           C     INPUT :RHO,NR?,NG,WSAVE?,IFAC?
    46:           C     OUTPUT:RHOG
    47:           C     WORK  :WORK
    48:           C
    49:                 IMPLICIT REAL*8 (A-H,O-Z)
    50:           C
    51:           c     dummy plancfp,plancbp
    52:                 integer*8 plancfp,plancbp
    53:           c
    54:                 integer fft
    55:                 common/ASLFFTNEW/fft
    56:           c
    57:                 complex*16 RHOG(NG),WORK(NG)
    58:           C
    59:           c
    60:                 call asl_fft_execute_complex_backward_d(fft,RHOG,WORK)
    61: V------>        do ig=1,NG
    62: |                RHOG(IG)=WORK(IG)
    63: V------         enddo
    64:           C
    65:                 END


NEC Fortran Compiler (3.5.0) for Vector Engine   Wed Oct 19 09:08:53 2022
FILE NAME: FFT_ASL_new.f

PROCEDURE NAME: FFT3FX_FFTWASL
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

    68:                 SUBROUTINE FFT3FX_fftwASL(NRX,NRY,NRZ,NG,RHOG,WORK
    69:                & ,plancfp,plancbp)
    70:                 use asl_unified
    71:           C***********************************************************
    72:           C     (G-SPACE -->REAL SPACE)
    73:           C                (2005-04-13) ASL by courtesy of RIST: KOKUBO
    74:           C     INPUT :RHO,NR?,NG,WSAVE?,IFAC?
    75:           C     OUTPUT:WORK
    76:           C     WORK  :NONE
    77:           C
    78:                 IMPLICIT REAL*8 (A-H,O-Z)
    79:           C     dummy plancfp,plancbp
    80:                 integer*8 plancfp,plancbp
    81:           c
    82:                 integer fft
    83:                 common/ASLFFTNEW/fft
    84:           c
    85:                 complex*16 RHOG(NG),WORK(NG)
    86:           C
    87:           c
    88:                 call asl_fft_execute_complex_forward_d(fft, rhog, work)
    89:           C
    90:                 FAC=1.0D0/DBLE(NG)
    91: V------>        DO I=1,NG
    92: |                 RHOG(I)= WORK(I)*FAC
    93: V------         ENDDO
    94:           C
    95:                 END


