      subroutine Efield(Vplt,nrx,nry,nrz,nxyz,time,iwt)
      implicit double precision (a-h,o-z)
      COMMON /AVEC/  A1(3), A2(3), A3(3), B1(3), B2(3), B3(3)
     &             , COVA, ALAT
      dimension Vplt(nxyz)
      parameter (nzlocal=1000)
      dimension Vz1(nzlocal),Vz2(nzlocal)  ! local dimension
      do izlocal=1,nzlocal
       Vz1(izlocal)=0
       Vz2(izlocal)=0
      enddo
c
      if (nzlocal.lt.nrz ) then
       write(6,*)' in sub. Efield, nzlocal < ',nrz
      stop
      endif
c
      axlen=A1(1)
      aylen=A2(2)
      azlen=A3(3)
      nxhlf=(nrx+1)/2
      nyhlf=(nry+1)/2
      nzhlf=(nrz+1)/2
      dx=axlen/dfloat(nrx)*0.529177d0  ! in angstrom
      dy=aylen/dfloat(nry)*0.529177d0  ! in angstrom
      dz=azlen/dfloat(nrz)*0.529177d0  ! in angstrom
c *** temp check;
c      write(6,*)' in sub. Efield: dx = ',dx
c      write(6,*)' in sub. Efield: dy = ',dy
c      write(6,*)' in sub. Efield: dz = ',dz
c      write(6,*)' in sub. Efield: nxhlf = ',nxhlf
c      write(6,*)' in sub. Efield: nyhlf = ',nyhlf
c      write(6,*)' in sub. Efield: nzhlf = ',nzhlf
c === temp check end
c
      do ii=1,nxyz
       K=1+(II-1)/(NRX*NRY)
       I=II-(K-1)*NRX*NRY
       J=1+(I-1)/NRX
       I=I-(J-1)*NRX
       LX=I
       LY=J
       LZ=K
       if (LX.eq.1 ) then
        Vz1(LZ)=Vz1(LZ)+Vplt(II)   ! on graphene
       endif
       if (LX.eq.nxhlf) then
        Vz2(LZ)=Vz2(LZ)+Vplt(II)  ! between graphene
       endif
      enddo
c
      fac=13.6d0*2
      do iz=1,nrz
      Vz1(iz)=fac*Vz1(iz)/dfloat(nry)
      Vz2(iz)=fac*Vz2(iz)/dfloat(nry)
      enddo
cc
c ** E-field at x=0 z= 3.34 A + H atom height =9.212 A
      nrzp=85  ! int( 7.948/(dz) )
c *** temp check
c      write(6,*)' in sub. Efield: Vz1(nrzp)=',Vz1(nrzp)
c *** temp check: end
      Ezp=( Vz1(nrzp+1)-Vz1(nrzp-1) )/(2*dz)
c ** E-field at x=0 z=-3.34 A - H atom height =-9.212 A
c      nrzm=nrz+1-nrzp
      nrzm=nrz+1-(nrzp-1)
c *** temp check
c      write(6,*)' in sub. Efield: Vz1(nrzm)=',Vz1(nrzm)
c *** temp check: end
      Ezm=( Vz1(nrzm+1)-Vz1(nrzm-1) )/(2*dz)
c ** E-field at x=3.34A z=0 A
c *** temp check
c      write(6,*)' in sub. Efield: Vz2(1)=',Vz2(1)
c *** temp check: end
      Ez2=( Vz2(2) - Vz2(nrz) )/(2*dz)  ! V/angstrom
c
c *** temp check
c      write(6,*)' in sub. Efield: time(fs)=',time
c *** temp check: end
      write(iwt,1000)time,Ezp,Ezm,Ez2
 1000 format(4f22.16)
      return
      end
