NEC Fortran Compiler (3.4.2) for Vector Engine   Thu Jul 28 08:27:24 2022
FILE NAME: lib4_ASL_2_check_Vext_SXACE.f

PROCEDURE NAME: VOFRHO
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

     3:                 SUBROUTINE VOFRHO(NRX,NRY,NRZ,NXYZ,NG,NGQ,G,TPIBA,
     4:                & VCLR,VCSR,VG,RHO,RHOG,I2G,
     5:           c *** for Sugino FFT
     6:           c     & WSAVEX,WSAVEY,WSAVEZ,IFACX,IFACY,IFACZ,LX1,LX2,LY1,LY2,LZ1,LZ2
     7:           c *** for Kokubo ASL FFT
     8:           c     & WSAVE_XYZ,IFAC_XYZ
     9:           c *** for Kokubo FFTW
    10:                & plancfp,plancbp
    11:                & ,DX,DY,DZ,DXX,DYY,DZZ,DXY,DYZ,DZX,VWORK)
    12:                 IMPLICIT REAL*8 (A-H,O-Z)
    13:                 REAL*8 RHO(NXYZ)
    14:                 COMPLEX*16 VCLR(NXYZ),VCSR(NXYZ),VG(NXYZ),RHOG(NXYZ)
    15:           c *** for Sugino FFT
    16:           c      COMPLEX*16 WSAVEX(NRX),WSAVEY(NRY),WSAVEZ(NRZ)
    17:           c *** for Kokubo ASL FFT
    18:           c      COMPLEX*16 WSAVE_XYZ(NRX+NRY+NRZ)
    19:           c *** for Kokubo FFTW
    20:                 integer*8 plancfp,plancbp
    21:           c ****  for GGA ***
    22:                 COMPLEX*16 DX(NXYZ),DY(NXYZ),DZ(NXYZ),
    23:                &   DXX(NXYZ),DYY(NXYZ),DZZ(NXYZ)
    24:                &  ,DXY(NXYZ),DYZ(NXYZ),DZX(NXYZ),VWORK(NXYZ)
    25:           c *** for Sugino FFT
    26:           c      DIMENSION IFACX(30),IFACY(30),IFACZ(30)
    27:           c      DIMENSION LX1(NXYZ),LX2(NXYZ),LY1(NXYZ),
    28:           c     &          LY2(NXYZ),LZ1(NXYZ),LZ2(NXYZ)
    29:           c *** for Kokubo ASL FFT
    30:           c      DIMENSION IFAC_XYZ(60)
    31:           c *** for Kokubo FFTW -- nothing for IFAC
    32:           c
    33:                 DIMENSION I2G(NGQ),G(4,NGQ)
    34:                 COMMON/SMOOTH/ADUMP
    35:                 COMMON/COMOPT/IOPT(10,5)
    36:           C
    37:           C     CALCULATE HARTREE AND EXCHANGE-CORRELATION POTENTIAL
    38:           C
    39:                 PI=4.D0*ATAN(1.D0)
    40:                 FPI=4.D0*PI
    41:                 TPIBA2=TPIBA**2
    42:                 IGGA = IOPT(8,2)
    43:           CC      CALL CLOCK(TIM0)
    44:           C
    45:           C     EXCHANGE CORRELATION CONTRIBUTION TO THE ONE-ELECTRON POTENTIAL
    46:           C
    47:                 IF(IGGA.EQ.1) THEN
    48:                  CALL G2VXC2(TPIBA,NRX,NRY,NRZ,NXYZ,NG,NGQ,G,
    49:                & VG,RHO,RHOG,I2G,
    50:           c *** for Sugino FFT
    51:           c     & WSAVEX,WSAVEY,WSAVEZ,IFACX,IFACY,IFACZ,LX1,LX2,
    52:           c     & LY1,LY2,LZ1,LZ2
    53:           c *** for Kokubo ASL FFT
    54:           c     & WSAVE_XYZ,IFAC_XYZ
    55:           c *** for Kokubo FFTW
    56:                & plancfp,plancbp
    57:                & , DX,DY,DZ,DXX,DYY,DZZ,DXY,DYZ,DZX,VWORK )
    58:                 ELSE
    59:                 CALL S2VXC2(NXYZ,RHO,VG)
    60:                 ENDIF
    61:           c ** for Sugino FFT
    62:           c      CALL FFT3FX(NRX,NRY,NRZ,NXYZ,VG,VCLR,
    63:           c     & WSAVEX,WSAVEY,WSAVEZ,IFACX,IFACY,IFACZ,LX1,LX2,LY1,LY2,LZ1,LZ2)
    64:           c ** for Kokubo ASL FFT
    65:           c      CALL FFT3FX_ASL(NRX,NRY,NRZ,NXYZ,VG,VCLR,WSAVE_XYZ,IFAC_XYZ)
    66:           c ** for Kokubo FFTW
    67:           c      call FFT3FX_fftw(NXYZ,VG,plancfp,plancbp)
    68:           c ** for Kokubo fftw ASL compatible
    69:                 CALL FFT3FX_fftwASL(NRX,NRY,NRZ,NXYZ,VG,VCLR,plancfp,plancbp)
    70:           C
    71:           C        HARTREE POTENTIAL
    72:           C
    73: V------>        DO 47 IG=1,NXYZ
    74: V------      47 VCSR(IG)=(0.D0,0.D0)
    75:           C
    76:           *VDIR NODEP(VCSR,RHOG)
    77:           !ocl norecurrence(VCSR,RHOG)
    78: V------>        DO 49 IG=2,NG
    79: |               JG=I2G(IG)
    80: V------ C    49 VCSR(JG)=0.5D0*FPI*RHOG(JG)/(TPIBA2*G(4,IG))
    81: V------>        DO 48 IG=1,NXYZ
    82: V------      48 VG(IG)=VG(IG)+VCSR(IG)*2.D0
    83:           C
    84:           c *** Smoothing of potential
    85:           c      adump4=4*adump
    86:           c      do ig=2,nxyz
    87:           c      jg=i2g(ig)
    88:           c      vg(jg)=vg(jg)*dexp(-g(4,ig)/adump4)
    89:           c      enddo
    90:           c ***  temp check
    91:           c      miya=13
    92:           c      if ( miya.eq.13 ) then
    93:           c
    94:           c      CALL FFT3BX(NRX,NRY,NRZ,NXYZ,VG,VCLR,
    95:           c     & WSAVEX,WSAVEY,WSAVEZ,IFACX,IFACY,IFACZ,LX1,LX2,LY1,LY2,LZ1,LZ2)
    96:           c      write(6,*)' After FFT3BX : VG in real space '
    97:           c      write(6,*)( vg(i),i=1,1500,100 )
    98:           c      stop
    99:           c      endif
   100:           c ***  temp check : end
   101:           CC      CALL CLOCK(TIM1)
   102:           C     WRITE(6,*) ' VOFRHO: CPTIME=',TIM1-TIM0
   103:                 RETURN
   104:                 END


NEC Fortran Compiler (3.4.2) for Vector Engine   Thu Jul 28 08:27:24 2022
FILE NAME: lib4_ASL_2_check_Vext_SXACE.f

PROCEDURE NAME: S2VXC2
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

   106:                 SUBROUTINE S2VXC2(NXYZ,RHO,VCSR)
   107:                 IMPLICIT REAL*8(A-H,O-Z)
   108:                 COMPLEX*16 VCSR(NXYZ)
   109:                 DIMENSION RHO(NXYZ)
   110:                 DATA A0,A1,A2,A3,A4/0.4582D0,0.048D0,0.0311D0,0.0116D0,0.002D0/
   111:                 DATA B1,B2,B3/0.1423D0,1.0529D0,0.3334D0/
   112:                 DATA XB1,XALPHA/0.6108870577D0,0.7D0/
   113:                 PAI=4.D0*DATAN(1.D0)
   114:                 FPT=3.D0/(4.D0*PAI)
   115: V------>        DO 10 IG=1,NXYZ
   116: |               VCSR(IG)=0.D0
   117: |               IF(RHO(IG).GT.0.D0) THEN
   118: |               IF(RHO(IG).LE.FPT) THEN
   119: |                  RS=(3.D0/(4.D0*PAI*RHO(IG)))**(1.D0/3.D0)
   120: |         c         RS=DCBRT( 3.D0/(4.D0*PAI*RHO(IG)) )
   121: |                  EC=-B1/(1.D0+B2*DSQRT(RS)+B3*RS)
   122: |                  VX=-4.D0*A0/(3.D0*RS)
   123: |                  CC=-B1/(1.D0+B2*DSQRT(RS)+B3*RS)
   124: |                  VC= (CC*CC/(3.D0*B1))*(B2*DSQRT(RS)/2.D0+B3*RS)
   125: |                  VXC2=VX+EC-VC
   126: |                  VCSR(IG)=VXC2
   127: |               ELSE
   128: |                  RS=(3.D0/(4.D0*PAI*RHO(IG)))**(1.D0/3.D0)
   129: |         c         RS=DCBRT( 3.D0/(4.D0*PAI*RHO(IG)) )
   130: |                  EC=-A1+A2*DLOG(RS)-A3*RS+A4*RS*DLOG(RS)
   131: |                  VX=-4.D0*A0/(3.D0*RS)
   132: |                  VC=A2/3.D0-A3*RS/3.D0+A4*(RS*DLOG(RS)+RS)/3.D0
   133: |                  VXC2=VX+EC-VC
   134: |                  VCSR(IG)=VXC2
   135: |               ENDIF
   136: |               ENDIF
   137: V------      10 CONTINUE
   138:                 RETURN
   139:                 END


NEC Fortran Compiler (3.4.2) for Vector Engine   Thu Jul 28 08:27:24 2022
FILE NAME: lib4_ASL_2_check_Vext_SXACE.f

PROCEDURE NAME: S2XC2
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

   141:                 SUBROUTINE S2XC2(NXYZ,RHO,EXC,VCSR)
   142:                 IMPLICIT REAL*8(A-H,O-Z)
   143:                 DIMENSION RHO(NXYZ),VCSR(NXYZ)
   144:                 DATA A0,A1,A2,A3,A4/0.4582D0,0.048D0,0.0311D0,0.0116D0,0.002D0/
   145:                 DATA B1,B2,B3/0.1423D0,1.0529D0,0.3334D0/
   146:                 DATA XA1,XALPHA/0.4581652933D0,0.7D0/
   147:           C
   148:                 PAI=4.D0*DATAN(1.D0)
   149:                 FPT=3.D0/(4.D0*PAI)
   150:                 EXC=0.D0
   151: V------>        DO 10 IG=1,NXYZ
   152: |               VCSR(IG)=0.D0
   153: |               IF(RHO(IG).GT.0.D0) THEN
   154: |               IF(RHO(IG).LE.FPT) THEN
   155: |                  RS=(3.D0/(4.D0*PAI*RHO(IG)))**(1.D0/3.D0)
   156: |         c         RS=DCBRT( 3.D0/(4.D0*PAI*RHO(IG)) )
   157: |                  EX=-A0/RS
   158: |                  EC=-B1/(1.D0+B2*DSQRT(RS)+B3*RS)
   159: |                  XC2=EC+EX
   160: |                  VCSR(IG)=XC2*RHO(IG)
   161: |               ELSE
   162: |                  RS=(3.D0/(4.D0*PAI*RHO(IG)))**(1.D0/3.D0)
   163: |         c         RS=DCBRT( 3.D0/(4.D0*PAI*RHO(IG)) )
   164: |                  EX=-A0/RS
   165: |                  EC=-A1+A2*DLOG(RS)-A3*RS+A4*RS*DLOG(RS)
   166: |                  XC2=EC+EX
   167: |                  VCSR(IG)=XC2*RHO(IG)
   168: |               ENDIF
   169: |               ENDIF
   170: |            10 CONTINUE
   171: |               EXC=0.D0
   172: |               DO 20 IG=1,NXYZ
   173: V------      20 EXC=EXC+VCSR(IG)
   174:           C
   175:                 RETURN
   176:                 END


NEC Fortran Compiler (3.4.2) for Vector Engine   Thu Jul 28 08:27:24 2022
FILE NAME: lib4_ASL_2_check_Vext_SXACE.f

PROCEDURE NAME: RHOGET
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

   178:                 SUBROUTINE RHOGET(NRX,NRY,NRZ,NXYZ,RHO,RHO1,RHOG,NTOT,S,OMEGA,
   179:                & ZVAL,RHO2,I2G,G,
   180:           c *** for Sugino FFT
   181:           c     & WSAVEX,WSAVEY,WSAVEZ,IFACX,IFACY,IFACZ,LX1,LX2,LY1,LY2,LZ1,LZ2
   182:           c  ***** for Kokubo FFT: LY2,LZ1,LZ2 are still necessary for ROTRA
   183:           c     & WSAVE_XYZ,IFAC_XYZ , LY2,LZ1,LZ2
   184:           c  ***** for Kokubo FFTW: LY2,LZ1,LZ2 are still necessary for ROTRA
   185:                & plancfp,plancbp, LY2,LZ1,LZ2
   186:                & ,FDUMP,itstep,itmod)
   187:           C
   188:           C                                   (1990-04-12) OSAMU SUGINO
   189:           C                                   (1990-08-21) OSAMU SUGINO
   190:           C     CONSTRUCTS THE FULLY-SYMMETRIZED CHARGE DENSITY.
   191:           C     OUTPUT: RHO,RHOG
   192:           C     WORK  : RHO1
   193:           C     SLAVE SUBROUTINES   RHOTRA,FFT'S
   194:           C
   195:                 IMPLICIT REAL*8 (A-H,O-Z)
   196:                 include 'mpif.h'
   197:                 REAL*8 RHO(NXYZ)
   198:                 COMPLEX*16 RHO1(NXYZ),RHOG(NXYZ)
   199:           C *** for smoothing !
   200:                 complex*16 RHO2(NXYZ)
   201:                 dimension I2G(NXYZ),G(4,NXYZ)
   202:                 INTEGER*4 S(3,3,48)
   203:           C     WORK ARRAYS FOR FOURIER TRANSFORM
   204:           c *** for Sugino FFT
   205:           c      COMPLEX*16 WSAVEX(NRX),WSAVEY(NRY),WSAVEZ(NRZ)
   206:           c      DIMENSION IFACX(30),IFACY(30),IFACZ(30)
   207:           c      DIMENSION LX1(NXYZ),LX2(NXYZ),LY1(NXYZ),
   208:           c     &          LY2(NXYZ),LZ1(NXYZ),LZ2(NXYZ)
   209:           c *** for Kokubo FFT
   210:           c  ***** LY2,LZ1,LZ2 are still necessary for ROTRA
   211:           c      DIMENSION LY2(NXYZ),LZ1(NXYZ),LZ2(NXYZ)
   212:           c      COMPLEX*16 WSAVE_XYZ(NRX+NRY+NRZ)
   213:           c      DIMENSION IFAC_XYZ(60)
   214:           c *** for Kokubo FFTW
   215:           c  ***** LY2,LZ1,LZ2 are still necessary for ROTRA
   216:                 DIMENSION LY2(NXYZ),LZ1(NXYZ),LZ2(NXYZ)
   217:                 integer*8 plancfp,plancbp
   218:                 dimension fdump(NXYZ)
   219:                 COMMON/SMOOTH/ADUMP
   220:           c
   221:                 call MPI_COMM_RANK(MPI_COMM_WORLD,my_rank,ierr)
   222:           c ** temp check
   223:           c      miya=13
   224:           c      if ( miya.eq.13 ) then
   225:           c      write(6,*)'my_rank=',my_rank,' just in RHOGET'
   226:           c      stop
   227:           c      endif
   228:           c ** temp check : end
   229:           C
   230:           C     #############################################
   231:           C     SYMMETRIZE THE CHARGE DENSITY (IN REAL SPACE)
   232:           C     #############################################
   233:           c ****  check by Miyamoto  9/6  '95
   234:           c      write(6,*) ' in sub. RHOGET: before calling ROTRA '
   235:           c      SUM=0.D0
   236:           c      DO 151 I=1,NXYZ
   237:           c  151 SUM=SUM+RHO(I)
   238:           c      SUM=SUM*OMEGA/DBLE(NXYZ)
   239:           c      write(6,*)' Tota charge = ',sum,' Zval = ',zval
   240:           c ****  check end
   241:           C
   242:                 CALL ROTRA(NRX,NRY,NRZ,NXYZ,RHO,RHO1,LY2,LZ1,LZ2,S,NTOT)
   243:           C
   244:                 SUM=0.D0
   245: V------>        DO 51 I=1,NXYZ
   246: V------      51 SUM=SUM+RHO(I)
   247:                 SUM=SUM*OMEGA/DBLE(NXYZ)
   248:           C
   249:           C ********
   250:                 CHECK = ABS( ZVAL-SUM )
   251:           c      IF( CHECK .GT. 1.D-3) THEN
   252:                 IF( CHECK .GT. 5.D-2) THEN
   253:                  if ( my_rank.eq.0 ) then
   254:                    WRITE(6,*) ' '
   255:                    WRITE(6,*) '  **** RHOGET: INTEGRATED CHARGE  SUM ZVAL = ',
   256:                &                   SUM, ZVAL
   257:                    STOP  ' INCORRECT TOTAL CHARGE '
   258:                  endif
   259:                 ELSE IF ( CHECK .GT. 1.D-7 .and. mod(itstep,itmod).eq.0 ) THEN
   260:                  if ( my_rank.eq.0 ) then
   261:                    WRITE(6,*) ' '
   262:                    WRITE(6,*) '  **** RHOGET: INTEGRATED CHARGE  SUM ZVAL = ',
   263:                &                   SUM, ZVAL
   264:                    WRITE(6,*) ' '
   265:                  endif
   266:                 END IF
   267:           C
   268:           c *** temp check
   269:           c      miya=13
   270:           c      if ( miya.eq.13 ) then
   271:           c      write(6,*)'my_rank=',my_rank,' finish to compute total RHO!'
   272:           c      stop
   273:           c      endif
   274:           c *** temp check ; end
   275:           C *******
   276:           C
   277:           C     MAKE LIST VECTORS FOR FFT
   278:           C
   279:                 if ( itstep.eq.0 ) then
   280:           c ** for Sugino FFT
   281:           c      CALL PREFFT(NRX,NRY,NRZ,NXYZ,
   282:           c     & WSAVEX,WSAVEY,WSAVEZ,IFACX,IFACY,IFACZ,LX1,LX2,LY1,LY2,LZ1,LZ2)
   283:           c ** for Kokubo ASL FFT
   284:           c      CALL PREFFT_ASL(NRX,NRY,NRZ,WSAVE_XYZ,IFAC_XYZ)
   285:           c ** for Kokubo FFTW
   286:           c      call PREFFT_fftw(NRX,NRY,NRZ,RHOG,plancfp,plancbp)
   287:           c ** for Kokubo fftw ASL compatible
   288:                 CALL PREFFT_fftwASL(NRX,NRY,NRZ,RHOG,plancfp,plancbp)
   289:                 endif
   290:           C
   291:           C        RHO IN K SPACE
   292:           C
   293: V------>        DO 551 IG=1,NXYZ
   294: V------     551 RHOG(IG)=DCMPLX(RHO(IG),0.D0)
   295:           c *** for Sugino FFT
   296:           c      CALL FFT3FX(NRX,NRY,NRZ,NXYZ,RHOG,RHO1,
   297:           c     & WSAVEX,WSAVEY,WSAVEZ,IFACX,IFACY,IFACZ,LX1,LX2,LY1,LY2,LZ1,LZ2)
   298:           c *** for Kokubo FFT
   299:           c      CALL FFT3FX_ASL(NRX,NRY,NRZ,NXYZ,RHOG,RHO1,WSAVE_XYZ,IFAC_XYZ)
   300:           c *** for Kokubo FFTW
   301:           c      call FFT3FX_fftw(NXYZ,RHOG,plancfp,plancbp)
   302:           c *** for Kokubo fftw ASL compatible
   303:                 CALL FFT3FX_fftwASL(NRX,NRY,NRZ,NXYZ,RHOG,RHO1,plancfp,plancbp)
   304:           c *** Smoothing !!
   305:                    adump4=4*adump
   306:           *VDIR NODEP(RHOG)
   307:           !ocl norecurrence(RHOG)
   308: +------>           do ig=1,nxyz
   309: |                  jg=i2g(ig)
   310: |                  rhog(jg)=rhog(jg)*fdump(ig)
   311: +------            enddo
   312: V------>           DO IG=1,NXYZ
   313: |                  RHO2(IG)=RHOG(IG)
   314: V------            ENDDO
   315:           c *** for Sugino FFT
   316:           c         CALL FFT3BX( NRX, NRY, NRZ, NXYZ, RHO2, RHO1,
   317:           c     &                WSAVEX, WSAVEY, WSAVEZ, IFACX, IFACY, IFACZ,
   318:           c     &                LX1, LX2, LY1, LY2, LZ1, LZ2                )
   319:           c *** for Kokubo ASL FFT
   320:           c         CALL FFT3BX_ASL( NRX, NRY, NRZ, NXYZ, RHO2, RHO1,
   321:           c     &                WSAVE_XYZ, IFAC_XYZ               )
   322:           c *** for Kokubo FFTW
   323:           c         call FFT3BX_fftw(NXYZ,RHO2,plancfp,plancbp)
   324:           c *** for Kokubo fftw ASL compatible
   325:                    CALL FFT3BX_fftwASL( NRX, NRY, NRZ, NXYZ, RHO2, RHO1,
   326:                &                plancfp,plancbp             )
   327: V------>           DO IG=1,NXYZ
   328: |                  RHO(IG)=DBLE(RHO2(IG))
   329: |                  ENDDO
   330: |         c *** Smoothing !! : END
   331: |         c **** smear negative rho: for SXACE!!
   332: |               rhomin=1.d-12
   333: |               do ir=1,nxyz
   334: |                if (rho(ir).lt.rhomin ) rho(ir)=rhomin
   335: V------         enddo
   336:           C
   337:           C
   338:           c   ****  temp check !1
   339:           c      SUM=0.D0
   340:           c      DO I=1,NXYZ
   341:           c      SUM=SUM+RHO(I)
   342:           c      ENDDO
   343:           c      SUM=SUM*OMEGA/DBLE(NXYZ)
   344:           C
   345:           C ********
   346:           c      CHECK = ABS( ZVAL-SUM )
   347:           c      IF( CHECK .GT. 1.D-3) THEN
   348:           c         WRITE(6,*) ' '
   349:           c         WRITE(6,*) '  **** RHOGET: INTEGRATED CHARGE  SUM ZVAL = ',
   350:           c     &                   SUM, ZVAL
   351:           c         STOP  ' INCORRECT TOTAL CHARGE '
   352:           c      ELSE IF ( CHECK .GT. 1.D-7) THEN
   353:           c         WRITE(6,*) ' '
   354:           c         WRITE(6,*) '  **** RHOGET: INTEGRATED CHARGE  SUM ZVAL = ',
   355:           c     &                   SUM, ZVAL
   356:           c         WRITE(6,*) ' '
   357:           c      END IF
   358:           C     WRITE(6,*) ' RHOG AND SUM',RHOG(1),SUM
   359:           C
   360:                 RETURN
   361:                 END


NEC Fortran Compiler (3.4.2) for Vector Engine   Thu Jul 28 08:27:24 2022
FILE NAME: lib4_ASL_2_check_Vext_SXACE.f

PROCEDURE NAME: ROTRA
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

   363:                 SUBROUTINE ROTRA(NRX,NRY,NRZ,NXYZ,RHO,RHO1,LX,LY,LZ,S,NTOT)
   364:           C***********************************************************
   365:           C
   366:           C                                   (1990-04-12) OSAMU SUGINO
   367:           C
   368:                 IMPLICIT REAL*8 (A-H,O-Z)
   369:                 REAL*8 RHO(NXYZ),RHO1(NXYZ)
   370:                 INTEGER*4 S(3,3,48),LX(NXYZ),LY(NXYZ),LZ(NXYZ)
   371:                 IF(NTOT.EQ.1) THEN
   372: +------>           DO 52 I=1,NXYZ
   373: +------      52    RHO(I)=RHO(I)
   374:                 ELSE
   375:           C
   376:           C
   377:           C        MAKE LIST VECTOR
   378:           C
   379: V------>           DO 100 II=1,NXYZ
   380: |                  K=1+(II-1)/(NRX*NRY)
   381: |                  I=II-(K-1)*NRX*NRY
   382: |                  J=1+(I-1)/NRX
   383: |                  I=I-(J-1)*NRX
   384: |                  LX(II)=I-1
   385: |                  LY(II)=J-1
   386: |                  LZ(II)=K-1
   387: |                  RHO1(II)=0.D0
   388: V------     100    CONTINUE
   389:           C
   390: +------>           DO 10 IROT=1,NTOT
   391: |V----->           DO 10 I=1,NXYZ
   392: ||                 IR1=S(1,1,IROT)*LX(I)*NRX/NRX
   393: ||             &      +S(2,1,IROT)*LY(I)*NRX/NRY
   394: ||             &      +S(3,1,IROT)*LZ(I)*NRX/NRZ
   395: ||                 IR2=S(1,2,IROT)*LX(I)*NRY/NRX
   396: ||             &      +S(2,2,IROT)*LY(I)*NRY/NRY
   397: ||             &      +S(3,2,IROT)*LZ(I)*NRY/NRZ
   398: ||                 IR3=S(1,3,IROT)*LX(I)*NRZ/NRX
   399: ||             &      +S(2,3,IROT)*LY(I)*NRZ/NRY
   400: ||             &      +S(3,3,IROT)*LZ(I)*NRZ/NRZ
   401: ||                 IC1=MOD(IR1,NRX)
   402: ||                 IF(IC1.GE.0) IC1=IC1+1
   403: ||                 IF(IC1.LT.0) IC1=IC1+1+NRX
   404: ||                 IC2=MOD(IR2,NRY)
   405: ||                 IF(IC2.GE.0) IC2=IC2+1
   406: ||                 IF(IC2.LT.0) IC2=IC2+1+NRY
   407: ||                 IC3=MOD(IR3,NRZ)
   408: ||                 IF(IC3.GE.0) IC3=IC3+1
   409: ||                 IF(IC3.LT.0) IC3=IC3+1+NRZ
   410: ||                 II=IC1+(IC2-1+(IC3-1)*NRY)*NRX
   411: |V----- G    10    RHO1(I)=RHO1(I)+RHO(II)
   412:           C
   413:                    FACTOR=1.D0/DBLE(NTOT)
   414: V------>           DO 51 I=1,NXYZ
   415: V------      51    RHO(I)=RHO1(I)*FACTOR
   416:                 ENDIF
   417:                 RETURN
   418:                 END


NEC Fortran Compiler (3.4.2) for Vector Engine   Thu Jul 28 08:27:24 2022
FILE NAME: lib4_ASL_2_check_Vext_SXACE.f

PROCEDURE NAME: LOCPOT
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

   421:                 SUBROUTINE LOCPOT(NXYZ,NG,NGQ,G,TPIBA,VG,EIGT,
   422:                & I2G,VGA,OMEGA,
   423:                & NTAUQ,NTYQ,NTYPE,TAU,NUMTY,NIDN
   424:                & ,NCRQ,ZV,RC0,COR,NUMC,itstep
   425:           c
   426:                & ,nbegint,nendt,ncpuq,ncpu )
   427:           C***********************************************************
   428:           C
   429:           C     CONSTRUCT LOCAL ONE-ELECTRON POTENTITL
   430:           C                                   (1990-08-21) OSAMU SUGINO
   431:           C               NUMERICAL POTENTIAL (1992-02-28) OSAMU SUGINO
   432:           C
   433:                 IMPLICIT REAL*8 (A-H,O-Z)
   434:                 include 'mpif.h'
   435:           c      parameter ( ncpuq=30 )
   436:           c      include 'ncpuq.h'
   437:                 REAL*8 G(4,NGQ)
   438:                 COMPLEX*16 VG(NXYZ),EIGT(NXYZ)
   439:           c      DIMENSION I2G(NGQ),VGA(NGQ)
   440:                 DIMENSION I2G(NGQ),VGA(NGQ,NTYQ)
   441:                 DIMENSION TAU(3,NTAUQ),NUMTY(NTYQ),NIDN(NTAUQ,NTYQ)
   442:                 DIMENSION ZV(NTYQ),RC0(NCRQ,NTYQ),COR(NCRQ,NTYQ),NUMC(NTYQ)
   443:           c      common/cputask2/nbegint(0:ncpuq),nendt(0:ncpuq),ncpu
   444:                 dimension nbegint(0:ncpuq),nendt(0:ncpuq)
   445:                 COMPLEX*16 VG_(NGQ)
   446:           CC      CALL CLOCK(TIM0)
   447:           ! ==============================================================================
   448:           !     call ftrace_region_begin("reg001")
   449:           ! ==============================================================================
   450:                 call MPI_COMM_RANK(MPI_COMM_WORLD,my_rank,ierr)
   451:                 PI=4.D0*ATAN(1.D0)
   452:                 TPIBA2=TPIBA**2
   453:                 FPI=4.D0*PI
   454:                 REWIND 81
   455:           ! ==============================================================================
   456:           !     call ftrace_region_end("reg001")
   457:           ! ==============================================================================
   458:           C
   459:           ! ==============================================================================
   460:           !     call ftrace_region_begin("reg002")
   461:           ! ==============================================================================
   462: V------>        DO 81 IG=1,NXYZ
   463: V------      81 VG(IG)=(0.D0,0.D0)
   464:           ! ==============================================================================
   465:           !     call ftrace_region_end("reg002")
   466:           ! ==============================================================================
   467:           C
   468:                 if ( my_rank.eq.0 .and. itstep.eq.0 ) then
   469:                  call clock (t0)
   470:                 endif
   471:           C
   472:           c *** temp check
   473:           c      if ( my_rank.eq.0 ) then
   474:           c        write(6,*)' in LOCPOT itstep=',itstep
   475:           c        do ITY=1,NTYPE
   476:           c        write(6,*)' VGA  ITY =',ITY
   477:           c        write(6,'(4F22.16)')(VGA(IG,ITY),IG=1,NGQ,1000)
   478:           c        enddo
   479:           c      endif
   480:           c *** temp check: end
   481:           ! ==============================================================================
   482:           !     call ftrace_region_begin("reg003")
   483:           ! ==============================================================================
   484: V------>        DO IG=1,NGQ
   485: |               VG_(IG)=(0.D0,0.D0)
   486: V------         ENDDO
   487: +------>        DO 20 ITY=1,NTYPE
   488: |         c      READ(81)  VGA
   489: |                 NUM=ABS(NUMTY(ITY))
   490: |         c        VG(1)=VG(1)+NUM*VGA(1)
   491: |         c        VG(1)=VG(1)+NUM*VGA(1,ITY)
   492: |+----->          DO 22 K=1,NUM
   493: ||                  ITAU=NIDN(K,ITY)
   494: ||                if ( ITAU.ge.nbegint(my_rank). and.
   495: ||             &       ITAU.le.nendt(my_rank) ) then
   496: ||                if ( K.eq.1 ) then
   497: ||                VG(1)=VG(1)+NUM*VGA(1,ITY)
   498: ||                VG_(1)=VG_(1)+NUM*VGA(1,ITY)
   499: ||                endif
   500: ||        c *** temp check
   501: ||        c         write(6,*)' my_rank=',my_rank,' ITAU=',ITAU
   502: ||        c *** temp check : end
   503: ||        *VDIR NODEP(VG)
   504: ||        !ocl norecurrence(VG)
   505: ||V---->            DO 80 IG=2,NG
   506: |||       !         JG=I2G(IG)
   507: |||                 Q=TPIBA2*G(4,IG)
   508: |||                 SUM=  G(1,IG)*TAU(1,ITAU) + G(2,IG)*TAU(2,ITAU)
   509: |||            &        + G(3,IG)*TAU(3,ITAU)
   510: |||                 SUM=SUM*TPIBA
   511: |||                 EIGT(IG)=DCMPLX(COS(SUM),-SIN(SUM))
   512: |||       cc          VG(JG)=VG(JG)+EIGT(IG)*VGA(IG)
   513: |||       !         VG(JG)=VG(JG)+EIGT(IG)*VGA(IG,ITY)
   514: |||                 VG_(IG)=VG_(IG)+EIGT(IG)*VGA(IG,ITY)
   515: |||       C     IF(IG.EQ.2) WRITE(6,*) 'VGA(2)',VGA(2),EIGT(IG)
   516: ||V----      80     CONTINUE
   517: ||        C
   518: ||        C
   519: ||+---->        DO 52 IA=1,NUMC(ITY)
   520: |||             R02=RC0(IA,ITY)**2
   521: |||       *VDIR NODEP(VG)
   522: |||       !ocl norecurrence(VG)
   523: |||V--->        DO 82 IG=2,NG
   524: ||||      !     JG=I2G(IG)
   525: ||||            Q=TPIBA2*G(4,IG)
   526: ||||      !     VG(JG)=VG(JG)+ZV(ITY)*COR(IA,ITY)*FPI/Q
   527: ||||            VG_(IG)=VG_(IG)+ZV(ITY)*COR(IA,ITY)*FPI/Q
   528: ||||           &                 *EIGT(IG)*EXP(-0.25D0*Q*R02)
   529: |||V---      82 CONTINUE
   530: ||+----      52 CONTINUE
   531: ||              endif  ! if ITAU is wihtin nbegint - nendt loop: end
   532: |+-----      22   CONTINUE
   533: +------      20 CONTINUE
   534: V------>        DO IG=2,NG
   535: |                 JG=I2G(IG)
   536: |       C         VG(JG)=VG_(IG)
   537: V------         ENDDO
   538:           ! ==============================================================================
   539:           !     call ftrace_region_end("reg003")
   540:           ! ==============================================================================
   541:           c
   542:                 if ( my_rank.eq.0 .and. itstep.eq.0 ) then
   543:                  call clock (t1)
   544:                  write(6,*)' in sub. LOCPOT:
   545:                &       VG calculation took ',t1-t0,' sec '
   546:                 endif
   547:           c
   548:           c *** temp check
   549:           c         write(6,*)' my_rank=',my_rank,' VG sum end'
   550:           c *** temp check : end
   551:           C
   552:           c ***
   553:                 if ( itstep.eq.0 .and. my_rank.eq.0 ) call clock(t00)
   554:           c   *** Use EIGT as work area!
   555:           ! ==============================================================================
   556:           !     call ftrace_region_begin("reg004")
   557:           ! ==============================================================================
   558: V------>        do ig=1,nxyz
   559: |                EIGT(ig)=0.0d0
   560: V------         enddo
   561:           ! ==============================================================================
   562:           !     call ftrace_region_end("reg004")
   563:           ! ==============================================================================
   564:           C
   565:                 miya=13
   566:                 if ( miya.eq.13 ) goto 1313 ! skip reduce and Bcast but do ALLReduce
   567:           c
   568:           ! ==============================================================================
   569:           !     call MPI_Barrier(MPI_COMM_WORLD,ierr)
   570:           !     call ftrace_region_begin("reg005")
   571:           ! ==============================================================================
   572:                   call MPI_Reduce(VG,EIGT,nxyz,MPI_DOUBLE_COMPLEX
   573:                &    ,MPI_SUM, 0,MPI_COMM_WORLD,ierr)
   574:           ! ==============================================================================
   575:           !     call MPI_Barrier(MPI_COMM_WORLD,ierr)
   576:           !     call ftrace_region_end("reg005")
   577:           ! ==============================================================================
   578:           C
   579:                 if ( my_rank.eq.0 ) then
   580:           ! ==============================================================================
   581:           !     call ftrace_region_begin("reg006")
   582:           ! ==============================================================================
   583: +------>        DO 70 IG=1,NXYZ
   584: |         c   70 VG(IG)=VG(IG)/OMEGA
   585: +------      70 VG(IG)=EIGT(IG)/OMEGA
   586:           ! ==============================================================================
   587:           !     call ftrace_region_end("reg006")
   588:           ! ==============================================================================
   589:                 endif
   590:           C
   591:           ! ==============================================================================
   592:           !     call MPI_Barrier(MPI_COMM_WORLD,ierr)
   593:           !     call ftrace_region_begin("reg007")
   594:           ! ==============================================================================
   595:                 call MPI_Bcast(VG ,nxyz,MPI_DOUBLE_COMPLEX,0,
   596:                &        MPI_COMM_WORLD,ierr)
   597:           ! ==============================================================================
   598:           !     call MPI_Barrier(MPI_COMM_WORLD,ierr)
   599:           !     call ftrace_region_end("reg007")
   600:           ! ==============================================================================
   601:            1313 continue
   602:           ! ==============================================================================
   603:           !     call MPI_Barrier(MPI_COMM_WORLD,ierr)
   604:           !     call ftrace_region_begin("reg008")
   605:           ! ==============================================================================
   606:                   call MPI_ALLReduce(VG,EIGT,nxyz,MPI_DOUBLE_COMPLEX
   607:                &    ,MPI_SUM, MPI_COMM_WORLD,ierr)
   608:           ! ==============================================================================
   609:           !     call MPI_Barrier(MPI_COMM_WORLD,ierr)
   610:           !     call ftrace_region_end("reg008")
   611:           ! ==============================================================================
   612:           C
   613:           ! ==============================================================================
   614:           !     call ftrace_region_begin("reg009")
   615:           ! ==============================================================================
   616: V------>        DO 71 IG=1,NXYZ
   617: |         c   70 VG(IG)=VG(IG)/OMEGA
   618: V------      71 VG(IG)=EIGT(IG)/OMEGA
   619:           ! ==============================================================================
   620:           !     call ftrace_region_end("reg009")
   621:           ! ==============================================================================
   622:           C
   623:           c ***
   624:                 if ( itstep.eq.0 .and. my_rank.eq.0 ) then
   625:                  call clock(t01)
   626:                  write(6,*)' in sub. LOCPOT:
   627:                &      Reduce-Bcast took ',t01-t00,' sec'
   628:                 endif
   629:           c *** temp check
   630:           c      if ( my_rank.eq.0 ) then
   631:           c      write(6,*)' VG check !!! '
   632:           c      write(6,1515)( VG(ig),ig=1,nxyz,100 )
   633:           c 1515 format(4f19.13)
   634:           c      endif
   635:           c *** temp check : end
   636:           CC      CALL CLOCK(TIM1)
   637:           C     WRITE(6,*) '  LOCPOT CPTIME:',TIM1-TIM0
   638:                 RETURN
   639:                 END


NEC Fortran Compiler (3.4.2) for Vector Engine   Thu Jul 28 08:27:24 2022
FILE NAME: lib4_ASL_2_check_Vext_SXACE.f

PROCEDURE NAME: EWALDY
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

   643:                 SUBROUTINE EWALDY(TPIBA,OMEGA,EWA,NGQ,NG,G,EXPG,
   644:                & FORCE,LATQ,EWVEC,NTAUQ,NTYQ,NTYPE,TAU,NUMTY,NIDN,ZV,ZZ,
   645:                & A1,A2,A3,B1,B2,B3,itstep
   646:           c
   647:                &  ,nbegint,nendt,ncpuq,ncpu  ) ! note nbegintt nendtt in upper routine
   648:                 IMPLICIT REAL*8 (A-H,O-Z)
   649:                 include 'mpif.h'
   650:           c      parameter ( ncpuq=30 )
   651:           c      include 'ncpuq.h'
   652:                 REAL*8 FORCE(3,NTAUQ),ZZ(NTAUQ)
   653:                 DIMENSION EWVEC(4,LATQ)
   654:                 DIMENSION G(4,NGQ),EXPG(NGQ)
   655:                 DIMENSION TAU(3,NTAUQ),NUMTY(NTYQ),NIDN(NTAUQ,NTYQ),
   656:                & ZV(NTYQ)
   657:                 REAL*8 A1(3),A2(3),A3(3),B1(3),B2(3),B3(3)
   658:                 REAL*8 FSUB(3),RP(3)
   659:                 integer status(MPI_STATUS_SIZE),tag
   660:                 common/tmod/itmod
   661:           c      common/cputask3/nbegint(0:ncpuq),nendt(0:ncpuq),ncpu
   662:                 dimension nbegint(0:ncpuq),nendt(0:ncpuq)
   663:                 data tag/21/
   664:           C
   665:                 call MPI_COMM_RANK(MPI_COMM_WORLD,my_rank,ierr)
   666:           C
   667:           CC      CALL CLOCK(TIM0)
   668:           C
   669:           C     COMPUTE VARIOUS PARAMETERS
   670:           C
   671:           C *****  INPUT CARE
   672:           c             TOL=50.0D0
   673:                     TOL=140.0D0  ! for large aspect ratio
   674:           c          TOL=280.0D0  ! for large aspect ratio
   675:           C            EPS=0.0256D0*2.D0
   676:                        EPS=0.0256D0
   677:           C *****  INPUT END
   678:                 TPIBA2=TPIBA*TPIBA
   679:                 PI=4.D0*ATAN(1.D0)
   680:                 PI2=2.D0*PI
   681:                 SEPS=SQRT(EPS)
   682:                 SEPI=2.D0*SEPS/SQRT(PI)
   683:                 RMAX=SQRT(TOL/EPS)
   684:                 B11=0.D0
   685:                 B22=0.D0
   686:                 B33=0.D0
   687: *------>        DO 1500 I=1,3
   688: |                 B11=B11+B1(I)*B1(I)
   689: |                 B22=B22+B2(I)*B2(I)
   690: |                 B33=B33+B3(I)*B3(I)
   691: *------    1500 CONTINUE
   692:                 B11=B11*TPIBA2
   693:                 B22=B22*TPIBA2
   694:                 B33=B33*TPIBA2
   695:                 IMX=INT(RMAX*SQRT(B11)/PI2)+1
   696:                 JMX=INT(RMAX*SQRT(B22)/PI2)+1
   697:                 KMX=INT(RMAX*SQRT(B33)/PI2)+1
   698:           C
   699:                 if ( mod(itstep,itmod).eq.0 ) then
   700:                 if ( my_rank.eq.0 ) WRITE(6,6000) IMX,JMX,KMX
   701:            6000 FORMAT(/10X,'  ** EWALDY: IMX JMX KMX = ',3I5)
   702:                 endif
   703:           C
   704:                 RMAX=RMAX*RMAX
   705:                 CALL AGEN(A1,A2,A3,IMX,JMX,KMX,NLV,LATQ,EWVEC,RMAX,itstep)
   706:           C
   707:           C     STORE DATA FOR ATOMS INTO NEW ARRAYS
   708:           C
   709:                 NATOT=0
   710: +------>        DO 1510 ITY=1,NTYPE
   711: |                 NAT=ABS(NUMTY(ITY))
   712: |V----->          DO 1511 ITA=1,NAT
   713: ||                  ITAU=NIDN(ITA,ITY)
   714: ||      C           ZZ(ITAU)=ZV(ITY)
   715: ||                  NATOT=NATOT+1
   716: |V-----    1511   CONTINUE
   717: +------    1510 CONTINUE
   718:                 ESUMG=0.D0
   719:                 ESUMR=0.D0
   720: V------>        DO 1520 I=1,NATOT
   721: |                 FORCE(1,I)=0.D0
   722: |                 FORCE(2,I)=0.D0
   723: |                 FORCE(3,I)=0.D0
   724: V------    1520 CONTINUE
   725: V------>        DO 1521 I=1,NGQ
   726: V------    1521 EXPG(I)=0.D0
   727:           C*****************************
   728:           C     START SUM IN G SPACE
   729:           C*****************************
   730:           C
   731:           C    DO G SUM FOR THE CASE WHERE A=B
   732:           C
   733:                 ESUM0=0.D0
   734: V------>        DO 1530 I=NG,2,-1
   735: |                 Q=G(4,I)*TPIBA2
   736: |                 EXPG(I)=EXP(-Q/(4.D0*EPS))/Q
   737: |                 ESUM0=ESUM0+EXPG(I)
   738: V------    1530 CONTINUE
   739:                 ESUM0=ESUM0-0.25D0/EPS
   740:           C
   741:           C     START LOOP OVER ATOMS IN CELL
   742:           C
   743:                 iseq=0
   744: +------>        DO 1540 I=1,NATOT
   745: |         C
   746: |               iseq=iseq+1
   747: |         c *****
   748: |               if ( iseq.ge.nbegint(my_rank) .and.
   749: |              &     iseq.le.nendt(my_rank) ) then
   750: |         C     TERM WITH A=B
   751: |         C
   752: |         C     ADD TO SUMS (ENERGY)
   753: |         C
   754: |                 ESUMG=ESUMG+ZZ(I)*ZZ(I)*ESUM0
   755: |               endif
   756: |         c *****
   757: |                 IM=I-1
   758: |                 IF(IM.NE.0) THEN
   759: |         C
   760: |         C    TERMS WITH A#B
   761: |         C
   762: |+----->            DO 1541 J=1,IM
   763: ||                   iseq=iseq+1
   764: ||              if ( iseq.ge.nbegint(my_rank) .and.
   765: ||             &     iseq.le.nendt(my_rank) ) then
   766: ||        C
   767: ||        C     R(X,Y,Z) IS THE VECTOR BETWEEN TWO ATOMS IN THE CELL
   768: ||        C
   769: ||                    RX=TAU(1,I)-TAU(1,J)
   770: ||                    RY=TAU(2,I)-TAU(2,J)
   771: ||                    RZ=TAU(3,I)-TAU(3,J)
   772: ||        C
   773: ||        C     LOOP OVER G VECTORS
   774: ||        C
   775: ||                    ESUB=0.D0
   776: ||*---->              DO 1542 K=1,3
   777: |||                     FSUB(K)=0.D0
   778: ||*----    1542       CONTINUE
   779: ||V---->              DO 1543 IG=NG,2,-1
   780: |||                     GDT=G(1,IG)*RX+G(2,IG)*RY+G(3,IG)*RZ
   781: |||                     GDT=GDT*TPIBA
   782: |||                     EXP1=COS(GDT)*EXPG(IG)
   783: |||                     EXP2=SIN(GDT)*EXPG(IG)
   784: |||                     ESUB=ESUB+EXP1
   785: |||                     FSUB(1)=FSUB(1)+G(1,IG)*EXP2
   786: |||                     FSUB(2)=FSUB(2)+G(2,IG)*EXP2
   787: |||                     FSUB(3)=FSUB(3)+G(3,IG)*EXP2
   788: ||V----    1543       CONTINUE
   789: ||                    ESUB=ESUB-0.25D0/EPS
   790: ||        C
   791: ||        C     ADD TO SUMS (ENERGY AND FORCE)
   792: ||        C
   793: ||                    ESUMG=ESUMG+2.D0*ZZ(I)*ZZ(J)*ESUB
   794: ||*---->              DO 1544 K=1,3
   795: |||                     FORCE(K,I)=FORCE(K,I)+ZZ(J)*FSUB(K)
   796: |||                     FORCE(K,J)=FORCE(K,J)-ZZ(I)*FSUB(K)
   797: ||*----    1544       CONTINUE
   798: ||                endif   ! iseq is within nbegint to nendt
   799: |+-----    1541     CONTINUE
   800: |                 ENDIF  ! IM.NE.0
   801: |         ccc      endif  ! if i.ge.nbegint(my_rank) .and. i.le.nendt(my_rank)
   802: +------    1540 CONTINUE
   803:                 ESUMG=PI2*ESUMG/OMEGA
   804: *------>        DO 1545 K=1,3
   805: |V----->        DO 1545 I=1,NATOT
   806: ||                FORCE(K,I)=4.D0*PI*ZZ(I)*TPIBA*FORCE(K,I)/OMEGA
   807: |V-----    1545 CONTINUE
   808:           C
   809:           C****************************
   810:           C     END G SUM
   811:           C****************************
   812:           C
   813:           C****************************
   814:           C     START SUM IN R SPACE
   815:           C****************************
   816:           C
   817:           C     DO R SUM FOR THE CASE WHERE A=B
   818:           C
   819:                 ESUM0=0.D0
   820: V------>        DO 1600 I=2,NLV
   821: |                 RMOD=SQRT(EWVEC(4,I))
   822: |                 ARG=SEPS*RMOD
   823: |                 IF(ARG.LE.25.D0) THEN
   824: |                    EXP1=DERFC(ARG)/RMOD
   825: |                    ESUM0=ESUM0+EXP1
   826: |                 ENDIF
   827: V------    1600 CONTINUE
   828:                 ESUM0=ESUM0-SEPI
   829:           C
   830:           C
   831:           C   START LOOP OVER ATOMS IN CELL
   832:           C
   833:                 iseq=0
   834: +------>        DO 1610 I=1,NATOT
   835: |               iseq=iseq+1
   836: |         c ******
   837: |               if ( iseq.ge.nbegint(my_rank) .and.
   838: |              &     iseq.le.nendt(my_rank) ) then
   839: |         C
   840: |         C     TERM WITH A=B
   841: |         C
   842: |                 ESUMR=ESUMR+ZZ(I)*ZZ(I)*ESUM0
   843: |               endif
   844: |         c ******
   845: |                 IM=I-1
   846: |                 IF(IM.NE.0) THEN
   847: |         C
   848: |         C     TERMS WITH A#B
   849: |         C
   850: |+----->            DO 1611 J=1,IM
   851: ||                  iseq=iseq+1
   852: ||        c ******
   853: ||              if ( iseq.ge.nbegint(my_rank) .and.
   854: ||             &     iseq.le.nendt(my_rank) ) then
   855: ||        C
   856: ||        C     LOOP OVER LATTICE POINTS
   857: ||        C
   858: ||                    ESUB=0.D0
   859: ||*---->              DO 1612 K=1,3
   860: |||                     FSUB(K)=0.D0
   861: ||*----    1612       CONTINUE
   862: ||V---->              DO 1613 IL=1,NLV
   863: |||                     RP(1)=EWVEC(1,IL)-TAU(1,J)+TAU(1,I)
   864: |||                     RP(2)=EWVEC(2,IL)-TAU(2,J)+TAU(2,I)
   865: |||                     RP(3)=EWVEC(3,IL)-TAU(3,J)+TAU(3,I)
   866: |||                     RMOD=RP(1)*RP(1)+RP(2)*RP(2)+RP(3)*RP(3)
   867: |||                     RMOD=SQRT(RMOD)
   868: |||                     ARG=SEPS*RMOD
   869: |||                     IF(ARG.LE.25.D0) THEN
   870: |||                       EXP1=DERFC(ARG)/RMOD
   871: |||                       EXP2=(EXP1+SEPI*DEXP(-ARG*ARG))/(RMOD*RMOD)
   872: |||                       ESUB=ESUB+EXP1
   873: |||                       FSUB(1)=FSUB(1)+RP(1)*EXP2
   874: |||                       FSUB(2)=FSUB(2)+RP(2)*EXP2
   875: |||                       FSUB(3)=FSUB(3)+RP(3)*EXP2
   876: |||                     ENDIF
   877: ||V----    1613       CONTINUE
   878: ||        C           ESUB=ESUB-PI/(EPS*OMEGA)
   879: ||        C
   880: ||        C     ADD TO SUMS (ENERGY AND FORCE)
   881: ||        C
   882: ||                    ESUMR=ESUMR+2.D0*ZZ(I)*ZZ(J)*ESUB
   883: ||*---->              DO 1616 K=1,3
   884: |||                     FORCE(K,I)=FORCE(K,I)+ZZ(I)*ZZ(J)*FSUB(K)
   885: |||                     FORCE(K,J)=FORCE(K,J)-ZZ(I)*ZZ(J)*FSUB(K)
   886: |||       C             WRITE(6,*) FORCE(K,I),FORCE(K,J)
   887: ||*----    1616       CONTINUE
   888: ||                 endif  ! iseq is within nbegint to nendt
   889: |+-----    1611     CONTINUE
   890: |                 ENDIF ! IM.NE.0
   891: |         c       endif  ! I is within nbegint(my_rank) and nendt(my_rank)
   892: +------    1610 CONTINUE
   893:                 ESUMR=ESUMR*0.5D0
   894:           C
   895:           C*************************
   896:           C     END R SUM
   897:           C*************************
   898:           C
   899:           C     GENERATE - FORCE(;)
   900:           C
   901: *------>        DO 1700 K=1,3
   902: |V----->        DO 1700 J=1,NATOT
   903: ||                FORCE(K,J)=-FORCE(K,J)
   904: |V-----    1700 CONTINUE
   905:           CC      CALL CLOCK(TIM2)
   906:           CC      WRITE(6,*) '  EWALD R ',ESUMR,TIM2-TIM1
   907:           CC        WRITE(6,*) '  EWALD R ',ESUMR
   908:                 EWA=ESUMG+ESUMR
   909:                 TEMP=0.d0
   910:                  call MPI_Reduce(EWA,TEMP,1,MPI_DOUBLE_PRECISION
   911:                &    ,MPI_SUM, 0,MPI_COMM_WORLD,ierr)
   912:                 EWA=TEMP
   913:                 FSUB(1)=0.d0
   914:                 FSUB(2)=0.d0
   915:                 FSUB(3)=0.d0
   916: +------>        do it=1,natot
   917: |                call MPI_Reduce(FORCE(1,it),FSUB,3,MPI_DOUBLE_PRECISION
   918: |              &    ,MPI_SUM, 0,MPI_COMM_WORLD,ierr)
   919: |                FORCE(1,it)=FSUB(1)
   920: |                FORCE(2,it)=FSUB(2)
   921: |                FORCE(3,it)=FSUB(3)
   922: +------         enddo
   923:                 call MPI_Bcast(FORCE,3*NATOT,MPI_DOUBLE_PRECISION,0,
   924:                &        MPI_COMM_WORLD,ierr)
   925:           C     DO 17 I=1,NTAUQ
   926:           C  17 WRITE(6,*) (FORCE(J,I),J=1,3)
   927:                 RETURN
   928:                 END


NEC Fortran Compiler (3.4.2) for Vector Engine   Thu Jul 28 08:27:24 2022
FILE NAME: lib4_ASL_2_check_Vext_SXACE.f

PROCEDURE NAME: AGEN
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

   931:                 SUBROUTINE AGEN(B1,B2,B3,NRX,NRY,NRZ,NG,NGQ,G,GCUT,itstep)
   932:           C
   933:                 IMPLICIT REAL*8 (A-H,O-Z)
   934:                 include 'mpif.h'
   935:                 REAL*8 B1(3),B2(3),B3(3),T(4)
   936:                 DIMENSION G(4,NGQ)
   937:                 INTEGER TNRM1,TNRM2,TNRM3
   938:                 common/tmod/itmod
   939:           c
   940:                 call MPI_COMM_RANK(MPI_COMM_WORLD,my_rank,ierr)
   941:           c
   942: *------>        DO 5 J=1,4
   943: *------       5 G(J,1)=0.D0
   944:                 NG=2
   945:                 IMAX=0
   946:                 JMAX=0
   947:                 KMAX=0
   948:           C *****
   949:                 TNRM1=2*NRX+1
   950:                 TNRM2=2*NRY+1
   951:                 TNRM3=2*NRZ+1
   952:           C *****
   953: +------>        DO 10 I1=1,TNRM1
   954: |               I=I1-NRX
   955: |+----->        DO 10 J1=1,TNRM2
   956: ||              J=J1-NRY
   957: ||+---->        DO 10 K1=1,TNRM3
   958: |||             K=K1-NRZ
   959: |||             G2=0.D0
   960: |||*--->        DO 15 IR=1,3
   961: ||||            T(IR)=DBLE(I)*B1(IR)+DBLE(J)*B2(IR)+DBLE(K)*B3(IR)
   962: |||*---      15 G2=G2+T(IR)*T(IR)
   963: |||             IF(G2.GT.GCUT) GO TO 10
   964: |||             IF(G2.LT.1.D-8) GOTO 10
   965: |||             IF(ABS(I).GT.IMAX) IMAX=ABS(I)
   966: |||             IF(ABS(J).GT.JMAX) JMAX=ABS(J)
   967: |||             IF(ABS(K).GT.KMAX) KMAX=ABS(K)
   968: |||*--->        DO 6 IR=1,3
   969: |||*---       6 G(IR,NG)=T(IR)
   970: |||             G(4,NG)=G2
   971: |||             NG=NG+1
   972: |||             IF(NG.GT.NGQ) GO TO 100
   973: ||+----      10 CONTINUE
   974:                 NG=NG-1
   975:                 if ( mod(itstep,itmod).eq.0 ) then
   976:                 if ( my_rank.eq.0 ) then
   977:                 WRITE(6,130) GCUT,NG,NRX*NRY*NRZ*4.0*3.141593/3.0/8.0
   978:             130 FORMAT(' GCUT=',F15.7,' NG=',I8,' NG EFFICIENT=',F15.7)
   979:                 WRITE(6,*) ' IMAX=',IMAX,' JMAX=',JMAX,' KMAX=',KMAX
   980:                 endif
   981:                 endif
   982:                 RETURN
   983:             100 if ( my_rank.eq.0 ) WRITE(6,110) GCUT,NG
   984:             110 FORMAT(' GCUT=',1PE12.4,' IS TOO BIG. STOPPING'/
   985:                &       ' NGQ should be ',I9)
   986:                 STOP
   987:                 END


NEC Fortran Compiler (3.4.2) for Vector Engine   Thu Jul 28 08:27:24 2022
FILE NAME: lib4_ASL_2_check_Vext_SXACE.f

PROCEDURE NAME: SYMFRC
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

   990:                 SUBROUTINE SYMFRC(S,NTOT,DFORCE,SFORCE,
   991:                & NTAUQ,NTYQ,NTYPE,TAU,NUMTY,NIDN,LATQ,RVEC, NLV )
   992:                 IMPLICIT REAL*8 (A-H,O-Z)
   993:                 DIMENSION H(3,3),BB(3,3),B2(3,3),RS(3,3,48)
   994:                 DIMENSION X(3),Y(3),RSINV(3,3,48),DUM1(3,3),DUM2(3,3)
   995:                 DIMENSION XX(3)
   996:                 COMMON/AVEC/A1(3),A2(3),A3(3),XB1(3),XB2(3),XB3(3),COVA,ALAT
   997:                 INTEGER*4 S(3,3,48)
   998:                 DIMENSION DFORCE(3,NTAUQ),SFORCE(3,NTAUQ),RVEC(4,LATQ)
   999:                 DIMENSION TAU(3,NTAUQ),NUMTY(NTYQ),NIDN(NTAUQ,NTYQ)
  1000:           C
  1001:                 IF(NTOT.EQ.1) THEN
  1002: V------>          DO 5555 IO=1,NTAUQ
  1003: |*----->          DO 5555 JO=1,3
  1004: |*-----    5555   SFORCE(JO,IO)=DFORCE(JO,IO)
  1005:                   RETURN
  1006:                 ENDIF
  1007:                 H(1,1)=A1(1)
  1008:                 H(1,2)=A2(1)
  1009:                 H(1,3)=A3(1)
  1010:                 H(2,1)=A1(2)
  1011:                 H(2,2)=A2(2)
  1012:                 H(2,3)=A3(2)
  1013:                 H(3,1)=A1(3)
  1014:                 H(3,2)=A2(3)
  1015:                 H(3,3)=A3(3)
  1016:           C
  1017:                 CALL INVMAT(H,BB)
  1018: +------>        DO 1000 IROT=1,NTOT
  1019: |*----->          DO 1010 J=1,3
  1020: ||*---->            DO 1020 K=1,3
  1021: |||                   B2(J,K)=0.D0
  1022: |||                   RS(J,K,IROT)=0.D0
  1023: ||*----    1020     CONTINUE
  1024: |*-----    1010   CONTINUE
  1025: |         C
  1026: |*----->          DO 1110 J=1,3
  1027: ||*---->            DO 1120 K=1,3
  1028: |||*--->              DO 1130 L=1,3
  1029: ||||                    B2(K,J)=S(L,K,IROT)*BB(L,J)+B2(K,J)
  1030: |||*---    1130       CONTINUE
  1031: ||*----    1120     CONTINUE
  1032: |*-----    1110   CONTINUE
  1033: |         C
  1034: |*----->          DO 1210 J=1,3
  1035: ||*---->            DO 1220 K=1,3
  1036: |||*--->              DO 1230 L=1,3
  1037: ||||                    RS(K,J,IROT)=RS(K,J,IROT)+H(K,L)*B2(L,J)
  1038: |||*---    1230       CONTINUE
  1039: ||*----    1220     CONTINUE
  1040: |*-----    1210   CONTINUE
  1041: |         C
  1042: |*----->          DO 1410 I=1,3
  1043: ||*---->            DO 1420 J=1,3
  1044: |||                   DUM1(I,J)=RS(I,J,IROT)
  1045: ||*----    1420     CONTINUE
  1046: |*-----    1410   CONTINUE
  1047: |                 CALL INVMAT(DUM1,DUM2)
  1048: |*----->          DO 1510 I=1,3
  1049: ||*---->            DO 1520 J=1,3
  1050: |||                   RSINV(I,J,IROT)=DUM2(I,J)
  1051: ||*----    1520     CONTINUE
  1052: |*-----    1510   CONTINUE
  1053: +------    1000 CONTINUE
  1054:           CC
  1055: +------>          DO 2000 I=1,NTYPE
  1056: |+----->            DO 2100 J=1,ABS(NUMTY(I))
  1057: ||                    ITAU=NIDN(J,I)
  1058: ||                    X(1)=TAU(1,ITAU)
  1059: ||                    X(2)=TAU(2,ITAU)
  1060: ||                    X(3)=TAU(3,ITAU)
  1061: ||                    SFORCE(1,ITAU)=0.D0
  1062: ||                    SFORCE(2,ITAU)=0.D0
  1063: ||                    SFORCE(3,ITAU)=0.D0
  1064: ||+---->              DO 2200 IROT=1,NTOT
  1065: |||*--->                DO 2300 L=1,3
  1066: ||||                      XX(L)=0.D0
  1067: ||||*-->                  DO 2400 M=1,3
  1068: |||||                       XX(L)=XX(L)+RS(L,M,IROT)*X(M)
  1069: ||||*--    2400           CONTINUE
  1070: |||*---    2300         CONTINUE
  1071: |||                     IFLG=0
  1072: |||+--->                DO 3000 I2=1,NTYPE
  1073: ||||+-->                  DO 3100 J2=1,ABS(NUMTY(I2))
  1074: |||||V->                    DO 3200 K=1, NLV
  1075: ||||||                        ITAU2=NIDN(J2,I2)
  1076: ||||||                        Y(1)=TAU(1,ITAU2)+RVEC(1,K)
  1077: ||||||                        Y(2)=TAU(2,ITAU2)+RVEC(2,K)
  1078: ||||||                        Y(3)=TAU(3,ITAU2)+RVEC(3,K)
  1079: ||||||                        ACHK=DABS(XX(1)-Y(1))+DABS(XX(2)-Y(2))
  1080: ||||||         &                   +DABS(XX(3)-Y(3))
  1081: ||||||                        IF(ACHK.LT.1.D-8)THEN
  1082: ||||||                          IFLG=1
  1083: ||||||*>                        DO 3600 L=1,3
  1084: |||||||>                          DO 3700 M=1,3
  1085: |||||||                             SFORCE(L,ITAU)=SFORCE(L,ITAU)
  1086: |||||||        &                   +DFORCE(M,ITAU2)*RSINV(L,M,IROT)/NTOT
  1087: |||||||    3700                   CONTINUE
  1088: ||||||*    3600                 CONTINUE
  1089: ||||||                        ENDIF
  1090: |||||V-    3200             CONTINUE
  1091: ||||+--    3100           CONTINUE
  1092: |||+---    3000         CONTINUE
  1093: |||                     IF(IFLG.EQ.0)WRITE(6,*) ' WARNING !!! IN SYMFRC ITAU= '
  1094: |||            &       ,ITAU,' IROT=',IROT
  1095: ||+----    2200       CONTINUE
  1096: |+-----    2100     CONTINUE
  1097: +------    2000   CONTINUE
  1098:                   RETURN
  1099:                   END


NEC Fortran Compiler (3.4.2) for Vector Engine   Thu Jul 28 08:27:24 2022
FILE NAME: lib4_ASL_2_check_Vext_SXACE.f

PROCEDURE NAME: INVMAT
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

  1101:                 SUBROUTINE INVMAT(H,B)
  1102:                 IMPLICIT REAL*8(A,B,D-H,O-Z)
  1103:                 REAL*8 H(3,3),B(3,3)
  1104:           C
  1105:                 DET=H(1,1)*H(2,2)*H(3,3)+H(1,3)*H(2,1)*H(3,2)
  1106:                &   +H(1,2)*H(2,3)*H(3,1)
  1107:                &   -H(1,3)*H(2,2)*H(3,1)-H(1,2)*H(2,1)*H(3,3)
  1108:                &   -H(1,1)*H(2,3)*H(3,2)
  1109:           C
  1110:                 B(1,1)=       H(2,2)*H(3,3) - H(2,3)*H(3,2)
  1111:                 B(2,1)=(-1)*( H(2,1)*H(3,3) - H(2,3)*H(3,1) )
  1112:                 B(3,1)=       H(2,1)*H(3,2) - H(2,2)*H(3,1)
  1113:                 B(1,2)=(-1)*( H(1,2)*H(3,3) - H(1,3)*H(3,2) )
  1114:                 B(2,2)=       H(1,1)*H(3,3) - H(1,3)*H(3,1)
  1115:                 B(3,2)=(-1)*( H(1,1)*H(3,2) - H(1,2)*H(3,1) )
  1116:                 B(1,3)=       H(1,2)*H(2,3) - H(1,3)*H(2,2)
  1117:                 B(2,3)=(-1)*( H(1,1)*H(2,3) - H(1,3)*H(2,1) )
  1118:                 B(3,3)=       H(1,1)*H(2,2) - H(1,2)*H(2,1)
  1119:                 IF(DET.EQ.0.D0) STOP ' INVMAT '
  1120: *------>        DO 10 I=1,3
  1121: |*----->        DO 20 J=1,3
  1122: ||                B(I,J)=B(I,J)/DET
  1123: |*-----      20 CONTINUE
  1124: *------      10 CONTINUE
  1125:           C
  1126:                 RETURN
  1127:                 END


NEC Fortran Compiler (3.4.2) for Vector Engine   Thu Jul 28 08:27:24 2022
FILE NAME: lib4_ASL_2_check_Vext_SXACE.f

PROCEDURE NAME: LOCPOTF
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

  1129:                 SUBROUTINE LOCPOTF(NXYZ,NG,NGQ,G,EXPG,EIGT,TPIBA,OMEGA,
  1130:                &  DELTA,DELTAd,VG,RHO,RHOG,I2G,FORCE,VGA,
  1131:                &  NTAUQ,NTYQ,NTYPE,TAU,NUMTY,NIDN
  1132:                & ,NCRQ,ZV,RC0,COR,NUMC,ZZ, ZVAL,
  1133:                &  ESELF, EWA, ELOCAL, EXC, EH,ITSTEP
  1134:                & ,DRX,DRY,DRZ,DRXX,DRYY,DRZZ,DRXY,DRYZ,DRZX,VWORK
  1135:                & ,REXT,WEXT,ft,dft,NRX,NRY,NRZ
  1136:           c *** for Sugino FFT
  1137:           c     &                  ,WSAVEX,WSAVEY,WSAVEZ
  1138:           c     &                  ,LX1,LX2,LY1
  1139:           c     &                  ,LY2,LZ1,LZ2
  1140:           c     &                  ,IFACX,IFACY,IFACZ)
  1141:           c *** for Kokubo ASL FFT
  1142:           c     &                  ,WSAVE_XYZ,IFAC_XYZ)
  1143:           c *** for Kokubo FFTW
  1144:                &                  ,plancfp,plancbp
  1145:           c
  1146:                &    ,nbegint,nendt,nbegintt,nendtt,ncpuq,ncpu )
  1147:           C
  1148:           C     CONSTRUCT LOCAL ONE-ELECTRON POTENTITL AND FORCE
  1149:           C               NUMERICAL POTENTIAL (1992-02-28) OSAMU SUGINO
  1150:           C
  1151:                 IMPLICIT REAL*8 (A-H,O-Z)
  1152:                 include 'mpif.h'
  1153:           c      PARAMETER(LATQ=15630, ncpuq=30)
  1154:                 PARAMETER(LATQ=15630)
  1155:           c      include 'ncpuq.h'
  1156:                 REAL*8 G(4,NGQ),RHO(NXYZ),FORCE(3,NTAUQ),ZZ(NTAUQ)
  1157:                 REAL*8 EXPG(NGQ)
  1158:                 COMPLEX*16 EIGT(NXYZ),VG(NXYZ),RHOG(NXYZ),CI,CRG,CTEMP
  1159:           c *** for GGA ***
  1160:                 COMPLEX*16 DRX(NXYZ),DRY(NXYZ),DRZ(NXYZ)
  1161:                &          ,DRXX(NXYZ),DRYY(NXYZ),DRZZ(NXYZ)
  1162:                &          ,DRXY(NXYZ),DRYZ(NXYZ),DRZX(NXYZ),VWORK(NXYZ)
  1163:           c      DIMENSION I2G(NGQ),VGA(NGQ)
  1164:                 DIMENSION I2G(NGQ),VGA(NGQ,NTYQ)
  1165:                 DIMENSION TAU(3,NTAUQ),NUMTY(NTYQ),NIDN(NTAUQ,NTYQ)
  1166:                 COMMON/AVEC/A1(3),A2(3),A3(3),B1(3),B2(3),B3(3),COVA,ALAT
  1167:                 COMMON/COMOPT/IOPT(10,5)
  1168:                 DIMENSION EWVEC(4,LATQ)
  1169:                 DIMENSION ZV(NTYQ),RC0(NCRQ,NTYQ),COR(NCRQ,NTYQ),NUMC(NTYQ)
  1170:           C     DIMENSION AFORCE(3,16),BFORCE(3,16)
  1171:           c *** for Sugino FFT
  1172:           c      COMPLEX*16 WSAVEX(NRX),WSAVEY(NRY),WSAVEZ(NRZ)
  1173:           c      DIMENSION IFACX(30),IFACY(30),IFACZ(30)
  1174:           c      DIMENSION LX1(NXYZ),LX2(NXYZ),LY1(NXYZ),
  1175:           c     &          LY2(NXYZ),LZ1(NXYZ),LZ2(NXYZ)
  1176:           c *** for Kokubo ASL FFT
  1177:           c      COMPLEX*16 WSAVE_XYZ(NRX+NRY+NRZ)
  1178:           c      DIMENSION IFAC_XYZ(60)
  1179:           c *** for Kokubo FFTW
  1180:                 integer*8 plancfp,plancbp
  1181:           c *** for extra charge
  1182:                 complex*16 REXT(NXYZ),WEXT(NXYZ)
  1183:                 integer tag,status(MPI_STATUS_SIZE)
  1184:           c      common/cputask2/nbegint(0:ncpuq),nendt(0:ncpuq),ncpu
  1185:                 dimension nbegint(0:ncpuq),nendt(0:ncpuq)
  1186:                 dimension nbegintt(0:ncpuq),nendtt(0:ncpuq)
  1187:                 data tag/21/
  1188:                 COMPLEX*16 VG_(NGQ), WEXT_(NGQ)
  1189:                 call MPI_COMM_RANK(MPI_COMM_WORLD,my_rank,ierr)
  1190:           c ** temp check
  1191:           c      if (my_rank.eq.0 ) then
  1192:           c       write(6,*)' in LOCPOT '
  1193:           c       write(6,*)' nbegint nendt '
  1194:           c       do icpu=1,ncpuq
  1195:           c        write(6,*) nbegint(icpu),nendt(icpu)
  1196:           c       enddo
  1197:           c       write(6,*)' nbegintt nendtt '
  1198:           c       do icpu=1,ncpuq
  1199:           c        write(6,*) nbegintt(icpu),nendtt(icpu)
  1200:           c       enddo
  1201:           c      endif
  1202:           c ** temp check : end
  1203:           c
  1204:                 CI=(0.D0,1.D0)
  1205:                 PI=4.D0*ATAN(1.D0)
  1206:                 FPI=4.D0*PI
  1207:                 TPIBA2=TPIBA**2
  1208:                 IGGA = IOPT(8,2)
  1209:           c *** temp check
  1210:           c      write(6,*)' in sub. LOCPOTF   RHOG !! '
  1211:           c      write(6,*)( RHOG(IG),IG=1,1500,100 )
  1212:           c *** temp check : end
  1213:           C
  1214:           c *** temp check
  1215:           c      if ( my_rank.eq.0 ) then
  1216:           c       write(6,*)' In LOCPOTF itstep=',itstep
  1217:           c       do ity=1,ntype
  1218:           c        write(6,*)'TAU  ity = ',ity
  1219:           c        NUM=ABS(NUMTY(ITY))
  1220:           c        do K=1,NUM
  1221:           c         ITAU=NIDN(K,ITY)
  1222:           c         write(6,'(3F22.16)')(TAU(jj,itau),jj=1,3)
  1223:           c        enddo
  1224:           c       enddo
  1225:           c      endif
  1226:           c *** temp check end
  1227:           c *** temp check
  1228:           c      if (my_rank.eq.0 ) then
  1229:           c       write(6,*)' In LOCPOTF itstep=',itstep
  1230:           c       do ity=1,NTYPE
  1231:           c        write(6,*)' ity =',ity
  1232:           c        write(6,*)' ZV =',ZV(ity),' RC0 =',RC0(1,ity),RC0(2,ity)
  1233:           c        write(6,*)' COR =',COR(1,ity),COR(2,ity)
  1234:           c       enddo
  1235:           c      endif
  1236:           c *** temp check end
  1237:           c *** temp check
  1238:           c      if ( my_rank.eq.0 ) then
  1239:           c        write(6,*)' in LOCPOTF itstep=',itstep
  1240:           c        do ITY=1,NTYPE
  1241:           c        write(6,*)' VGA  ITY =',ITY
  1242:           c        write(6,'(4F22.16)')(VGA(IG,ITY),IG=1,NGQ,1000)
  1243:           c        enddo
  1244:           c      endif
  1245:           c *** temp check: end
  1246:           c *** temp check
  1247:           c      if ( my_rank.eq.0 ) then
  1248:           c      write(6,*)' ELOCAL= ',ELOCAL
  1249:           c      write(6,*)' ELOCALd= ',ELOCALd
  1250:           C        HARTREE ENERGY
  1251:           C
  1252:           c      EH=0.D0
  1253:           c      EHd=0.D0
  1254:           c*VDIR NODEP(WEXT,REXT)
  1255:           c!ocl norecurrence(WEXT,REXT)
  1256:           c      DO IG=2,NG
  1257:           c      JG=I2G(IG)
  1258:           c       EHd=EHd
  1259:           c     & +FPI*DBLE(WEXT(JG)*dft*Rext(JG))/(TPIBA2*G(4,IG))
  1260:           c      EH=EH+0.5D0*FPI*DBLE(DCONJG(WEXT(JG))*WEXT(JG))/(TPIBA2*G(4,IG))
  1261:           c      enddo
  1262:           c      write(6,*)' Before SELF ENERGY : EH=',EH
  1263:           c      endif
  1264:           c *** temp check ; end
  1265:           C
  1266:           C       SELF-ENERGY
  1267:           C
  1268:                 ESUM=0.D0
  1269:                 ZSUM=0.D0
  1270: +------>        DO 30 ITAU=1,NTYPE
  1271: |               UM=DBLE(ABS(NUMTY(ITAU)))
  1272: |               ZSUM=ZSUM+ZV(ITAU)*UM
  1273: |               NN=NUMC(ITAU)
  1274: |               VAL=0.D0
  1275: |V----->        DO 32 IA=1,NN
  1276: |V-----      32 VAL=VAL+COR(IA,ITAU)*RC0(IA,ITAU)**2
  1277: +------      30 ESUM=ESUM+VAL*UM*ZV(ITAU)
  1278:           C ******     3/4/93... FIX BUG: FROM ZSUM TO - ZVAL
  1279:                     ESELF = -PI*ZVAL/OMEGA*ESUM
  1280:           C ******
  1281:           C
  1282: V------>        DO 1500 I=1,NTAUQ
  1283: |               FORCE(1,I)=0.D0
  1284: |               FORCE(2,I)=0.D0
  1285: |               FORCE(3,I)=0.D0
  1286: V------    1500 CONTINUE
  1287:           C
  1288:           c *** temp check
  1289:           c      if ( my_rank.eq.0 ) then
  1290:           c      write(6,*)' ELOCAL= ',ELOCAL
  1291:           c      write(6,*)' ELOCALd= ',ELOCALd
  1292:           cC        HARTREE ENERGY
  1293:           cC
  1294:           c      EH=0.D0
  1295:           c      EHd=0.D0
  1296:           c*VDIR NODEP(WEXT,REXT)
  1297:           c!ocl norecurrence(WEXT,REXT)
  1298:           c      DO IG=2,NG
  1299:           c      JG=I2G(IG)
  1300:           c       EHd=EHd
  1301:           c     & +FPI*DBLE(WEXT(JG)*dft*Rext(JG))/(TPIBA2*G(4,IG))
  1302:           c      EH=EH+0.5D0*FPI*DBLE(DCONJG(WEXT(JG))*WEXT(JG))/(TPIBA2*G(4,IG))
  1303:           c      enddo
  1304:           c      write(6,*)' Before EWALDY : EH=',EH
  1305:           c      endif
  1306:           c *** temp check ; end
  1307:           C
  1308:           C       EWALD SUM
  1309:           C
  1310:                 CALL EWALDY(TPIBA,OMEGA,EWA,NGQ,NG,G,EXPG,FORCE,LATQ,EWVEC,
  1311:                &           NTAUQ,NTYQ,NTYPE,TAU,NUMTY,NIDN,ZV,ZZ,
  1312:                &           A1,A2,A3,B1,B2,B3,itstep
  1313:           c
  1314:                &          ,nbegintt,nendtt,ncpuq,ncpu )
  1315:           C *****   EWALD END
  1316:           C     WRITE(6,6002)
  1317:           C6002 FORMAT(15X,'  ****  FORCE EWALD PARTS: NEGATIVE')
  1318:           C     DO 9030 ITAU=1,NTAUQ
  1319:           C9030 WRITE(6,'(23X,3F14.6)') (FORCE(I,ITAU),I=1,3)
  1320:           C
  1321:           c *** temp check
  1322:                 if ( my_rank.eq.0.and.itstep.eq.0 ) then
  1323:                 write(6,*)' ELOCAL= ',ELOCAL
  1324:                 write(6,*)' ELOCALd= ',ELOCALd
  1325:           C        HARTREE ENERGY
  1326:           C
  1327:                 EH=0.D0
  1328:                 EHd=0.D0
  1329:           *VDIR NODEP(WEXT,REXT)
  1330:           !ocl norecurrence(WEXT,REXT)
  1331: V------>        DO IG=2,NG
  1332: |               JG=I2G(IG)
  1333: |                EHd=EHd
  1334: |              & +FPI*DBLE(WEXT(JG)*dft*Rext(JG))/(TPIBA2*G(4,IG))
  1335: |       G       EH=EH+0.5D0*FPI*DBLE(DCONJG(WEXT(JG))*WEXT(JG))/(TPIBA2*G(4,IG))
  1336: V------         enddo
  1337:                 write(6,*)' Before ELOCAL : EH=',EH
  1338:                 endif
  1339:           c *** temp check ; end
  1340:           C
  1341:           C
  1342:           C LOCAL POTENTITAL
  1343:           C
  1344:           C
  1345: V------>        do IG=1,NXYZ
  1346: |         c       WEXT(IG)=DCONJG( RHOG(IG)+REXT(IG) )
  1347: |                WEXT(IG)=DCONJG( RHOG(IG)+ft*REXT(IG) )
  1348: |               enddo
  1349: |         c
  1350: |               DO 25 IG=1,NXYZ
  1351: |               EIGT(IG)=(0.D0,0.D0)
  1352: V------      25 VG(IG)=(0.D0,0.D0)
  1353:           C
  1354:                 ENERGY1=0.D0
  1355:                 ENERGY2=0.D0
  1356:                 REWIND 81
  1357: V------>        DO IG=1,NG
  1358: |                 JG=I2G(IG)
  1359: |                 VG_(IG)=(0.D0,0.D0)
  1360: |       G         WEXT_(IG) = WEXT(JG)
  1361: V------         ENDDO
  1362: +------>        DO 20 ITY=1,NTYPE
  1363: |         cc      READ(81) VGA
  1364: |               NUM=ABS(NUMTY(ITY))
  1365: |         c      VG(1)=VG(1)+VGA(1)*NUM/OMEGA
  1366: |         c      VG(1)=VG(1)+VGA(1,ITY)*NUM/OMEGA
  1367: |+----->        DO 22 K=1,NUM
  1368: ||              ITAU=NIDN(K,ITY)
  1369: ||              if ( ITAU.ge.nbegint(my_rank) .and.
  1370: ||             &     ITAU.le.nendt(my_rank) ) then
  1371: ||              if (K.eq.1 ) then
  1372: ||              VG(1)=VG(1)+VGA(1,ITY)*NUM/OMEGA
  1373: ||              VG_(1)=VG_(1)+VGA(1,ITY)*NUM/OMEGA
  1374: ||              endif
  1375: ||        *VDIR NODEP(VG,WEXT)
  1376: ||        !ocl norecurrence(VG,WEXT)
  1377: ||V---->        DO 80 IG=2,NG
  1378: |||       !     JG=I2G(IG)
  1379: |||             Q=TPIBA2*G(4,IG)
  1380: |||             SUM=  G(1,IG)*TAU(1,ITAU) + G(2,IG)*TAU(2,ITAU)
  1381: |||            &    + G(3,IG)*TAU(3,ITAU)
  1382: |||             SUM=SUM*TPIBA
  1383: |||             EIGT(IG)=DCMPLX(COS(SUM),-SIN(SUM))
  1384: |||       c      CTEMP=VGA(IG)*EIGT(IG)/OMEGA
  1385: |||             CTEMP=VGA(IG,ITY)*EIGT(IG)/OMEGA
  1386: |||       !     VG(JG)=VG(JG)+CTEMP
  1387: |||             VG_(IG)=VG_(IG)+CTEMP
  1388: |||             C1=G(1,IG)*TPIBA*OMEGA
  1389: |||             C2=G(2,IG)*TPIBA*OMEGA
  1390: |||             C3=G(3,IG)*TPIBA*OMEGA
  1391: |||       c      CRG=DCONJG(RHOG(JG))
  1392: |||       !     CRG=WEXT(JG)
  1393: |||             CRG=WEXT_(IG)
  1394: |||             ENERGY1=ENERGY1+DBLE(CRG*CTEMP)
  1395: |||       C     AFORCE(1,ITAU)=AFORCE(1,ITAU)+DBLE(-CI*CTEMP*C1*CRG)
  1396: |||       C     AFORCE(2,ITAU)=AFORCE(2,ITAU)+DBLE(-CI*CTEMP*C2*CRG)
  1397: |||       C     AFORCE(3,ITAU)=AFORCE(3,ITAU)+DBLE(-CI*CTEMP*C3*CRG)
  1398: |||             FORCE(1,ITAU)=FORCE(1,ITAU)+DBLE(-CI*CTEMP*C1*CRG)
  1399: |||             FORCE(2,ITAU)=FORCE(2,ITAU)+DBLE(-CI*CTEMP*C2*CRG)
  1400: |||             FORCE(3,ITAU)=FORCE(3,ITAU)+DBLE(-CI*CTEMP*C3*CRG)
  1401: ||V----      80 CONTINUE
  1402: ||        c *** temp check
  1403: ||        c      if (my_rank.eq.1 ) then
  1404: ||        c       write(6,*)' in LOCPOTF after DO 80 ity= ',ity
  1405: ||        c       write(6,*)' VGA '
  1406: ||        c       write(6,'(4F22.16)')( VGA(IG,ITY),IG=1,NXYZ,1000)
  1407: ||        c       write(6,*)' EIGT '
  1408: ||        c       write(6,'(4F22.16)')( EIGT(IG),IG=1,NXYZ,1000)
  1409: ||        c       write(6,*)' VG_ '
  1410: ||        c       write(6,'(4F22.16)')( VG_(IG),IG=1,NXYZ,1000)
  1411: ||        c      endif
  1412: ||        c *** temp check: end
  1413: ||        C              LONG RANGE PART
  1414: ||+---->        DO 52 IA=1,NUMC(ITY)
  1415: |||             R02=RC0(IA,ITY)**2
  1416: |||       *VDIR NODEP(VG,WEXT)
  1417: |||       !ocl norecurrence(VG,WEXT)
  1418: |||V--->        DO 82 IG=2,NG
  1419: ||||      !     JG=I2G(IG)
  1420: ||||            Q=TPIBA2*G(4,IG)
  1421: ||||            AA=ZV(ITY)*COR(IA,ITY)*FPI/Q*EXP(-0.25D0*Q*R02)/OMEGA
  1422: ||||      !     VG(JG)=VG(JG)+EIGT(IG)*AA
  1423: ||||            VG_(IG)=VG_(IG)+EIGT(IG)*AA
  1424: ||||            C1=AA*G(1,IG)*TPIBA*OMEGA
  1425: ||||            C2=AA*G(2,IG)*TPIBA*OMEGA
  1426: ||||            C3=AA*G(3,IG)*TPIBA*OMEGA
  1427: ||||      c      CRG=DCONJG(RHOG(JG))
  1428: ||||      !     CRG=WEXT(JG)
  1429: ||||            CRG=WEXT_(IG)
  1430: ||||            ENERGY2=ENERGY2+DBLE(EIGT(IG)*AA*CRG)
  1431: ||||      C     BFORCE(1,ITAU)=BFORCE(1,ITAU)+DBLE(-CI*EIGT(IG)*C1*CRG)
  1432: ||||      C     BFORCE(2,ITAU)=BFORCE(2,ITAU)+DBLE(-CI*EIGT(IG)*C2*CRG)
  1433: ||||      C     BFORCE(3,ITAU)=BFORCE(3,ITAU)+DBLE(-CI*EIGT(IG)*C3*CRG)
  1434: ||||            FORCE(1,ITAU)=FORCE(1,ITAU)+DBLE(-CI*EIGT(IG)*C1*CRG)
  1435: ||||            FORCE(2,ITAU)=FORCE(2,ITAU)+DBLE(-CI*EIGT(IG)*C2*CRG)
  1436: ||||            FORCE(3,ITAU)=FORCE(3,ITAU)+DBLE(-CI*EIGT(IG)*C3*CRG)
  1437: |||V---      82 CONTINUE
  1438: ||+----      52 CONTINUE
  1439: ||        c *** temp check
  1440: ||        c      if (my_rank.eq.1 ) then
  1441: ||        c       write(6,*)' in LOCPOTF after DO 52 ITY= ',ity
  1442: ||        c       write(6,*)' AA = ',AA
  1443: ||        c       write(6,*)'  EIGT '
  1444: ||        c       write(6,'(4F22.16)')( EIGT(IG),IG=1,NXYZ,1000)
  1445: ||        c       write(6,*)'  VG_ '
  1446: ||        c       write(6,'(4F22.16)')( VG_(IG),IG=1,NXYZ,1000)
  1447: ||        c      endif
  1448: ||        c *** temp check: end
  1449: ||        C
  1450: ||              endif  ! if ITAU.ge.nbegint and lt nendt loop: end
  1451: |+-----      22 CONTINUE
  1452: +------      20 CONTINUE
  1453: V------>        DO IG=2,NG
  1454: |                 JG=I2G(IG)
  1455: |       C         VG(JG)=VG_(IG)
  1456: V------         ENDDO
  1457:           c *****
  1458: V------>        do ig=1,nxyz
  1459: |                EIGT(ig)=0.d0
  1460: V------         enddo
  1461:                   call MPI_Reduce(VG,EIGT,nxyz,MPI_DOUBLE_COMPLEX
  1462:                &    ,MPI_SUM, 0,MPI_COMM_WORLD,ierr)
  1463:           C
  1464:           c*****************************
  1465:           C
  1466:                      if ( my_rank.ne.0 ) then
  1467:                       ntleng=nendt(my_rank)-nbegint(my_rank)+1
  1468:                       if ( ntleng.gt.0) then
  1469:                       call MPI_Send(FORCE(1,nbegint(my_rank)),3*ntleng,
  1470:                &        MPI_DOUBLE_PRECISION,0,tag,MPI_COMM_WORLD,ierr)
  1471:                       endif
  1472:                      else
  1473: +------>              do icpu=1,ncpu
  1474: |                     ntleng=nendt(icpu)-nbegint(icpu)+1
  1475: |                     if ( ntleng.gt.0) then
  1476: |                     call MPI_Recv(FORCE(1,nbegint(icpu)),3*ntleng,
  1477: |              &    MPI_DOUBLE_PRECISION,icpu,tag,MPI_COMM_WORLD,status,ierr)
  1478: |                     endif
  1479: +------               enddo
  1480:                      endif ! end of if my_rank.ne.0 loop
  1481:           c
  1482:           C * TEMP
  1483:           C     WRITE(6,6004)
  1484:           C6004 FORMAT(15X,'  ****  FORCE LOCAL PARTS: NEGATIVE ')
  1485:           C     DO 9031 ITAU=1,NTAUQ
  1486:           C9031 WRITE(6,'(23X,3F14.6)') (FORCE(I,ITAU),I=1,3)
  1487:           C
  1488:           c *** temp check
  1489:                 miya=13
  1490:                 if ( miya.eq.13 .and.my_rank.eq.0.and.itstep.eq.0 ) then
  1491:                  write(6,*)'just before do 6351 '
  1492:           ccc       write(6,*)'plot EIGT!'
  1493:           ccc       write(6,7979)(EIGT(IG),IG=1,NXYZ,NXYZ)
  1494:                  write(6,*)'plot REXT!'
  1495: +------>         write(6,7979)(REXT(IG),IG=1,NXYZ,NXYZ)
  1496:           ccc       write(6,*)'plot WEXT!'
  1497:           ccc       write(6,7979)(WEXT(IG),IG=1,NXYZ,NXYZ)
  1498:                 endif
  1499:            7979 format(4f22.16)
  1500:           c *** temp check : end
  1501:                 ELOCAL=0.D0
  1502:                 ELOCALd=0.D0
  1503: V------>        DO 6351 IG=1,NXYZ
  1504: |         c 6351 ELOCAL=ELOCAL+DBLE(DCONJG(VG(IG))*RHOG(IG))
  1505: |         c 6351 ELOCAL=ELOCAL+DBLE(DCONJG(EIGT(IG))*RHOG(IG))
  1506: |               ELOCALd=ELOCALd+DBLE(DCONJG(EIGT(IG))*dft*REXT(IG))
  1507: V------    6351 ELOCAL=ELOCAL+DBLE(EIGT(IG)*WEXT(IG))
  1508:           c *** temp check
  1509:           c      if (my_rank.eq.0 ) then
  1510:           c       write(6,*)' in LOCPOTF after DO 6351 '
  1511:           c       write(6,*)'  EIGT '
  1512:           c       write(6,'(4F22.16)')(EIGT(IG),IG=1,NXYZ,1000)
  1513:           c       write(6,*)'  WEXT '
  1514:           c       write(6,'(4F22.16)')(WEXT(IG),IG=1,NXYZ,1000)
  1515:           c      endif
  1516:           c *** temp check :end
  1517:                 ELOCAL=OMEGA*ELOCAL
  1518:                 ELOCALd=OMEGA*ELOCALd
  1519:           C
  1520:           c *** temp check
  1521:           c      if ( my_rank.eq.0 ) then
  1522:           c      write(6,*)' ELOCAL= ',ELOCAL
  1523:           c      write(6,*)' ELOCALd= ',ELOCALd
  1524:           cC        HARTREE ENERGY
  1525:           cC
  1526:           c      EH=0.D0
  1527:           c      EHd=0.D0
  1528:           c*VDIR NODEP(WEXT,REXT)
  1529:           ccccc!ocl norecurrence(WEXT,REXT)
  1530:           c      DO IG=2,NG
  1531:           c      JG=I2G(IG)
  1532:           c       EHd=EHd
  1533:           c     & +FPI*DBLE(WEXT(JG)*dft*Rext(JG))/(TPIBA2*G(4,IG))
  1534:           c      EH=EH+0.5D0*FPI*DBLE(DCONJG(WEXT(JG))*WEXT(JG))/(TPIBA2*G(4,IG))
  1535:           c      enddo
  1536:           c      write(6,*)' Before calling S2XC2 : EH=',EH
  1537:           c      endif
  1538:           c *** temp check ; end
  1539:           C         EXCHANGE CORRELATION PART
  1540:                 IF(IGGA.EQ.1) THEN
  1541:           c *** temp check
  1542:           c       write(6,*)' GGA is selected!'
  1543:           c *** temp check: end
  1544:                  CALL G2XC2(TPIBA, NRX,NRY,NRZ,NXYZ,NG,NGQ,G,
  1545:                & RHO,RHOG,I2G,
  1546:           c *** for Sugino FFT
  1547:           c     & WSAVEX,WSAVEY,WSAVEZ,IFACX,IFACY,IFACZ,LX1,LX2,
  1548:           c     & LY1,LY2,LZ1,LZ2,EXC,VG,DRX,DRY,DRZ,
  1549:           c *** for Kokubo ASL FFT
  1550:           c     & WSAVE_XYZ,IFAC_XYZ,EXC,VG,DRX,DRY,DRZ,
  1551:           c *** for Kokubo FFTW
  1552:                & plancfp,plancbp,EXC,VG,DRX,DRY,DRZ,
  1553:                & DRXX,DRYY,DRZZ,DRXY,DRYZ,DRZX,VWORK)
  1554:                 ELSE
  1555:           c *** temp check
  1556:           c       write(6,*)' LDA is selected!'
  1557:           c *** temp check: end
  1558:                 CALL S2XC2(NXYZ,RHO,EXC,VG)
  1559:                 ENDIF
  1560:                 EXC = OMEGA*EXC/DBLE(NXYZ)
  1561:           C
  1562:           C      CALL S2VXC2(NXYZ,RHO,VG)
  1563:           C      EVXC=0.D0
  1564:           C      DO 651 I=1,NXYZ
  1565:           C        EVXC=EVXC+VG(I)*RHO(I)
  1566:           C  651 CONTINUE
  1567:           C      EVXC=EVXC*OMEGA/DBLE(NXYZ)
  1568:           C     WRITE(6,*) ' EVXC=',EVXC
  1569:           C
  1570:           C        HARTREE ENERGY
  1571:           C
  1572:                 EH=0.D0
  1573:                 EHd=0.D0
  1574:           *VDIR NODEP(WEXT,REXT)
  1575:           cccc!ocl norecurrence(WEXT,REXT)
  1576:           !$omp parallel default(shared)
  1577:           !$omp do private(JG),reduction(+:EH),reduction(+:EHd)
  1578: V------>        DO 652 IG=2,NG
  1579: |               JG=I2G(IG)
  1580: |         c  652 EH=EH+0.5D0*FPI*DBLE(DCONJG(RHOG(JG))*RHOG(JG))/(TPIBA2*G(4,IG))
  1581: |       G        EHd=EHd
  1582: |              & +FPI*DBLE(WEXT(JG)*dft*Rext(JG))/(TPIBA2*G(4,IG))
  1583: V------     652 EH=EH+0.5D0*FPI*DBLE(DCONJG(WEXT(JG))*WEXT(JG))/(TPIBA2*G(4,IG))
  1584:           !$omp enddo
  1585:           !$omp end parallel
  1586:                 EH=OMEGA*EH
  1587:                 EHd=OMEGA*EHd
  1588:           c *** temp check
  1589:                 if ( my_rank.eq.0.and.itstep.eq.0 ) then
  1590:                  write(6,*)' after DO 652  EH = ',EH
  1591:                 endif
  1592:           c *** temp check : end
  1593:           C
  1594:           C
  1595:                 DELTAd=EHd+ELOCALd
  1596:                 DELTA=EWA+EH+ELOCAL+EXC+ESELF
  1597:           C
  1598:                 RETURN
  1599:                 END


NEC Fortran Compiler (3.4.2) for Vector Engine   Thu Jul 28 08:27:24 2022
FILE NAME: lib4_ASL_2_check_Vext_SXACE.f

PROCEDURE NAME: FINDNBR
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

  1684:                 SUBROUTINE FINDNBR(NTAU,TAU,LATQ,RVEC,NLV)
  1685:                 IMPLICIT REAL*8(A-H,O-Z)
  1686:                 PARAMETER (NATM=250)
  1687:                 DIMENSION TAU(3,NTAU),RVEC(4,LATQ)
  1688:                 DIMENSION INEIBR(NATM),RLEN(NATM),ILAT(NATM)
  1689:           C
  1690:                 DATA PI/3.1415926535897932D0/
  1691:                 DATA RMAX/5.D0/
  1692:                 DATA AU/0.5292D0/
  1693:                 IFIN=NTAU
  1694:           C
  1695: +------>        DO 1000 I=1,IFIN
  1696: |                 X=TAU(1,I)
  1697: |                 Y=TAU(2,I)
  1698: |                 Z=TAU(3,I)
  1699: |                 ICONT=0
  1700: |+----->          DO 2000 J=1,NTAU
  1701: ||+---->          DO 2050 M=1,NLV
  1702: |||                 XX=TAU(1,J)+RVEC(1,M)
  1703: |||                 YY=TAU(2,J)+RVEC(2,M)
  1704: |||                 ZZ=TAU(3,J)+RVEC(3,M)
  1705: |||                 XXX=XX-X
  1706: |||                 YYY=YY-Y
  1707: |||                 ZZZ=ZZ-Z
  1708: |||                 R1= XXX*XXX + YYY*YYY + ZZZ*ZZZ
  1709: |||                 IF(I.NE.J.AND.R1.LT.RMAX*RMAX)THEN
  1710: |||                   ICONT=ICONT+1
  1711: |||                   INEIBR(ICONT)=J
  1712: |||                   ILAT(ICONT)=M
  1713: |||                   RLEN(ICONT)=DSQRT(R1)
  1714: |||                 ENDIF
  1715: |||                 IF(ICONT.GT.NATM) STOP 'NATM.LT.ICONT'
  1716: ||+----    2050   CONTINUE
  1717: |+-----    2000   CONTINUE
  1718: |                 WRITE(6,2600) I,ICONT
  1719: |          2600   FORMAT(1H , I5,' -TH ATOM HAS ',I5, ' NEAR ATOMS')
  1720: |+----->          DO 2500 J=1,ICONT
  1721: ||                  K=INEIBR(J)
  1722: ||                  XXX=TAU(1,K)-X  + RVEC(1,ILAT(J))
  1723: ||                  YYY=TAU(2,K)-Y  + RVEC(2,ILAT(J))
  1724: ||                  ZZZ=TAU(3,K)-Z  + RVEC(3,ILAT(J))
  1725: ||                  R1=RLEN(J)*AU
  1726: ||                  WRITE(6,2700) INEIBR(J),RLEN(J),R1,XXX,YYY,ZZZ
  1727: ||         2700     FORMAT(1H ,I5,' -ATOM:  ',2E18.8, ' ( ',3E15.5,')' )
  1728: |+-----    2500   CONTINUE
  1729: |         C
  1730: |+----->          DO 3000 J=1,ICONT
  1731: ||+---->            DO 3100 K=J+1,ICONT
  1732: |||                   L=INEIBR(J)
  1733: |||                   M=INEIBR(K)
  1734: |||                   X1=TAU(1,L)-X + RVEC(1,ILAT(J))
  1735: |||                   Y1=TAU(2,L)-Y + RVEC(2,ILAT(J))
  1736: |||                   Z1=TAU(3,L)-Z + RVEC(3,ILAT(J))
  1737: |||                   X2=TAU(1,M)-X + RVEC(1,ILAT(K))
  1738: |||                   Y2=TAU(2,M)-Y + RVEC(2,ILAT(K))
  1739: |||                   Z2=TAU(3,M)-Z + RVEC(3,ILAT(K))
  1740: |||                   R1=X1*X2+Y1*Y2+Z1*Z2
  1741: |||                   ANGLE=ACOS(R1/RLEN(J)/RLEN(K))*180.D0/PI
  1742: |||                   WRITE(6,3500) L,M,ANGLE
  1743: |||        3500       FORMAT(1H ,'ANGLE BETWEEN ',I5,',',I5, ':  ',F15.5)
  1744: ||+----    3100     CONTINUE
  1745: |+-----    3000   CONTINUE
  1746: +------    1000 CONTINUE
  1747:                 RETURN
  1748:                 END


NEC Fortran Compiler (3.4.2) for Vector Engine   Thu Jul 28 08:27:24 2022
FILE NAME: lib4_ASL_2_check_Vext_SXACE.f

PROCEDURE NAME: GGEN
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

  1875:                 SUBROUTINE GGEN(A,A1,A2,A3,B1,B2,B3,NRX,NRY,NRZ,NXYZ,
  1876:                &                NG,NGQ,G,I2G,GCUT,GG,I2GG,INDX)
  1877:           C
  1878:           C   GENERATES THE RECIPROCAL LATTICE VECTORS WITH LENGTH SQUARED
  1879:           C   LESS THAN GCUT, AND RETURNS THEM IN ORDER OF INCREASING LENGTH.
  1880:           C      G=I*B1+J*B2+K*B3,
  1881:           C   WHERE B1,B2,B3 ARE THE VECTORS DEFINING THE RECIPROCAL LATTICE,
  1882:           C   THE G'S ARE IN UNITS OF 2PI/A, WHERE A IS THE LATTICE CONSTANT.
  1883:           C   (I.E. TRUE G IS OBTAINED BY MULTIPLYING THE G'S WITH 2PAI/A.)
  1884:           C                                   (1990-04-12) OSAMU SUGINO
  1885:           C   QUICK SORT VERSION              (1991-02-13) OSAMU SUGINO
  1886:           C   SLAVE SUBROUTINE:RECIP
  1887:           C   INPUT:A?(3), LATTICE VECTOR
  1888:           C   OUTPUT:G(NG), RECIPROCAL LATTICE VECTORS
  1889:           C
  1890:                 IMPLICIT REAL*8 (A-H,O-Z)
  1891:                 include 'mpif.h'
  1892:                 REAL*8 A1(3),A2(3),A3(3),B1(3),B2(3),B3(3),T(4)
  1893:                 DIMENSION I2G(NGQ),G(4,NGQ)
  1894:                 DIMENSION I2GG(NGQ),GG(4,NGQ),INDX(NGQ)
  1895:                 INTEGER TNRM1,TNRM2,TNRM3
  1896:           cc
  1897:                 call MPI_COMM_RANK(MPI_COMM_WORLD,my_rank,ierr)
  1898:           ccc
  1899: *------>        if (my_rank.eq.0 ) WRITE(6,3001) (A1(I),A2(I),A3(I),I=1,3)
  1900:            3001 FORMAT(' A-VECTORS'/,3(' ',3F15.7/))
  1901:                 CALL RECIPS(A,A1,A2,A3,B1,B2,B3)
  1902: *------>        if (my_rank.eq.0 ) WRITE(6,3002) (B1(I),B2(I),B3(I),I=1,3)
  1903:            3002 FORMAT(' B-VECTORS'/,3(' ',3F15.7/))
  1904:                 NG=1
  1905:                 IG=1
  1906:                 IMAX=0
  1907:                 JMAX=0
  1908:                 KMAX=0
  1909:           c      TNRM1=2*NRX-1
  1910:           c      TNRM2=2*NRY-1
  1911:           c      TNRM3=2*NRZ-1
  1912:                 TNRM1=NRX
  1913:                 TNRM2=NRY
  1914:                 TNRM3=NRZ
  1915:           c ***  check FFT grids !!!
  1916:                 if ( mod( nrx,2).ne.1 ) then
  1917:                  write(6,*)' NRX should be odd number !! STOPPING'
  1918:                  stop
  1919:                 elseif ( mod(nry,2).ne.1 ) then
  1920:                  write(6,*)' NRY should be odd number !! STOPPING'
  1921:                  stop
  1922:                 elseif ( mod(nrz,2).ne.1 ) then
  1923:                  write(6,*)' NRZ should be odd number !! STOPPING'
  1924:                  stop
  1925:                 endif
  1926:           c
  1927: +------>        DO 10 I1=0,TNRM1-1
  1928: |         c      I=I1-NRX
  1929: |               I=I1-NRX/2
  1930: |+----->        DO 10 J1=0,TNRM2-1
  1931: ||        c      J=J1-NRY
  1932: ||              J=J1-NRY/2
  1933: ||+---->        DO 10 K1=0,TNRM3-1
  1934: |||       c      K=K1-NRZ
  1935: |||             K=K1-NRZ/2
  1936: |||             G2=0.D0
  1937: |||*--->        DO 5 IR=1,3
  1938: ||||            T(IR)=DBLE(I)*B1(IR)+DBLE(J)*B2(IR)+DBLE(K)*B3(IR)
  1939: |||*---       5 G2=G2+T(IR)*T(IR)
  1940: |||       cccc      IF(G2.GT.GCUT) GO TO 10
  1941: |||             IF(ABS(I).GT.IMAX) IMAX=ABS(I)
  1942: |||             IF(ABS(J).GT.JMAX) JMAX=ABS(J)
  1943: |||             IF(ABS(K).GT.KMAX) KMAX=ABS(K)
  1944: |||*--->        DO 6 IR=1,3
  1945: ||||      c    6 GG(IR,NG)=T(IR)
  1946: ||||      c      GG(4,NG)=G2
  1947: |||*---       6 GG(IR,IG)=T(IR)
  1948: |||             GG(4,IG)=G2
  1949: |||             N1=I+1
  1950: |||             IF(I.LT.0) N1=N1+NRX
  1951: |||             N2=J+1
  1952: |||             IF(J.LT.0) N2=N2+NRY
  1953: |||             N3=K+1
  1954: |||             IF(K.LT.0) N3=N3+NRZ
  1955: |||       c      I2GG(NG)=N1+(N2-1)*NRX+(N3-1)*NRX*NRY
  1956: |||             I2GG(IG)=N1+(N2-1)*NRX+(N3-1)*NRX*NRY
  1957: |||       c ***
  1958: |||       c      IF ( G2.LE.GCUT ) NG=NG+1
  1959: |||             NG=NG+1
  1960: |||             IG=IG+1
  1961: |||             IF(NG.GT.NGQ+1) GO TO 100
  1962: ||+----      10 CONTINUE
  1963:                 NG=NG-1
  1964:                 IG=IG-1
  1965:                 if ( my_rank.eq.0 ) then
  1966:                 WRITE(6,130) GCUT,NG,NXYZ*4.0*3.141593/3.0/8.0
  1967:             130 FORMAT(' GCUT=',F15.7,' NG=',I8,' NG EFFICIENT=',F15.7)
  1968:                 WRITE(6,*) ' IMAX=',IMAX,' JMAX=',JMAX,' KMAX=',KMAX
  1969:                 endif
  1970:           C
  1971:           C   REORDER THE G'S IN ORDER OF INCREASING MAGNITUDE.
  1972:           c      CALL INDEXX(NG,GG,INDX)
  1973:           c      DO 20 IG=1,NG
  1974:                 CALL INDEXX(NXYZ,GG,INDX)
  1975: V------>        DO 20 IG=1,NXYZ
  1976: |       G       G(1,IG)=GG(1,INDX(IG))
  1977: |       G       G(2,IG)=GG(2,INDX(IG))
  1978: |       G       G(3,IG)=GG(3,INDX(IG))
  1979: |       G       G(4,IG)=GG(4,INDX(IG))
  1980: |       G       I2G(IG)=I2GG(INDX(IG))
  1981: V------      20 CONTINUE
  1982:           c ***  temp check
  1983:           c      write(6,*)' GGEN ! NG = ',NG,' IG = ',ig
  1984:           c      write(6,*)' 1 to NG '
  1985:           c      write(6,*)( G(4,i),i=1,ng,100 )
  1986:           c      write(6,*)' beyod NG '
  1987:           c      write(6,*)( G(4,i),i=ng+1,ig,500 )
  1988:           c ***  temp check : end
  1989:                 RETURN
  1990:             100 WRITE(6,110) GCUT,NGQ
  1991:             110 FORMAT(' GCUT=',1PE12.4,' IS TOO BIG. STOPPING',I9)
  1992:                 STOP
  1993:                 END


NEC Fortran Compiler (3.4.2) for Vector Engine   Thu Jul 28 08:27:24 2022
FILE NAME: lib4_ASL_2_check_Vext_SXACE.f

PROCEDURE NAME: INDEXX
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

  1994:                 SUBROUTINE INDEXX(N,ARRIN,INDX)
  1995:                 IMPLICIT REAL*8(A-H,O-Z)
  1996:                 DIMENSION ARRIN(4,N),INDX(N)
  1997: V------>        DO 11 J=1,N
  1998: V------      11 INDX(J)=J
  1999:                 L=N/2+1
  2000:                 IR=N
  2001:              10 CONTINUE
  2002:                 IF(L.GT.1) THEN
  2003:                    L=L-1
  2004:                    INDXT=INDX(L)
  2005:                    Q=ARRIN(4,INDXT)
  2006:                 ELSE
  2007:                    INDXT=INDX(IR)
  2008:                    Q=ARRIN(4,INDXT)
  2009:                    INDX(IR)=INDX(1)
  2010:                    IR=IR-1
  2011:                    IF(IR.EQ.1) THEN
  2012:                       INDX(1)=INDXT
  2013:                       RETURN
  2014:                    ENDIF
  2015:                 ENDIF
  2016:                 I=L
  2017:                 J=L+L
  2018:              20 IF(J.LE.IR) THEN
  2019:                    IF(J.LT.IR) THEN
  2020:                       IF(ARRIN(4,INDX(J)).LT.ARRIN(4,INDX(J+1))) J=J+1
  2021:                    ENDIF
  2022:                    IF(Q.LT.ARRIN(4,INDX(J))) THEN
  2023:                       INDX(I)=INDX(J)
  2024:                       I=J
  2025:                       J=J+J
  2026:                    ELSE
  2027:                       J=IR+1
  2028:                    ENDIF
  2029:                    GOTO20
  2030:                 ENDIF
  2031:                 INDX(I)=INDXT
  2032:                 GOTO 10
  2033:                 END


NEC Fortran Compiler (3.4.2) for Vector Engine   Thu Jul 28 08:27:24 2022
FILE NAME: lib4_ASL_2_check_Vext_SXACE.f

PROCEDURE NAME: LVGEN
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

  2113:                 SUBROUTINE LVGEN(A1,A2,A3,LATQ,NLV,RCUT,R,RR,NTOT)
  2114:           C
  2115:           C   GENERATES THE LATTICE VECTORS WITH LENGTH SQUARED
  2116:           C   LESS THAN RCUT, AND RETURNS THEM IN ORDER OF INCREASING LENGTH.
  2117:           C      R=I*A1+J*A2+K*A3,
  2118:           C   WHERE A1,A2,A3 ARE THE VECTORS DEFINING THE DIRECT LATTICE.
  2119:           C   THE R'S ARE IN ATOMIC UNITS.
  2120:           C
  2121:                 IMPLICIT REAL*8 (A-H,O-Z)
  2122:                 include 'mpif.h'
  2123:                 REAL*8 A1(3),A2(3),A3(3),T(4)
  2124:                 DIMENSION R(4,LATQ),RR(LATQ),NTOT(LATQ)
  2125:                 INTEGER TNRM1
  2126:                 DATA NR/15/
  2127:           c
  2128:                 call MPI_COMM_RANK(MPI_COMM_WORLD,my_rank,ierr)
  2129:           c
  2130:                 NLV=1
  2131:                 TNRM1=2*NR-1
  2132: +------>        DO 10 I1=1,TNRM1
  2133: |               I=I1-NR
  2134: |+----->        DO 10 J1=1,TNRM1
  2135: ||              J=J1-NR
  2136: ||+---->        DO 10 K1=1,TNRM1
  2137: |||             K=K1-NR
  2138: |||             R2=0.D0
  2139: |||*--->        DO 5 IR=1,3
  2140: ||||            T(IR)=DBLE(I)*A1(IR)+DBLE(J)*A2(IR)+DBLE(K)*A3(IR)
  2141: |||*---       5 R2=R2+T(IR)*T(IR)
  2142: |||             IF(R2.GT.RCUT) GO TO 10
  2143: |||*--->        DO 6 IR=1,3
  2144: |||*---       6 R(IR,NLV)=T(IR)
  2145: |||             R(4,NLV)=R2
  2146: |||             NLV=NLV+1
  2147: |||             IF(NLV.GT.LATQ) GO TO 100
  2148: ||+----      10 CONTINUE
  2149:                 NLV=NLV-1
  2150:           C   REORDER THE R'S IN ORDER OF INCREASING MAGNITUDE.
  2151: +------>        DO 20 IV=1,NLV
  2152: |+----->        DO 20 JV=IV,NLV
  2153: ||              IF(R(4,JV).GE.R(4,IV)) GO TO 20
  2154: ||*---->        DO 15 IR=1,4
  2155: |||             Q=R(IR,IV)
  2156: |||             R(IR,IV)=R(IR,JV)
  2157: ||*----      15 R(IR,JV)=Q
  2158: |+-----      20 CONTINUE
  2159:           C*    PRINT SHELL INFORMATION
  2160:                 IND=1
  2161:                 II=1
  2162:                 RR(1)=R(4,1)
  2163: +------>        DO 50 I=2,NLV
  2164: |               NTOT(IND)=I-II
  2165: |               IF(ABS(R(4,I)-R(4,II)).LT.0.001) GO TO 50
  2166: |         C
  2167: |               IND=IND+1
  2168: |               RR(IND)=R(4,I)
  2169: |               II=I
  2170: +------   50    CONTINUE
  2171:                 NTOT(IND)=NLV+1-II
  2172:                 if ( my_rank.eq.0 ) then
  2173: +------>        DO 60 I=1,IND
  2174: +------      60 PRINT 200,I,RR(I),NTOT(I)
  2175:                 endif
  2176:           200   FORMAT(10X,'    SHELL NO.',I4,1X,' LENGTH SQUARED',1X,F9.3,2X,
  2177:                1   'NO. OF VECTS.',I4)
  2178:                 RETURN
  2179:             100 if ( my_rank.eq.0 ) WRITE(6,110) RCUT, NLV, LATQ
  2180:             110 FORMAT(' RCUT=',1PE12.4,' IS TOO BIG.  NLV LATQ = ',2I5)
  2181:                 STOP
  2182:                 END


NEC Fortran Compiler (3.4.2) for Vector Engine   Thu Jul 28 08:27:24 2022
FILE NAME: lib4_ASL_2_check_Vext_SXACE.f

PROCEDURE NAME: ESORT
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

  2185:                 SUBROUTINE ESORT(N,ARRIN,INDX)
  2186:                 IMPLICIT REAL*8(A-H,O-Z)
  2187:                 DIMENSION ARRIN(N),INDX(N)
  2188: V------>        DO 11 J=1,N
  2189: V------      11 INDX(J)=J
  2190:                 L=N/2+1
  2191:                 IR=N
  2192:              10 CONTINUE
  2193:                 IF(L.GT.1) THEN
  2194:                    L=L-1
  2195:                    INDXT=INDX(L)
  2196:                    Q=ARRIN(INDXT)
  2197:                 ELSE
  2198:                    INDXT=INDX(IR)
  2199:                    Q=ARRIN(INDXT)
  2200:                    INDX(IR)=INDX(1)
  2201:                    IR=IR-1
  2202:                    IF(IR.EQ.1) THEN
  2203:                       INDX(1)=INDXT
  2204:                       RETURN
  2205:                    ENDIF
  2206:                 ENDIF
  2207:                 I=L
  2208:                 J=L+L
  2209:              20 IF(J.LE.IR) THEN
  2210:                    IF(J.LT.IR) THEN
  2211:                       IF(ARRIN(INDX(J)).LT.ARRIN(INDX(J+1))) J=J+1
  2212:                    ENDIF
  2213:                    IF(Q.LT.ARRIN(INDX(J))) THEN
  2214:                       INDX(I)=INDX(J)
  2215:                       I=J
  2216:                       J=J+J
  2217:                    ELSE
  2218:                       J=IR+1
  2219:                    ENDIF
  2220:                    GOTO20
  2221:                 ENDIF
  2222:                 INDX(I)=INDXT
  2223:                 GOTO 10
  2224:                 END


NEC Fortran Compiler (3.4.2) for Vector Engine   Thu Jul 28 08:27:24 2022
FILE NAME: lib4_ASL_2_check_Vext_SXACE.f

PROCEDURE NAME: LVGENX
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

  2233:                 SUBROUTINE LVGENX(A1,A2,A3,S,NROT,RKK,KG,KZ,NNK,NKG)
  2234:                 PARAMETER(LATQ=50)
  2235:                 IMPLICIT REAL*8(A-H,O-Z)
  2236:                 include 'mpif.h'
  2237:                 DIMENSION A1(3),A2(3),A3(3),SP(3,3),KG(3,LATQ),KZ(3,LATQ,48)
  2238:                &         ,NNK(LATQ),RKK(LATQ), A3WK(3)
  2239:                 INTEGER*4 S(3,3,48)
  2240:                 call MPI_COMM_RANK(MPI_COMM_WORLD,my_rank,ierr)
  2241:                 if ( my_rank.eq.0 ) write(6,*) ' in sub. LVGENX !!'
  2242:                 if ( my_rank.eq.0 ) READ(5,*) QFR
  2243:                 call MPI_BCAST(QFR,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
  2244:                 if ( my_rank.eq.0 ) write(6,*) ' QFR has been BCASTed!'
  2245:           CARE * TEMP:  FOR REMOVING LATTICE VECTORS IN A3 DIRECTION
  2246: *------>            DO 1 K = 1, 3
  2247: *------       1     A3WK(K) =           A3(K)
  2248:           CC  1     A3WK(K) = 3.0D+00 * A3(K)
  2249:           C ***         NORMALLY, THE FOLLOWING A3WK SHOULD BE REPLACED BY A3.
  2250:                     CALL SRPGEN(A1,A2,A3WK,SP)
  2251:           C ***   TEMP END
  2252:           c      CALL RARR2(SP,S,NROT,1,QFR,1.0D-12,1,RKK,KG,KZ,NNK,NKG)
  2253:                 CALL RARR3(SP,S,NROT,1,QFR,1.0D-12,1,RKK,KG,KZ,NNK,NKG)
  2254:           c      if ( my_rank.eq.0 ) write(6,*) ' RARR3 has been done!'
  2255:           cc      write(6,*)'my_rank=',my_rank,'  RARR3 has been done!'
  2256:                 RETURN
  2257:                 END


NEC Fortran Compiler (3.4.2) for Vector Engine   Thu Jul 28 08:27:24 2022
FILE NAME: lib4_ASL_2_check_Vext_SXACE.f

PROCEDURE NAME: SRPGEN
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

  2258:                 SUBROUTINE SRPGEN(A1,A2,A3,SP)
  2259:                 IMPLICIT REAL*8(A-H,O-Z)
  2260:                 DIMENSION A1(3),A2(3),A3(3),SP(3,3)
  2261:                 SP(1,2)=A1(1)*A2(1)+A1(2)*A2(2)+A1(3)*A2(3)
  2262:                 SP(1,3)=A1(1)*A3(1)+A1(2)*A3(2)+A1(3)*A3(3)
  2263:                 SP(2,3)=A2(1)*A3(1)+A2(2)*A3(2)+A2(3)*A3(3)
  2264:                 SP(1,1)=A1(1)*A1(1)+A1(2)*A1(2)+A1(3)*A1(3)
  2265:                 SP(2,2)=A2(1)*A2(1)+A2(2)*A2(2)+A2(3)*A2(3)
  2266:                 SP(3,3)=A3(1)*A3(1)+A3(2)*A3(2)+A3(3)*A3(3)
  2267:                 SP(3,1)=SP(1,3)
  2268:                 SP(2,1)=SP(1,2)
  2269:                 SP(3,2)=SP(2,3)
  2270:                 RETURN
  2271:                 END


NEC Fortran Compiler (3.4.2) for Vector Engine   Thu Jul 28 08:27:24 2022
FILE NAME: lib4_ASL_2_check_Vext_SXACE.f

PROCEDURE NAME: RARR2
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

  2273:                 SUBROUTINE RARR2(SP,RG,NG,INV,QF,EPS,IPRINT,AKK,KG,KZ,NNK,NKG)
  2274:                 IMPLICIT REAL*8(A-H,O-Z)
  2275:                 PARAMETER(LATQ=50)
  2276:                 DIMENSION KG(3,LATQ),AKK(LATQ),SP(3,3),NN(3)
  2277:                &         ,KZ(3,LATQ,48),NNK(LATQ)
  2278:                 INTEGER*4 RG(3,3,48)
  2279:                 REAL*8  AKK,SP
  2280:                 EQUIVALENCE (N1,NN(1)),(N2,NN(2)),(N3,NN(3))
  2281:                 IND=0
  2282:                 QFF=QF*QF
  2283:                 A=SP(3,3)
  2284:                 B0=SP(2,2)*SP(3,3)-SP(2,3)**2
  2285:                 B=B0/A
  2286:                 C=(SP(1,1)*SP(2,2)*SP(3,3)+2.0*SP(2,3)*SP(3,1)*SP(1,2)
  2287:                &  -(SP(1,1)*SP(2,3)**2+SP(2,2)*SP(3,1)**2+SP(3,3)*SP(1,2)**2))/B0
  2288:                 N=0
  2289:                 QN1=-QF/SQRT(C)
  2290:                 N1=QN1
  2291:              20 GK1=N1
  2292:                 SB=-(SP(1,2)*SP(3,3)-SP(1,3)*SP(2,3))*GK1/B0
  2293:                 S=C*GK1*GK1
  2294:                 RS=QFF-S
  2295:                 IF(RS) 65,21,21
  2296:              21 QN2=SB-SQRT(RS/B)
  2297:                 N2=QN2
  2298:                 IF(QN2.GT.0.0) N2=N2+1
  2299:              22 GK2=N2
  2300:                 SA=-(SP(1,3)*GK1+SP(2,3)*GK2)/A
  2301:                 SS=S+B*(GK2-SB)**2
  2302:                 RS=QFF-SS
  2303:                 IF(RS) 64,23,23
  2304:              23 QN3=SA-SQRT(RS/A)
  2305:                 N3=QN3
  2306:                 IF(QN3.GT.0.0) N3=N3+1
  2307:              24 GK3=N3
  2308:                 SSS=SS+A*(GK3-SA)**2
  2309:                 IF(QFF-SSS) 62,25,25
  2310:              25 IF(N) 46,46,26
  2311: V------>     26 DO 28 K=1,NKG
  2312: |               IF(AKK(K)-(SSS-EPS)) 28,32,32
  2313: V------      28 CONTINUE
  2314:                 IF(N-LATQ) 30,50,50
  2315:              30 K=N+1
  2316:                 GO TO 48
  2317:              32 IF(AKK(K)-(SSS+EPS)) 52,52,34
  2318:              34 IF(N-LATQ) 38,36,36
  2319:              36 IF(NKG-K) 48,48,40
  2320:              40 KM=K+1
  2321:                 GO TO 42
  2322:              38 KM=K
  2323: V------>     42 DO 44 KK=KM,NKG
  2324: |               KS=NKG-KK+K
  2325: |               AKK(KS+1)=AKK(KS)
  2326: |*----->        DO 41 J=1,3
  2327: |*-----      41 KG(J,KS+1)=KG(J,KS)
  2328: V------      44 CONTINUE
  2329:                 GO TO 48
  2330:              46 K=1
  2331:              48 AKK(K)=SSS
  2332: *------>        DO 49 I=1,3
  2333: *------      49 KG(I,K)=NN(I)
  2334:              50 N=N+1
  2335:                 NKG=MIN0(N,LATQ)
  2336:                 GO TO 60
  2337: +------>     52 DO 54 IV=1,INV+1
  2338: |+----->        DO 54 IG=1,NG
  2339: ||*---->        DO 55 I=1,3
  2340: |||             IS=0
  2341: |||*--->        DO 56 M=1,3
  2342: |||*---      56 IS=IS+RG(M,I,IG)*KG(M,K)
  2343: |||             IF( IV.EQ.2) IS=-IS
  2344: |||             IF(IS-NN(I)) 54,55,54
  2345: ||*----      55 CONTINUE
  2346: ||              GO TO 60
  2347: |+-----      54 CONTINUE
  2348:                 IF(K.GE.LATQ) GO TO 50
  2349:                 K=K+1
  2350:                 IF(K.GT.NKG) GO TO 48
  2351:                 IF(AKK(K)-(SSS+EPS)) 52,52,34
  2352:              60 N3=N3+1
  2353:                 GO TO 24
  2354:              62 N2=N2+1
  2355:                 GO TO 22
  2356:              64 N1=N1+1
  2357:                 GO TO 20
  2358:              65 CONTINUE
  2359:                 IF(N.GT.NKG) IND=-1
  2360:           C
  2361:                 WRITE(6,6000) NKG, IND
  2362:            6000 FORMAT(/8X,
  2363:                &'  **** RARR2: NEXPND = ',I4,' IND = ',I2,' SHOULD BE 0')
  2364:           C
  2365:                 IF(IPRINT.NE.0) WRITE(6,100) N
  2366:             100 FORMAT(8X,
  2367:                &'              N = ',I3,'   NO  KR1 KR2 KR3    ADR ')
  2368:                 IF(IPRINT) 80,88,80
  2369: +------>     80 DO 82 KK=1,NKG
  2370: |*----->        WRITE(6,2000) KK,(KG(I,KK),I=1,3),AKK(KK)
  2371: |          2000 FORMAT(31X,I3,2X,3I3,2X,D13.5)
  2372: +------      82 CONTINUE
  2373:           CC
  2374: +------>     88 DO 71 KK=1,NKG
  2375: |               KS=1
  2376: |               KZ(1,KK,1)=KG(1,KK)
  2377: |               KZ(2,KK,1)=KG(2,KK)
  2378: |               KZ(3,KK,1)=KG(3,KK)
  2379: |+----->        DO 72 IG=1,NG
  2380: ||*---->        DO 72 IW=1,-1,-2
  2381: |||             KK1=RG(1,1,IG)*KG(1,KK)+RG(2,1,IG)*KG(2,KK)+RG(3,1,IG)*KG(3,KK)
  2382: |||             KK2=RG(1,2,IG)*KG(1,KK)+RG(2,2,IG)*KG(2,KK)+RG(3,2,IG)*KG(3,KK)
  2383: |||             KK3=RG(1,3,IG)*KG(1,KK)+RG(2,3,IG)*KG(2,KK)+RG(3,3,IG)*KG(3,KK)
  2384: |||             KK1=KK1*IW
  2385: |||             KK2=KK2*IW
  2386: |||             KK3=KK3*IW
  2387: |||V--->        DO 73 KX=1,KS
  2388: ||||            IF((KK1.EQ.KZ(1,KK,KX)).AND.(KK2.EQ.KZ(2,KK,KX)).AND.
  2389: ||||           &   (KK3.EQ.KZ(3,KK,KX))) GO TO 72
  2390: |||V---      73 CONTINUE
  2391: |||             KS=KS+1
  2392: |||             KZ(1,KK,KS)=KK1
  2393: |||             KZ(2,KK,KS)=KK2
  2394: |||             KZ(3,KK,KS)=KK3
  2395: ||*----      72 CONTINUE
  2396: |               NNK(KK)=KS
  2397: +------      71 CONTINUE
  2398:           CCC   DO 74 KK=1,NKG
  2399:           C     WRITE(6,91) KK,NNK(KK)
  2400:           C     DO 75 KI=1,NNK(KK)
  2401:           C     WRITE(6,92) KI,(KZ(II,KK,KI),II=1,3)
  2402:           C  75 CONTINUE
  2403:           C  74 CONTINUE
  2404:           C  91 FORMAT(1H ,I5,I10)
  2405:           CC 92 FORMAT(1H ,I3,15X,3I4)
  2406:           C     WRITE(37) KG,NKG
  2407:           C     WRITE(28) KZ,NNK,NKG
  2408:                 RETURN
  2409:                 END


NEC Fortran Compiler (3.4.2) for Vector Engine   Thu Jul 28 08:27:24 2022
FILE NAME: lib4_ASL_2_check_Vext_SXACE.f

PROCEDURE NAME: MESHK
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

  2416:                 SUBROUTINE MESHK(RG,NG,NS,NI,KR,NRF,MM,RCO,JDR,SK,WK,NJD,CCO,
  2417:                &                 NDX, NDY, NDZ )
  2418:                 IMPLICIT INTEGER(A-Z)
  2419:                 include 'mpif.h'
  2420:                 PARAMETER(NAS=72, LATQ=144,NARF=LATQ)
  2421:                 PARAMETER(NAD=72 )
  2422:                 REAL*8 SK,WK,SS,CCO,PAI,RCO
  2423:           CCC   REAL*8 SS1,SS2,SS3
  2424:                 DIMENSION NJD(NAS),CCO(-NAD:NAD)
  2425:                 DIMENSION SK(3,NAS),WK(NAS),KR(3,NARF)
  2426:                 DIMENSION MM(3,10000),RCO(NAS,NARF),JDR(48,NAS)
  2427:                 INTEGER*4 RG(3,3,48)
  2428:           c
  2429:                 call MPI_COMM_RANK(MPI_COMM_WORLD,my_rank,ierr)
  2430:           c
  2431:                 PAI=4.D0*ATAN(1.D0)
  2432:           C
  2433:           CCC   REWIND 63
  2434:           
  2435:                 if ( my_rank.eq.0 ) then
  2436:                 READ(5,*) N
  2437:                 endif
  2438:                 call MPI_BCAST(N,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
  2439:           c *** temp check
  2440:           c      do icpu=0,3
  2441:           c       if ( my_rank.eq.icpu ) then
  2442:           c        write(6,*)' in sub MESHK my_rank=',my_rank,' N=',N
  2443:           c       endif
  2444:           c      enddo
  2445:           c *** temp check : end
  2446:                 if ( my_rank.eq.0 ) then
  2447:                 WRITE(6,6600) N
  2448:                 endif
  2449:           c *** temp check
  2450:           c      call MPI_Barrier(MPI_COMM_WORLD,ierr)
  2451:           c *** temp check : end
  2452:            6600 FORMAT(/8X,
  2453:                &'  **** MESHK: N = ',I4)
  2454:           c      IF(NAD .LT. 2*N-1 ) STOP ' N IS TOO BIG... OR CHANGE NAD.'
  2455:                 IF(NAD .LT. 2*N-1 ) then
  2456:                  if ( my_rank.eq.0 ) write(6,*)' N IS TOO BIG... OR CHANGE NAD.'
  2457:                  STOP
  2458:                 ENDIF
  2459:           C
  2460: V------>        DO 98 IH=-(N-1),N-1
  2461: |               CCO(IH)=COS(2.0D0*PAI*DFLOAT(IH)/DFLOAT(N))
  2462: V------      98 CONTINUE
  2463:           c *** temp check
  2464:           c      if ( my_rank.ne.0 ) write(6,*)' my_rank and N ',my_rank,N
  2465:           c      call MPI_Barrier(MPI_COMM_WORLD,ierr)
  2466:           c      miya=13
  2467:           c      if ( miya.eq.13) stop
  2468:           c *** temp check ; end
  2469:                 CALL MESHK2(NG,RG,NS,NI,SK,WK,KR,NRF,MM,RCO,JDR,N,NJD,CCO)
  2470:           c *** temp check
  2471:           c      write(6,*)' my_rank=',my_rank,' MESHK2 finished ! '
  2472:           c      call MPI_Barrier(MPI_COMM_WORLD,ierr)
  2473:           c      miya=13
  2474:           c      if ( miya.eq.13) stop
  2475:           c *** temp check ; end
  2476:           C ****
  2477:                 if ( my_rank.eq.0 ) then
  2478:                 READ(5,*) NDX, NDY, NDZ
  2479:                 endif
  2480:                 call MPI_BCAST(NDX,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
  2481:                 call MPI_BCAST(NDY,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
  2482:                 call MPI_BCAST(NDZ,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
  2483:           C
  2484:                 if ( my_rank.eq.0 ) then
  2485: *------>        WRITE(6,6602) NI, NS, ( IS,( SK(I,IS),I=1,3),WK(IS), IS=1,NS )
  2486:            6602 FORMAT(8X
  2487:                &'          TOTAL NO. OF K IN WHOLE BZ = ',I4/8X
  2488:                &'          TOTAL NO. OF K IN WEDGE    = ',I4/8X
  2489:                &'          NO.            COORDINATES      WK  '/
  2490:                & (18X, I3, 3F8.4, 2X, F8.4)  )
  2491: +------>        DO 99 IS=1,NS
  2492: |+----->        WRITE(6,6604) IS, NJD(IS), ( JDR(IG,IS), IG = 1, NJD(IS) )
  2493: |          6604 FORMAT(8X,
  2494: |              &'          NO. ',I3,' NJD = ',I4,'  JDR(1..NJD) = :'/
  2495: |              & ( 22X,15I3) )
  2496: +------      99 CONTINUE
  2497:                 WRITE(6,6606) NDX, NDY, NDZ
  2498:            6606 FORMAT(8X,'          FOR DOS: NDX NDY NDZ = ',3I4)
  2499:           c **** temp check
  2500:           c      miya=13
  2501:           c      if ( miya.eq.13 ) stop
  2502:           c **** temp check : end
  2503:                 endif  ! end of if my_rank.eq.0 loop
  2504:           c
  2505:                 SS=0.0
  2506: V------>        DO 12 I=1,NS
  2507: V------      12 SS=SS+WK(I)
  2508: V------>        DO 14 I=1,NS
  2509: V------      14 WK(I)=WK(I)/SS
  2510:           CCC   WRITE(6,*) 'SS=',SS
  2511:           CCC   DO 13 KS=1,NS
  2512:           CCC   WRITE(6,3) (SK(I,KS),I=1,3),NRF,(RCO(KS,I),I=1,NRF),WK(KS)
  2513:           CCC13 CONTINUE
  2514:           CCC 3 FORMAT(3X,3F10.5,/,3X,I3,/,1X,20(2X,4F10.5))
  2515:                 RETURN
  2516:                 END


NEC Fortran Compiler (3.4.2) for Vector Engine   Thu Jul 28 08:27:24 2022
FILE NAME: lib4_ASL_2_check_Vext_SXACE.f

PROCEDURE NAME: MESHK2
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

  2519:                 SUBROUTINE MESHK2(NG,RG,NS,NI,SK,WK,KR,NRF,MM,RCO,JDR,N,NJD,CCO)
  2520:           CCC   SUBROUTINE MESHK2(NG,RG,NS,NI,SK,WK,KR,NRF,MM,RCO,JDR,N,NJD)
  2521:                 IMPLICIT INTEGER(A-Z)
  2522:                 include 'mpif.h'
  2523:                 PARAMETER(NAS=72, LATQ=144,NARF=LATQ)
  2524:                 PARAMETER(NAD=72 )
  2525:                 REAL*8 SK,WK,CCO,RCO
  2526:                 DIMENSION NJD(NAS),CCO(-NAD:NAD)
  2527:           C     REAL*8 SK,WK,    RCO,ADX,ADY,ADZ,P2
  2528:           C     DIMENSION NJD(NAS)
  2529:                 DIMENSION PP(3),QQ(3),KK(3),KR(3,NARF),RCO(NAS,NARF),JDR(48,NAS)
  2530:                 DIMENSION SK(3,NAS),WK(NAS),MM(3,10000)
  2531:                 INTEGER*4 RG(3,3,48)
  2532:           C ****  FOR NEW VERSION 'DOS' *****
  2533:           C     DATA P2/6.28318530717958648D0/
  2534:           c
  2535:                 call MPI_COMM_RANK(MPI_COMM_WORLD,my_rank,ierr)
  2536:           c **** temp check
  2537:           c      write(6,*)' my_rank=',my_rank,' N=',N,' in MESHK2'
  2538:                 if ( n.eq.0 )then
  2539:                 write(6,*) 'my_rank=',my_rank,' N=0 !!!'
  2540:                 stop
  2541:                 endif
  2542:           c      call MPI_Barrier(MPI_COMM_WORLD,ierr)
  2543:           c      miya=13
  2544:           c      if ( miya.eq.13 ) then
  2545:           c       stop
  2546:           c      endif
  2547:           c **** temp check : end
  2548:           c
  2549:           C     ADX=P2/DFLOAT(N)
  2550:           C     ADY=P2/DFLOAT(N)
  2551:           C     ADZ=P2/DFLOAT(N)
  2552:           C
  2553: W------>        DO 98 II=1,NAS
  2554: |*----->        DO 98 JJ=1,NARF
  2555: ||              RCO(II,JJ)=0.0D0
  2556: |*-----      98 CONTINUE
  2557:           C
  2558: W------>        DO 99 II=1,NAS
  2559: |               NJD(II)=0
  2560: |V----->        DO 99 JJ=1,48
  2561: |V-----     99  JDR(JJ,II)=0
  2562:           C
  2563:                 NI=1
  2564:                 IS=1
  2565:             100 CONTINUE
  2566:           C
  2567:                 if ( my_rank.eq.0 ) then
  2568:                 READ(5,*) M1,M2,M3
  2569:                 endif
  2570:           c      call MPI_Barrier(MPI_COMM_WORLD,ierr)
  2571:                 call MPI_BCAST(M1,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
  2572:                 call MPI_BCAST(M2,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
  2573:                 call MPI_BCAST(M3,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
  2574:           c **** temp check
  2575:           c      if ( my_rank.ne.0 ) then
  2576:           c      write(6,*)' my_rank=',my_rank,'M1=',M1,' in MESHK2'
  2577:           c      write(6,*)' my_rank=',my_rank,'M2=',M2,' in MESHK2'
  2578:           c      write(6,*)' my_rank=',my_rank,'M3=',M3,' in MESHK2'
  2579:           c      endif
  2580:           c **** temp check : end
  2581:                 IF( M1*M1 + M2*M2 + M3*M3 .EQ.0) GO TO 101
  2582:                 if ( my_rank.eq.0 ) then
  2583:                 READ(5,*) MM1,MM2,MM3
  2584:                 READ(5,*) J1X,J2X,J3X
  2585:                 READ(5,*) J1Y,J2Y,J3Y
  2586:                 READ(5,*) J1Z,J2Z,J3Z
  2587:                 endif
  2588:                 call MPI_BCAST(MM1,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
  2589:                 call MPI_BCAST(MM2,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
  2590:                 call MPI_BCAST(MM3,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
  2591:                 call MPI_BCAST(J1X,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
  2592:                 call MPI_BCAST(J2X,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
  2593:                 call MPI_BCAST(J3X,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
  2594:                 call MPI_BCAST(J1Y,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
  2595:                 call MPI_BCAST(J2Y,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
  2596:                 call MPI_BCAST(J3Y,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
  2597:                 call MPI_BCAST(J1Z,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
  2598:                 call MPI_BCAST(J2Z,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
  2599:                 call MPI_BCAST(J3Z,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
  2600:           c **** temp check
  2601:           c      if ( my_rank.ne.0 ) then
  2602:           c      write(6,*)' my_rank=',my_rank,'MM1=',MM1
  2603:           c      write(6,*)' my_rank=',my_rank,'MM2=',MM2
  2604:           c      write(6,*)' my_rank=',my_rank,'MM3=',MM3
  2605:           c      write(6,*)' my_rank=',my_rank,'J1X=',J1X
  2606:           c      write(6,*)' my_rank=',my_rank,'J2X=',J2X
  2607:           c      write(6,*)' my_rank=',my_rank,'J3X=',J3X
  2608:           c      write(6,*)' my_rank=',my_rank,'J1Y=',J1Y
  2609:           c      write(6,*)' my_rank=',my_rank,'J2Y=',J2Y
  2610:           c      write(6,*)' my_rank=',my_rank,'J3Y=',J3Y
  2611:           c      write(6,*)' my_rank=',my_rank,'J1Z=',J1Z
  2612:           c      write(6,*)' my_rank=',my_rank,'J2Z=',J2Z
  2613:           c      write(6,*)' my_rank=',my_rank,'J3Z=',J3Z
  2614:           cc      miya=13
  2615:           cc      if ( miya.eq.13 ) stop
  2616:           c      endif
  2617:           c **** temp check : end
  2618:           C
  2619:           c ***** temp check
  2620:           c      if ( my_rank.ne.0 ) then
  2621:           c      write(6,*)' my_rank=',my_rank,' N=',N,' in sub MESHK2'
  2622:           cc      miya=13
  2623:           cc      if ( miya.eq.13 ) stop
  2624:           c      endif
  2625:           c ***** temp check : end
  2626:           c
  2627: +------>        DO 1 I1=-M1,M1,MM1
  2628: |+----->        DO 2 I2=-M2,M2,MM2
  2629: ||+---->        DO 3 I3=-M3,M3,MM3
  2630: |||       c                        IF(IS.GT.NAS) STOP ' MESHK2: N IS TOO BIG...'
  2631: |||                               IF(IS.GT.NAS) then
  2632: |||                                if (my_rank.eq.0 )
  2633: |||            &                       write(6,*) ' MESHK2: N IS TOO BIG...'
  2634: |||                                STOP
  2635: |||                               ENDIF
  2636: |||             PP(1)=I1*J1X+I2*J1Y+I3*J1Z
  2637: |||             PP(2)=I1*J2X+I2*J2Y+I3*J2Z
  2638: |||             PP(3)=I1*J3X+I2*J3Y+I3*J3Z
  2639: |||*--->        DO 11 I=1,3
  2640: ||||            QQ(I)=PP(I)
  2641: |||*---      11 CONTINUE
  2642: |||       C
  2643: |||*--->        DO 13 I=1,3
  2644: ||||            PP(I)=MOD(QQ(I),N)
  2645: ||||            IF(PP(I).GT.N/2)  PP(I)=PP(I)-N
  2646: ||||            IF(PP(I).LE.-N/2)  PP(I)=PP(I)+N
  2647: |||*---      13 CONTINUE
  2648: |||       C
  2649: |||             ND=0
  2650: |||             IQRT=0
  2651: |||             IF(NI.NE.1) THEN
  2652: |||V--->        DO 31 I=1,NI-1
  2653: ||||            IF((PP(1).EQ.MM(1,I)).AND.(PP(2).EQ.MM(2,I)).AND.
  2654: ||||           *   (PP(3).EQ.MM(3,I)))  THEN
  2655: ||||            IQRT=1
  2656: ||||            END IF
  2657: |||V---      31 CONTINUE
  2658: |||             IF(IQRT.EQ.1) GO TO 3
  2659: |||             END IF
  2660: |||             NNI=NI
  2661: |||             JIG=0
  2662: |||*--->        DO 21 IW=1,-1,-2
  2663: ||||+-->        DO 21 IG=1,NG
  2664: |||||           IQRT2=0
  2665: |||||           IQRT3=0
  2666: |||||*->        DO 23 I=1,3
  2667: ||||||          KK(I)=0
  2668: ||||||*>        DO 24 J=1,3
  2669: |||||||      24 KK(I)=KK(I)+RG(I,J,IG)*PP(J)*IW
  2670: |||||*-      23 CONTINUE
  2671: |||||*->        DO 25 I=1,3
  2672: ||||||          QQ(I)=MOD(KK(I),N)
  2673: ||||||          IF(QQ(I).GT.N/2) QQ(I)=QQ(I)-N
  2674: ||||||          IF(QQ(I).LE.-N/2) QQ(I)=QQ(I)+N
  2675: |||||*-      25 CONTINUE
  2676: |||||           IF((QQ(1).EQ.PP(1)).AND.(PP(2).EQ.QQ(2)).AND
  2677: |||||          *   .(QQ(3).EQ.PP(3))) THEN
  2678: |||||           ND=ND+1
  2679: |||||           IF((IG.EQ.1).AND.(IW.EQ.1)) THEN
  2680: |||||           JIG=JIG+1
  2681: |||||*->        DO 29 I=1,3
  2682: ||||||          MM(I,NI)=QQ(I)
  2683: |||||*-      29 CONTINUE
  2684: |||||V->        DO 64 KA=1,NRF
  2685: ||||||  G       RCO(IS,KA)=RCO(IS,KA)
  2686: ||||||         &  +CCO(MOD((QQ(1)*KR(1,KA)+QQ(2)*KR(2,KA)+QQ(3)*KR(3,KA)),N))
  2687: |||||V-      64 CONTINUE
  2688: |||||           NJD(IS)=NJD(IS)+1
  2689: |||||           JDR(JIG,IS)=IG
  2690: |||||           ELSE
  2691: |||||           NI=NI-1
  2692: |||||           END IF
  2693: |||||           ELSE
  2694: |||||     C
  2695: |||||     C
  2696: |||||V->        DO 33 I=NNI,NI-1
  2697: ||||||          IF((QQ(1).EQ.MM(1,I)).AND.(QQ(2).EQ.MM(2,I)).AND.
  2698: ||||||         *   (QQ(3).EQ.MM(3,I)))  THEN
  2699: ||||||          IQRT2=1
  2700: ||||||          END IF
  2701: ||||||          IF(((QQ(1).EQ.-MM(1,I)).OR.((QQ(1).EQ.N/2).AND.(MM(1,I).EQ.N/2)))
  2702: ||||||         *   .AND.
  2703: ||||||         *   ((QQ(2).EQ.-MM(2,I)).OR.((QQ(2).EQ.N/2).AND.(MM(2,I).EQ.N/2)))
  2704: ||||||         *   .AND.
  2705: ||||||         *   ((QQ(3).EQ.-MM(3,I)).OR.((QQ(3).EQ.N/2).AND.(MM(3,I).EQ.N/2))))
  2706: ||||||         *  THEN
  2707: ||||||          IQRT3=1
  2708: ||||||          END IF
  2709: |||||V-      33 CONTINUE
  2710: |||||           IF(IQRT2.EQ.1) GO TO 21
  2711: |||||V->        DO 65 KA=1,NRF
  2712: ||||||  G       RCO(IS,KA)=RCO(IS,KA)
  2713: ||||||         &  +CCO(MOD((QQ(1)*KR(1,KA)+QQ(2)*KR(2,KA)+QQ(3)*KR(3,KA)),N))
  2714: |||||V-      65 CONTINUE
  2715: |||||           IF(IQRT3.NE.1) THEN
  2716: |||||           JIG=JIG+1
  2717: |||||           NJD(IS)=NJD(IS)+1
  2718: |||||           JDR(JIG,IS)=IG
  2719: |||||           END IF
  2720: |||||*->        DO 27 I=1,3
  2721: |||||*-      27 MM(I,NI)=QQ(I)
  2722: |||||           END IF
  2723: |||||           NI=NI+1
  2724: ||||+--      21 CONTINUE
  2725: |||       c **** temp check
  2726: |||       c      write(6,*)' my_rank=',my_rank,' ND=',ND
  2727: |||       c **** temp check : end
  2728: |||             WK(IS)=1.0D0/DFLOAT(ND)
  2729: |||       c **** temp check
  2730: |||       c      write(6,*)' my_rank=',my_rank,' N=',N
  2731: |||       c **** temp check : end
  2732: |||*--->        DO 28 I=1,3
  2733: ||||            SK(I,IS)=DFLOAT(PP(I))/DFLOAT(N)
  2734: |||*---      28 CONTINUE
  2735: |||             IS=IS+1
  2736: ||+----       3 CONTINUE
  2737: |+-----       2 CONTINUE
  2738: +------       1 CONTINUE
  2739:                 GO TO 100
  2740:             101 CONTINUE
  2741:                 NI=NI-1
  2742:                 NS=IS-1
  2743:                 RETURN
  2744:                 END


NEC Fortran Compiler (3.4.2) for Vector Engine   Thu Jul 28 08:27:24 2022
FILE NAME: lib4_ASL_2_check_Vext_SXACE.f

PROCEDURE NAME: SMATCHK
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

  2765:                 SUBROUTINE SMATCHK( S, TAU, CTAU, B1, B2, B3, ALAT,
  2766:                &                    NTOT, NTAUQ )
  2767:                 IMPLICIT REAL*8 (A-H, O-Z)
  2768:                 INTEGER  S(3,3,48), IS(3,3)
  2769:                 DIMENSION TAU(3,NTAUQ), CTAU(3,NTAUQ), B1(3), B2(3), B3(3)
  2770:                 DATA  ONE/1.0D+00/, ZERO/0.0D+00/
  2771:           C
  2772:                 WRITE(6,1000)
  2773:            1000 FORMAT(/
  2774:                &'   **** SMATCHK: THIS VERSION DOES NOT RECOGNIZE ATOM TYPE.')
  2775:           C
  2776: +------>        DO 1 I = 1, NTOT
  2777: |+----->        DO 2 J = 1, NTOT
  2778: ||*---->            DO 3 K1 = 1, 3
  2779: |||*--->            DO 3 K2 = 1, 3
  2780: |||*---       3     IS(K1,K2) = 0
  2781: ||*---->            DO 4 K1 = 1, 3
  2782: |||*--->            DO 4 K2 = 1, 3
  2783: |||*---       4     IS(K1,K2) = IS(K1,K2) + S(K1,1,I) * S(1,K2,J)
  2784: ||             &                          + S(K1,2,I) * S(2,K2,J)
  2785: ||             &                          + S(K1,3,I) * S(3,K2,J)
  2786: ||              NUM = 0
  2787: ||V---->            DO 5 JP = 1, NTOT
  2788: |||*--->               DO 6 K1 = 1, 3
  2789: ||||*-->               DO 6 K2 = 1, 3
  2790: |||||                  IF( IS(K1,K2) .NE. S(K1,K2,JP) ) GO TO 5
  2791: ||||*--       6        CONTINUE
  2792: |||                 NUM = NUM + 1
  2793: ||V----       5     CONTINUE
  2794: ||        C
  2795: ||              IF( NUM .NE. 1 ) THEN
  2796: ||*---->           WRITE(6,1010) NUM, I, J,
  2797: ||             &    ( (S(K1,K2,I), K2=1,3), (S(K1,K2,J), K2=1,3),
  2798: ||             &      (IS(K1,K2), K2=1,3),  K1 = 1, 3             )
  2799: ||         1010    FORMAT(10X,'  SOMETHING WRONG FOR S MATRIX: ',
  2800: ||             &              '  NUM I J = ',3I3/
  2801: ||             &   (15X,3I3,3X,3I3,3X,3I3) )
  2802: ||                 STOP
  2803: ||              END IF
  2804: ||        C
  2805: |+-----       2 CONTINUE
  2806: +------       1 CONTINUE
  2807:           C ***
  2808:           C    CHECK OF CLOSED ALGEBRA FOR  MATRICES IS COMPLETED
  2809:           C ***
  2810: V------>        DO 10 IAT = 1, NTAUQ
  2811: |               C1 = (  TAU(1,IAT)*B1(1) + TAU(2,IAT)*B1(2)
  2812: |              &                         + TAU(3,IAT)*B1(3) ) / ALAT
  2813: |               C2 = (  TAU(1,IAT)*B2(1) + TAU(2,IAT)*B2(2)
  2814: |              &                         + TAU(3,IAT)*B2(3) ) / ALAT
  2815: |               C3 = (  TAU(1,IAT)*B3(1) + TAU(2,IAT)*B3(2)
  2816: |              &                         + TAU(3,IAT)*B3(3) ) / ALAT
  2817: |                                           CTAU(1,IAT) = MOD(C1,ONE)
  2818: |               IF( CTAU(1,IAT) .LT. ZERO ) CTAU(1,IAT) = CTAU(1,IAT) + ONE
  2819: |                                           CTAU(2,IAT) = MOD(C2,ONE)
  2820: |               IF( CTAU(2,IAT) .LT. ZERO ) CTAU(2,IAT) = CTAU(2,IAT) + ONE
  2821: |                                           CTAU(3,IAT) = MOD(C3,ONE)
  2822: |               IF( CTAU(3,IAT) .LT. ZERO ) CTAU(3,IAT) = CTAU(3,IAT) + ONE
  2823: V------      10 CONTINUE
  2824:           C
  2825: +------>        DO 12 IAT = 1, NTAUQ
  2826: |+----->        DO 14 IOP = 1, NTOT
  2827: ||              CP1 =  CTAU(1,IAT) * DBLE( S(1,1,IOP) )
  2828: ||             &     + CTAU(2,IAT) * DBLE( S(2,1,IOP) )
  2829: ||             &     + CTAU(3,IAT) * DBLE( S(3,1,IOP) )
  2830: ||              CP2 =  CTAU(1,IAT) * DBLE( S(1,2,IOP) )
  2831: ||             &     + CTAU(2,IAT) * DBLE( S(2,2,IOP) )
  2832: ||             &     + CTAU(3,IAT) * DBLE( S(3,2,IOP) )
  2833: ||              CP3 =  CTAU(1,IAT) * DBLE( S(1,3,IOP) )
  2834: ||             &     + CTAU(2,IAT) * DBLE( S(2,3,IOP) )
  2835: ||             &     + CTAU(3,IAT) * DBLE( S(3,3,IOP) )
  2836: ||                                  C1 = MOD(CP1,ONE)
  2837: ||              IF( C1 .LT. ZERO )  C1 = C1 + ONE
  2838: ||                                  C2 = MOD(CP2,ONE)
  2839: ||              IF( C2 .LT. ZERO )  C2 = C2 + ONE
  2840: ||                                  C3 = MOD(CP3,ONE)
  2841: ||              IF( C3 .LT. ZERO )  C3 = C3 + ONE
  2842: ||        C
  2843: ||                   NUM = 0
  2844: ||V---->          DO 16 JAT = 1, NTAUQ
  2845: |||               IF( ABS(C1-CTAU(1,JAT)) .GT. 0.1D-04 ) GO TO 16
  2846: |||               IF( ABS(C2-CTAU(2,JAT)) .GT. 0.1D-04 ) GO TO 16
  2847: |||               IF( ABS(C3-CTAU(3,JAT)) .GT. 0.1D-04 ) GO TO 16
  2848: |||                  NUM = NUM + 1
  2849: |||       C          WRITE(6,1020) IAT, JAT, IOP
  2850: |||       C1020      FORMAT(10X,3X,I4,'-TH ATOM IS MAPPED ON ',I4,'-TH ATOM ',
  2851: |||       C    &                      ' BY ',I2,'-TH OPERATION.')
  2852: ||V----      16   CONTINUE
  2853: ||        C
  2854: ||              IF(NUM.EQ.0) THEN
  2855: ||              WRITE(6,1040) IOP, IAT, C1, C2, C3
  2856: ||         1040 FORMAT(10X,'   SYMMETRY OPERATION ',I3,' ON ',I4,'TH ATOM NOT',
  2857: ||             &           ' TRANSFORM ANOTHER ATOM.'/
  2858: ||             &       10X,'     C1 C2 C3 = ',3D18.10)
  2859: ||              STOP
  2860: ||              END IF
  2861: ||        C
  2862: |+-----      14 CONTINUE
  2863: +------      12 CONTINUE
  2864:           C
  2865:                 WRITE(6,1100)
  2866:            1100 FORMAT(
  2867:                &'                 NORMAL END')
  2868:           C
  2869:                 RETURN
  2870:                 END


NEC Fortran Compiler (3.4.2) for Vector Engine   Thu Jul 28 08:27:24 2022
FILE NAME: lib4_ASL_2_check_Vext_SXACE.f

PROCEDURE NAME: CRDAN
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

  2872:                 SUBROUTINE CRDAN( IND, TAU, RTAU, NTAUQ )
  2873:                 IMPLICIT REAL*8 (A-H,O-Z)
  2874:                 include 'mpif.h'
  2875:                 DIMENSION  TAU(3,NTAUQ), RTAU(3,NTAUQ)
  2876:                 COMMON /AVEC/  A1(3), A2(3), A3(3), B1(3), B2(3), B3(3)
  2877:                &             , COVA, ALAT
  2878:                 call MPI_COMM_RANK(MPI_COMM_WORLD,my_rank,ierr)
  2879:           C
  2880: V------>        DO 1 I = 1, NTAUQ
  2881: |*----->        DO 1 K = 1, 3
  2882: |*-----       1 RTAU(K,I) = 0.0D+00
  2883: |               DO 2 I = 1, NTAUQ
  2884: |*----->          DO 3 K = 1, 3
  2885: ||                RTAU(1,I) = RTAU(1,I) + B1(K) * TAU(K,I)
  2886: ||                RTAU(2,I) = RTAU(2,I) + B2(K) * TAU(K,I)
  2887: |*-----       3   RTAU(3,I) = RTAU(3,I) + B3(K) * TAU(K,I)
  2888: |*----->          DO 4 K = 1, 3
  2889: |*-----       4   RTAU(K,I) =  RTAU(K,I) / ALAT
  2890: V------       2 CONTINUE
  2891:           C **
  2892:           C        HEXAGONAL ALPHA QUARTZ CASE
  2893:                 IF( IND .EQ. 2 ) THEN
  2894:                   if ( my_rank.eq.0 ) then
  2895:                   WRITE(6,1000)
  2896:            1000   FORMAT(//'     ****** CRDAN:    HEXAGONAL ALPHA QUARTZ')
  2897: +------>          DO 100 I = 1, NTAUQ
  2898: |*----->    100   WRITE(6,1100) I, ( RTAU(K,I), K = 1, 3 )
  2899:            1100   FORMAT(12X,' ATOM ',I4,' RTAU = ',3D13.5)
  2900:                   WRITE(6,*) ' '
  2901:                   endif
  2902:                 ELSE
  2903:                   if ( my_rank.eq.0 ) then
  2904:                   WRITE(6,*) ' IND .NE. 2:  NOT PROGRAMMED IND = ', IND
  2905:                   endif
  2906:                 END IF
  2907:           C
  2908:                 RETURN
  2909:                 END


