NEC Fortran Compiler (3.4.2) for Vector Engine   Thu Jul 28 08:27:28 2022
FILE NAME: rexgenDummy.f

PROCEDURE NAME: REXGEN
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

     2:                 subroutine rexgen(nrx,nry,nrz,nxyz,rext,omega,A1,A2,A3,my_rank)
     3:                 implicit double precision (a-h,o-z)
     4:                 dimension A1(3),A2(3),A3(3)
     5:                 complex*16 rext(nxyz)
     6:           c
     7:           	if ( my_rank.eq.0 ) then
     8:                 write(6,*)' omega=',omega
     9:           	endif
    10:           c
    11:           c      vzlng=40.49999999634389403094128d0  ! in Bohr unit
    12:                 vxlng=A1(1)  ! in Bohr unit
    13:                 vylng=A2(2)  ! in Bohr unit
    14:           	vzlng=A3(3)  ! in Bohr unit
    15:           	if ( my_rank.eq.0 ) then
    16:                 write(6,*)' vzlength = ',vzlng
    17:           	endif
    18:                 dx=vxlng/dfloat(nrx)
    19:                 dy=vylng/dfloat(nry)
    20:           	dz=vzlng/dfloat(nrz)
    21:                 rc=0.5d0/0.529177d0  ! in Bohr unit
    22:           c      rc=1.5d0/0.529177d0  ! in Bohr unit
    23:           c
    24:                 nx0=(nrx-1)/2
    25:                 ny0=(nry-1)/2
    26:                 nz0=(nrz-1)/2
    27: V------>        do 10 ii=1,nxyz
    28: |                rext(ii)=0.d0
    29: |           10  continue
    30: |         c
    31: |         c      lzhlf=(nrz-1)/2
    32: |               dxhlf=0.0d0
    33: |               dyhlf=0.0d0
    34: |         	dzhlf=0.0d0
    35: |         c
    36: |         c        expogi=-0.271535d0    ! E=0.1765VpA
    37: |         c        exnega= 0.271535d0
    38: |         c
    39: |         c        expogi=-0.0015383998615631d0    ! E=0.001VpA
    40: |         c        exnega= 0.0015383998615631d0
    41: |         c
    42: |         c        expogi=-0.015383998615631d0    ! E=0.01VpA
    43: |         c        exnega= 0.015383998615631d0
    44: |         c
    45: |         c        expogi=-0.046151995846893d0    ! E=0.03VpA
    46: |         c        exnega= 0.046151995846893d0
    47: |         c
    48: |         c        expogi=-0.271535d0    ! E=0.321VpA (1x1)
    49: |         c        exnega= 0.271535d0
    50: |         c
    51: |         c        expogi=-0.543070d0    ! E=0.643VpA (1x1)
    52: |         c        exnega= 0.543070d0
    53: |         c        expogi=-0.543070d0*(1.035d0**2)    ! E=0.643VpA (1x1) for GGA lattic
    54: |         c        exnega= 0.543070d0*(1.035d0**2)
    55: |         c
    56: |         c        expogi=-1.08614d0    ! E=0.643VpA (1x2)
    57: |         c        exnega= 1.08614d0
    58: |         c         expogi=-1.08614d0*(1.035d0**2)  ! for GGA lattice constant
    59: |         c         exnega= 1.08614d0*(1.035d0**2)
    60: |                  expogi=0.0  ! for GGA lattice constant
    61: |                  exnega=0.0
    62: |         c *** for dia111 surface Emax=0.03VpA
    63: |         c        expogi=-0.022710272278d0
    64: |         c        exnega= 0.022710272278d0
    65: |         c *** for dia111 surface Emax=0.10VpA
    66: |         c        expogi=-0.075700907593d0
    67: |         c        exnega= 0.075700907593d0
    68: |         c *** for dia111 surface Emax=0.30VpA
    69: |         c        expogi=-0.22710272278d0
    70: |         c        exnega= 0.22710272278d0
    71: |         c
    72: |         c        expogi=-0.15383998615631d0    ! E=0.1VpA
    73: |         c        exnega= 0.15383998615631d0
    74: |         c
    75: |         c        expogi=-1.5383998615631d0    ! E=1.0VpA
    76: |         c        exnega= 1.5383998615631d0
    77: |         c
    78: |         c
    79: |         c ***
    80: |         c	P_pogi=0.48d0*Vxlng
    81: |         c	P_nega=0.52d0*Vxlng
    82: |         c	P_neut=0.5d0*Vxlng
    83: |         c ****
    84: |         	P_pogi=0.48d0*Vzlng
    85: |         	P_nega=0.52d0*Vzlng
    86: |         	P_neut=0.5d0*Vzlng
    87: |         c *** make factor
    88: |         	sum=0
    89: |         	do 90 II=1,nxyz
    90: |         	 K=1+(II-1)/(NRX*NRY)
    91: |                I=II-(K-1)*NRX*NRY
    92: |                J=1+(I-1)/NRX
    93: |                I=I-(J-1)*NRX
    94: |                LX=I-1 + (nrx-1)/2 +1 -nx0
    95: |                LY=J-1 + (nry-1)/2 +1 -ny0
    96: |                LZ=K-1 + (nrz-1)/2 +1 -nz0
    97: |         c	 x=dx*(LX-1)+dxhlf - P_neut
    98: |         c	 XX=(x/rc)**2
    99: |         c	 sum=sum+dexp(-XX)
   100: |         c ***
   101: |         	 z=dz*(Lz-1)+dzhlf - P_neut
   102: |         	 zz=(z/rc)**2
   103: |         	 sum=sum+dexp(-zz)
   104: V------     90	continue
   105:           	sum=sum/dfloat(nxyz)
   106:           	fac=1.d0/(omega*sum)
   107:           	sumpogi=0
   108:           	sumnega=0
   109: V------>  	do 92 II=1,nxyz
   110: |         	 K=1+(II-1)/(NRX*NRY)
   111: |                I=II-(K-1)*NRX*NRY
   112: |                J=1+(I-1)/NRX
   113: |                I=I-(J-1)*NRX
   114: |                LX=I-1 + (nrx-1)/2 +1 -nx0
   115: |                LY=J-1 + (nry-1)/2 +1 -ny0
   116: |                LZ=K-1 + (nrz-1)/2 +1 -nz0
   117: |         c	 x=dx*(LX-1)+dxhlf
   118: |         c	 XX=( (x-P_pogi)/rc)**2
   119: |         c	 sumpogi=sumpogi+expogi*fac*dexp(-XX)
   120: |         c	 x=dx*(LX-1)+dxhlf
   121: |         c	 XX=( (x-P_nega)/rc)**2
   122: |         c	 sumnega=sumnega+exnega*fac*dexp(-XX)
   123: |         c ***
   124: |         	 z=dz*(Lz-1)+dzhlf
   125: |         	 zz=( (z-P_pogi)/rc)**2
   126: |         	 sumpogi=sumpogi+expogi*fac*dexp(-zz)
   127: |         	 z=dz*(Lz-1)+dzhlf
   128: |         	 zz=( (z-P_nega)/rc)**2
   129: |         	 sumnega=sumnega+exnega*fac*dexp(-zz)
   130: V------     92	continue
   131:             	sumpogi=sumpogi/dfloat(nxyz)*omega
   132:           	sumnega=sumnega/dfloat(nxyz)*omega
   133:           	if ( my_rank.eq.0 ) then
   134:           	write(6,*)' Sum of Pogitive extra charge = ',sumpogi
   135:           	write(6,*)' Sum of Negative extra charge = ',sumnega
   136:           	endif
   137:           c
   138: V------>        DO 100 II=1,NXYZ
   139: |                K=1+(II-1)/(NRX*NRY)
   140: |                I=II-(K-1)*NRX*NRY
   141: |                J=1+(I-1)/NRX
   142: |                I=I-(J-1)*NRX
   143: |                LX=I-1 + (nrx-1)/2 +1 -nx0
   144: |                LY=J-1 + (nry-1)/2 +1 -ny0
   145: |                LZ=K-1 + (nrz-1)/2 +1 -nz0
   146: |                x=dx*(LX-1)+dxhlf
   147: |                y=dy*(LY-1)+dyhlf
   148: |         	 z=dz*(LZ-1)+dzhlf
   149: |         c	 xp=( x-P_pogi )/rc
   150: |         c	 xn=( x-P_nega )/rc
   151: |         c      rext(ii)=expogi*fac*dexp(-xp*xp)
   152: |         c     &        +exnega*fac*dexp(-xn*xn)
   153: |         c ***
   154: |         	 zp=( z-P_pogi )/rc
   155: |         	 zn=( z-P_nega )/rc
   156: |               rext(ii)=expogi*fac*dexp(-zp*zp)
   157: |              &        +exnega*fac*dexp(-zn*zn)
   158: |         c *** Gaussian type charge :end
   159: |           100 continue
   160: |               sum=0
   161: |               do ig=1,nxyz
   162: |               sum=sum+dreal( rext(ig) )
   163: V------         enddo
   164:           	sum=sum*omega/dfloat(nxyz)
   165:           	if ( my_rank.eq.0 ) then
   166:                 write(6,*)' total extra charge = ',sum
   167:           	endif
   168:                 return
   169:                 end


