NEC Fortran Compiler (3.4.2) for Vector Engine   Thu Jul 28 08:27:32 2022
FILE NAME: tdep.f

PROCEDURE NAME: TDEP
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

     2:                 subroutine tdep(f,df,t)
     3:                 implicit double precision(a-h,o-z)
     4:           c *** phase shift !!
     5:                 COMMON/PHASE/phshft
     6:                 COMMON/PULSE/t000,tw00,tau00  ! peak, period, width
     7:                 tpi=2*dacos(-1.d0)
     8:           c      tau00=50.0d0  ! in fsec width
     9:                 tau=tau00*100.d0/2.42d0  ! in a.u. of time
    10:           c      t00=200.d0  ! in fsec  peak of time
    11:                 t0=t000*100.d0/2.42d0   ! in a.u. of time
    12:           c        tw00=2.6685d0  !  time frequency
    13:                   tw=tw00*100.d0/2.42d0  ! in a.u. of time
    14:                 omega=tpi/tw
    15:                 tt=(t-t0)/tau
    16:           c **** truly FWHM
    17:                 A=-1.d0/2.d0*dlog(1.d0/2.d0)
    18:                   theta=(t-t0)*omega
    19:                   if (theta.gt.tpi) theta=theta-tpi
    20:                   expt=dexp(-A*tt*tt)
    21:                   dsw=dsin( theta + phshft )
    22:                   dcw=dcos( theta + phshft )
    23:                   f=expt*dsw
    24:                   df=( omega*dcw - 2*A*tt/tau*dsw )*expt
    25:                 return
    26:                 end


