NEC Fortran Compiler (3.4.2) for Vector Engine   Wed Jul  6 14:26:17 2022
FILE NAME: tm_inputs_art.f

PROCEDURE NAME: AINPUT
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

     6:                 SUBROUTINE AINPUT(IOPT,CELLDM,MAXFN,OKSTEP,ZVAL,NBND,
     7:                &                  NFL, NPFL, RCUT,
     8:                &                  GCUT2,GRAT, KCONT,MXBND,dt,ntstep)
     9:                 IMPLICIT REAL*8(A-H,O-Z)
    10:                 include 'mpif.h'
    11:                 DIMENSION IOPT(10,5),CELLDM(6)
    12:                 COMMON/COMFRP/RMIX,TR2,ITCMAX,ITMAX,ITC1,ITC7
    13:                 COMMON/COMINI/MAXG2
    14:                 COMMON/COMFIX/FATM(3,101),NFIX,IFATM(101)
    15:                 COMMON/TMOD/ITMOD
    16:                 COMMON/SUZUKI/IOPTION
    17:                 CHARACTER ATEMP(80)*72,NUL*72,ASAVE(80)*12,
    18:                &          BSAVE(80)*20,A1(72)*1,NAIBU*80
    19:           C
    20:                 call MPI_COMM_RANK(MPI_COMM_WORLD,my_rank,ierr)
    21:           c **** temp check
    22:           c      write(6,*)' my_rank=',my_rank,' sub. AINPUT is working'
    23:           c **** temp check ; end
    24:                 NFIX = 0
    25: +======>        NUL=' '
    26: +------>        DO 2100 I=1,80
    27: |+=====>        ASAVE(I)=' '
    28: |+=====>        BSAVE(I)=' '
    29: |+=====>   2100 ATEMP(I)=' '
    30:                 MAXG2=0
    31:           C****************************************************
    32:           C****************************************************
    33:                 if ( my_rank.eq.0 ) then
    34: +======>        READ(5,1) A1
    35: +======>        WRITE(6,1) A1
    36:                 endif
    37:                 call MPI_Bcast(A1,72,MPI_CHARACTER,0,MPI_COMM_WORLD,ierr)
    38:           c      if ( my_rank.eq.0 ) then
    39:           c      WRITE(6,1) A1
    40:           c      endif
    41:                 I=0
    42: +======>   9000 if ( my_rank.eq.0 ) READ(5,1) A1
    43:                 call MPI_Bcast(A1,72,MPI_CHARACTER,0,MPI_COMM_WORLD,ierr)
    44:               1 FORMAT(72A1)
    45:                 N=1
    46:            9100 IF(A1(N).EQ.'/') GO TO 9200
    47:                 IF(A1(N).EQ.' ') GO TO 9101
    48:           C
    49:           C
    50:                 J=1
    51:                 I=I+1
    52: +======>        ATEMP(I)=A1(N)
    53:            9110 N=N+1
    54:                 IF(A1(N).EQ.'/') GO TO 9200
    55:                 IF(A1(N).EQ.' ') GO TO 9101
    56: +======>        ATEMP(I)=ATEMP(I)(1:J)//A1(N)
    57:                 J=J+1
    58:                 IF(   N .LT. 72) GO TO 9110
    59:            9101 N=N+1
    60:                 IF(   N .LE. 72) GO TO 9100
    61:                                  GO TO 9000
    62:           C***************************************************
    63:           C     MAIN ROUTINE
    64:           C***************************************************
    65:            9200 L=0
    66: +------>        DO 1000 I=1,80
    67: |               IF(ATEMP(I).EQ.NUL) GO TO 201
    68: |               L=L+1
    69: |         C
    70: |         C
    71: |+----->        DO 140 J=72,1,-1
    72: |+-----     140 IF(ATEMP(I)(J:J).NE.' ') GO TO 141
    73: |         C
    74: |         C
    75: |           141 CONTINUE
    76: |               IEQ=INDEX(ATEMP(I),'=')
    77: |               IF(IEQ.EQ.0) THEN
    78: |+=====>           ASAVE(L)=ATEMP(I)(1:J)
    79: |+=====>           BSAVE(L)=ATEMP(I)(13:32)
    80: |               ELSE
    81: |+=====>           ASAVE(L)=ATEMP(I)(1:IEQ-1)
    82: |+=====>           BSAVE(L)=ATEMP(I)(IEQ+1:J)
    83: |               ENDIF
    84: +------    1000 CONTINUE
    85:             201 JSAVE=L
    86:           C
    87:                 if ( my_rank.eq.0 ) WRITE(6,*) ' # OF COMMANDS = ',JSAVE
    88: +------>        DO 220 I=1,JSAVE
    89: |               if (my_rank.eq.0 ) WRITE(6,221) I,ASAVE(I),BSAVE(I)
    90: +------     220 continue
    91:             221 FORMAT(' NO. ',I2,'  COMMAND = ',A12,' OPERATION = ',A20)
    92:           C
    93: +------>        DO 3000 L=1,JSAVE
    94: |               IF(ASAVE(L)(1:2).EQ.'PP') THEN
    95: |                  IF(INDEX(BSAVE(L),'KB').NE.0) THEN
    96: |                     IOPT(1,1)=0
    97: |                     if ( my_rank.eq.0 ) then
    98: |                     WRITE(6,*) ' KLEINMAN BYLANDER PSEUDOPOTENTIAL IS USED '
    99: |                     endif
   100: |                  ENDIF
   101: |                  IF(INDEX(BSAVE(L),'BHS').NE.0) THEN
   102: |                     IOPT(1,1)=1
   103: |                     if ( my_rank.eq.0 ) then
   104: |                     WRITE(6,*) ' BHS TYPE  PSEUDOPOTENTIAL IS USED '
   105: |                     endif
   106: |                  ENDIF
   107: |                  IF(INDEX(BSAVE(L),'DEBUG').NE.0) THEN
   108: |                     IOPT(1,1)=2
   109: |                     if ( my_rank.eq.0 ) then
   110: |                     WRITE(6,*) ' DEBUG KB PSEUDOPOTENTIAL '
   111: |                     endif
   112: |                  ENDIF
   113: |                  IF(INDEX(BSAVE(L),'SOFT').NE.0) THEN
   114: |                     IOPT(5,1)=0
   115: |                     if ( my_rank.eq.0 ) then
   116: |                     WRITE(6,*) ' SOFT PSEUDOPOTENTIAL IS USED '
   117: |                     endif
   118: |                  ENDIF
   119: |                  IF(INDEX(BSAVE(L),'HARD').NE.0) THEN
   120: |                     IOPT(5,1)=1
   121: |                     if ( my_rank.eq.0 ) then
   122: |                     WRITE(6,*) ' HARD PSEUDOPOTENTIAL IS USED '
   123: |                     endif
   124: |                  ENDIF
   125: |                  IF(INDEX(BSAVE(L),'NOND').NE.0) THEN
   126: |                     IOPT(6,1)=1
   127: |                     if ( my_rank.eq.0 ) then
   128: |                     WRITE(6,*) ' D-COMPONENT IS SET ZERO '
   129: |                     endif
   130: |                  ENDIF
   131: |               ELSEIF(ASAVE(L)(1:4).EQ.'DISP') THEN
   132: |                  IOPT(2,1)=1
   133: |                  if ( my_rank.eq.0 ) then
   134: |                  WRITE(6,*) ' BAND DISPERION IS CALCULATED '
   135: |                  endif
   136: |               ELSEIF(ASAVE(L)(1:4).EQ.'FCHK') THEN
   137: |                  IOPT(2,1)=2
   138: |                  if ( my_rank.eq.0 ) then
   139: |                  WRITE(6,*) ' FORCE IS CHECKED '
   140: |                  endif
   141: |               ELSEIF(ASAVE(L)(1:5).EQ.'STEEP') THEN
   142: |                  IOPT(2,1)=3
   143: |                  if ( my_rank.eq.0 ) then
   144: |                  WRITE(6,*) ' STEEPEST DESCENT '
   145: |                  endif
   146: |               ELSEIF(ASAVE(L)(1:5).EQ.'PROJE') THEN
   147: |                  IOPT(2,1)=4
   148: |                  if ( my_rank.eq.0 ) then
   149: |                  WRITE(6,*) ' ORBITAL PROJECTION ON ATOMS'
   150: |                  endif
   151: |               ELSEIF(ASAVE(L)(1:3).EQ.'GGA') THEN
   152: |                  IOPT(8,2)=1
   153: |                  if ( my_rank.eq.0 ) then
   154: |                  WRITE(6,*) ' GGA is adopted'
   155: |                  endif
   156: |               ELSEIF(ASAVE(L)(1:5).EQ.'FFTWF') THEN
   157: |                  IOPT(2,1)=5
   158: |                  if ( my_rank.eq.0 ) then
   159: |                  WRITE(6,*) ' STORE THE NORM OF WFs'
   160: |                  endif
   161: |               ELSEIF(ASAVE(L)(1:4).EQ.'LDOS') THEN
   162: |                  IF(BSAVE(L)(1:3).EQ.'SMK') THEN
   163: |                     IOPT(10,1)=1
   164: |                     if ( my_rank.eq.0 ) then
   165: |                     WRITE(6,*) ' LDOS: K SAMPLING AS IN SCF'
   166: |                     endif
   167: |                  ELSEIF(BSAVE(L)(1:3).EQ.'NWK') THEN
   168: |                     IOPT(10,1)=2
   169: |                     if ( my_rank.eq.0 ) then
   170: |                     WRITE(6,*) ' LDOS: NEW K SAMPLING '
   171: |                     endif
   172: |                  ENDIF
   173: |               ELSEIF(ASAVE(L)(1:2).EQ.'CD') THEN
   174: |                  IF(BSAVE(L)(1:1).EQ.'I') THEN
   175: |                     IOPT(3,1)=0
   176: |                     if ( my_rank.eq.0 ) then
   177: |                     WRITE(6,*) ' CHARGE DENSITY IS CREADTED INTERNALLY '
   178: |                     endif
   179: |                  ELSEIF(BSAVE(L)(1:1).EQ.'R') THEN
   180: |                     IOPT(3,1)=2
   181: |                     if ( my_rank.eq.0 ) then
   182: |                     WRITE(6,*) ' READ PREVIOUS CHARGE DENSITY FROM FILE20 '
   183: |                     endif
   184: |                  ELSEIF(BSAVE(L)(1:1).EQ.'A') THEN
   185: |                     IOPT(3,1)=4
   186: |                     if ( my_rank.eq.0 ) then
   187: |                     WRITE(6,*) ' MAKE CHARGE FROM OVERLAP OF ATOM CHARGE '
   188: |                     endif
   189: |                  ELSEIF(BSAVE(L)(1:1).EQ.'F') THEN
   190: |                     IOPT(3,1)=1
   191: |                     if ( my_rank.eq.0 ) then
   192: |                     WRITE(6,*) ' READ CHARGE DENSITY FROM FILE20 (REAL SPACE)'
   193: |                     endif
   194: |                  ELSE
   195: |                     IOPT(3,1)=3
   196: |                     if ( my_rank.eq.0 ) then
   197: |                     WRITE(6,*) ' CREATE CHARGE DENSITY FROM READ WAVEFUNCTION'
   198: |                     endif
   199: |                  ENDIF
   200: |               ELSEIF(ASAVE(L)(1:2).EQ.'WF') THEN
   201: |                  IF(BSAVE(L)(1:1).EQ.'I') THEN
   202: |                     IOPT(4,1)=0
   203: |                     if ( my_rank.eq.0 ) then
   204: |                     WRITE(6,*) ' WAVEFUNCTION IS CREADTED INTERNALLY '
   205: |                     endif
   206: |                  ELSE
   207: |                     IOPT(4,1)=1
   208: |                   if ( my_rank.eq.0 ) then
   209: |                    WRITE(NAIBU,'(A20)') BSAVE(L)
   210: |                    READ(NAIBU,'(BN,I20)') MXBND
   211: |                   endif
   212: |                   call MPI_Bcast(MXBND,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
   213: |                   if ( my_rank.eq.0 ) then
   214: |                    WRITE(6,*) ' MAX # OF BAND ',MXBND
   215: |                      WRITE(6,*) ' READ PREVIOUS WAVEFUNCTION FROM FILE22 '
   216: |                   endif
   217: |                  ENDIF
   218: |               ELSEIF(ASAVE(L)(1:2).EQ.'CG') THEN
   219: |                     I0 = INDEX(BSAVE(L),'(') + 1
   220: |                     I9 = INDEX(BSAVE(L),')') - 1
   221: |                     I1 = INDEX(BSAVE(L),',')
   222: |                     I2 = INDEX(BSAVE(L)(I1+1:I9),',') + I1
   223: |                     if (my_rank.eq.0 ) then
   224: |                     WRITE(NAIBU,'(A20)') BSAVE(L)(I0:I1-1)
   225: |                     READ(NAIBU,'(BN,I20)') ITC7
   226: |                     endif
   227: |                     call MPI_Bcast(ITC7  ,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
   228: |                     if (my_rank.eq.0 ) then
   229: |                     WRITE(NAIBU,'(A20)') BSAVE(L)(I1+1:I2-1)
   230: |                     READ(NAIBU,'(BN,I20)') ITC1
   231: |                     endif
   232: |                     call MPI_Bcast(ITC1  ,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
   233: |                     if (my_rank.eq.0 ) then
   234: |                     WRITE(NAIBU,'(A20)') BSAVE(L)(I2+1:I9)
   235: |                     READ(NAIBU,'(BN,I20)') ITCMAX
   236: |                     endif
   237: |                     call MPI_Bcast(ITCMAX,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
   238: |                     if (my_rank.eq.0 ) then
   239: |                     WRITE(6,*) ' #CG  STEP IS ',ITC7,ITC1,ITCMAX
   240: |                     endif
   241: |               ELSEIF(ASAVE(L)(1:3).EQ.'SCF') THEN
   242: |                  if (my_rank.eq.0 ) then
   243: |                  WRITE(NAIBU,'(A20)') BSAVE(L)
   244: |                  READ(NAIBU,'(BN,I20)') ITMAX
   245: |                  endif
   246: |                  call MPI_Bcast(ITMAX,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
   247: |                  if (my_rank.eq.0 ) then
   248: |                  WRITE(6,*) ' #SCF STEP IS ',ITMAX
   249: |                  endif
   250: |               ELSEIF(ASAVE(L)(1:6).EQ.'SUZUKI') THEN
   251: |                  if ( my_rank.eq.0 ) then
   252: |                   WRITE(NAIBU,'(A20)') BSAVE(L)
   253: |                   READ(NAIBU,'(BN,I20)') ioption
   254: |                  endif
   255: |                  call MPI_Bcast(ioption,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
   256: |                  if ( ioption.eq.2 ) then
   257: |                    if ( my_rank.eq.0 ) then
   258: |                    write(6,*)' Second order Suzuki-Trotter decomposition!! '
   259: |                    endif
   260: |                  elseif ( ioption.eq.3 ) then
   261: |                    if ( my_rank.eq.0 ) then
   262: |                    write(6,*)' Fourth order Suzuki-Trotter decomposition
   263: |              &  (Ver.1)!! '
   264: |                    endif
   265: |                  elseif ( ioption.eq.4 ) then
   266: |                    if ( my_rank.eq.0 ) then
   267: |                    write(6,*)' Fourth order Suzuki-Trotter decomposition
   268: |              &  (Ver.2)!! '
   269: |                    endif
   270: |                  else
   271: |                    if ( my_rank.eq.0 ) then
   272: |                    write(6,*)' WRONG option for Suzuki-Trotter decompostion'
   273: |                    write(6,*)'    has been assigned !!!  STOPPING '
   274: |                    endif
   275: |                    stop
   276: |                  endif
   277: |               ELSEIF(ASAVE(L)(1:3).EQ.'EXT') THEN
   278: |                  IF(BSAVE(L)(1:3).EQ.'PAN') THEN
   279: |                     IOPT(7,1)=0
   280: |                     if ( my_rank.eq.0 ) then
   281: |                     WRITE(6,*) ' PANDEY EXTRAPOLATION SCHEME (R) IS USED '
   282: |                     endif
   283: |                  ELSEIF(BSAVE(L)(1:3).EQ.'PAG') THEN
   284: |                     IOPT(7,1)=2
   285: |                     if ( my_rank.eq.0 ) then
   286: |                     WRITE(6,*) ' PANDEY EXTRAPOLATION SCHEME (G) IS USED '
   287: |                     endif
   288: |                  ELSEIF(BSAVE(L)(1:3).EQ.'PKB') THEN
   289: |                     IOPT(7,1)=3
   290: |                     if ( my_rank.eq.0 ) then
   291: |                     WRITE(6,*) ' PANDEY-KB EXTRAPOLATION SCHEME IS USED '
   292: |                     endif
   293: |                  ELSEIF(BSAVE(L)(1:3).EQ.'NEX') THEN
   294: |                     IOPT(7,1)=4
   295: |                     if ( my_rank.eq.0 ) then
   296: |                     WRITE(6,*) ' NO EXTRAPOLATION SCHEMES IS USED '
   297: |                     endif
   298: |                  ELSE
   299: |                     IOPT(7,1)=1
   300: |                     if ( my_rank.eq.0 ) then
   301: |                     WRITE(6,*) ' KB EXTRAPOLATION SCHEME IS USED '
   302: |                     endif
   303: |                  ENDIF
   304: |               ELSEIF(ASAVE(L)(1:4).EQ.'TMOD') THEN
   305: |                  if ( my_rank.eq.0 ) then
   306: |                  WRITE(NAIBU,'(A20)') BSAVE(L)
   307: |                  READ(NAIBU,'(BN,I10)') ITMOD
   308: |                  endif
   309: |                  call MPI_Bcast(ITMOD,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
   310: |                  if ( my_rank.eq.0 ) then
   311: |                  WRITE(6,*) ' FREQUENCY OF MONITOR ',ITMOD
   312: |                  endif
   313: |               ELSEIF(ASAVE(L)(1:4).EQ.'RMIX') THEN
   314: |                  if ( my_rank.eq.0 ) then
   315: |                  WRITE(NAIBU,'(A20)') BSAVE(L)
   316: |                  READ(NAIBU,'(BN,E20.0)') RMIX
   317: |                  endif
   318: |                  call MPI_Bcast(RMIX ,1,MPI_DOUBLE_PRECISION
   319: |              &     ,0,MPI_COMM_WORLD,ierr)
   320: |                  if ( my_rank.eq.0 ) then
   321: |                  WRITE(6,*) ' MIXING RATIO IS ',RMIX
   322: |                  endif
   323: |               ELSEIF(ASAVE(L)(1:4).EQ.'CONV') THEN
   324: |                  if ( my_rank.eq.0 ) then
   325: |                  WRITE(NAIBU,'(A20)') BSAVE(L)
   326: |                  READ(NAIBU,'(BN,E20.0)') TR2
   327: |                  endif
   328: |                  call MPI_Bcast(TR2,1,MPI_DOUBLE_PRECISION
   329: |              &    ,0,MPI_COMM_WORLD,ierr)
   330: |                  if ( my_rank.eq.0 ) then
   331: |                  WRITE(6,*) ' SCF CONVERGENCE CRITERION IS ',TR2
   332: |                  endif
   333: |               ELSEIF(ASAVE(L)(1:4).EQ.'MAXF') THEN
   334: |                  if ( my_rank.eq.0 ) then
   335: |                  WRITE(NAIBU,'(A20)') BSAVE(L)
   336: |                  READ(NAIBU,'(BN,I20)') MAXFN
   337: |                  endif
   338: |                  call MPI_Bcast(MAXFN,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
   339: |                  if ( my_rank.eq.0 ) then
   340: |                  WRITE(6,*) ' #G-OPT LOOP IS ',MAXFN
   341: |                  endif
   342: |               ELSEIF(ASAVE(L)(1:4).EQ.'KCON') THEN
   343: |                  if ( my_rank.eq.0 ) then
   344: |                  WRITE(NAIBU,'(A20)') BSAVE(L)
   345: |                  READ(NAIBU,'(BN,I20)') KCONT
   346: |                  endif
   347: |                  call MPI_Bcast(KCONT,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
   348: |                  if ( my_rank.eq.0 ) then
   349: |                  WRITE(6,*) ' CONTINUATION? KCONT =  ', KCONT
   350: |                  endif
   351: |               ELSEIF(ASAVE(L)(1:4).EQ.'OKST') THEN
   352: |                  if ( my_rank.eq.0 ) then
   353: |                  WRITE(NAIBU,'(A20)') BSAVE(L)
   354: |                  READ(NAIBU,'(BN,E20.0)') OKSTEP
   355: |                  endif
   356: |                  call MPI_Bcast(OKSTEP,1,MPI_DOUBLE_PRECISION
   357: |              &                ,0,MPI_COMM_WORLD,ierr)
   358: |                  if ( my_rank.eq.0 ) then
   359: |                  WRITE(6,*) ' AT G-OPT INITIAL DISPLACEMENT IS ',OKSTEP
   360: |                  endif
   361: |               ELSEIF(ASAVE(L)(1:4).EQ.'ALAT') THEN
   362: |                  if ( my_rank.eq.0 ) then
   363: |                  WRITE(NAIBU,'(A20)') BSAVE(L)
   364: |                  READ(NAIBU,'(BN,E20.0)') CELLDM(1)
   365: |                  endif
   366: |                  call MPI_Bcast(CELLDM(1),1,MPI_DOUBLE_PRECISION
   367: |              &     ,0,MPI_COMM_WORLD,ierr)
   368: |                  if ( my_rank.eq.0 ) then
   369: |                  WRITE(6,*) ' LATTICE CONSTANT ',CELLDM(1)
   370: |                  endif
   371: |               ELSEIF(ASAVE(L)(1:4).EQ.'ZVAL') THEN
   372: |                  if ( my_rank.eq.0 ) then
   373: |                  WRITE(NAIBU,'(A20)') BSAVE(L)
   374: |                  READ(NAIBU,'(BN,E20.0)') ZVAL
   375: |                  endif
   376: |                  call MPI_Bcast(ZVAL,1,MPI_DOUBLE_PRECISION
   377: |              &    ,0,MPI_COMM_WORLD,ierr)
   378: |                  if ( my_rank.eq.0 ) then
   379: |                  WRITE(NAIBU,'(A20)') BSAVE(L)
   380: |                  WRITE(6,*) ' #CHARGE IS ',ZVAL
   381: |                  endif
   382: |               ELSEIF(ASAVE(L)(1:4).EQ.'DUAL') THEN
   383: |                  IOPT(5,2)=1
   384: |                  if ( my_rank.eq.0 ) then
   385: |                  WRITE(NAIBU,'(A20)') BSAVE(L)
   386: |                  READ(NAIBU,'(BN,E20.0)') GRAT
   387: |                  endif
   388: |                  call MPI_Bcast(GRAT,1,MPI_DOUBLE_PRECISION
   389: |              &    ,0,MPI_COMM_WORLD,ierr)
   390: |                  if ( my_rank.eq.0 ) then
   391: |                  WRITE(6,*) ' DUAL SPACE FORMALISM RATIO = ',GRAT
   392: |                  endif
   393: |                  IF(GRAT.EQ.0.D0) GRAT=1.D0
   394: |               ELSEIF(ASAVE(L)(1:4).EQ.'NBND') THEN
   395: |                  if ( my_rank.eq.0 ) then
   396: |                  WRITE(NAIBU,'(A20)') BSAVE(L)
   397: |                  READ(NAIBU,'(BN,I20)') NBND
   398: |                  endif
   399: |                  call MPI_Bcast(NBND,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
   400: |                  if ( my_rank.eq.0 ) then
   401: |                  WRITE(6,*) ' #OCCUPIED BAND IS ',NBND
   402: |                  endif
   403: |               ELSEIF(ASAVE(L)(1:4).EQ.'RCUT') THEN
   404: |                  if ( my_rank.eq.0 ) then
   405: |                  WRITE(NAIBU,'(A20)') BSAVE(L)
   406: |                  READ(NAIBU,'(BN,E20.0)') RCUT
   407: |                  endif
   408: |                  call MPI_Bcast(RCUT,1,MPI_DOUBLE_PRECISION
   409: |              &    ,0,MPI_COMM_WORLD,ierr)
   410: |                  if ( my_rank.eq.0 ) then
   411: |                  WRITE(6,*) ' RCUT**2 IS (AU) ',RCUT
   412: |                  endif
   413: |               ELSEIF(ASAVE(L)(1:4).EQ.'GCUT') THEN
   414: |                  if ( my_rank.eq.0 ) then
   415: |                  WRITE(NAIBU,'(A20)') BSAVE(L)
   416: |                  READ(NAIBU,'(BN,E20.0)') GCUT2
   417: |                  endif
   418: |                  call MPI_Bcast(GCUT2,1,MPI_DOUBLE_PRECISION
   419: |              &    ,0,MPI_COMM_WORLD,ierr)
   420: |                  if ( my_rank.eq.0 ) then
   421: |                  WRITE(6,*) ' GCUT2 IS ',GCUT2
   422: |                  endif
   423: |         c **** Miyamoto
   424: |               elseif(asave(l)(1:2).eq.'ST') then
   425: |                  if(asave(l)(3:4).eq.'ND') then
   426: |                   iopt(1,2)=99
   427: |                   if ( my_rank.eq.0 ) then
   428: |                   write(6,*) ' ****  Standard inputs !!!! *****'
   429: |                   endif
   430: |                  end if
   431: |               elseif(asave(l)(1:2).eq.'dt') then
   432: |                if ( my_rank.eq.0 ) then
   433: |                write(naibu,'(A20)') bsave(l)
   434: |                read( naibu,'(BN,E20.12)') dt
   435: |                endif
   436: |                call MPI_Bcast(dt,1,MPI_DOUBLE_PRECISION
   437: |              &   ,0,MPI_COMM_WORLD,ierr)
   438: |                if ( my_rank.eq.0 ) then
   439: |                write(6,*)' Delta t = ',dt,' a.u.'
   440: |                endif
   441: |               elseif(asave(l)(1:5).eq.'tstep') then
   442: |                if ( my_rank.eq.0 ) then
   443: |                write(naibu,'(A20)') bsave(l)
   444: |                read( naibu,'(BN,I20)')ntstep
   445: |                endif
   446: |                call MPI_Bcast(ntstep,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
   447: |         c
   448: |               ELSEIF(ASAVE(L)(1:2).EQ.'AL') THEN
   449: |                     IOPT(1,2)=11
   450: |                     if ( my_rank.eq.0 ) then
   451: |                     WRITE(6,*) ' AL FCC LATTICE'
   452: |                     endif
   453: |               ELSEIF(ASAVE(L)(1:2).EQ.'CB') THEN
   454: |                     IOPT(1,2)=30
   455: |                     if ( my_rank.eq.0 ) then
   456: |                     WRITE(6,*) ' CRISTOBALITE'
   457: |                     endif
   458: |               ELSEIF(ASAVE(L)(1:2).EQ.'SI') THEN
   459: |                  IF(ASAVE(L)(3:4).EQ.'TE') THEN
   460: |                     IOPT(1,2)=1
   461: |                     if ( my_rank.eq.0 ) then
   462: |                     WRITE(6,*) ' SITEST CALCULATION'
   463: |                     endif
   464: |                  ELSEIF(ASAVE(L)(3:4).EQ.'O2') THEN
   465: |                     IOPT(1,2)=2
   466: |                     if ( my_rank.eq.0 ) then
   467: |                     WRITE(6,*) ' SIO2 '
   468: |                     endif
   469: |                  ELSEIF(ASAVE(L)(3:4).EQ.'EP') THEN
   470: |                     IOPT(1,2)=13
   471: |                     if ( my_rank.eq.0 ) then
   472: |                     WRITE(6,*) ' SUPER CELL CALCULATION FOR A-QUARTZ'
   473: |                     endif
   474: |                  ELSEIF(ASAVE(L)(3:5).EQ.'GEH') THEN
   475: |                     IOPT(1,2)=21
   476: |                     if ( my_rank.eq.0 ) then
   477: |                     WRITE(6,*) ' SI/GE + H '
   478: |                     endif
   479: |                  ELSEIF(ASAVE(L)(3:3).EQ.'8') THEN
   480: |                     IOPT(1,2)=5
   481: |                     if ( my_rank.eq.0 ) then
   482: |                     WRITE(6,*) ' SI8 CUBIC LATTICE'
   483: |                     endif
   484: |                  ELSEIF(ASAVE(L)(3:3).EQ.'2') THEN
   485: |                     IOPT(1,2)=0
   486: |                     if ( my_rank.eq.0 ) then
   487: |                     WRITE(6,*) ' SI2 LATTICE'
   488: |                     endif
   489: |                  ELSEIF(ASAVE(L)(3:5).EQ.'SL5') THEN
   490: |                     IOPT(1,2)=6
   491: |                     if ( my_rank.eq.0 ) then
   492: |                     WRITE(6,*) ' 5-LAYER SLAB CALCULATIONS'
   493: |                     endif
   494: |                  ELSEIF(ASAVE(L)(3:6).EQ.'SLH1') THEN
   495: |                     IOPT(1,2)=8
   496: |                     if ( my_rank.eq.0 ) then
   497: |                     WRITE(6,*) ' H-TERMINATED SLAB CALCULATIONS: 1'
   498: |                     endif
   499: |                  ELSEIF(ASAVE(L)(3:6).EQ.'SLH2') THEN
   500: |                     IOPT(1,2)=3
   501: |                     if ( my_rank.eq.0 ) then
   502: |                     WRITE(6,*) ' H-TERMINATED SLAB CALCULATIONS: 2'
   503: |                     endif
   504: |                  ELSEIF(ASAVE(L)(3:6).EQ.'SLH3') THEN
   505: |                     IOPT(1,2)=4
   506: |                     if ( my_rank.eq.0 ) then
   507: |                     WRITE(6,*) ' H-TERMINATED SLAB CALCULATIONS: 3'
   508: |                     endif
   509: |                  ELSEIF(ASAVE(L)(3:6).EQ.'SLH4') THEN
   510: |                     IOPT(1,2)=10
   511: |                     if ( my_rank.eq.0 ) then
   512: |                     WRITE(6,*) ' H-TERMINATED VICINAL SURFACE CALCULATIONS'
   513: |                     endif
   514: |                  ELSEIF(ASAVE(L)(3:6).EQ.'SLH5') THEN
   515: |                     IOPT(1,2)=12
   516: |                     if ( my_rank.eq.0 ) then
   517: |                     WRITE(6,*) ' H-TERMINATED (1,1,10) VICINAL SURFACE '
   518: |                     endif
   519: |                  ELSEIF(ASAVE(L)(3:4).EQ.'H4') THEN
   520: |                     IOPT(1,2)=9
   521: |                     if ( my_rank.eq.0 ) then
   522: |                     WRITE(6,*) ' SIH4(CUBIC CELL) CALCULATIONS'
   523: |                     endif
   524: |                  ELSE
   525: |                     if ( my_rank.eq.0 ) then
   526: |                     WRITE(6,*) ' SUCH A LATTICE IS NOT SUPPORTED HERE '
   527: |                     endif
   528: |                     STOP
   529: |                  ENDIF
   530: |               ELSEIF(ASAVE(L)(1:2).EQ.'KP') THEN
   531: |                  IF(BSAVE(L)(1:1).EQ.'0') THEN
   532: |                     IOPT(2,2)=0
   533: |                     if ( my_rank.eq.0 ) then
   534: |                     WRITE(6,*) ' INTERNAL SAMPLING FOR K-VECTORS'
   535: |                     endif
   536: |                  ELSEIF(BSAVE(L)(1:1).EQ.'1') THEN
   537: |                     IOPT(2,2)=1
   538: |                     if ( my_rank.eq.0 ) then
   539: |                     WRITE(6,*) ' GAMMA SAMPLING '
   540: |                     endif
   541: |                  ELSEIF(BSAVE(L)(1:1).EQ.'2') THEN
   542: |                     IOPT(2,2)=2
   543: |                     if ( my_rank.eq.0 ) then
   544: |                     WRITE(6,*) ' # OF K-POINT = 2 '
   545: |                     endif
   546: |                  ELSEIF(BSAVE(L)(1:1).EQ.'4') THEN
   547: |                     IOPT(2,2)=4
   548: |                     if ( my_rank.eq.0 ) then
   549: |                     WRITE(6,*) ' # OF K-POINT = 4 '
   550: |                     endif
   551: |                  ELSEIF(BSAVE(L)(1:1).EQ.'M') THEN
   552: |                     IOPT(2,2)=100
   553: |                     if ( my_rank.eq.0 ) then
   554: |                     WRITE(6,*) ' MESH SAMPLING FOR K-VECTROS'
   555: |                     endif
   556: |                  ELSE
   557: |                     if ( my_rank.eq.0 ) then
   558: |                     WRITE(6,*) ' SUCH A KPOINT SAMPLING IS NOT SUPPORTED HERE'
   559: |                     endif
   560: |                     STOP
   561: |                  ENDIF
   562: |         C
   563: |               ELSEIF(ASAVE(L)(1:5).EQ.'METAL') THEN
   564: |                  IF(INDEX(BSAVE(L),',').NE.0) THEN
   565: |                     I1=INDEX(BSAVE(L),'(')+1
   566: |                     I2=INDEX(BSAVE(L),',')-1
   567: |                     if ( my_rank.eq.0 ) then
   568: |                     WRITE(NAIBU,'(A20)') BSAVE(L)(I1:I2)
   569: |                     READ(NAIBU,'(BN,I20)') NFL
   570: |                     endif
   571: |                     call MPI_Bcast(NFL,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
   572: |                     I1=INDEX(BSAVE(L),',')+1
   573: |                     I2=INDEX(BSAVE(L),')')-1
   574: |                     if ( my_rank.eq.0 ) then
   575: |                     WRITE(NAIBU,'(A20)') BSAVE(L)(I1:I2)
   576: |                     READ(NAIBU,'(BN,I20)') NPFL
   577: |                     endif
   578: |                     call MPI_Bcast(NPFL,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
   579: |                  ELSE
   580: |                     if ( my_rank.eq.0 ) then
   581: |                     WRITE(6,*) ' ******  CHECK YOUR INPUT... METAL = ?'
   582: |                     endif
   583: |                     STOP
   584: |                  ENDIF
   585: |                     if ( my_rank.eq.0 ) then
   586: |                     WRITE(6,*) ' METAL CASE: NFL NPFL = ', NFL, NPFL
   587: |                     endif
   588: |         C
   589: |               ELSEIF(ASAVE(L)(1:5).EQ.'FORCE') THEN
   590: |                  I0=INDEX(BSAVE(L),'(')+1
   591: |                  I9=INDEX(BSAVE(L),')')-1
   592: |                  I1=INDEX(BSAVE(L),',')
   593: |                  I2=INDEX(BSAVE(L)(I1+1:I9),',')+I1
   594: |                  I3=INDEX(BSAVE(L)(I2+1:I9),',')+I2
   595: |                  NFIX=NFIX+1
   596: |                  if ( my_rank.eq.0 ) then
   597: |                  WRITE(NAIBU,'(A20)') BSAVE(L)(I0:I1-1)
   598: |                  READ(NAIBU,'(BN,I20)') IFATM(NFIX)
   599: |                  endif
   600: |                  call MPI_Bcast(IFATM(NFIX),1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
   601: |                  if ( my_rank.eq.0 ) then
   602: |                  WRITE(NAIBU,'(A20)') BSAVE(L)(I1+1:I2-1)
   603: |                  READ(NAIBU,'(BN,F20.0)') XX
   604: |                  endif
   605: |                  call MPI_Bcast(XX,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
   606: |                  if ( my_rank.eq.0 ) then
   607: |                  WRITE(NAIBU,'(A20)') BSAVE(L)(I2+1:I3-1)
   608: |                  READ(NAIBU,'(BN,F20.0)') YY
   609: |                  endif
   610: |                  call MPI_Bcast(YY,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
   611: |                  if ( my_rank.eq.0 ) then
   612: |                  WRITE(NAIBU,'(A20)') BSAVE(L)(I3+1:I9)
   613: |                  READ(NAIBU,'(BN,F20.0)') ZZ
   614: |                  endif
   615: |                  call MPI_Bcast(ZZ,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
   616: |                  RR=SQRT(XX**2+YY**2+ZZ**2)
   617: |                  IF(RR.LT.1.D-5) THEN
   618: |                     RR=0.D0
   619: |                     IFATM(NFIX)=-IFATM(NFIX)
   620: |                  ELSE
   621: |                     RR=1.D0/RR
   622: |                  ENDIF
   623: |                  FATM(1,NFIX)=XX*RR
   624: |                  FATM(2,NFIX)=YY*RR
   625: |                  FATM(3,NFIX)=ZZ*RR
   626: |                  if ( my_rank.eq.0 ) then
   627: |                  WRITE(6,'('' FIXED ATOM '',2I5,3F15.7)')
   628: |              &               NFIX,IFATM(NFIX),XX,YY,ZZ
   629: |                  endif
   630: |               ELSEIF(ASAVE(L)(1:5).EQ.'MAXG2') THEN
   631: |                  if ( my_rank.eq.0 ) then
   632: |                  WRITE(NAIBU,'(A20)') BSAVE(L)
   633: |                  READ(NAIBU,'(BN,I20)') MAXG2
   634: |                  endif
   635: |                  call MPI_Bcast(MAXG2,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
   636: |                  if ( my_rank.eq.0 ) then
   637: |                  WRITE(6,*) ' #MAXG2 IS ',MAXG2
   638: |                  endif
   639: |               ELSEIF(ASAVE(L)(1:5).EQ.'OUTWF') THEN
   640: |                  if ( my_rank.eq.0 ) then
   641: |                  WRITE(NAIBU,'(A20)') BSAVE(L)
   642: |                  READ(NAIBU,'(BN,I20)') ITEMP
   643: |                  endif
   644: |                  call MPI_Bcast(ITEMP,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
   645: |                  if ( my_rank.eq.0 ) then
   646: |                  WRITE(6,*) ' WRITE WF TO FILE ',ITEMP
   647: |                  endif
   648: |                  IOPT(4,2)=ITEMP
   649: |               ELSE
   650: |                  if ( my_rank.eq.0 ) then
   651: |                  WRITE(6,*) ' OPTION ',ASAVE(L),' IS NOT SUPPORTED'
   652: |                  endif
   653: |               ENDIF
   654: +------    3000 CONTINUE
   655:                 if (my_rank.eq.0 ) then
   656:                 WRITE(6,3002)
   657:            3002 FORMAT(' ------------',
   658:                &'------------------------------------------------------------'//)
   659:                 endif
   660:                 RETURN
   661:                 END


NEC Fortran Compiler (3.4.2) for Vector Engine   Wed Jul  6 14:26:17 2022
FILE NAME: tm_inputs_art.f

PROCEDURE NAME: CRYST
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

   663:                 SUBROUTINE CRYST(NRX,NRY,NRZ,NXYZ,NG,NGQ,
   664:                & NBNDQ,NBND,ZVAL,NFL, NPFL, NUMK,
   665:                & NUMKQ,CELLDM,NTOT,S,VECK,WGT,G,I2G,OMEGA,GCUT,
   666:                & GCUT2,GRAT,GG,I2GG,INDX,OCC,
   667:                & LATQ,RVEC,RCUT,NLV,RR,NWK,
   668:                & NTAUQ,NTYQ,NTYPE,TAU, CTAU, NUMTY,NIDN,
   669:                & RKK,KG,KZ,NSY,NEXPND,
   670:                & RCOSIN,CCO,NKMESH,SK,WK,JDR,MM,NJD, NDX, NDY, NDZ, MXOFL,
   671:                & atmss )
   672:                 IMPLICIT REAL*8 (A-H,O-Z)
   673:                 include 'mpif.h'
   674:                 DIMENSION TAU(3,NTAUQ),NUMTY(NTYQ),NIDN(NTAUQ,NTYQ)
   675:                &        , CTAU(3,NTAUQ), MXOFL(NTYQ)
   676:                 COMMON/AVEC/A1(3),A2(3),A3(3),B1(3),B2(3),B3(3),COVA,ALAT
   677:                 DIMENSION G(4,NGQ),CELLDM(6)
   678:                 DIMENSION GG(4,NGQ),I2GG(NGQ),INDX(NGQ)
   679:                 DIMENSION VECK(3,NUMKQ),WGT(NUMKQ),I2G(NGQ)
   680:                 DIMENSION RR(LATQ),NWK(LATQ),RVEC(4,LATQ),OCC(NBNDQ,NUMKQ)
   681:                 dimension atmss(ntauq)
   682:                 INTEGER*4 S(3,3,48)
   683:                 INTEGER PGIND, RIND(32)
   684:                 COMMON/COMOPT/IOPT(10,5)
   685:                 PARAMETER (IRLATQ=144,NARF=IRLATQ)
   686:                 PARAMETER (NAS=72,NAD=72)
   687:                 DIMENSION RKK(IRLATQ),KG(3,IRLATQ),KZ(3,IRLATQ,48),NSY(IRLATQ)
   688:                 DIMENSION RCOSIN(NAS,IRLATQ),CCO(-NAD:NAD),SK(3,NAS),WK(NAS),
   689:                &          JDR(48,NAS),MM(3,10000),NJD(NAS)
   690:                 DATA RIND/5*1,2*3,6*2,4*1,3*2,7*1,2*2,3*1/
   691:           C
   692:                 call MPI_COMM_RANK(MPI_COMM_WORLD,my_rank,ierr)
   693:           C**********************************************************
   694:           C     SETS UP THE BASIS VECTORS AND INITIAL GEOMETRY.
   695:                 CALL STRUC(CELLDM,IBRAV,PGIND,NK,NBNDQ,NBND,ZVAL,GCUT,
   696:                &  GCUT2,GRAT,A1,A2,A3,OMEGA,OCC,NUMKQ,
   697:                &  NTAUQ,NTYQ,TAU,NTYPE,NUMTY,NIDN, MXOFL, COVA, ALAT,atmss )
   698:           C
   699:                 if ( my_rank.eq.0 ) then
   700:                 WRITE(6,3001) IBRAV,PGIND,NFL,NBND,NPFL,NK,RCUT,GCUT,GCUT2
   701:            3001 FORMAT(/' IBRAV = ',I3,' PGIND = ',I3,' NFL = ',I3,
   702:                &       ' NBND = ',I3,' NPFL = ',I3,' NK = ',I3/
   703:                &       ' RCUT = ',F15.7,' GCUT = ',F15.7,' GCUT2 = ',F15.7)
   704: *------>        WRITE(6,3002) (A1(I),A2(I),A3(I),I=1,3),OMEGA
   705:            3002 FORMAT(' A-VECTORS'/,3(' ',3F15.7/),' OMEGA=',F15.7)
   706:                 endif
   707:           C**************ROTATION MATRIX S**********************
   708:           C     OBTAIN THE ROTATION MATRIX(IN REAL SPACE)
   709:           C
   710:                 IF( IOPT(1,2) .EQ. 0 ) THEN
   711:                    CALL SMAT(PGIND,S,NTOT,IBRAV)
   712:           C
   713:           C    **     NO SYMMETRY IS ASSUMED
   714:           CARE  ELSEIF( IOPT(1,2).EQ.5 .OR. IOPT(1,2).EQ.11 .OR.
   715:           C    &        IOPT(1,2).EQ.8 .OR. IOPT(1,2).EQ.9  ) THEN
   716:                 ELSEIF( IOPT(1,2).EQ.5 .OR. IOPT(1,2).EQ.11 .OR.
   717:                &        IOPT(1,2).EQ.8 .OR. IOPT(1,2).EQ.3  .OR.
   718:                &        IOPT(1,2).EQ.4 .OR. IOPT(1,2).EQ.10 .OR.
   719:                &        IOPT(1,2).EQ.12 .OR. IOPT(1,2).EQ.1 .OR.
   720:                &        IOPT(1,2).EQ.2  .OR. IOPT(1,2).EQ.21 .OR.
   721:                &        IOPT(1,2).EQ.13 .OR. IOPT(1,2).EQ.30     ) THEN
   722:                   NTOT=1
   723: +------>          DO 53 I3=1,NTOT
   724: |*----->          DO 53 I2=1,3
   725: ||*---->          DO 53 I1=1,3
   726: |||                 S(I1,I2,I3)=0
   727: ||*----      53   CONTINUE
   728: *------>          DO 54 I1=1,3
   729: |                   S(I1,I1,1)=1
   730: *------      54   CONTINUE
   731:           C
   732:                 ELSE IF(IOPT(1,2).EQ.6) THEN
   733:           C ******   D2D SYMMETRY FOR A1=(0.5,0.5,0), A2=(-0.5,0.5,0)
   734:           C                           A3=(0,0,1)
   735:                   NTOT=8
   736: V------>            DO 60 IOP = 1, NTOT
   737: |*----->            DO 60 K1 = 1, 3
   738: ||*---->            DO 60 K2 = 1, 3
   739: ||*----      60     S(K1,K2,IOP) = 0
   740: *------>          DO 62 K1 = 1, 3
   741: *------      62   S(K1,K1,1) = 1
   742:           C ***      3C(2)
   743:                   S(1,2,2) = -1
   744:                   S(2,1,2) = -1
   745:                   S(3,3,2) = -1
   746:           C
   747:                   S(1,2,3) =  1
   748:                   S(2,1,3) =  1
   749:                   S(3,3,3) = -1
   750:           C
   751:                   S(1,1,4) = -1
   752:                   S(2,2,4) = -1
   753:                   S(3,3,4) =  1
   754:           C ***     2 MIRRORS
   755:                   S(1,1,5) =  1
   756:                   S(2,2,5) = -1
   757:                   S(3,3,5) =  1
   758:           C
   759:                   S(1,1,6) = -1
   760:                   S(2,2,6) =  1
   761:                   S(3,3,6) =  1
   762:           C ***     2 ADDITIONAL S(4)
   763:                   S(1,2,7) = -1
   764:                   S(2,1,7) =  1
   765:                   S(3,3,7) = -1
   766:           C
   767:                   S(1,2,8) =  1
   768:                   S(2,1,8) = -1
   769:                   S(3,3,8) = -1
   770:                 ELSE IF(IOPT(1,2).EQ.9) THEN
   771:           C ******   D2D SYMMETRY FOR A1=(1,0,0), A2=(0,1,0)
   772:           C                           A3=(0,0,1)
   773:                   NTOT=8
   774: V------>            DO 360 IOP = 1, NTOT
   775: |*----->            DO 360 K1 = 1, 3
   776: ||*---->            DO 360 K2 = 1, 3
   777: ||*----     360     S(K1,K2,IOP) = 0
   778: *------>          DO 362 K1 = 1, 3
   779: *------     362   S(K1,K1,1) = 1
   780:           C ***      3C(2)
   781:                   S(1,1,2) =  1
   782:                   S(2,2,2) = -1
   783:                   S(3,3,2) = -1
   784:           C
   785:                   S(1,1,3) = -1
   786:                   S(2,2,3) =  1
   787:                   S(3,3,3) = -1
   788:           C
   789:                   S(1,1,4) = -1
   790:                   S(2,2,4) = -1
   791:                   S(3,3,4) =  1
   792:           C ***     2 MIRRORS
   793:                   S(1,2,5) =  1
   794:                   S(2,1,5) =  1
   795:                   S(3,3,5) =  1
   796:           C
   797:                   S(1,2,6) = -1
   798:                   S(2,1,6) = -1
   799:                   S(3,3,6) =  1
   800:           C ***     2 ADDITIONAL S(4)
   801:                   S(1,2,7) =  1
   802:                   S(2,1,7) = -1
   803:                   S(3,3,7) = -1
   804:           C
   805:                   S(1,2,8) = -1
   806:                   S(2,1,8) =  1
   807:                   S(3,3,8) = -1
   808:           c ***  Miyamoto
   809:                 elseif ( iopt(1,2).eq.99 ) then
   810:                  if ( my_rank.eq.0 ) then
   811:                  write(6,*)' Read S-matrices fron file !!'
   812:                  read(55,*)ntot
   813:                  endif
   814:                  call MPI_Bcast(ntot,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
   815:                  if ( my_rank.eq.0 ) then
   816: +------>         do 199 ir=1,ntot
   817: |*----->          read(55,*)irot,((s(i,j,ir),j=1,3),i=1,3)
   818: +------     199  continue
   819:                  endif
   820:                  nsize=3*3*48
   821:                  call MPI_Bcast(S,nsize,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
   822:                 ELSE
   823:                   if ( my_rank.eq.0 ) then
   824:                   WRITE(6,*) '  ***  IOPT(1,2) = ', IOPT(1,2), ' NOT PROGRAMED'
   825:                   endif
   826:                   STOP
   827:                 ENDIF
   828:           C
   829:                 if ( my_rank.eq.0 ) then
   830:                 WRITE(6,*) ' # OF SYMMETRY OPERATIONS: NTOT = ',NTOT
   831:                 WRITE(6,*) ' S MATRICES: OP  1ST RAW   2ND RAW   3RD RAW'
   832: +------>        DO 6662 I3 = 1, NTOT
   833: |*----->   6662 WRITE(6,6660) I3, (  (S(I1,I2,I3),I2=1,3), I1=1,3)
   834:            6660 FORMAT( 7X,I3,3X,3(2X,3I3) )
   835:                 WRITE(6,*) ' '
   836:                 endif
   837:           C******************************************************
   838:           C     GENERATE ALL LATTICE VECTORS INSIDE A RADIUS RCUT
   839:                 CALL LVGEN(A1,A2,A3,LATQ,NLV,RCUT,RVEC,RR,NWK)
   840:                 if ( my_rank.eq.0 ) then
   841:                 WRITE(6,*) '   # OF LATTICE VECTORS: NLV = ',NLV
   842:                 endif
   843:           C***********************************************************
   844:           C     GENERATE ALL RECIPROCAL LATTICE VECTORS INSIDE GCUT
   845:                 CALL GGEN(CELLDM(1),A1,A2,A3,B1,B2,B3,NRX,NRY,NRZ,NXYZ,
   846:                &          NG,NGQ,G,I2G,GCUT,GG,I2GG,INDX)
   847:           C**************SYMMETRY BUSINESS***********************
   848:           C
   849:                 IF(NTOT.NE.1) CALL SMATCHK2( S, TAU, CTAU, B1, B2, B3, CELLDM(1),
   850:                &                            NTOT, NTAUQ )
   851:           C
   852:                 if ( my_rank.eq.0 ) write(6,*) ' SMATCHK2 finished ! '
   853:           C     GENERATE VECK'S AND WEIGHTS WITHIN IRREDUCIBLE BZ
   854:                 IF( IOPT(2,2).EQ.0 ) THEN
   855:                   CALL KWGT( NUMKQ, VECK, WGT, NK, IBRAV, CELLDM, OMEGA,
   856:                &             RIND(PGIND), NUMK )
   857:                 if ( my_rank.eq.0 ) write(6,*) ' KWGT finished ! '
   858:           C *******   SUM OF WGT OVER NUMK SHOULD BE THE INVERSE OF OMEGA
   859: V------>               DO 7002 IK = 1, NUMK
   860: |          7002        WGT(IK) = DBLE(NTOT) * WGT(IK)
   861: |         C               ALSO NKMESH WHICH IS NOT ESSENTIALLY USED SHOULD NOT
   862: |         C               BE ZERO IN NONLOCF
   863: |                      NKMESH = 1
   864: |         C *******
   865: |                 DO 7000 IK = 1, NUMK
   866: V------    7000   WK(IK) = OMEGA * WGT(IK)
   867:                 ELSE IF( IOPT(2,2) .EQ. 100 ) THEN
   868:                 if ( my_rank.eq.0 ) write(6,*) ' begin LVGENX! '
   869:                   CALL LVGENX(A1,A2,A3,S,NTOT,RKK,KG,KZ,NSY,NEXPND)
   870:           c      if ( my_rank.eq.0 ) write(6,*) ' LVGENX finished ! '
   871:           c      write(6,*)' my_rank=',my_rank,' LVGENX finished ! '
   872:                   CALL MESHK(S,NTOT,NUMK,NKMESH,KG,NEXPND,MM,RCOSIN,JDR,SK,
   873:                &           WK,NJD,CCO, NDX, NDY, NDZ )
   874:                 if ( my_rank.eq.0 ) write(6,*) ' MESHK finished ! '
   875:           C
   876:           CARE ****
   877:           c **** Miyamoto 9/6/95
   878:           c        read(5,*)nexpnd
   879:                       IF( NUMK.LT.NEXPND ) THEN
   880:                          NEXPND = MIN( NUMK, NEXPND )
   881:                          if ( my_rank.eq.0 ) then
   882:                          WRITE(6,6600) NEXPND
   883:                          endif
   884:            6600          FORMAT(/20X,'  ****  CRYST: NEXPND CHANGED TO BE ',I3)
   885:                        ELSE
   886:                        END IF
   887:           CARE         NEXPND = 10
   888:           CARE END *****
   889:           C
   890: V------>          DO 55 IK=1,NUMKQ
   891: |                   VECK(1,IK)=0.D0
   892: |                   VECK(2,IK)=0.D0
   893: |                   VECK(3,IK)=0.D0
   894: |                   WGT(IK)=0.D0
   895: V------    55     CONTINUE
   896: V------>          DO 56 IK=1,NUMK
   897: |                   VECK(1,IK)=SK(1,IK)*B1(1)+SK(2,IK)*B2(1)+SK(3,IK)*B3(1)
   898: |                   VECK(2,IK)=SK(1,IK)*B1(2)+SK(2,IK)*B2(2)+SK(3,IK)*B3(2)
   899: |                   VECK(3,IK)=SK(1,IK)*B1(3)+SK(2,IK)*B2(3)+SK(3,IK)*B3(3)
   900: |                   WGT(IK)=WK(IK)/OMEGA
   901: V------    56     CONTINUE
   902:                 ELSEIF(IOPT(2,2).EQ.1) THEN
   903:                    NUMK=1
   904:                    NKMESH = 1
   905:           CARE
   906:                      IF( IOPT(1,2) .EQ. 2 ) THEN
   907:           C ** HEXAGONAL ONE SPECIAL POINT
   908:                        OTH = 0.333333333333333D+00
   909:                        VECK(1,1) = OTH
   910:                        VECK(2,1) = OTH / SQRT(3.0D+00)
   911:                        VECK(3,1) = 0.25D+00 / COVA
   912:                      ELSE IF(IOPT(1,2) .EQ. 30 ) THEN
   913:           C ** TETRAGONAL ONE SPECIAL POINT
   914:                        VECK(1,1) =  0.25d+00
   915:                        VECK(2,1) =  0.25d+00
   916:                        VECK(3,1) =  0.25D+00 / COVA
   917:                      ELSE IF(IOPT(1,2) .EQ. 13 ) THEN
   918:           C ** TRICLINIC SUPERCELL
   919:                        OTH = 1.0D+00 / 9.0D+00
   920:                        VECK(1,1) = - OTH
   921:                        VECK(2,1) =   OTH * SQRT(3.0D+00)
   922:                        VECK(3,1) =   2.0D+00 * OTH / COVA
   923:                      ELSE
   924:           C **  GAMMA POINT
   925:                        VECK(1, 1)=0.000D0
   926:                        VECK(2, 1)=0.000D0
   927:                        VECK(3, 1)=0.000D0
   928:                      END IF
   929:           C **
   930:                    WGT( 1)=1.D0/(OMEGA)
   931:                    WK( 1)=1.D0
   932:                 ELSEIF(IOPT(2,2).EQ.2) THEN
   933:                    if ( my_rank.eq.0 ) then
   934:                     write(6,*)' NUMK=2 IS NOT SUPPORTED'
   935:                    endif
   936:                    STOP
   937:                 ELSEIF(IOPT(2,2).EQ.3) THEN
   938:                    NUMK=3
   939:                    VECK(1, 1)=0.125D0
   940:                    VECK(2, 1)=0.000D0
   941:                    VECK(3, 1)=0.000D0
   942:                    WGT( 1)=1.D0/(3.D0*OMEGA)
   943:                    WK( 1)=1.D0/3.D0
   944:                    VECK(1, 2)=0.000D0
   945:                    VECK(2, 2)=0.125D0
   946:                    VECK(3, 2)=0.000D0
   947:                    WGT( 2)=1.D0/(3.D0*OMEGA)
   948:                    WK( 2)=1.D0/3.D0
   949:                    VECK(1, 3)=0.000D0
   950:                    VECK(2, 3)=0.000D0
   951:                    VECK(3, 3)=0.125D0
   952:                    WGT( 3)=1.D0/(3.D0*OMEGA)
   953:                    WK( 3)=1.D0/3.D0
   954:                 ELSEIF(IOPT(2,2).EQ.4) THEN
   955:                    NUMK=4
   956:                    VECK(1, 1)= 0.25D0
   957:                    VECK(2, 1)= 0.25D0
   958:                    VECK(3, 1)= 0.25D0
   959:                    WGT( 1)=1.D0/(4.D0*OMEGA)
   960:                    WK( 1)=1.D0/4.D0
   961:                    VECK(1, 2)=-0.25D0
   962:                    VECK(2, 2)= 0.25D0
   963:                    VECK(3, 2)= 0.25D0
   964:                    WGT( 2)=1.D0/(4.D0*OMEGA)
   965:                    WK( 2)=1.D0/4.D0
   966:                    VECK(1, 3)= 0.25D0
   967:                    VECK(2, 3)=-0.25D0
   968:                    VECK(3, 3)= 0.25D0
   969:                    WGT( 3)=1.D0/(4.D0*OMEGA)
   970:                    WK( 3)=1.D0/4.D0
   971:                    VECK(1, 4)= 0.25D0
   972:                    VECK(2, 4)= 0.25D0
   973:                    VECK(3, 4)=-0.25D0
   974:                    WGT( 4)=1.D0/(4.D0*OMEGA)
   975:                    WK( 4)=1.D0/4.D0
   976:                 ELSEIF(IOPT(2,2).EQ.6) THEN
   977:                    NUMK=4
   978:                    VECK(1, 1)= 0.25D0
   979:                    VECK(2, 1)= 0.25D0
   980:                    VECK(3, 1)= 0.25D0
   981:                    WGT( 1)=1.D0/(4.D0*OMEGA)
   982:                    WK( 1)=1.D0/4.D0
   983:                    VECK(1, 2)=-0.25D0
   984:                    VECK(2, 2)= 0.25D0
   985:                    VECK(3, 2)= 0.25D0
   986:                    WGT( 2)=1.D0/(4.D0*OMEGA)
   987:                    WK( 2)=1.D0/4.D0
   988:                    VECK(1, 3)= 0.25D0
   989:                    VECK(2, 3)=-0.25D0
   990:                    VECK(3, 3)= 0.25D0
   991:                    WGT( 3)=1.D0/(4.D0*OMEGA)
   992:                    WK( 3)=1.D0/4.D0
   993:                    VECK(1, 4)= 0.25D0
   994:                    VECK(2, 4)= 0.25D0
   995:                    VECK(3, 4)=-0.25D0
   996:                    WGT( 4)=1.D0/(4.D0*OMEGA)
   997:                    WK( 4)=1.D0/4.D0
   998:                 ELSEIF(IOPT(2,2).EQ.5) THEN
   999:                    NUMK=4
  1000:                    VECK(1, 1)= 1.D0/SQRT(32.D0)
  1001:                    VECK(2, 1)= 1.D0/SQRT(32.D0)
  1002:                    VECK(3, 1)= 1.D0/8.D0
  1003:                    WGT( 1)=1.D0/(4.D0*OMEGA)
  1004:                    WK( 1)=1.D0/4.D0
  1005:                    VECK(1, 2)=-1.D0/SQRT(32.D0)
  1006:                    VECK(2, 2)= 1.D0/SQRT(32.D0)
  1007:                    VECK(3, 2)= 1.D0/8.D0
  1008:                    WGT( 2)=1.D0/(4.D0*OMEGA)
  1009:                    WK( 2)=1.D0/4.D0
  1010:                    VECK(1, 3)= 1.D0/SQRT(32.D0)
  1011:                    VECK(2, 3)=-1.D0/SQRT(32.D0)
  1012:                    VECK(3, 3)= 1.D0/8.D0
  1013:                    WGT( 3)=1.D0/(4.D0*OMEGA)
  1014:                    WK( 3)=1.D0/4.D0
  1015:                    VECK(1, 4)=-1.D0/SQRT(32.D0)
  1016:                    VECK(2, 4)=-1.D0/SQRT(32.D0)
  1017:                    VECK(3, 4)= 1.D0/8.D0
  1018:                    WGT( 4)=1.D0/(4.D0*OMEGA)
  1019:                    WK( 4)=1.D0/4.D0
  1020:                 ENDIF
  1021:                    IF(NUMK.LE.0.OR.NUMK.GT.NUMKQ) then
  1022:                     if ( my_rank.eq.0 ) write(6,*)' NUMK'
  1023:                     STOP
  1024:                    ENDIF
  1025:           C
  1026:                 if ( my_rank.eq.0 ) then
  1027: +------>        DO 811 IK=1,NUMK
  1028: |*----->    811 WRITE(6,812) IK,(VECK(KK,IK),KK=1,3)
  1029:             812 FORMAT(' ***   CRYST: VECK(',I2,') =',3(F10.5,3X))
  1030: +------>        DO 3004 K2 = 1, NUMK
  1031: |+----->   3004 WRITE(6,3003) K2, ( OCC(K1,K2), K1 = 1, NFL + NPFL )
  1032:            3003 FORMAT(' OCC: K2 = ',I3/(7X,5F12.4))
  1033:                 endif
  1034:           C
  1035:                 RETURN
  1036:                 END


NEC Fortran Compiler (3.4.2) for Vector Engine   Wed Jul  6 14:26:17 2022
FILE NAME: tm_inputs_art.f

PROCEDURE NAME: STRUC
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

  1038:                 SUBROUTINE STRUC(CELLDM,IBRAV,PGIND,NK,NBNDQ,NBND,ZVAL,
  1039:                &  GCUT,GCUT2,GRAT,A1,A2,A3,OMEGA,OCC,NUMKQ,
  1040:                &  NTAUQ,NTYQ,
  1041:                &  TAU,NTYPE,NUMTY,NIDN, MXOFL, COVA, ALAT,atmss )
  1042:                 IMPLICIT REAL*8 (A-H,O-Z)
  1043:                 include 'mpif.h'
  1044:           C
  1045:                 PARAMETER (ZERO=0.D0, UM=1.D0, TRES=3.D0)
  1046:           C
  1047:                 CHARACTER*1 IOP(3,3),JOP(3),IP
  1048:                 DIMENSION AVEC(3,3),RAT(3),DRAT(3)
  1049:                 REAL*8 CELLDM(6)
  1050:                 INTEGER PGIND
  1051:                 DIMENSION TAU(3,NTAUQ),NUMTY(NTYQ),NIDN(NTAUQ,NTYQ)
  1052:                &         ,OCC(NBNDQ,NUMKQ), MXOFL(NTYQ)
  1053:                 DIMENSION A1(3),A2(3),A3(3)
  1054:                 dimension atmss(ntauq)
  1055:                 COMMON/COMOPT/IOPT(10,5)
  1056:                 call MPI_COMM_RANK(MPI_COMM_WORLD,my_rank,ierr)
  1057:                 PI=4.D0*ATAN(1.D0)
  1058:           C   FOLLOWING PARAMETER (IBRAV,PGIND,NK) IS VALID IN SI2 CALCULATION
  1059:           C     IBRAV=FCC TYPE BRAVAIS LATTICE
  1060:                 IBRAV=0
  1061:                 NK = 0
  1062:           C     PGIND IS THE POINT-GROUP INDEX, WHICH DETERMINES THE IRREDUCIBLE
  1063:           C     WEDGE FOR THE GIVEN STRUCTURE.
  1064:           C
  1065:           C     POINT GROUP CHARACTERISTIC IS OF TD.
  1066:                 PGIND=0
  1067:           C
  1068:           C     CELLDM(1) IS THE LATTICE CONSTANT (THE STANDARD CRYSTALLOGRAPHIC
  1069:           C     BASAL-PLANE DIMENSION A) IN ATOMIC UNITS.
  1070:           C     REQUIRED VALUES OF CELLDM(I),I>1 ARE GIVEN IN THE TABLE BELOW FOR
  1071:           C     EACH POINT GROUP AND BRAVAIS LATTICE.
  1072:           C
  1073:           C
  1074:           C     SI-SI DISTANCE
  1075:           C     RSI=4.44D0
  1076:           C     SIMPLE CUBIC LATTICE,  EIGHT ATOMS IN A UNIT CELL
  1077:           CELLDM(1)=ALAT
  1078:           CELLDM(2)=B/A
  1079:           CELLDM(3)=C/A
  1080:           CELLDM(4)=COS(BC)
  1081:           CELLDM(5)=COS(AC)
  1082:           CELLDM(6)=COS(AB)
  1083:           C     Alat=RSI/(SQRT(3.D0)*0.25D0)
  1084:           C                      /VACANCY/ LATTICE CONSTANT
  1085:                 ALAT=CELLDM(1)
  1086:           C
  1087:           C
  1088:                 IF(IOPT(5,2).EQ.0) THEN
  1089:                    GCUT=(GCUT2*4.D0)/((PI*2.D0/CELLDM(1))**2 )
  1090:                 ELSE
  1091:                    if (my_rank.eq.0 ) then
  1092:                    WRITE(6,*) ' !!! DUAL SPACE FORMALISM MAY NOT WORK WELL !!!'
  1093:                    endif
  1094:                    GCUT=(GCUT2*GRAT)/((PI*2.D0/CELLDM(1))**2 )
  1095:                 ENDIF
  1096:           C
  1097:                     IF( ZVAL.LT.0.1D00 ) then
  1098:                      if ( my_rank.eq.0 ) write(6,*)' **  STRUC:  ZVAL = 0 ???'
  1099:                      STOP
  1100:                     ENDIF
  1101:                     NBND =  ZVAL + 0.1D-04
  1102:                     IF( MOD(NBND,2) .EQ. 0 ) THEN
  1103:                          IFLAG = 0
  1104:                          NBND = NBND / 2
  1105:                     ELSE
  1106:                          IFLAG = 1
  1107:                          NBND = NBND / 2 + 1
  1108:                     END IF
  1109: W------>                      DO 120 K=1,NUMKQ
  1110: |*----->                      DO 120 I=1,NBNDQ
  1111: |*-----     120               OCC(I,K)=0.D0
  1112: +------>            DO 121 K=1,NUMKQ
  1113: |         c ****
  1114: |                include 'art_OCC.h'
  1115: |         c ****
  1116: +------     121     CONTINUE
  1117:           C
  1118:           C
  1119:           C     THERE ARE ONE TYPE OF ATOMS.
  1120:           C
  1121:                 IF(IOPT(1,2).EQ.0) THEN
  1122:           C   SI 2
  1123:                   IBRAV = 2
  1124:                   PGIND = 31
  1125:                   NK = 3
  1126:                   NTYPE=1
  1127:                   NUMTY(1)=NTAUQ
  1128: V------>          DO 711 I=1,NTAUQ
  1129: V------     711   NIDN(I,1)=I
  1130:                   MXOFL(1) = 2
  1131: *------>          DO 712 IR=1,3
  1132: |                 A1(IR)=0.D0
  1133: |                 A2(IR)=0.D0
  1134: *------     712   A3(IR)=0.D0
  1135:           C     IBRAV=2:FCC
  1136:           C     A1=(-A/2,  0,A/2)
  1137:           C     A2=(   0,A/2,A/2)
  1138:           C     A3=(-A/2,A/2,  0)
  1139:                   TERM=CELLDM(1)/2.D0
  1140:                   A1(1)=-TERM
  1141:                   A1(3)=TERM
  1142:                   A2(2)=TERM
  1143:                   A2(3)=TERM
  1144:                   A3(1)=-TERM
  1145:                   A3(2)=TERM
  1146:                   TAU(1,1)=0.D0
  1147:                   TAU(2,1)=0.D0
  1148:                   TAU(3,1)=0.D0
  1149:                   TAU(1,2)=ALAT/4.D0
  1150:                   TAU(2,2)=ALAT/4.D0
  1151:                   TAU(3,2)=ALAT/4.D0
  1152:                 ELSEIF(IOPT(1,2).EQ.1) THEN
  1153:           C   ***   SITEST:   SI2 CASE
  1154:                   NTYPE=1
  1155:                   NUMTY(1)=NTAUQ
  1156: V------>          DO 731 I=1,NTAUQ
  1157: V------     731   NIDN(I,1)=I
  1158:                   MXOFL(1) = 2
  1159: *------>          DO 732 IR=1,3
  1160: |                 A1(IR)=0.D0
  1161: |                 A2(IR)=0.D0
  1162: *------     732   A3(IR)=0.D0
  1163:           C     A1=( A/2,   0, A/2)
  1164:           C     A2=( A/2, A/2,   0)
  1165:           C     A3=(   0, A/2, A/2)
  1166:                   TERM=CELLDM(1)/2.D0
  1167:                   A1(1) =  TERM
  1168:                   A1(3) =  TERM
  1169:                   A2(1) =  TERM
  1170:                   A2(2) =  TERM
  1171:                   A3(2) =  TERM
  1172:                   A3(3) =  TERM
  1173:                   TAU(1,1)=0.D0
  1174:                   TAU(2,1)=0.D0
  1175:                   TAU(3,1)=0.D0
  1176:                   TAU(1,2)=ALAT/4.D0
  1177:                   TAU(2,2)=ALAT/4.D0
  1178:                   TAU(3,2)=ALAT/4.D0
  1179:                 ELSEIF(IOPT(1,2).EQ.2 .OR. IOPT(1,2).EQ.30 ) THEN
  1180:           C  **           O2 OR SIO2
  1181:           C         O2
  1182:           CARE    NTYPE = 1
  1183:           C       NUMTY(1) = NTAUQ
  1184:           C       MXOFL(1) = 1
  1185:           C       DO 800 IR=1,3
  1186:           C       A1(IR)=0.D0
  1187:           C       A2(IR)=0.D0
  1188:           C 800   A3(IR)=0.D0
  1189:           C       DO 810 I = 1, NUMTY(1)
  1190:           C 810   NIDN(I,1) = I
  1191:           C       A1(1) =  ALAT
  1192:           C       A2(2) =  ALAT
  1193:           C       A3(3) =  ALAT
  1194:           C       READ(5,*) DIST
  1195:           C
  1196:           C       DO 820 K = 1, 3
  1197:           C       DO 820 ITAU = 1, NUMTY(1)
  1198:           C 820   TAU(K,ITAU) = 0.0D+00
  1199:           C       TAU(3,1) =   0.5D+00 * DIST
  1200:           C       TAU(3,2) = - 0.5D+00 * DIST
  1201:           CARE  **  ALPHA QUARTZ or CRISTOBALITE
  1202:                   NTYPE = 2
  1203:                   NUMTY(1) = NTAUQ / 3
  1204:                   NUMTY(2) = 2 * NUMTY(1)
  1205:                     NUMCHK = NUMTY(1) + NUMTY(2)
  1206:                     IF( NUMCHK .NE. NTAUQ ) THEN
  1207:                        if ( my_rank.eq.0 ) WRITE(6,801) NUMTY(1), NUMTY(2), NTAUQ
  1208:             801        FORMAT(' ** STRUC  SIO2:  NUMTY(1) NUMTY(2) NTAUQ = ',3I5)
  1209:                        STOP
  1210:                     END IF
  1211:                   MXOFL(1) = 2
  1212:                   MXOFL(2) = 1
  1213: *------>          DO 800 IR=1,3
  1214: |                 A1(IR)=0.D0
  1215: |                 A2(IR)=0.D0
  1216: *------     800   A3(IR)=0.D0
  1217: V------>          DO 810 I = 1, NUMTY(1)
  1218: V------     810   NIDN(I,1) = I
  1219: V------>          DO 812 I = 1, NUMTY(2)
  1220: V------     812   NIDN(I,2) = I + NUMTY(1)
  1221:                   if ( my_rank.eq.0 ) then
  1222:                   READ(5,*) COVA, U, X, Y, Z
  1223:                   endif
  1224:                   call MPI_Bcast(COVA,1,MPI_DOUBLE_PRECISION
  1225:                &   ,0,MPI_COMM_WORLD,ierr)
  1226:                   call MPI_Bcast(U   ,1,MPI_DOUBLE_PRECISION
  1227:                &   ,0,MPI_COMM_WORLD,ierr)
  1228:                   call MPI_Bcast(X   ,1,MPI_DOUBLE_PRECISION
  1229:                &   ,0,MPI_COMM_WORLD,ierr)
  1230:                   call MPI_Bcast(Y   ,1,MPI_DOUBLE_PRECISION
  1231:                &   ,0,MPI_COMM_WORLD,ierr)
  1232:                   call MPI_Bcast(Z   ,1,MPI_DOUBLE_PRECISION
  1233:                &   ,0,MPI_COMM_WORLD,ierr)
  1234:                     if( iopt(1,2) .eq. 2 ) then
  1235:                   A1(1) =                    0.5D+00 * ALAT
  1236:                   A1(2) = - 0.5D+00 * SQRT(3.0D+00 ) * ALAT
  1237:                   A2(1) =                    0.5D+00 * ALAT
  1238:                   A2(2) =   0.5D+00 * SQRT(3.0D+00 ) * ALAT
  1239:                   A3(3) =                       COVA * ALAT
  1240:           C
  1241:                   OTH = 0.3333333333333333D+00
  1242: *------>          DO 820 K = 1, 3
  1243: |                 TAU(K,1) = - U * ( A1(K) + A2(K) ) + OTH * A3(K)
  1244: |                 TAU(K,2) =   U * A1(K)
  1245: |                 TAU(K,3) =   U * A2(K) - OTH * A3(K)
  1246: |                 TAU(K,4) =   X * A1(K) + Y * A2(K) + Z * A3(K)
  1247: |                 TAU(K,5) =   (Y-X) * A1(K) - X * A2(K) + (Z+OTH) * A3(K)
  1248: |                 TAU(K,6) = - Y * A1(K) + (X-Y) * A2(K) + (Z-OTH) * A3(K)
  1249: |                 TAU(K,7) =   (X-Y) * A1(K) - Y * A2(K) - Z * A3(K)
  1250: |                 TAU(K,8) =   Y * A1(K) + X * A2(K) - (Z+OTH) * A3(K)
  1251: *------     820   TAU(K,9) = - X * A1(K) + (Y-X) * A2(K) - (Z-OTH) * A3(K)
  1252:           
  1253:           Care *** Tau for Cristobalite  by A.Yokozawa *****
  1254:           
  1255:                       else if( iopt(1,2) .eq. 30 ) then
  1256:                   A1(1) =    ALAT
  1257:                   A2(2) =    ALAT
  1258:                   A3(3) =    COVA * ALAT
  1259: *------>          DO 823 K = 1, 3
  1260: |                 TAU(K, 1) =   U * ( A1(K) + A2(K) )
  1261: |                 TAU(K, 2) =  -U * ( A1(K) + A2(K) ) + 0.5 * A3(K)
  1262: |                 TAU(K, 3) =  (0.5-U) * A1(K) + (0.5+U) * A2(K) - 0.25 * A3(K)
  1263: |                 TAU(K, 4) =  (0.5+U) * A1(K) + (0.5-U) * A2(K) + 0.75 * A3(K)
  1264: |                 TAU(K, 5) =   X * A1(K) + Y * A2(K) + Z * A3(K)
  1265: |                 TAU(K, 6) =  -X * A1(K) - Y * A2(K) + (0.5+Z) * A3(K)
  1266: |                 TAU(K, 7) =  (0.5-Y) * A1(K) + (0.5+X) * A2(K)+(Z+0.25) * A3(K)
  1267: |                 TAU(K, 8) =  (0.5+Y) * A1(K) + (0.5-X) * A2(K)+(Z+0.75) * A3(K)
  1268: |                 TAU(K, 9) =   Y * A1(K) + X * A2(K) - Z * A3(K)
  1269: |                 TAU(K,10) =  -Y * A1(K) - X * A2(K) + (0.5-Z) * A3(K)
  1270: |                 TAU(K,11) =  (0.5-X) * A1(K) + (0.5+Y) * A2(K)+(0.25-Z) * A3(K)
  1271: *------     823   TAU(K,12) =  (0.5+X) * A1(K) + (0.5-Y) * A2(K)+(0.75-Z) * A3(K)
  1272:                       end if
  1273:           C
  1274:                   if ( my_rank.eq.0 ) then
  1275:                   READ(5,*) IREAD
  1276:                   endif
  1277:                   call MPI_Bcast(IREAD,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
  1278:                   IF(IREAD.EQ.1) THEN
  1279:                     if ( my_rank.eq.0 ) then
  1280: +------>            DO 821 I = 1, NTAUQ
  1281: |*----->    821     READ(76,*) ( TAU(K,I), K = 1, 3 )
  1282:                     endif
  1283:                     call MPI_Bcast(TAU,3*NTAUQ,MPI_DOUBLE_PRECISION
  1284:                &     ,0,MPI_COMM_WORLD,ierr)
  1285:                   END IF
  1286:           CARE END
  1287:                 ELSEIF(IOPT(1,2).EQ.13) THEN
  1288:           CARE  **  ALPHA QUARTZ:  TRICLINIC SUPER CELL
  1289:           C        NTYPE = 2
  1290:           C        NUMTY(1) = NTAUQ / 3
  1291:           C        NUMTY(2) = 2 * NUMTY(1)
  1292:           C          NUMCHK = NUMTY(1) + NUMTY(2)
  1293:           C          IF( NUMCHK .NE. NTAUQ ) THEN
  1294:           C             WRITE(6,801) NUMTY(1), NUMTY(2), NTAUQ
  1295:           C             STOP
  1296:           C          END IF
  1297:           C        MXOFL(1) = 2
  1298:           C        MXOFL(2) = 1
  1299:           C        DO 880 IR=1,3
  1300:           C        A1(IR)=0.D0
  1301:           C        A2(IR)=0.D0
  1302:           C  880   A3(IR)=0.D0
  1303:           C        DO 882 I = 1, NUMTY(1)
  1304:           C  882   NIDN(I,1) = I
  1305:           C        DO 884 I = 1, NUMTY(2)
  1306:           C  884   NIDN(I,2) = I + NUMTY(1)
  1307:           C        READ(5,*) COVA
  1308:           C        A1(1) =                    1.5D+00 * ALAT
  1309:           C        A1(2) =   0.5D+00 * SQRT(3.0D+00 ) * ALAT
  1310:           C        A2(2) =             SQRT(3.0D+00 ) * ALAT
  1311:           C        A3(1) =                    0.5D+00 * ALAT
  1312:           C        A3(2) =   0.5D+00 * SQRT(3.0D+00 ) * ALAT
  1313:           C        A3(3) =                       COVA * ALAT
  1314:           C
  1315:           C          DO 888 I = 1, NTAUQ
  1316:           C  888     READ(76,*) ( TAU(K,I), K = 1, 3 )
  1317:           CARE END
  1318:           CARE  **  OXYGEN VACANCY IN ALPHA QUARTZ:  TRICLINIC SUPER CELL
  1319:                   NTYPE = 2
  1320:                   NUMTY(1) = 9
  1321:                   NUMTY(2) = 17
  1322:                   MXOFL(1) = 2
  1323:                   MXOFL(2) = 1
  1324: *------>          DO 880 IR=1,3
  1325: |                 A1(IR)=0.D0
  1326: |                 A2(IR)=0.D0
  1327: *------     880   A3(IR)=0.D0
  1328: V------>          DO 882 I = 1, NUMTY(1)
  1329: V------     882   NIDN(I,1) = I
  1330: V------>          DO 884 I = 1, NUMTY(2)
  1331: V------     884   NIDN(I,2) = I + NUMTY(1)
  1332:                   if ( my_rank.eq.0 ) then
  1333:                   READ(5,*) COVA
  1334:                   endif
  1335:                   call MPI_Bcast(COVA,1,MPI_DOUBLE_PRECISION
  1336:                &    ,0,MPI_COMM_WORLD,ierr)
  1337:                   A1(1) =                    1.5D+00 * ALAT
  1338:                   A1(2) =   0.5D+00 * SQRT(3.0D+00 ) * ALAT
  1339:                   A2(2) =             SQRT(3.0D+00 ) * ALAT
  1340:                   A3(1) =                    0.5D+00 * ALAT
  1341:                   A3(2) =   0.5D+00 * SQRT(3.0D+00 ) * ALAT
  1342:                   A3(3) =                       COVA * ALAT
  1343:           C
  1344:                     if ( my_rank.eq.0 ) then
  1345: +------>            DO 888 I = 1, NTAUQ
  1346: |         CC888     READ(76,*) IDUMM, ( TAU(K,I), K = 1, 3 )
  1347: |*----->    888     READ(76,*) ( TAU(K,I), K = 1, 3 )
  1348:                     endif
  1349:                     call MPI_Bcast(TAU,3*NTAUQ,MPI_DOUBLE_PRECISION
  1350:                &     ,0,MPI_COMM_WORLD,ierr)
  1351:           CARE END
  1352:           c ***** Miyamoto
  1353:           c      for standard inputs
  1354:           c
  1355:                 elseif(iopt(1,2).eq.99) then
  1356:           cccc        read(5,*) alat   ! read in AINPUT
  1357:                   if ( my_rank.eq.0 ) then
  1358: *------>          read(5,*)(avec(i,1),i=1,3)
  1359: *------>          read(5,*)(avec(i,2),i=1,3)
  1360: *------>          read(5,*)(avec(i,3),i=1,3)
  1361:                   endif
  1362:                   call MPI_Bcast(avec,3*3,MPI_DOUBLE_PRECISION
  1363:                &    ,0,MPI_COMM_WORLD,ierr)
  1364: *------>          do 991 i=1,3
  1365: |                  a1(i)=alat*avec(i,1)
  1366: |                  a2(i)=alat*avec(i,2)
  1367: |                  a3(i)=alat*avec(i,3)
  1368: *------     991   continue
  1369:                   if ( my_rank.eq.0 ) read(5,*)ntype
  1370:                   call MPI_Bcast(ntype,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
  1371:                   ntseq=0
  1372: +------>          do 992 ity=1,ntype
  1373: |                  if ( my_rank.eq.0 ) then
  1374: |                  read(5,*)numty(ity),mxofl(ity),amass
  1375: |                  endif
  1376: |                  call MPI_Bcast(numty(ity),1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
  1377: |                  call MPI_Bcast(mxofl(ity),1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
  1378: |                  call MPI_Bcast(amass     ,1,MPI_DOUBLE_PRECISION
  1379: |              &    ,0,MPI_COMM_WORLD,ierr)
  1380: |+----->            do 993 it=1,abs(numty(ity))
  1381: ||                   ntseq=ntseq+1
  1382: ||                   if (ntseq.gt.ntauq ) then
  1383: ||                    if ( my_rank.eq.0 ) then
  1384: ||                    write(6,*) ' NTAUQ should be grater than ',ntseq
  1385: ||                    endif
  1386: ||                    stop
  1387: ||                   endif
  1388: ||                   atmss(ntseq)=amass
  1389: ||                   nidn(it,ity)=ntseq
  1390: ||                   if ( my_rank.eq.0 ) then
  1391: ||+---->             read(5,*)(rat(i),i=1,3)
  1392: ||                   endif
  1393: ||                   call MPI_Bcast(rat,3,MPI_DOUBLE_PRECISION
  1394: ||             &      ,0,MPI_COMM_WORLD,ierr)
  1395: ||                   tau(1,ntseq)=a1(1)*rat(1)+a2(1)*rat(2)+a3(1)*rat(3)
  1396: ||                   tau(2,ntseq)=a1(2)*rat(1)+a2(2)*rat(2)+a3(2)*rat(3)
  1397: ||                   tau(3,ntseq)=a1(3)*rat(1)+a2(3)*rat(2)+a3(3)*rat(3)
  1398: |+-----     993     continue
  1399: +------     992   continue
  1400:           cc
  1401:                 ELSEIF(IOPT(1,2).EQ.11) THEN
  1402:           C   AL
  1403:                   NTYPE=1
  1404:                   MXOFL(1) = 2
  1405:                   NUMTY(1)=NTAUQ
  1406: V------>          DO 721 I=1,NTAUQ
  1407: V------     721   NIDN(I,1)=I
  1408:                   if ( my_rank.eq.0 ) then
  1409:                   READ(5,100) ALAT
  1410:                   endif
  1411:                   call MPI_Bcast(ALAT,1,MPI_DOUBLE_PRECISION
  1412:                &     ,0,MPI_COMM_WORLD,ierr)
  1413:                   if ( my_rank.eq.0 ) then
  1414:                   WRITE(6,200) ALAT
  1415:                   endif
  1416:                   CELLDM(1)=ALAT
  1417:           C
  1418:           C     READ THE BASIS VECTORS FOR THE LATTICE (CARTESIAN COORDINATES
  1419:           C     AND ATOMIC UNITS DIVIDED BY ASCALE). MODIFY ACCORDING TO IOP..
  1420:           C     MULTIPLY BY ALAT.
  1421:           C
  1422:                   if ( my_rank.eq.0 ) then
  1423: *------>          READ(5,101) (IOP(I,1),AVEC(I,1),I=1,3)
  1424: *------>          READ(5,101) (IOP(I,2),AVEC(I,2),I=1,3)
  1425: *------>          READ(5,101) (IOP(I,3),AVEC(I,3),I=1,3)
  1426:                   endif
  1427:                   call MPI_Bcast(IOP, 3*3,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
  1428:                   call MPI_Bcast(AVEC,3*3,MPI_DOUBLE_PRECISION
  1429:                &   ,0,MPI_COMM_WORLD,ierr)
  1430: +------>          DO 10 J=1,3
  1431: |*----->          DO 10 I=1,3
  1432: ||                  SGN=UM
  1433: ||                  IF(AVEC(I,J).LT.ZERO) SGN=-UM
  1434: ||                  AVEC(I,J)=ABS(AVEC(I,J))
  1435: ||                  IF(IOP(I,J).EQ.'S') AVEC(I,J)=SQRT(AVEC(I,J))
  1436: ||                  IF(IOP(I,J).EQ.'C') AVEC(I,J)=AVEC(I,J)**(UM/TRES)
  1437: ||                  IF(IOP(I,J).EQ.'T') AVEC(I,J)=AVEC(I,J)/TRES
  1438: ||                  IF(IOP(I,J).EQ.'H') AVEC(I,J)=AVEC(I,J)/SQRT(TRES)
  1439: ||                  AVEC(I,J)=SGN*ALAT*AVEC(I,J)
  1440: |*-----      10   CONTINUE
  1441: *------>          DO 11 I=1,3
  1442: |                   A1(I)=AVEC(I,1)
  1443: |                   A2(I)=AVEC(I,2)
  1444: |                   A3(I)=AVEC(I,3)
  1445: *------      11   CONTINUE
  1446:                   if ( my_rank.eq.0 ) READ(5,*) NUMAT
  1447:                   call MPI_Bcast(NUMAT,1,MPI_INTETGER,0,MPI_COMM_WORLD,ierr)
  1448:                   IF(NUMAT.NE.NTAUQ) THEN
  1449:                     WRITE(6,*) ' ERROR IN NUMBER OF ATOMS '
  1450:                   ENDIF
  1451: +------>          DO 12 JA=1,NTAUQ
  1452: |                   if ( my_rank.eq.0 ) then
  1453: |*----->            READ(5,101) (JOP(I),RAT(I),I=1,3),IP
  1454: |                   endif
  1455: |                   call MPI_Bcast(JOP,3,MPI_INTEGER  ,0,MPI_COMM_WORLD,ierr)
  1456: |                   call MPI_Bcast(RAT,3,MPI_DOUBLE_PRECISION
  1457: |              &        ,0,MPI_COMM_WORLD,ierr)
  1458: |                   call MPI_Bcast( IP,1,MPI_CHARACTER,0,MPI_COMM_WORLD,ierr)
  1459: |*----->            DO 13 I=1,3
  1460: ||                    SGN=UM
  1461: ||                    IF(RAT(I).LT.ZERO) SGN=-UM
  1462: ||                    RAT(I)=ABS(RAT(I))
  1463: ||                    IF(JOP(I).EQ.'S') RAT(I)=SQRT(RAT(I))
  1464: ||                    IF(JOP(I).EQ.'C') RAT(I)=RAT(I)**(UM/TRES)
  1465: ||                    IF(JOP(I).EQ.'T') RAT(I)=RAT(I)/TRES
  1466: ||                    RAT(I)=SGN*RAT(I)
  1467: |*-----      13     CONTINUE
  1468: |                   IF(IP.NE.' ') THEN
  1469: |                     if ( my_rank.eq.0 ) then
  1470: |*----->              READ(5,101) (JOP(I),DRAT(I),I=1,3)
  1471: |                     endif
  1472: |                     call MPI_Bcast(JOP,3,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
  1473: |                     call MPI_Bcast(DRAT,3,MPI_DOUBLE_PRECISION
  1474: |              &       ,0,MPI_COMM_WORLD,ierr)
  1475: |*----->              DO 14 I=1,3
  1476: ||                      SGN=UM
  1477: ||                      IF(DRAT(I).LT.ZERO) SGN=-UM
  1478: ||                      DRAT(I)=ABS(DRAT(I))
  1479: ||                      IF(JOP(I).EQ.'S') DRAT(I)=SQRT(DRAT(I))
  1480: ||                      IF(JOP(I).EQ.'C') DRAT(I)=DRAT(I)**(UM/TRES)
  1481: ||                      IF(JOP(I).EQ.'T') DRAT(I)=DRAT(I)/TRES
  1482: ||                      DRAT(I)=SGN*DRAT(I)
  1483: ||                      RAT(I)=RAT(I)+DRAT(I)
  1484: |*-----      14       CONTINUE
  1485: |                   ENDIF
  1486: |                   TAU(1,JA)=RAT(1)*A1(1)+RAT(2)*A2(1)+RAT(3)*A3(1)
  1487: |                   TAU(2,JA)=RAT(1)*A1(2)+RAT(2)*A2(2)+RAT(3)*A3(2)
  1488: |                   TAU(3,JA)=RAT(1)*A1(3)+RAT(2)*A2(3)+RAT(3)*A3(3)
  1489: +------      12   CONTINUE
  1490:                   if ( my_rank.eq.0 ) READ(5,*) IBRAV,PGIND
  1491:                   call MPI_Bcast(IBRAV,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
  1492:                   call MPI_Bcast(PGIND,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
  1493:           C
  1494:                 ELSEIF(IOPT(1,2).EQ.5) THEN
  1495:           C     SI8 CUBIC STRUCTURE
  1496:                    IBRAV=1
  1497:                    PGIND=1
  1498:                    ALAT=CELLDM(1)
  1499:                    NTYPE=1
  1500:                    MXOFL(1) = 2
  1501:                    NUMTY(1)=NTAUQ
  1502: V------>           DO 31 I=1,NTAUQ
  1503: V------      31    NIDN(I,1)=I
  1504: *------>           DO 32 IR=1,3
  1505: |                  A1(IR)=0.D0
  1506: |                  A2(IR)=0.D0
  1507: *------      32    A3(IR)=0.D0
  1508:           C        CUBIC 8 ATOMS
  1509:           C        A1=(  A,  0,  0)
  1510:           C        A2=(  0,  A,  0)
  1511:           C        A3=(  0,  0,  A)
  1512:                    A1(1)=ALAT
  1513:                    A2(2)=ALAT
  1514:                    A3(3)=ALAT
  1515:           C
  1516:                   if ( my_rank.eq.0 ) then
  1517: +------>          DO 33 J=1,NTAUQ
  1518: |*----->     33   READ(76,*) (TAU(I,J),I=1,3)
  1519:                   endif
  1520:                   call MPI_Bcast(tau,3*NTAUQ,MPI_DOUBLE_PRECISION
  1521:                &   ,0,MPI_COMM_WORLD,ierr)
  1522:           C **
  1523:                 ELSEIF(IOPT(1,2).EQ.6) THEN
  1524:           C               SI SLAB
  1525:                    ALAT=CELLDM(1)
  1526:                    NTYPE=1
  1527:                    MXOFL(1) = 2
  1528:                    NUMTY(1)=NTAUQ
  1529: V------>           DO 35 I=1,NTAUQ
  1530: V------      35    NIDN(I,1)=I
  1531: *------>           DO 36 IR=1,3
  1532: |                  A1(IR)=0.D0
  1533: |                  A2(IR)=0.D0
  1534: *------      36    A3(IR)=0.D0
  1535:                    A1(1) =   0.5D+00 * ALAT
  1536:                    A1(2) =   0.5D+00 * ALAT
  1537:                    A2(1) = - 0.5D+00 * ALAT
  1538:                    A2(2) =   0.5D+00 * ALAT
  1539:           C ***       SI XTAL (5 LAYER)
  1540:           C                 A3(3) =   ALAT
  1541:           C ***       SI (100)  (5 LAYER + 6-LAYER VACUUM)
  1542:           C                 A3(3) =   2.5D+00 * ALAT
  1543:           C ***       SI (100)  (9 LAYER + 6-LAYER VACUUM)
  1544:           C                 A3(3) =   3.5D+00 * ALAT
  1545:                      if ( my_rank.eq.0 )READ(5,*) A3(3)
  1546:                      call MPI_Bcast(A3(3),1,MPI_DOUBLE_PRECISION
  1547:                &      ,0,MPI_COMM_WORLD,ierr)
  1548:                      A3(3) = A3(3) * ALAT
  1549:           C
  1550:                   if ( my_rank.eq.0 ) then
  1551: +------>          DO 37 J=1,NTAUQ
  1552: |*----->     37   READ(5,*) (TAU(I,J),I=1,3)
  1553:                   endif
  1554:                   call MPI_Bcast(TAU,3*NTAUQ,MPI_DOUBLE_PRECISION
  1555:                &    ,0,MPI_COMM_WORLD,ierr)
  1556:           C ***
  1557:                 ELSEIF(IOPT(1,2).EQ.9) THEN
  1558:           C     SIH4 CUBIC STRUCTURE
  1559:                    ALAT=CELLDM(1)
  1560:                    NTYPE=2
  1561:                    NUMTY(1)=1
  1562:                    MXOFL(1) = 2
  1563:           C ** FOR LOCAL POTENTIAL ONLY, SET NUMTY BE NEGATIVE.
  1564:                        NUMTY(2)= - ( NTAUQ-NUMTY(1) )
  1565:                        MXOFL(2) = 0
  1566:           C **
  1567: +------>           DO 631 I=1,ABS(NUMTY(1))
  1568: +------     631    NIDN(I,1)=I
  1569: V------>           DO 639 I=1,ABS(NUMTY(2))
  1570: V------     639    NIDN(I,2)=I + NUMTY(1)
  1571: *------>           DO 632 IR=1,3
  1572: |                  A1(IR)=0.D0
  1573: |                  A2(IR)=0.D0
  1574: *------     632    A3(IR)=0.D0
  1575:           C        CUBIC 8 ATOMS
  1576:           C        A1=(  A,  0,  0)
  1577:           C        A2=(  0,  A,  0)
  1578:           C        A3=(  0,  0,  A)
  1579:                    A1(1)=ALAT
  1580:                    A2(2)=ALAT
  1581:                    A3(3)=ALAT
  1582:           C
  1583:                   if ( my_rank.eq.0 ) then
  1584: +------>          DO 633 J=1,NTAUQ
  1585: |*----->    633   READ(5,*) (TAU(I,J),I=1,3)
  1586:                   endif
  1587:                   call MPI_Bcast(TAU,3*NTAUQ,MPI_DOUBLE_PRECISION
  1588:                &   ,0,MPI_COMM_WORLD,ierr)
  1589:           C **
  1590:           C
  1591:                 ELSEIF( IOPT(1,2) .EQ. 21 ) THEN
  1592:           C     SI/GE PLUS H
  1593:                    ALAT = CELLDM(1)
  1594:                    NTYPE=3
  1595:           C ** TYPE 1 = GE, TYPE 2 = SI, TYPE 3 = H
  1596:                    NUMTY(1) = 10
  1597:                    NUMTY(2) = 2
  1598:                    NUMTY(3) = - 4
  1599:                    MXOFL(1) = 2
  1600:                    MXOFL(2) = 2
  1601:                    MXOFL(3) = 0
  1602: V------>           DO 645 I=1,ABS(NUMTY(1))
  1603: V------     645    NIDN(I,1) = I + 2
  1604:                    NIDN(1,2) = 1
  1605:                    NIDN(2,2) = 2
  1606: V------>           DO 646 I=1,ABS(NUMTY(3))
  1607: V------     646    NIDN(I,3) = I + ABS(NUMTY(1)) + ABS(NUMTY(2))
  1608:                    A1(1) =   0.5D+00  *   ALAT
  1609:                    A1(2) = - 0.5D+00  *   ALAT
  1610:                    A1(3) =   0.0D+00
  1611:                    A2(1) =   1.0D+00  *   ALAT
  1612:                    A2(2) =   1.0D+00  *   ALAT
  1613:                    A2(3) =   0.0D+00
  1614:                    A3(1) =   0.0D+00
  1615:                    A3(2) =   0.0D+00
  1616:                    A3(3) =   2.75D+00 *   ALAT
  1617:           C
  1618:                   if ( my_rank.eq.0 ) then
  1619: +------>          DO 648 J=1,NTAUQ
  1620: |*----->    648   READ(76,*) (TAU(I,J),I=1,3)
  1621:                   endif
  1622:                   call MPI_Bcast(TAU,3*NTAUQ,MPI_DOUBLE_PRECISION
  1623:                &   ,0,MPI_COMM_WORLD,ierr)
  1624:           C **
  1625:           C
  1626:                 ELSEIF(IOPT(1,2).EQ.8) THEN
  1627:           C     SISLH1
  1628:                    ALAT=CELLDM(1)
  1629:                    NTYPE=2
  1630:                    NUMTY(1)=10
  1631:                    MXOFL(1) = 2
  1632:           C ** FOR LOCAL POTENTIAL ONLY, SET NUMTY BE NEGATIVE.
  1633:                        NUMTY(2)= - ( NTAUQ-NUMTY(1) )
  1634:                        MXOFL(2) = 0
  1635:           C **
  1636: V------>           DO 640 I=1,ABS(NUMTY(1))
  1637: V------     640    NIDN(I,1)=I
  1638: V------>           DO 641 I=1,ABS(NUMTY(2))
  1639: V------     641    NIDN(I,2)=I + NUMTY(1)
  1640: *------>           DO 642 IR=1,3
  1641: |                  A1(IR)=0.D0
  1642: |                  A2(IR)=0.D0
  1643: *------     642    A3(IR)=0.D0
  1644:           C           2X1 LATERAL CELL
  1645:                    A1(1) =   0.5D+00  * ALAT
  1646:                    A1(2) = - 0.5D+00  * ALAT
  1647:                    A2(1) =              ALAT
  1648:                    A2(2) =              ALAT
  1649:           C TEMP   A3(3) =   2.75D+00 * ALAT
  1650:                    A3(3) =   2.25D+00 * ALAT
  1651:           C
  1652:                   if ( my_rank.eq.0 ) then
  1653: +------>          DO 643 J=1,NTAUQ
  1654: |*----->    643   READ(76,*) (TAU(I,J),I=1,3)
  1655:                   endif
  1656:                   call MPI_Bcast(TAU,3*NTAUQ,MPI_DOUBLE_PRECISION
  1657:                &   ,0,MPI_COMM_WORLD,ierr)
  1658:           C **
  1659:           C **
  1660:           C
  1661:                 ELSEIF(IOPT(1,2).EQ.3) THEN
  1662:           C     SISLH2
  1663:                    ALAT=CELLDM(1)
  1664:                    NTYPE=2
  1665:                    NUMTY(1)=72
  1666:                    MXOFL(1) = 2
  1667:           C ** FOR LOCAL POTENTIAL ONLY, SET NUMTY BE NEGATIVE.
  1668:                        NUMTY(2)= - ( NTAUQ-NUMTY(1) )
  1669:                        MXOFL(2) = 0
  1670:           C **
  1671: V------>           DO 650 I=1,ABS(NUMTY(1))
  1672: V------     650    NIDN(I,1)=I
  1673: V------>           DO 651 I=1,ABS(NUMTY(2))
  1674: V------     651    NIDN(I,2)=I + NUMTY(1)
  1675: *------>           DO 652 IR=1,3
  1676: |                  A1(IR)=0.D0
  1677: |                  A2(IR)=0.D0
  1678: *------     652    A3(IR)=0.D0
  1679:           C           6X2 LATERAL CELL
  1680:                    A1(1) =              ALAT
  1681:                    A1(2) = -            ALAT
  1682:                    A2(1) =   3.00D+00  * ALAT
  1683:                    A2(2) =   3.00D+00  * ALAT
  1684:                    A3(3) =   3.00D+00  * ALAT
  1685:           C
  1686:                   if ( my_rank.eq.0 ) then
  1687: +------>          DO 653 J=1,NTAUQ
  1688: |*----->    653   READ(76,*) (TAU(I,J),I=1,3)
  1689:                   endif
  1690:                   call MPI_Bcast(TAU,3*NTAUQ,MPI_DOUBLE_PRECISION
  1691:                &    ,0,MPI_COMM_WORLD,ierr)
  1692:           C **
  1693:           C **
  1694:           C
  1695:                 ELSEIF(IOPT(1,2).EQ.4) THEN
  1696:           C     SISLH3
  1697:           C ******* CARE
  1698:                    ALAT=CELLDM(1)
  1699:                    NTYPE=2
  1700:           C 2X4    NUMTY(1)=40
  1701:           C 2X8    NUMTY(1)=80
  1702:                    NUMTY(1)=20
  1703:           C        NUMTY(1)=62
  1704:           C 2X6DBN NUMTY(1)=58
  1705:           C 2X1    NUMTY(1)=20
  1706:                    MXOFL(1) = 2
  1707:           C ** FOR LOCAL POTENTIAL ONLY, SET NUMTY BE NEGATIVE.
  1708:                        NUMTY(2)= - ( NTAUQ-NUMTY(1) )
  1709:                        MXOFL(2) = 0
  1710:           C **
  1711: V------>           DO 660 I=1,ABS(NUMTY(1))
  1712: V------     660    NIDN(I,1)=I
  1713: V------>           DO 661 I=1,ABS(NUMTY(2))
  1714: V------     661    NIDN(I,2)=I + NUMTY(1)
  1715: *------>           DO 662 IR=1,3
  1716: |                  A1(IR)=0.D0
  1717: |                  A2(IR)=0.D0
  1718: *------     662    A3(IR)=0.D0
  1719:           C           2X2  2X4  2X6  2X8  LATERAL CELL
  1720:                    A1(1) =              ALAT
  1721:                    A1(2) = -            ALAT
  1722:           CARE     A2(1) =   4.00D+00  * ALAT
  1723:           CARE     A2(2) =   4.00D+00  * ALAT
  1724:           CARE     A2(1) =   3.00D+00  * ALAT
  1725:           CARE     A2(2) =   3.00D+00  * ALAT
  1726:           CARE     A2(1) =   2.00D+00  * ALAT
  1727:           CARE     A2(2) =   2.00D+00  * ALAT
  1728:                    A2(1) =   1.00D+00  * ALAT
  1729:                    A2(2) =   1.00D+00  * ALAT
  1730:                    A3(3) =   2.75D+00  * ALAT
  1731:           CARE     A3(3) =   3.00D+00  * ALAT
  1732:           CARE     A3(3) =   2.50D+00  * ALAT
  1733:           C
  1734:                   if ( my_rank.eq.0 ) then
  1735: +------>          DO 663 J=1,NTAUQ
  1736: |*----->    663   READ(76,*) (TAU(I,J),I=1,3)
  1737:                   endif
  1738:                   call MPI_Bcast(TAU,3*NTAUQ,MPI_DOUBLE_PRECISION
  1739:                &    ,0,MPI_COMM_WORLD,ierr)
  1740:           C **
  1741:           C **
  1742:           C
  1743:                 ELSEIF(IOPT(1,2).EQ.10) THEN
  1744:           C     SISLH4:  VICINAL SURFACE
  1745:                    ALAT=CELLDM(1)
  1746:                    NTYPE=2
  1747:           CARE ***    NON-REBONDED DB CASE AND OTHERS
  1748:           CARE     NUMTY(1)=62
  1749:                    NUMTY(1)=63
  1750:           CARE     NUMTY(1)=64
  1751:                    MXOFL(1) = 2
  1752:           CARE END ****
  1753:           C ** FOR LOCAL POTENTIAL ONLY, SET NUMTY BE NEGATIVE.
  1754:                        NUMTY(2)= - ( NTAUQ-NUMTY(1) )
  1755:                        MXOFL(2) = 0
  1756:           C **
  1757: V------>           DO 670 I=1,ABS(NUMTY(1))
  1758: V------     670    NIDN(I,1)=I
  1759: V------>           DO 671 I=1,ABS(NUMTY(2))
  1760: V------     671    NIDN(I,2)=I + NUMTY(1)
  1761: *------>           DO 672 IR=1,3
  1762: |                  A1(IR)=0.D0
  1763: |                  A2(IR)=0.D0
  1764: *------     672    A3(IR)=0.D0
  1765:           C          (1,1,15) VICINAL SURFACE
  1766:                    A1(1) =              ALAT
  1767:                    A1(2) = -            ALAT
  1768:                    A2(1) =   3.50D+00  * ALAT
  1769:                    A2(2) =   4.00D+00  * ALAT
  1770:                    A2(3) = - 0.50D+00  * ALAT
  1771:           C ****  TEMP CARE
  1772:                          THICK =  26.0D+00
  1773:           C ****
  1774:                    A3(1) =              THICK / SQRT( 227.0D+00 )
  1775:                    A3(2) =              THICK / SQRT( 227.0D+00 )
  1776:                    A3(3) =   15.0D+00 * THICK / SQRT( 227.0D+00 )
  1777:           C
  1778:                   if ( my_rank.eq.0 ) then
  1779: +------>          DO 673 J=1,NTAUQ
  1780: |*----->    673   READ(76,*) JDUMMY, (TAU(I,J),I=1,3)
  1781:                   endif
  1782:                   call MPI_Bcast(TAU,3*NTAUQ,MPI_DOUBLE_PRECISION
  1783:                &   ,0,MPI_COMM_WORLD,ierr)
  1784:           CARE    DO 673 J=1,NTAUQ
  1785:           C 673   READ(76,*)         (TAU(I,J),I=1,3)
  1786:           C **
  1787:           C **
  1788:           C
  1789:                 ELSEIF(IOPT(1,2).EQ.12) THEN
  1790:           C     SISLH5:  (1,1,10) VICINAL SURFACE
  1791:                    ALAT=CELLDM(1)
  1792:                    NTYPE=2
  1793:           CARE ***    QB CASE
  1794:                    NUMTY(1)=84
  1795:                    MXOFL(1) = 2
  1796:           CARE END ****
  1797:           C ** FOR LOCAL POTENTIAL ONLY, SET NUMTY BE NEGATIVE.
  1798:                        NUMTY(2)= - ( NTAUQ-NUMTY(1) )
  1799:                        MXOFL(2) = 0
  1800:           C **
  1801: V------>           DO 680 I=1,ABS(NUMTY(1))
  1802: V------     680    NIDN(I,1)=I
  1803: V------>           DO 681 I=1,ABS(NUMTY(2))
  1804: V------     681    NIDN(I,2)=I + NUMTY(1)
  1805: *------>           DO 682 IR=1,3
  1806: |                  A1(IR)=0.D0
  1807: |                  A2(IR)=0.D0
  1808: *------     682    A3(IR)=0.D0
  1809:           C          (1,1,10) VICINAL SURFACE
  1810:                    A1(1) =              ALAT
  1811:                    A1(2) = -            ALAT
  1812:                    A2(1) =   5.0D+00  * ALAT
  1813:                    A2(2) =   5.0D+00  * ALAT
  1814:                    A2(3) = - 1.0D+00  * ALAT
  1815:           C ****  TEMP CARE
  1816:                          THICK =  26.0D+00
  1817:           C ****
  1818:                    A3(1) =              THICK / SQRT( 102.0D+00 )
  1819:                    A3(2) =              THICK / SQRT( 102.0D+00 )
  1820:                    A3(3) =   10.0D+00 * THICK / SQRT( 102.0D+00 )
  1821:           C
  1822:                   if ( my_rank.eq.0 ) then
  1823: +------>          DO 683 J=1,NTAUQ
  1824: |*----->    683   READ(76,*) (TAU(I,J),I=1,3)
  1825:                   endif
  1826:                   call MPI_Bcast(TAU,3*NTAUQ,MPI_DOUBLE_PRECISION
  1827:                &    ,0,MPI_COMM_WORLD,ierr)
  1828:           C **
  1829:           C
  1830:                 ENDIF
  1831:           C
  1832:           C
  1833:                 if ( my_rank.eq.0 ) then
  1834:                 WRITE(6,6000)
  1835:            6000 FORMAT(/
  1836:                & ' INITIAL POSITION OF ATOM IN CARTESIAN COORDINATE IN ATOMIC'
  1837:                &,' UNIT:')
  1838: +------>        DO 314 J=1,NTAUQ
  1839: |*----->    314 WRITE(6,6001) J, (TAU(I,J),I=1,3)
  1840:            6001 FORMAT(3X,I4,2X,3F15.7)
  1841: +------>        WRITE(6,6003) NTYPE, ( NUMTY(J), J=1,NTYPE )
  1842:            6003 FORMAT(5X,'  ****  NTYPE = ',I3,'  NUMTY = ',4I4)
  1843:                 endif
  1844:           C
  1845:           C     WRITE(6,*) ' BAND OCCUPATION FOR NBNDQ BANDS: '
  1846:           C     DO 322 K=1,NUMKQ
  1847:           C 322 WRITE(6,6002) K, (OCC(I,K),I=1,NBNDQ)
  1848:           C6002 FORMAT(3X,'K = ',I3/(7X,6F7.3) )
  1849:           C
  1850:           C
  1851:            1000 OMEGA=0.D0
  1852:                 S=1.D0
  1853:                 I=1
  1854:                 J=2
  1855:                 K=3
  1856: *------>   1001 DO 1002 IPERM=1,3
  1857: |               OMEGA=OMEGA+S*A1(I)*A2(J)*A3(K)
  1858: |               L=I
  1859: |               I=J
  1860: |               J=K
  1861: |               K=L
  1862: *------    1002 CONTINUE
  1863:                 I=2
  1864:                 J=1
  1865:                 K=3
  1866:                 S=-S
  1867:                 IF(S.LT.0.D0) GO TO 1001
  1868:                 OMEGA=ABS(OMEGA)
  1869:           C
  1870:           C
  1871:                 RETURN
  1872:             100 FORMAT(F12.6)
  1873:             101 FORMAT(3(2X,A1,F12.6),1X,A1)
  1874:             200 FORMAT(//,' CRYSTAL STRUCTURE :',//,' LATTICE CONSTANT ',
  1875:                &      F12.5,' (A.U.)',/)
  1876:            7100 FORMAT(3(4X,F14.7))
  1877:                 END


