NEC Fortran Compiler (3.4.2) for Vector Engine   Thu Jul 28 08:27:42 2022
FILE NAME: tmevl10_Avec_v4.f

PROCEDURE NAME: TMEVL
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

    15:                 SUBROUTINE TMEVL(itstep, OSHI,ITCF,NRX,NRY,NRZ,NXYZ,NG2,NG2Q,
    16:           c     &               NBNDQ,NBSEQ, NBND, P, HP, PJ,
    17:                &               NBNDQ,NBSEQ, NBND, P, HP,
    18:                &                   YLM, G2, RHO1, RHO2, RHO3,
    19:           c     &                   TPIBA, VG, J2G, WORK2, OUT, VPJ,
    20:                &   TPIBA, VG,VG1,VG2,VG3,VG4,VG5, J2G, WORK2, OUT, VPJ,
    21:           c
    22:                &                   VPP,
    23:                &                   IOWF, IOVP, MXBND, MBLK,
    24:                &                   OMEGA, NTAUQ, NTYQ, NTYPE, LREQ, TAU, NUMTY,
    25:           c *** for Sugino FFT
    26:           c     &                   NIDN, EE, WSAVEX, WSAVEY, WSAVEZ, IFACX,
    27:           c     &                   IFACY, IFACZ, LX1, LX2, LY1, LY2, LZ1, LZ2,
    28:           c *** for Kokubo ASL FFT
    29:           c     &                   NIDN, EE, WSAVE_XYZ, IFAC_XYZ,
    30:           c *** for Kokubo FFTW
    31:                &                   NIDN, EE, plancfp,plancbp,
    32:           c
    33:                &    MXOFL,dt,IK,NUMK,VPP2,EXTAU
    34:                &   ,GDUMP
    35:                &   ,GMHF,fdump,Vloc,NGNL
    36:           c *** for P-A formalism
    37:                &         ,YLM1,YLM2,YLM3,YLM4,YLM5,GG2,G21,G22,G23,G24,G25,
    38:           c +++++ for P-A VPJ is updated
    39:                &   VPJWORK,VPJ1,VPJ2,VPJ3,VPJ4,VPJ5
    40:           c ++++ P-A
    41:                &   ,VPP21,VPP22,VPP23,VPP24,VPP25
    42:           c  +++ for A-vector GDUMP1 to GDUMP5
    43:                &   ,GDUMP1,GDUMP2,GDUMP3,GDUMP4,GDUMP5
    44:                &   ,RAD,PSPOT,PSPOT2,PHIL,MESHQ,ISPD
    45:           c
    46:                &   ,NGcont
    47:           c
    48:                &   ,nbegin,nend,mshbegin,mshend,ncpuq,ncpu )
    49:           C
    50:                 IMPLICIT REAL*8(A-H,O-Z)
    51:                 include 'mpif.h'
    52:           c      parameter ( ncpuq=30 )
    53:           c      include 'ncpuq.h'
    54:                 COMPLEX*16  P(NG2Q,MXBND), HP(NG2Q,1)
    55:           c      COMPLEX*16  P(NG2Q,MXBND), HP(NG2Q,3)
    56:           c     &            PJ(NG2Q,MXBND)
    57:                 DIMENSION IOWF(MBLK),IOVP(2,NTYQ)
    58:           C
    59:           c      REAL*8 YLM(NG2Q,4),OUT(NBNDQ,3),EE(NBNDQ)
    60:           c      REAL*8 YLM(NG2Q,9),OUT(NBNDQ,3),EE(NBNDQ)
    61:                 REAL*8 YLM(NGcont,16),OUT(NBNDQ,3),EE(NBNDQ)
    62:           c *** for P-A formalisms
    63:                 dimension YLM1(NGcont,16),YLM2(NGcont,16),YLM3(NGcont,16),
    64:                &          YLM4(NGcont,16),YLM5(NGcont,16)
    65:           c
    66:           c      COMPLEX*16 RHO1(NXYZ),RHO2(NXYZ),RHO3(NXYZ),
    67:                 COMPLEX*16 RHO1(NXYZ),RHO2(NXYZ),
    68:           c     &           VG(NXYZ),WORK2(NG2Q,3)
    69:           c     &           VG(NXYZ),WORK2(NG2Q,5)
    70:                &           VG(NXYZ),WORK2(NG2Q,7)
    71:           c     & VG(NXYZ),VG1(NXYZ),VG2(NXYZ),VG3(NXYZ),VG4(NXYZ),
    72:           c     & VG5(NXYZ),WORK2(NG2Q,3)
    73:                 dimension VG1(NXYZ),VG2(NXYZ),VG3(NXYZ),VG4(NXYZ),
    74:                & VG5(NXYZ)
    75:           c ***  attention !!
    76:           c      COMPLEX*16 EXTAU(NXYZ,NTAUQ)
    77:           c      COMPLEX*16 EXTAU(NXYZ,NTAUQ,5)
    78:           c      COMPLEX*16 EXTAU(NXYZ/6,NTAUQ,5)
    79:                 COMPLEX*16 EXTAU(NGcont,5,NTAUQ)
    80:           c *** for Sugino FFT
    81:           c      COMPLEX*16 WSAVEX(NRX),WSAVEY(NRY),WSAVEZ(NRZ)
    82:           c *** for Kokubo ASL FFT
    83:           c      COMPLEX*16 WSAVE_XYZ(NRX+NRY+NRZ)
    84:           c *** for Kokubo FFTW
    85:                 integer*8 plancfp,plancbp
    86:                 DIMENSION RHO3(NXYZ)
    87:           c ** for Sugino FFT
    88:           c      DIMENSION IFACX(30),IFACY(30),IFACZ(30)
    89:           c      DIMENSION LX1(NXYZ),LX2(NXYZ),LY1(NXYZ),
    90:           c     &          LY2(NXYZ),LZ1(NXYZ),LZ2(NXYZ)
    91:           c ** for Kokubo ASL FFT
    92:           c      DIMENSION IFAC_XYZ(60)
    93:           c ** for Kokubo FFTW -- nothing is needed for IFAC
    94:                 DIMENSION J2G(NG2Q),G2(4,NG2Q),GDUMP(NG2Q)
    95:           c +++ for P-A formalisms
    96:                 DIMENSION GG2(4,NG2Q)
    97:                 DIMENSION G21(4,NG2Q),G22(4,NG2Q),G23(4,NG2Q),
    98:                &          G24(4,NG2Q),G25(4,NG2Q)
    99:           c +++ for A-vec GDUMP1 to GDUMP5
   100:                 DIMENSION GDUMP1(NG2Q),GDUMP2(NG2Q),GDUMP3(NG2Q)
   101:                &         ,GDUMP4(NG2Q),GDUMP5(NG2Q)
   102:                 DIMENSION TAU(3,NTAUQ),NUMTY(NTYQ),NIDN(NTAUQ,NTYQ), MXOFL(NTYQ)
   103:           c      DIMENSION VPJ(NG2Q,3),VPP(3)
   104:           c      DIMENSION VPJ(NG2Q,3,2,NTYQ),VPP(3,2,NTYQ)
   105:           c      DIMENSION VPJ(NG2Q/3,3,3,NTYQ),VPP(3,3,NTYQ)
   106:                 DIMENSION VPJ(NGcont,3,4,NTYQ),VPP(3,4,NTYQ)
   107:           c +++ for P-A VPJ is updated!!
   108:                 dimension VPJWORK(NGcont,3),
   109:                &          VPJ1(NGcont,3,4,NTYQ),VPJ2(NGcont,3,4,NTYQ),
   110:                &          VPJ3(NGcont,3,4,NTYQ),VPJ4(NGcont,3,4,NTYQ),
   111:                &          VPJ5(NGcont,3,4,NTYQ)
   112:           c
   113:                 dimension RAD(MESHQ,NTYQ),PSPOT(MESHQ,ISPD,NTYQ),
   114:                &    PSPOT2(MESHQ,ISPD,NTYQ),PHIL(MESHQ,4,NTYQ)
   115:           c
   116:           c      dimension VPP2(4,3,NTYQ)
   117:           c      dimension VPP2(9,3,NTYQ)
   118:                 dimension VPP2(16,3,NTYQ)
   119:           c +++ for P-A +++
   120:                &  ,VPP21(16,3,NTYQ),VPP22(16,3,NTYQ),VPP23(16,3,NTYQ)
   121:                &  ,VPP24(16,3,NTYQ),VPP25(16,3,NTYQ)
   122:                 dimension fdump(NXYZ)
   123:           c      complex*16 RHO4(NXYZ)  ! but used as real
   124:                 dimension Vloc(NXYZ,5)
   125:                 dimension NGNL(NTYQ)
   126:           C
   127:                 complex*16 dtex,cone
   128:           C
   129:                 integer tag,status(MPI_STATUS_SIZE)
   130:           c
   131:                 common/tmod/itmod
   132:                 common/Suzuki/ioption
   133:           c      common/cputask/nbegin(0:ncpuq),nend(0:ncpuq),ncpu
   134:                 dimension nbegin(0:ncpuq),nend(0:ncpuq)
   135:                 dimension mshbegin(0:ncpuq),mshend(0:ncpuq)
   136:                 logical VPJGENdo
   137:                 common/ExtDyn/VPJGENdo
   138:           c
   139:           c ***  temp check
   140:           c      write(6,*)' in sub. VG in real space '
   141:           c      write(6,*)( VG(ig),ig=1,1500,100 )
   142:           c ***  temp check : end
   143:           c      ioption=2     ! choise of second order decomposition
   144:           c      ioption=3     ! choise of 4-th order decomposition ver.1
   145:           c      ioption=4     ! choise of 4-th order decomposition ver.2
   146:           c
   147:                 call MPI_COMM_RANK(MPI_COMM_WORLD,my_rank,ierr)
   148:           c
   149:           c  *** temp check
   150:           c      if (my_rank.eq.0) then
   151:           c       write(6,*)' GDUMP '
   152:           c       write(6,'(4F22.16)')( GDUMP(IG),IG=1,NXYZ,50000)
   153:           c       write(6,*)' GDUMP1'
   154:           c       write(6,'(4F22.16)')( GDUMP1(IG),IG=1,NXYZ,50000)
   155:           c       write(6,*)' GDUMP2'
   156:           c       write(6,'(4F22.16)')( GDUMP2(IG),IG=1,NXYZ,50000)
   157:           c       write(6,*)' GDUMP3'
   158:           c       write(6,'(4F22.16)')( GDUMP3(IG),IG=1,NXYZ,50000)
   159:           c       write(6,*)' GDUMP4'
   160:           c       write(6,'(4F22.16)')( GDUMP4(IG),IG=1,NXYZ,50000)
   161:           c       write(6,*)' GDUMP5'
   162:           c      endif
   163:           c
   164:                 cone=dcmplx( 0.d0, 1.d0)
   165:                 PI=4.D0*ATAN(1.D0)
   166:                 TPIBA2=TPIBA**2
   167:           C
   168:                 if ( MBLK.ne.1 ) then
   169:                 if ( my_rank.eq.0 ) write(6,*) 'in sub. TMEVL:  MBLK = ',MBLK
   170:                 stop
   171:                 endif
   172:           c
   173:           c      NJ=MXBND
   174:                 NJ=NBSEQ
   175:           c
   176: V------>           DO 588 IG=1,NG2
   177: |         c         DO 588 IG=1,NXYZ
   178: |                   GX=GG2(1,IG)
   179: |                   GY=GG2(2,IG)
   180: |                   GZ=GG2(3,IG)
   181: V------     588    RHO3(IG)=DSQRT(GG2(4,IG))*TPIBA
   182:           c
   183:           c +++++++++
   184:                    NGNLMX=1
   185: V------>           do ity=1,NTYPE
   186: |                   NGNLMX=MAX(NGNL(ity),NGNLMX)
   187: V------            enddo
   188:           c +++++++++ now GG2 depends P-A, thus YLM VPJ VPP2 are, too
   189:           c         CALL GETYLM(NG2Q,NG2,G2,RHO3,YLM,TPIBA)
   190:                    CALL GETYLM(NG2Q,NGNLMX,GG2,RHO3,YLM,TPIBA,NGcont)
   191:                    if (VPJGENdo) then
   192:                    CALL VPJ_GEN(G2,GG2,NG2Q,NG2,RHO3,VPJ,VPJWORK,VPP2,
   193:                &    TPIBA,NTYQ,ntype,GMHF,MXOFL
   194:                &    ,RAD,PSPOT,PSPOT2,PHIL,MESHQ,ISPD,NGNL,OMEGA,NGcont
   195:                &    ,mshbegin,mshend,ncpuq )
   196:                    endif
   197:           c *** temp check
   198:           c         if (my_rank.eq.0) then
   199:           c           write(6,*)' after DO 588 VPJ_GEN ended'
   200:           c           do ity=1,NTYPE
   201:           c           write(6,*)' ity = ',ity
   202:           c           write(6,'(4F22.16)')(VPJ(IG,1,1,ity),IG=1,NGNL(ITY),1000)
   203:           c           enddo
   204:           c         endif
   205:           c *** temp check end
   206:           c *** for P-A
   207:           c     *** part 1 ***
   208:           c         do ig=1,NG2Q/6
   209:           c          GX=G21(1,IG)
   210:           c          GY=G21(2,IG)
   211:           c          GZ=G21(3,IG)
   212:           c          RHO3(IG)=DSQRT(G21(4,IG))*TPIBA
   213:           c         enddo
   214:           c         CALL GETYLM(NG2Q,NGNLMX,G21,RHO3,YLM1,TPIBA)
   215:           c         CALL VPJ_GEN(G21,NG2Q,NG2,RHO3,VPJ1,VPJWORK,VPP21,
   216:           c     &               TPIBA,NTYQ,ntype,GMHF,MXOFL
   217:           c     &    ,RAD,PSPOT,PSPOT2,PHIL,MESHQ,ISPD,NGNL,OMEGA)
   218:           c *** temp check
   219:           c         if (my_rank.eq.0) then
   220:           c           write(6,*)' part 1   VPJ_GEN ended'
   221:           c           do ity=1,NTYPE
   222:           c           write(6,*)' ity = ',ity
   223:           c           write(6,'(4F22.16)')(VPJ1(IG,1,1,ity),IG=1,NGNL(ITY),1000)
   224:           c           enddo
   225:           c         endif
   226:           c *** temp check end
   227:           c     *** part 2 ***
   228:           c         do ig=1,NG2Q/6
   229:           c          GX=G22(1,IG)
   230:           c          GY=G22(2,IG)
   231:           c          GZ=G22(3,IG)
   232:           c          RHO3(IG)=DSQRT(G22(4,IG))*TPIBA
   233:           c         enddo
   234:           c         CALL GETYLM(NG2Q,NGNLMX,G22,RHO3,YLM2,TPIBA)
   235:           c         CALL VPJ_GEN(G22,NG2Q,NG2,RHO3,VPJ2,VPJWORK,VPP22,
   236:           c     &               TPIBA,NTYQ,ntype,GMHF,MXOFL
   237:           c     &    ,RAD,PSPOT,PSPOT2,PHIL,MESHQ,ISPD,NGNL,OMEGA)
   238:           c *** temp check
   239:           c         if (my_rank.eq.0) then
   240:           c           do ity=1,NTYPE
   241:           c           write(6,*)' ity = ',ity
   242:           c           write(6,*)' part 2   VPJ_GEN ended'
   243:           c           write(6,'(4F22.16)')(VPJ2(IG,1,1,ity),IG=1,NGNL(ITY),1000)
   244:           c           enddo
   245:           c         endif
   246:           c *** temp check end
   247:           c     *** part 3 ***
   248:           c         do ig=1,NG2Q/6
   249:           c          GX=G23(1,IG)
   250:           c          GY=G23(2,IG)
   251:           c          GZ=G23(3,IG)
   252:           c          RHO3(IG)=DSQRT(G23(4,IG))*TPIBA
   253:           c         enddo
   254:           c         CALL GETYLM(NG2Q,NGNLMX,G23,RHO3,YLM3,TPIBA)
   255:           c         CALL VPJ_GEN(G23,NG2Q,NG2,RHO3,VPJ3,VPJWORK,VPP23,
   256:           c     &               TPIBA,NTYQ,ntype,GMHF,MXOFL
   257:           c     &    ,RAD,PSPOT,PSPOT2,PHIL,MESHQ,ISPD,NGNL,OMEGA)
   258:           c *** temp check
   259:           c         if (my_rank.eq.0) then
   260:           c           do ity=1,NTYPE
   261:           c           write(6,*)' ity = ',ity
   262:           c           write(6,*)' part 3   VPJ_GEN ended'
   263:           c           write(6,'(4F22.16)')(VPJ3(IG,1,1,ity),IG=1,NGNL(ITY),1000)
   264:           c           enddo
   265:           c         endif
   266:           c *** temp check end
   267:           c     *** part 4 ***
   268:           c         do ig=1,NG2Q/6
   269:           c          GX=G24(1,IG)
   270:           c          GY=G24(2,IG)
   271:           c          GZ=G24(3,IG)
   272:           c          RHO3(IG)=DSQRT(G24(4,IG))*TPIBA
   273:           c         enddo
   274:           c         CALL GETYLM(NG2Q,NGNLMX,G24,RHO3,YLM4,TPIBA)
   275:           c         CALL VPJ_GEN(G24,NG2Q,NG2,RHO3,VPJ4,VPJWORK,VPP24,
   276:           c     &               TPIBA,NTYQ,ntype,GMHF,MXOFL
   277:           c     &    ,RAD,PSPOT,PSPOT2,PHIL,MESHQ,ISPD,NGNL,OMEGA)
   278:           c *** temp check
   279:           c         if (my_rank.eq.0) then
   280:           c           do ity=1,NTYPE
   281:           c           write(6,*)' ity = ',ity
   282:           c           write(6,*)' part 4   VPJ_GEN ended'
   283:           c           write(6,'(4F22.16)')(VPJ4(IG,1,1,ity),IG=1,NGNL(ITY),1000)
   284:           c           enddo
   285:           c         endif
   286:           c *** temp check end
   287:           c     *** part 5 ***
   288:           c         do ig=1,NG2Q/6
   289:           c          GX=G25(1,IG)
   290:           c          GY=G25(2,IG)
   291:           c          GZ=G25(3,IG)
   292:           c          RHO3(IG)=DSQRT(G25(4,IG))*TPIBA
   293:           c         enddo
   294:           c         CALL GETYLM(NG2Q,NGNLMX,G25,RHO3,YLM5,TPIBA)
   295:           c         CALL VPJ_GEN(G25,NG2Q,NG2,RHO3,VPJ5,VPJWORK,VPP25,
   296:           c     &               TPIBA,NTYQ,ntype,GMHF,MXOFL
   297:           c     &    ,RAD,PSPOT,PSPOT2,PHIL,MESHQ,ISDP,NGNL,OMEGA)
   298:           c *** temp check
   299:           c         if (my_rank.eq.0) then
   300:           c           write(6,*)' part 5   VPJ_GEN ended'
   301:           c           do ity=1,NTYPE
   302:           c           write(6,*)' ity = ',ity
   303:           c           write(6,'(4F22.16)')(VPJ5(IG,1,1,ity),IG=1,NGNL(ITY),1000)
   304:           c           enddo
   305:           c         endif
   306:           c *** temp check end
   307:           c
   308:           c
   309:           c ****  Suzuki-Trotter decomposition of time-evolution operator
   310:           c
   311:                 if ( ioption.eq.2 ) then
   312:           c ***********************************************************
   313:           c *    Masuo Suzuki
   314:           c *     create second order decomposition
   315:           c ***********************************************************
   316:           c      do ib=1,nj
   317:           cc **      if ( my_rank.ne.0 ) then
   318: +------>        do ib=nbegin(my_rank),nend(my_rank)
   319: |               iib=ib-nbegin(my_rank)+1
   320: |         c      call exkin(dt,nxyz,ng2q,P(1,ib),G2,TPIBA2,GDUMP,GMHF)
   321: |               call exkin(dt,nxyz,ng2q,P(1,iib),G2,TPIBA2,GDUMP,GMHF)
   322: |         c
   323: |               call S2(dt, NXYZ,NRX,NRY,NRZ, NG2, NG2Q, NJ,
   324: |         c     &     P(1,ib), HP, YLM, G2,J2G, RHO1, RHO2, TPIBA, WORK2, VPJ,
   325: |              & P(1,iib), HP, YLM, G2,J2G, RHO1, RHO2, TPIBA, WORK2, VPJ,
   326: |              &     VPP,VPP2, OMEGA, NTAUQ, NTYQ, NTYPE, LREQ, TAU, NUMTY,
   327: |         c *** for Sugino FFT
   328: |         c     &     NIDN, IOVP, MXOFL, WSAVEX, WSAVEY, WSAVEZ,
   329: |         c     & IFACX,IFACY,IFACZ,LX1,LX2,LY1,LY2,LZ1,LZ2,VG,VG3,
   330: |         c *** for Kokubo ASL FFT
   331: |         c     &     NIDN, IOVP, MXOFL, WSAVE_XYZ,IFAC_XYZ,VG,VG3,
   332: |         c *** for Kokubo FFTW
   333: |              &     NIDN, IOVP, MXOFL, plancfp,plancbp,VG,VG3,
   334: |              & fdump,Vloc(1,3),EXTAU(1,1,1),3,NGNL,NGcont)
   335: |         C
   336: |         c      call exkin(dt,nxyz,ng2q,P(1,ib),G2,TPIBA2,GDUMP,GMHF)
   337: |               call exkin(dt,nxyz,ng2q,P(1,iib),G2,TPIBA2,GDUMP,GMHF)
   338: +------         enddo   ! end of band loop
   339:           cc **      endif ! end of if my_rank.e.0 loop
   340:                 elseif ( ioption.eq.3 ) then
   341:           c ***********************************************************
   342:           c *    Masuo Suzuki ( J. Phys. Soc. Jpn. Vol.61, p3015, '92)
   343:           c *     create fourth-order decomposition
   344:           c *       from first-order decompositions
   345:           c ***********************************************************
   346:           c    parameters for third order decomposition
   347:                  pr1= 0.2683300957817599D0
   348:                  pr2= 0.6513314272356399d0
   349:                  pr3=-0.8393230460347997d0
   350:           c      do ib=1,nbseq ! band loop
   351:           cc ***      if ( my_rank.ne.0 ) then
   352: +------>        do ib=nbegin(my_rank),nend(my_rank) ! band loop
   353: |                iib=ib-nbegin(my_rank)+1
   354: |         c
   355: |         c    At first, make the third-order decomposition by S1
   356: |         c    S1: first order deconposition
   357: |         c
   358: |               call S1(0.5d0*pr1*dt, NXYZ,NRX,NRY,NRZ, NG2, NG2Q, NJ,
   359: |         c     &     P(1,ib), HP, YLM, G2,J2G, RHO1, RHO2, TPIBA, WORK2, VPJ,
   360: |              &  P(1,iib), HP, YLM, G2,J2G, RHO1, RHO2, TPIBA, WORK2, VPJ,
   361: |              &     VPP,VPP2, OMEGA, NTAUQ, NTYQ, NTYPE, LREQ, TAU, NUMTY,
   362: |         c *** for Sugino FFT
   363: |         c     &     NIDN, IOVP, MXOFL, WSAVEX, WSAVEY, WSAVEZ,
   364: |         c     &     IFACX, IFACY, IFACZ, LX1, LX2, LY1, LY2, LZ1, LZ2,VG,VG1,
   365: |         c *** for Kokubo ASL FFT
   366: |         c     &     NIDN, IOVP, MXOFL, WSAVE_XYZ, IFAC_XYZ,VG,VG1,
   367: |         c *** for Kokubo FFTW
   368: |              &     NIDN, IOVP, MXOFL, plancfp,plancbp,VG,VG1,
   369: |              &     fdump,Vloc(1,1),TPIBA2,EXTAU(1,1,1),1,NGNL,NGcont)
   370: |         C
   371: |               call S1(0.5d0*pr2*dt, NXYZ,NRX,NRY,NRZ, NG2, NG2Q, NJ,
   372: |         c     &     P(1,ib), HP, YLM, G2,J2G, RHO1, RHO2, TPIBA, WORK2, VPJ,
   373: |              &  P(1,iib), HP, YLM, G2,J2G, RHO1, RHO2, TPIBA, WORK2, VPJ,
   374: |              &     VPP,VPP2, OMEGA, NTAUQ, NTYQ, NTYPE, LREQ, TAU, NUMTY,
   375: |         c *** for Sugino FFT
   376: |         c     &     NIDN, IOVP, MXOFL, WSAVEX, WSAVEY, WSAVEZ,
   377: |         c     &     IFACX, IFACY, IFACZ, LX1, LX2, LY1, LY2, LZ1, LZ2,VG,VG2,
   378: |         c *** for Kokubo ASK FFT
   379: |         c     &     NIDN, IOVP, MXOFL, WSAVE_XYZ, IFAC_XYZ,VG,VG2,
   380: |         c *** for Kokubo ASK FFTW
   381: |              &     NIDN, IOVP, MXOFL, plancfp,plancbp,VG,VG2,
   382: |              &     fdump,Vloc(1,2),TPIBA2,EXTAU(1,1,1),2,NGNL,NGcont)
   383: |         C
   384: |               call S1(0.5d0*pr3*dt, NXYZ,NRX,NRY,NRZ, NG2, NG2Q, NJ,
   385: |         c     &     P(1,ib), HP, YLM, G2,J2G, RHO1, RHO2, TPIBA, WORK2, VPJ,
   386: |              &  P(1,iib), HP, YLM, G2,J2G, RHO1, RHO2, TPIBA, WORK2, VPJ,
   387: |              &     VPP,VPP2, OMEGA, NTAUQ, NTYQ, NTYPE, LREQ, TAU, NUMTY,
   388: |         c *** for Sugino FFT
   389: |         c     &     NIDN, IOVP, MXOFL, WSAVEX, WSAVEY, WSAVEZ,
   390: |         c     &     IFACX, IFACY, IFACZ, LX1, LX2, LY1, LY2, LZ1, LZ2,VG,VG3,
   391: |         c *** for Kokubo ASL FFT
   392: |         c     &     NIDN, IOVP, MXOFL, WSAVE_XYZ,  IFAC_XYZ,VG,VG3,
   393: |         c *** for Kokubo FFTW
   394: |              &     NIDN, IOVP, MXOFL, plancfp,plancbp,VG,VG3,
   395: |              &     fdump,Vloc(1,3),TPIBA2,EXTAU(1,1,1),3,NGNL,NGcont)
   396: |         C
   397: |               call S1(0.5d0*pr2*dt, NXYZ,NRX,NRY,NRZ, NG2, NG2Q, NJ,
   398: |         c     &     P(1,ib), HP, YLM, G2,J2G, RHO1, RHO2, TPIBA, WORK2, VPJ,
   399: |              &  P(1,iib), HP, YLM, G2,J2G, RHO1, RHO2, TPIBA, WORK2, VPJ,
   400: |              &     VPP,VPP2, OMEGA, NTAUQ, NTYQ, NTYPE, LREQ, TAU, NUMTY,
   401: |         c *** for Sugino FFT
   402: |         c     &     NIDN, IOVP, MXOFL, WSAVEX, WSAVEY, WSAVEZ,
   403: |         c     &     IFACX, IFACY, IFACZ, LX1, LX2, LY1, LY2, LZ1, LZ2,VG,VG4,
   404: |         c *** for Kokubo ASK FFT
   405: |         c     &     NIDN, IOVP, MXOFL, WSAVE_XYZ,    IFAC_XYZ,VG,VG4,
   406: |         c *** for Kokubo ASK FFTW
   407: |              &     NIDN, IOVP, MXOFL, plancfp,plancbp,VG,VG4,
   408: |              &     fdump,Vloc(1,4),TPIBA2,EXTAU(1,1,1),4,NGNL,NGcont)
   409: |         C
   410: |               call S1(0.5d0*pr1*dt, NXYZ,NRX,NRY,NRZ, NG2, NG2Q, NJ,
   411: |         c     &     P(1,ib), HP, YLM, G2,J2G, RHO1, RHO2, TPIBA, WORK2, VPJ,
   412: |              &  P(1,iib), HP, YLM, G2,J2G, RHO1, RHO2, TPIBA, WORK2, VPJ,
   413: |              &     VPP,VPP2, OMEGA, NTAUQ, NTYQ, NTYPE, LREQ, TAU, NUMTY,
   414: |         c *** for Sugino FFT
   415: |         c     &     NIDN, IOVP, MXOFL, WSAVEX, WSAVEY, WSAVEZ,
   416: |         c     &     IFACX, IFACY, IFACZ, LX1, LX2, LY1, LY2, LZ1, LZ2,VG,VG5,
   417: |         c *** for Kokubo ASL FFT
   418: |         c     &     NIDN, IOVP, MXOFL, WSAVE_XYZ,   IFAC_XYZ,VG,VG5,
   419: |         c *** for Kokubo FFTW
   420: |              &     NIDN, IOVP, MXOFL, plancfp,plancbp,VG,VG5,
   421: |              &     fdump,Vloc(1,5),TPIBA2,EXTAU(1,1,1),5,NGNL,NGcont)
   422: |         C*** start tilda operation
   423: |         c    Second, make the tilda of the third-order decomposition by S1
   424: |         c
   425: |               call S1T(0.5d0*pr1*dt, NXYZ,NRX,NRY,NRZ, NG2, NG2Q, NJ,
   426: |         c     &     P(1,ib), HP, YLM, G2,J2G, RHO1, RHO2, TPIBA, WORK2, VPJ,
   427: |              & P(1,iib), HP, YLM, G2,J2G, RHO1, RHO2, TPIBA, WORK2, VPJ,
   428: |              &     VPP,VPP2, OMEGA, NTAUQ, NTYQ, NTYPE, LREQ, TAU, NUMTY,
   429: |         c *** for Sugino FFT
   430: |         c     &     NIDN, IOVP, MXOFL, WSAVEX, WSAVEY, WSAVEZ,
   431: |         c     &     IFACX, IFACY, IFACZ, LX1, LX2, LY1, LY2, LZ1, LZ2,VG,VG5,
   432: |         c *** for Kokubo ASL FFT
   433: |         c     &     NIDN, IOVP, MXOFL, WSAVE_XYZ,   IFAC_XYZ,VG,VG5,
   434: |         c *** for Kokubo FFTW
   435: |              &     NIDN, IOVP, MXOFL, plancfp,plancbp,VG,VG5,
   436: |              &     fdump,Vloc(1,5),TPIBA2,EXTAU(1,1,1),5,NGNL,NGcont)
   437: |         C
   438: |               call S1T(0.5d0*pr2*dt, NXYZ,NRX,NRY,NRZ, NG2, NG2Q, NJ,
   439: |         c     &     P(1,ib), HP, YLM, G2,J2G, RHO1, RHO2, TPIBA, WORK2, VPJ,
   440: |              & P(1,iib), HP, YLM, G2,J2G, RHO1, RHO2, TPIBA, WORK2, VPJ,
   441: |              &     VPP,VPP2, OMEGA, NTAUQ, NTYQ, NTYPE, LREQ, TAU, NUMTY,
   442: |         c *** for Sugino FFT
   443: |         c     &     NIDN, IOVP, MXOFL, WSAVEX, WSAVEY, WSAVEZ,
   444: |         c     &     IFACX, IFACY, IFACZ, LX1, LX2, LY1, LY2, LZ1, LZ2,VG,VG4,
   445: |         c *** for Kokubo ASL FFT
   446: |         c     &     NIDN, IOVP, MXOFL, WSAVE_XYZ, IFAC_XYZ,VG,VG4,
   447: |         c *** for Kokubo FFTW
   448: |              &     NIDN, IOVP, MXOFL, plancfp,plancbp,VG,VG4,
   449: |              &     fdump,Vloc(1,4),TPIBA2,EXTAU(1,1,1),4,NGNL,NGcont)
   450: |         C
   451: |               call S1T(0.5d0*pr3*dt, NXYZ,NRX,NRY,NRZ, NG2, NG2Q, NJ,
   452: |         c     &     P(1,ib), HP, YLM, G2,J2G, RHO1, RHO2, TPIBA, WORK2, VPJ,
   453: |              & P(1,iib), HP, YLM, G2,J2G, RHO1, RHO2, TPIBA, WORK2, VPJ,
   454: |              &     VPP,VPP2, OMEGA, NTAUQ, NTYQ, NTYPE, LREQ, TAU, NUMTY,
   455: |         c *** for Sugino FFT
   456: |         c     &     NIDN, IOVP, MXOFL, WSAVEX, WSAVEY, WSAVEZ,
   457: |         c     &     IFACX, IFACY, IFACZ, LX1, LX2, LY1, LY2, LZ1, LZ2,VG,VG3,
   458: |         c *** for Kokubo ASL FFT
   459: |         c     &     NIDN, IOVP, MXOFL, WSAVE_XYZ, IFAC_XYZ,VG,VG3,
   460: |         c *** for Kokubo FFTW
   461: |              &     NIDN, IOVP, MXOFL, plancfp,plancbp,VG,VG3,
   462: |              &     fdump,Vloc(1,3),TPIBA2,EXTAU(1,1,1),3,NGNL,NGcont)
   463: |         C
   464: |               call S1T(0.5d0*pr2*dt, NXYZ,NRX,NRY,NRZ, NG2, NG2Q, NJ,
   465: |         c     &     P(1,ib), HP, YLM, G2,J2G, RHO1, RHO2, TPIBA, WORK2, VPJ,
   466: |              & P(1,iib), HP, YLM, G2,J2G, RHO1, RHO2, TPIBA, WORK2, VPJ,
   467: |              &     VPP,VPP2, OMEGA, NTAUQ, NTYQ, NTYPE, LREQ, TAU, NUMTY,
   468: |         c *** for Sugino FFT
   469: |         c     &     NIDN, IOVP, MXOFL, WSAVEX, WSAVEY, WSAVEZ,
   470: |         c     &     IFACX, IFACY, IFACZ, LX1, LX2, LY1, LY2, LZ1, LZ2,VG,VG2,
   471: |         c *** for Kokubo ASL FFT
   472: |         c     &     NIDN, IOVP, MXOFL, WSAVE_XYZ,  IFAC_XYZ,VG,VG2,
   473: |         c *** for Kokubo FFTW
   474: |              &     NIDN, IOVP, MXOFL, plancfp,plancbp,VG,VG2,
   475: |              &     fdump,Vloc(1,2),TPIBA2,EXTAU(1,1,1),2,NGNL,NGcont)
   476: |         C
   477: |               call S1T(0.5d0*pr1*dt, NXYZ,NRX,NRY,NRZ, NG2, NG2Q, NJ,
   478: |         c     &     P(1,ib), HP, YLM, G2,J2G, RHO1, RHO2, TPIBA, WORK2, VPJ,
   479: |              & P(1,iib), HP, YLM, G2,J2G, RHO1, RHO2, TPIBA, WORK2, VPJ,
   480: |              &     VPP,VPP2, OMEGA, NTAUQ, NTYQ, NTYPE, LREQ, TAU, NUMTY,
   481: |         c *** for Sugino FFT
   482: |         c     &     NIDN, IOVP, MXOFL, WSAVEX, WSAVEY, WSAVEZ,
   483: |         c     &     IFACX, IFACY, IFACZ, LX1, LX2, LY1, LY2, LZ1, LZ2,VG,VG1,
   484: |         c *** for Kokubo ASL FFT
   485: |         c     &     NIDN, IOVP, MXOFL, WSAVE_XYZ,  IFAC_XYZ,VG,VG1,
   486: |         c *** for Kokubo ASL FFT
   487: |              &     NIDN, IOVP, MXOFL, plancfp,plancbp,VG,VG1,
   488: |              &     fdump,Vloc(1,1),TPIBA2,EXTAU(1,1,1),1,NGNL,NGcont)
   489: |         C
   490: |         c     Then the fourth-order decomposition is made.
   491: |         c
   492: +------         enddo          ! band loop end
   493:           cc ***      endif  ! end of if my_rank.ne.0 loop
   494:                 elseif ( ioption.eq.4 ) then
   495:           c ***********************************************************
   496:           c *   Masuo Suzuki ( J. Math. Phys. Vol.32(2), p400, '91)
   497:           c *     create fourth-order decomposition
   498:           c *       from second-order decompositions
   499:           c ***********************************************************
   500:                  m=2
   501:                  pm=1.d0/( 4.d0 - 4.d0**(1.d0/dfloat(2*m-1) ) )
   502:                  pr1=pm
   503:                  pr2=pm
   504:                  pr3=1.d0-4*pm
   505:           c +++  check : parameters
   506:                   if ( abs(pr3+2*(pr1+pr2)-1.d0).gt.1.d-08 ) then
   507:                    write(6,*)' sum of pr-s is not one WRONG !! '
   508:                    stop
   509:                   elseif ( abs(pr3**3+2*( pr1**3+pr2**3)).gt.1.d-08 ) then
   510:                    write(6,*)' sum of pr-cubes is not zero WRONG !! '
   511:                    stop
   512:                   endif
   513:           c +++  check : end
   514:           c      do ib=1,nbseq   ! band loop
   515:           ccc **      if (my_rank.ne.0 ) then
   516:           c **** for the case of 4-th order decomposition
   517:           c  S2:       second order decomposition
   518:           c
   519:           c *****  temp check : orthonormality
   520:           c      if ( mod(itstep,itmod).eq.0 ) then
   521:           c      write(6,*)' before ekin ! ib =',ib
   522:           c        temp=0
   523:           c        do ig=1,nxyz
   524:           c        temp=temp+dble( dconjg(P(IG,ib))*P(IG,ib) )
   525:           c        enddo
   526:           c        write(6,*)' norm = ',temp
   527:           c      endif
   528:           c *** temp check:end
   529:                 dt1=pr1*dt
   530:           c      call exkin(dt1,nxyz,ng2q,P(1,ib),G2,TPIBA2,GDUMP,GMHF)
   531:                 call exkin_(dt1,nxyz,ng2q,P,G2,TPIBA2,GDUMP1,GMHF,
   532:                &            mxbnd,nbegin(my_rank),nend(my_rank))
   533:           c *****  temp check : orthonormality
   534:           c      if ( mod(itstep,itmod).eq.0 ) then
   535:           c      write(6,*)' after ekin and before S2 ! ib =',ib
   536:           c        temp=0
   537:           c        do ig=1,nxyz
   538:           c        temp=temp+dble( dconjg(P(IG,ib))*P(IG,ib) )
   539:           c        enddo
   540:           c        write(6,*)' norm = ',temp
   541:           c      endif
   542:           c *** temp check:end
   543:           c
   544:                 call S2_(dt1, NXYZ,NRX,NRY,NRZ, NG2, NG2Q, NJ,
   545:           c     &     P(1,ib), HP, YLM, G2,J2G, RHO1, RHO2, TPIBA, WORK2, VPJ,
   546:           c     &     P, HP, YLM, G2,J2G, RHO1, RHO2, TPIBA, WORK2, VPJ,
   547:                &     P, HP, YLM1, G21,J2G, RHO1, RHO2, TPIBA, WORK2, VPJ1,
   548:                &     VPP,VPP21, OMEGA, NTAUQ, NTYQ, NTYPE, LREQ, TAU, NUMTY,
   549:           c *** for Sugino FFT
   550:           c     &     NIDN, IOVP, MXOFL, WSAVEX, WSAVEY, WSAVEZ,
   551:           c     & IFACX,IFACY,IFACZ,LX1,LX2,LY1,LY2,LZ1,LZ2,VG,VG1,
   552:           c *** for Kokubo ASL FFT
   553:           c     &     NIDN, IOVP, MXOFL, WSAVE_XYZ,IFAC_XYZ,VG,VG1,
   554:           c *** for Kokubo ASL FFT
   555:                &     NIDN, IOVP, MXOFL, plancfp,plancbp,VG,VG1,
   556:                & fdump,Vloc(1,1),EXTAU(1,1,1),1,NGNL,
   557:                &            mxbnd,nbegin(my_rank),nend(my_rank),NGcont)
   558:           C
   559:           c *****  temp check : orthonormality
   560:           c      if ( mod(itstep,itmod).eq.0 .and. my_rank.eq.0 ) then
   561:           c      write(6,*)' after S2 !  ib =',ib
   562:           c        temp=0
   563:           c        do ig=1,nxyz
   564:           c        temp=temp+dble( dconjg(P(IG,iib))*P(IG,iib) )
   565:           c        enddo
   566:           c        write(6,*)' norm = ',temp
   567:           c      endif
   568:           c *** temp check:end
   569:           c
   570:           c      dt12=(pr1+pr2)*dt
   571:           cc      call exkin(dt12,nxyz,ng2q,P(1,ib),G2,TPIBA2,GDUMP,GMHF)
   572:           c      call exkin_(dt12,nxyz,ng2q,P,G2,TPIBA2,GDUMP2,GMHF,
   573:           c     &            mxbnd,nbegin(my_rank),nend(my_rank))
   574:           c
   575:                 call exkin_(dt1,nxyz,ng2q,P,G2,TPIBA2,GDUMP1,GMHF,
   576:                &            mxbnd,nbegin(my_rank),nend(my_rank))
   577:           c
   578:                 dt2=pr2*dt
   579:                 call exkin_(dt2,nxyz,ng2q,P,G2,TPIBA2,GDUMP2,GMHF,
   580:                &            mxbnd,nbegin(my_rank),nend(my_rank))
   581:           c
   582:                 call S2_(dt2, NXYZ,NRX,NRY,NRZ, NG2, NG2Q, NJ,
   583:           c     &     P(1,ib), HP, YLM, G2,J2G, RHO1, RHO2, TPIBA, WORK2, VPJ,
   584:           c     &   P, HP, YLM, G2,J2G, RHO1, RHO2, TPIBA, WORK2, VPJ,
   585:                &   P, HP, YLM2, G22,J2G, RHO1, RHO2, TPIBA, WORK2, VPJ2,
   586:                &     VPP,VPP22, OMEGA, NTAUQ, NTYQ, NTYPE, LREQ, TAU, NUMTY,
   587:           c *** for Sugino FFT
   588:           c     &     NIDN, IOVP, MXOFL, WSAVEX, WSAVEY, WSAVEZ,
   589:           c     &  IFACX,IFACY,IFACZ,LX1,LX2,LY1,LY2,LZ1,LZ2,VG,VG2,
   590:           c *** for Kokubo ASL FFT
   591:           c     &     NIDN, IOVP, MXOFL, WSAVE_XYZ,IFAC_XYZ,VG,VG2,
   592:           c *** for Kokubo FFTW
   593:                &     NIDN, IOVP, MXOFL, plancfp,plancbp,VG,VG2,
   594:                &  fdump,Vloc(1,2),EXTAU(1,1,1),2,NGNL,
   595:                &            mxbnd,nbegin(my_rank),nend(my_rank),NGcont)
   596:           c
   597:                 call exkin_(dt2,nxyz,ng2q,P,G2,TPIBA2,GDUMP2,GMHF,
   598:                &            mxbnd,nbegin(my_rank),nend(my_rank))
   599:           c
   600:           c      dt23=(pr2+pr3)*dt
   601:           cc      call exkin(dt23,nxyz,ng2q,P(1,ib),G2,TPIBA2,GDUMP,GMHF)
   602:           c      call exkin_(dt23,nxyz,ng2q,P,G2,TPIBA2,GDUMP3,GMHF,
   603:           c     &            mxbnd,nbegin(my_rank),nend(my_rank))
   604:           c
   605:                 dt3=pr3*dt
   606:                 call exkin_(dt3,nxyz,ng2q,P,G2,TPIBA2,GDUMP3,GMHF,
   607:                &            mxbnd,nbegin(my_rank),nend(my_rank))
   608:           c
   609:                 call S2_(dt3, NXYZ,NRX,NRY,NRZ, NG2, NG2Q, NJ,
   610:           c     &     P(1,ib), HP, YLM, G2,J2G, RHO1, RHO2, TPIBA, WORK2, VPJ,
   611:           c     &     P, HP, YLM, G2,J2G, RHO1, RHO2, TPIBA, WORK2, VPJ,
   612:                &     P, HP, YLM3, G23,J2G, RHO1, RHO2, TPIBA, WORK2, VPJ3,
   613:                &     VPP,VPP23, OMEGA, NTAUQ, NTYQ, NTYPE, LREQ, TAU, NUMTY,
   614:           c *** for Sugino FFT
   615:           c     &     NIDN, IOVP, MXOFL, WSAVEX, WSAVEY, WSAVEZ,
   616:           c     &  IFACX,IFACY,IFACZ,LX1,LX2,LY1,LY2,LZ1,LZ2,VG,VG3,
   617:           c *** for Kokubo ASL FFT
   618:           c     &     NIDN, IOVP, MXOFL, WSAVE_XYZ,IFAC_XYZ,VG,VG3,
   619:           c *** for Kokubo FFTW
   620:                &     NIDN, IOVP, MXOFL, plancfp,plancbp,VG,VG3,
   621:                &  fdump,Vloc(1,3),EXTAU(1,1,1),3,NGNL,
   622:                &            mxbnd,nbegin(my_rank),nend(my_rank),NGcont)
   623:           c
   624:                 call exkin_(dt3,nxyz,ng2q,P,G2,TPIBA2,GDUMP3,GMHF,
   625:                &            mxbnd,nbegin(my_rank),nend(my_rank))
   626:           c
   627:           c      dt32=(pr3+pr2)*dt
   628:           cc      call exkin(dt32,nxyz,ng2q,P(1,ib),G2,TPIBA2,GDUMP,GMHF)
   629:           c      call exkin_(dt32,nxyz,ng2q,P,G2,TPIBA2,GDUMP4,GMHF,
   630:           c     &            mxbnd,nbegin(my_rank),nend(my_rank))
   631:           C
   632:                 dt2=pr2*dt
   633:                 call exkin_(dt2,nxyz,ng2q,P,G2,TPIBA2,GDUMP4,GMHF,
   634:                &            mxbnd,nbegin(my_rank),nend(my_rank))
   635:           C
   636:                 call S2_(dt2, NXYZ,NRX,NRY,NRZ, NG2, NG2Q, NJ,
   637:           c     &     P(1,ib), HP, YLM, G2,J2G,RHO1, RHO2, TPIBA, WORK2, VPJ,
   638:           c     &     P, HP, YLM, G2,J2G,RHO1, RHO2, TPIBA, WORK2, VPJ,
   639:                &     P, HP, YLM4, G24,J2G,RHO1, RHO2, TPIBA, WORK2, VPJ4,
   640:                &     VPP,VPP24, OMEGA, NTAUQ, NTYQ, NTYPE, LREQ, TAU, NUMTY,
   641:           c *** for Sugino FFT
   642:           c     &     NIDN, IOVP, MXOFL, WSAVEX, WSAVEY, WSAVEZ,
   643:           c     & IFACX,IFACY,IFACZ,LX1,LX2,LY1,LY2,LZ1,LZ2,VG,VG4,
   644:           c *** for Kokubo ASL FFT
   645:           c     &     NIDN, IOVP, MXOFL, WSAVE_XYZ,IFAC_XYZ,VG,VG4,
   646:           c *** for Kokubo FFTW
   647:                &     NIDN, IOVP, MXOFL, plancfp,plancbp,VG,VG4,
   648:                & fdump,Vloc(1,4),EXTAU(1,1,1),4,NGNL,
   649:                &            mxbnd,nbegin(my_rank),nend(my_rank),NGcont)
   650:           C
   651:                 call exkin_(dt2,nxyz,ng2q,P,G2,TPIBA2,GDUMP4,GMHF,
   652:                &            mxbnd,nbegin(my_rank),nend(my_rank))
   653:           c
   654:           c      dt21=(pr2+pr1)*dt
   655:           cc      call exkin(dt21,nxyz,ng2q,P(1,ib),G2,TPIBA2,GDUMP,GMHF)
   656:           c      call exkin_(dt21,nxyz,ng2q,P,G2,TPIBA2,GDUMP5,GMHF,
   657:           c     &            mxbnd,nbegin(my_rank),nend(my_rank))
   658:           C
   659:                 dt1=pr1*dt
   660:                 call exkin_(dt1,nxyz,ng2q,P,G2,TPIBA2,GDUMP5,GMHF,
   661:                &            mxbnd,nbegin(my_rank),nend(my_rank))
   662:           C
   663:                 call S2_(dt1, NXYZ,NRX,NRY,NRZ, NG2, NG2Q, NJ,
   664:           c     &     P(1,ib), HP, YLM, G2,J2G,RHO1, RHO2, TPIBA, WORK2, VPJ,
   665:           c     &     P, HP, YLM, G2,J2G,RHO1, RHO2, TPIBA, WORK2, VPJ,
   666:                &     P, HP, YLM5, G25,J2G,RHO1, RHO2, TPIBA, WORK2, VPJ5,
   667:                &     VPP,VPP25, OMEGA, NTAUQ, NTYQ, NTYPE, LREQ, TAU, NUMTY,
   668:           c *** for Sugino FFT
   669:           c     &     NIDN, IOVP, MXOFL, WSAVEX, WSAVEY, WSAVEZ,
   670:           c     &  IFACX,IFACY,IFACZ,LX1,LX2,LY1,LY2,LZ1,LZ2,VG,VG5,
   671:           c *** for Kokubo ASL FFT
   672:           c     &     NIDN, IOVP, MXOFL, WSAVE_XYZ,IFAC_XYZ,VG,VG5,
   673:           c *** for Kokubo ASL FFT
   674:                &     NIDN, IOVP, MXOFL, plancfp,plancbp,VG,VG5,
   675:                &  fdump,Vloc(1,5),EXTAU(1,1,1),5,NGNL,
   676:                &            mxbnd,nbegin(my_rank),nend(my_rank),NGcont)
   677:           c
   678:           c *****  temp check : orthonormality
   679:           c      if ( mod(itstep,itmod).eq.0 .and. my_rank.eq.0 ) then
   680:           c      write(6,*)' after S2 5  ib =',ib
   681:           c        temp=0
   682:           c        do ig=1,nxyz
   683:           c        temp=temp+dble( dconjg(P(IG,iib))*P(IG,iib) )
   684:           c        enddo
   685:           c        write(6,*)' norm = ',temp
   686:           c      endif
   687:           c *** temp check:end
   688:                 dt1=pr1*dt
   689:           c      call exkin(dt1,nxyz,ng2q,P(1,ib),G2,TPIBA2,GDUMP,GMHF)
   690:                 call exkin_(dt1,nxyz,ng2q,P,G2,TPIBA2,GDUMP5,GMHF,
   691:                &            mxbnd,nbegin(my_rank),nend(my_rank))
   692:           c ***
   693:           ccc ***      endif ! end of if my_rank.ne.0 loop
   694:           c *****  temp check : orthonormality
   695:           c      if ( mod(itstep,itmod).eq.0 ) then
   696:           c      do ib=1,nbseq
   697:           c       do jb=1,ib
   698:           c        temp=0
   699:           c        write(6,*)' ib = ',ib,' jb = ',jb
   700:           c        do ig=1,nxyz
   701:           c        temp=temp+dble( dconjg(P(IG,jb))*P(IG,ib) )
   702:           c        enddo
   703:           c        write(6,*)' overlap = ',temp
   704:           c       enddo
   705:           c      enddo
   706:           c      endif
   707:           c ***
   708:                 endif  ! end of if (ioption.eq...)  loop
   709:           c      WRITE(71,REC=IOWF(JJB)) PJ
   710:           c
   711:           c      do ib=1,mxbnd
   712:           c      call eqp(pj(1,ib),p(1,ib),ng2,ng2q) ! update p for next time step
   713:           c      enddo
   714:           c
   715:           c  ****  Orthogonalization here ! ( if necessary )
   716:           c
   717:           c      call nrmlz(p,nbnd,mxbnd,NG2,NG2Q)   !  normalization first
   718:           c      call ortho(mxbnd,ng2q,pj,p,mxbnd,ng2q,
   719:           c     &           sig,x0,x1,work1,work20)
   720:           c      do ib=1,mxbnd
   721:           c      call eqp(pj(1,ib),p(1,ib),ng2,ng2q) ! update p for next time step
   722:           c      enddo
   723:           c
   724:           c
   725:           c Calculation of the expectation values.
   726:           c
   727:                  if ( mod(itstep,itmod).eq.0 ) then
   728:                   tag=11
   729:           ccc ***        if ( my_rank.ne.0 ) then
   730:           c         do ib=1,nbseq
   731: +------>           do ib=nbegin(my_rank),nend(my_rank)
   732: |                   iib=ib-nbegin(my_rank)+1
   733: |                   CALL HLOCAL( NRX, NRY, NRZ, NXYZ, NG2, NG2Q, NJ,
   734: |         c *** for Sugino FFT
   735: |         c     &   P(1,iib),HP(1,1), RHO1, RHO2, VG, J2G, WSAVEX, WSAVEY, WSAVEZ,
   736: |         c     &             IFACX, IFACY, IFACZ, LX1, LX2, LY1, LY2, LZ1, LZ2  )
   737: |         c *** for Kokubo ASL FFT
   738: |         c     &   P(1,iib),HP(1,1), RHO1, RHO2, VG, J2G, WSAVE_XYZ,IFAC_XYZ  )
   739: |         c *** for Kokubo FFTW
   740: |              &   P(1,iib),HP(1,1), RHO1, RHO2, VG, J2G, plancfp,plancbp  )
   741: |         C
   742: |                   CALL NONLOC( NXYZ, NG2, NG2Q, NJ,
   743: |         c     &     P(1,ib), HP(1,1), YLM, G2, RHO2, RHO3, TPIBA, WORK2, VPJ,
   744: |              &    P(1,iib), HP(1,1), YLM, GG2, RHO2, RHO3, TPIBA, WORK2, VPJ,
   745: |              &             VPP, OMEGA, NTAUQ, NTYQ, NTYPE, LREQ, TAU, NUMTY,
   746: |              &             NIDN, IOVP, MXOFL,GDUMP,NGNL,NGcont )
   747: |                   temp=0
   748: |V----->            do ig=1,ng2
   749: ||        c           temp=temp + dble( dconjg( P(ig,ib) )*HP(ig,1)  )
   750: ||                   temp=temp + dble( dconjg( P(ig,iib) )*HP(ig,1)  )
   751: |V-----             enddo
   752: |                  EE(ib)=temp
   753: |         c *** temp check
   754: |         c        write(6,*)'my_rank=',my_rank,'EE(',ib,')=',EE(IB)*27.212d0
   755: |         c *** temp check ; end
   756: +------            enddo  ! ib loop: end
   757:                   if ( my_rank.ne.0 ) then
   758:                    nbleng=nend(my_rank)-nbegin(my_rank)+1
   759:                    call MPI_Send(EE(nbegin(my_rank)),nbleng,
   760:                &       MPI_DOUBLE_PRECISION,0,tag,MPI_COMM_WORLD,ierr)
   761:                   else
   762: +------>           do icpu=1,ncpu
   763: |                  nbleng=nend(icpu)-nbegin(icpu)+1
   764: |                  call MPI_Recv(EE(nbegin(icpu)),nbleng,
   765: |              &    MPI_DOUBLE_PRECISION,icpu,tag,MPI_COMM_WORLD,status,ierr)
   766: +------            enddo   ! icpu loop : end
   767:           c *** temp check
   768:           c        do ib=1,nbseq
   769:           c        write(6,*)'my_rank=',my_rank,'EE(',ib,')=',EE(IB)*27.212d0
   770:           c        enddo
   771:           c *** temp check ; end
   772:                   endif   ! if my_rank.ne.o loop:  end
   773:                  endif ! if mod(itstep,itmod).eq.0 loop: end
   774:           c ***  temp check
   775:           c       if ( my_rank.eq.0 ) then
   776:           c       write(6,*)' in sub, TMEVL: Expectation values.'
   777:           c       write(6,*)( EE(ib)*27.212d0,ib=1,nbseq )
   778:           c       endif
   779:           c ***  temp check : end
   780:           c ***  temp check
   781:           c      write(6,*)' in sub. TMEVL : VG !! '
   782:           c      write(6,*)( vg(ig),ig=1,1500,100 )
   783:           c ***  temp check : end
   784:           C
   785:                 RETURN
   786:                 END


NEC Fortran Compiler (3.4.2) for Vector Engine   Thu Jul 28 08:27:42 2022
FILE NAME: tmevl10_Avec_v4.f

PROCEDURE NAME: EQP
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

   788:                 subroutine eqp(p,pj,ng2,ng2q)
   789:                 complex*16 p(ng2q),pj(ng2q)
   790: V------>         do 2 ig=1,ng2
   791: |                pj(ig)=p(ig)
   792: V------       2  continue
   793:                 return
   794:                 end


NEC Fortran Compiler (3.4.2) for Vector Engine   Thu Jul 28 08:27:42 2022
FILE NAME: tmevl10_Avec_v4.f

PROCEDURE NAME: S1
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

   807:                 subroutine S1(dt, NXYZ,NRX,NRY,NRZ, NG2, NG2Q, NJ,
   808:                &     P, HP, YLM, G2,J2G,RHO1, RHO2, TPIBA, WORK2, VPJ,
   809:                &     VPP,VPP2,OMEGA, NTAUQ, NTYQ, NTYPE, LREQ, TAU, NUMTY,
   810:           c *** for Sugino FFT
   811:           c     &     NIDN, IOVP, MXOFL, WSAVEX, WSAVEY, WSAVEZ,
   812:           c     &     IFACX, IFACY, IFACZ, LX1, LX2, LY1, LY2, LZ1, LZ2,
   813:           c *** for Kokubo FFT
   814:           c     &     NIDN, IOVP, MXOFL, WSAVE_XYZ, IFAC_XYZ,
   815:           c *** for Kokubo FFTW
   816:                &     NIDN, IOVP, MXOFL, plancfp,plancbp,
   817:                &     VG,VGG ,fdump,Vloc,TPIBA2,EXTAU,NP,NGNL,NGcont)
   818:                 implicit double precision(a-h,o-z)
   819:           c      COMPLEX*16  P(NG2Q), HP(NG2Q,3)
   820:                 COMPLEX*16  P(NG2Q), HP(NG2Q)
   821:           cc      DIMENSION IOWF(MBLK),IOVP(2,NTYQ)
   822:           C
   823:           c      REAL*8 YLM(NG2Q,4),OUT(NBNDQ,3),EE(NBNDQ)
   824:           c      REAL*8 YLM(NG2Q,4)
   825:           c      REAL*8 YLM(NG2Q,9)
   826:                 REAL*8 YLM(NGcont,16)
   827:                 COMPLEX*16 RHO1(NXYZ),RHO2(NXYZ),
   828:           c     &    VG(NXYZ),VGG(NXYZ),WORK2(NG2Q,3),EXTAU(NXYZ,NTAUQ)
   829:           c     &    VG(NXYZ),WORK2(NG2Q,3),EXTAU(NXYZ,NTAUQ)
   830:           c     &    VG(NXYZ),WORK2(NG2Q,3),EXTAU(NXYZ/6,NTAUQ)
   831:           c     &    VG(NXYZ),WORK2(NG2Q,5),EXTAU(NXYZ/6,5,NTAUQ)
   832:                &    VG(NXYZ),WORK2(NG2Q),EXTAU(NGcont,5,NTAUQ)
   833:                 dimension VGG(NXYZ)
   834:           c *** for Sugino FFT
   835:           c      COMPLEX*16 WSAVEX(NRX),WSAVEY(NRY),WSAVEZ(NRZ)
   836:           c      DIMENSION IFACX(30),IFACY(30),IFACZ(30)
   837:           c      DIMENSION LX1(NXYZ),LX2(NXYZ),LY1(NXYZ),
   838:           c     &          LY2(NXYZ),LZ1(NXYZ),LZ2(NXYZ)
   839:           c *** for Kokubo ASL FFT
   840:           c      COMPLEX*16 WSAVE_XYZ(NRX+NRY+NRZ)
   841:           c      DIMENSION IFAC_XYZ(60)
   842:           c *** for Kokubo FFTW
   843:                 integer*8 plancfp,plancbp
   844:                 DIMENSION J2G(NG2Q),G2(4,NG2Q)
   845:                 DIMENSION TAU(3,NTAUQ),NUMTY(NTYQ),NIDN(NTAUQ,NTYQ), MXOFL(NTYQ)
   846:           c      DIMENSION VPJ(NG2Q,3,2,NTYQ),VPP(3,2,NTYQ),VPP2(4,3,NTYQ)
   847:           c      DIMENSION VPJ(NG2Q/3,3,2,NTYQ),VPP(3,3,NTYQ),VPP2(4,3,NTYQ)
   848:           c      DIMENSION VPJ(NG2Q/3,3,3,NTYQ),VPP(3,3,NTYQ),VPP2(9,3,NTYQ)
   849:                 DIMENSION VPJ(NGcont,3,4,NTYQ),VPP(3,4,NTYQ),VPP2(16,3,NTYQ)
   850:                 dimension fdump(NXYZ)
   851:           c      complex*16 rho4(NXYZ)
   852:                 dimension Vloc(NXYZ)
   853:                 dimension NGNL(NTYQ)
   854:                 parameter ( ntyq2=4 )
   855:           c      COMMON/SAITO2/IBUN(3,NTYQ2)
   856:                 COMMON/SAITO2/IBUN(4,NTYQ2)
   857:           c *** first: operate kinetic energy term
   858:           c      do ig=1,ng2
   859: V------>        do ig=1,nxyz
   860: |                fac=dt*0.5d0*g2(4,ig)*TPIBA2  ! 0.5d0*g2(4,ig) = Ekin (Hr)
   861: |                P(ig)=dcmplx( dcos(fac),-dsin(fac) )*P(ig)
   862: V------         enddo
   863:           c *** second: operate  nonlocal pseudopotential terms
   864: +------>        do 1 ity=1,ntype
   865: |                if ( numty(ity).lt.0 ) goto 1 ! skip Hydrogen
   866: |+----->         do 2 it=1,numty(ity)
   867: ||               itseq=nidn(it,ity)  ! seq # of atomic site
   868: ||+---->          do 3 il=1,mxofl(ity)
   869: |||               call zero(hp,ng2q)
   870: |||               if ( IBUN(il,ity).eq.0 ) then
   871: |||       c NON PARTITIONING !
   872: |||       c         call exnlp( dt,NG2Q, NG2, G2,
   873: |||                if (il.eq.1 ) then
   874: |||                l=il
   875: |||                call exnlp( dt,NG2Q, Nxyz, G2,
   876: |||            &   VPJ(1,1,il,ity), VPP(1,il,ity), VPP2(1,1,ity),
   877: |||       c     &   l,YLM, EXTAU(1,itseq), WORK2(1,1), WORK2(1,2),WORK2(1,3),
   878: |||       ccc     &   l,YLM, EXTAU(1,NP,itseq), WORK2(1,1), WORK2(1,2),WORK2(1,3),
   879: |||            &   l,YLM, EXTAU(1,NP,itseq), WORK2,
   880: |||       ccc     &   WORK2(1,4),WORK2(1,5),
   881: |||            &   P, HP, TPIBA,  OMEGA, TAU(1,itseq),NGNL(ity),Ngcont )
   882: |||                elseif ( il.eq.2 ) then
   883: |||+--->           do l=2,4
   884: ||||               call exnlp( dt,NG2Q, Nxyz, G2,
   885: ||||           &   VPJ(1,1,il,ity), VPP(1,il,ity), VPP2(l,1,ity),
   886: ||||      c     &   l,YLM,EXTAU(1,itseq),WORK2(1,1), WORK2(1,2),WORK2(1,3),
   887: ||||      c     &   l,YLM,EXTAU(1,NP,itseq),WORK2(1,1), WORK2(1,2),WORK2(1,3),
   888: ||||           &   l,YLM,EXTAU(1,NP,itseq),WORK2,
   889: ||||      ccc     &   WORK2(1,4),WORK2(1,5),
   890: ||||           &   P, HP, TPIBA,  OMEGA, TAU(1,itseq),NGNL(ity),NGcont )
   891: |||+---            enddo
   892: |||                elseif ( il.eq.3 ) then
   893: |||+--->           do l=5,9
   894: ||||               call exnlp( dt,NG2Q, Nxyz, G2,
   895: ||||           &   VPJ(1,1,il,ity), VPP(1,il,ity), VPP2(l,1,ity),
   896: ||||      c     &   l,YLM,EXTAU(1,itseq),WORK2(1,1), WORK2(1,2),WORK2(1,3),
   897: ||||      cc     &   l,YLM,EXTAU(1,NP,itseq),WORK2(1,1), WORK2(1,2),WORK2(1,3),
   898: ||||           &   l,YLM,EXTAU(1,NP,itseq),WORK2,
   899: ||||      ccc     &   WORK2(1,4),WORK2(1,5),
   900: ||||           &   P, HP, TPIBA,  OMEGA, TAU(1,itseq),NGNL(ity),NGcont )
   901: |||+---            enddo
   902: |||                elseif ( il.eq.4 ) then
   903: |||+--->           do l=10,16
   904: ||||               call exnlp( dt,NG2Q, Nxyz, G2,
   905: ||||           &   VPJ(1,1,il,ity), VPP(1,il,ity), VPP2(l,1,ity),
   906: ||||      c     &   l,YLM,EXTAU(1,itseq),WORK2(1,1), WORK2(1,2),WORK2(1,3),
   907: ||||      cc     &   l,YLM,EXTAU(1,NP,itseq),WORK2(1,1), WORK2(1,2),WORK2(1,3),
   908: ||||           &   l,YLM,EXTAU(1,NP,itseq),WORK2,
   909: ||||      ccc     &   WORK2(1,4),WORK2(1,5),
   910: ||||           &   P, HP, TPIBA,  OMEGA, TAU(1,itseq),NGNL(ity),NGcont )
   911: |||+---            enddo
   912: |||                endif
   913: |||               else
   914: |||       c PARTITIONING !
   915: |||*--->           do ip=2,3
   916: ||||      c         call exnlp( dt,NG2Q, NG2, G2,
   917: ||||               if (il.eq.1 ) then
   918: ||||               l=il
   919: ||||               call exnlp( dt,NG2Q, Nxyz, G2,
   920: ||||           &   VPJ(1,ip,il,ity), VPP(ip,il,ity), VPP2(1,ip,ity),
   921: ||||      c     &   l,YLM, EXTAU(1,itseq), WORK2(1,1), WORK2(1,2),WORK2(1,3),
   922: ||||      ccc     &   l,YLM, EXTAU(1,NP,itseq), WORK2(1,1), WORK2(1,2),WORK2(1,3),
   923: ||||           &   l,YLM, EXTAU(1,NP,itseq), WORK2,
   924: ||||      ccc     &   WORK2(1,4),WORK2(1,5),
   925: ||||           &   P, HP, TPIBA,  OMEGA, TAU(1,itseq) ,NGNL(ity),NGcont )
   926: ||||               elseif ( il.eq.2 ) then
   927: ||||+-->           do l=2,4
   928: |||||              call exnlp( dt,NG2Q, Nxyz, G2,
   929: |||||          &   VPJ(1,ip,il,ity), VPP(ip,il,ity), VPP2(l,ip,ity),
   930: |||||     c     &   l,YLM, EXTAU(1,itseq), WORK2(1,1), WORK2(1,2),WORK2(1,3),
   931: |||||     ccc     &   l,YLM, EXTAU(1,NP,itseq), WORK2(1,1), WORK2(1,2),WORK2(1,3),
   932: |||||          &   l,YLM, EXTAU(1,NP,itseq), WORK2,
   933: |||||     ccc     &   WORK2(1,4),WORK2(1,5),
   934: |||||          &   P, HP, TPIBA,  OMEGA, TAU(1,itseq) ,NGNL(ity),NGcont )
   935: ||||+--            enddo
   936: ||||               elseif ( il.eq.3 ) then
   937: ||||+-->           do l=5,9
   938: |||||              call exnlp( dt,NG2Q, Nxyz, G2,
   939: |||||          &   VPJ(1,ip,il,ity), VPP(ip,il,ity), VPP2(l,ip,ity),
   940: |||||     c     &   l,YLM, EXTAU(1,itseq), WORK2(1,1), WORK2(1,2),WORK2(1,3),
   941: |||||     c     &   l,YLM, EXTAU(1,NP,itseq), WORK2(1,1), WORK2(1,2),WORK2(1,3),
   942: |||||          &   l,YLM, EXTAU(1,NP,itseq), WORK2,
   943: |||||     ccc     &   WORK2(1,4),WORK2(1,5),
   944: |||||          &   P, HP, TPIBA,  OMEGA, TAU(1,itseq) ,NGNL(ity),NGcont )
   945: ||||+--            enddo
   946: ||||               elseif ( il.eq.4 ) then
   947: ||||+-->           do l=10,16
   948: |||||              call exnlp( dt,NG2Q, Nxyz, G2,
   949: |||||          &   VPJ(1,ip,il,ity), VPP(ip,il,ity), VPP2(l,ip,ity),
   950: |||||     c     &   l,YLM, EXTAU(1,itseq), WORK2(1,1), WORK2(1,2),WORK2(1,3),
   951: |||||     c     &   l,YLM, EXTAU(1,NP,itseq), WORK2(1,1), WORK2(1,2),WORK2(1,3),
   952: |||||          &   l,YLM, EXTAU(1,NP,itseq), WORK2,
   953: |||||     ccc     &   WORK2(1,4),WORK2(1,5),
   954: |||||          &   P, HP, TPIBA,  OMEGA, TAU(1,itseq) ,NGNL(ity),NGcont )
   955: ||||+--            enddo
   956: ||||               endif
   957: |||*---            enddo
   958: |||               endif
   959: ||+----       3   continue
   960: |+-----       2  continue
   961: +------       1 continue
   962:           c ** Last: operate local potential term
   963: V------>           DO 101 JG=1,NXYZ
   964: V------     101    RHO1(JG)=(0.D0,0.D0)
   965:           *VDIR NODEP(RHO1)
   966:           !ocl norecurrence(RHO1)
   967:           c         DO 100 IG=1,NG2
   968: V------>           DO 100 IG=1,NXYZ
   969: |                  JG=J2G(IG)
   970: V------ C   100    RHO1(JG)=P(IG)
   971:           C From G-space to R-space
   972:           c *** for Sugino FFT
   973:           c         CALL FFT3BX(NRX,NRY,NRZ,NXYZ,RHO1,RHO2,
   974:           c     & WSAVEX,WSAVEY,WSAVEZ,IFACX,IFACY,IFACZ,LX1,LX2,LY1,LY2,LZ1,LZ2)
   975:           c *** for Kokubo ASL FFT
   976:           c         CALL FFT3BX_ASL(NRX,NRY,NRZ,NXYZ,RHO1,RHO2,WSAVE_XYZ,IFAC_XYZ)
   977:           c *** for Kokubo FFTW
   978:           c         call FFT3BX_fftw(NXYZ,RHO1,plancfp,plancbp)
   979:           c *** for Kokubo fftw ASL compatible
   980:                    CALL FFT3BX_fftwASL(NRX,NRY,NRZ,NXYZ,RHO1,RHO2
   981:                &    ,plancfp,plancbp)
   982:           C
   983:           C        RHO2:WAVEFN IN REAL SPACE
   984:           C        VG:POTENTIAL IN REAL SPACE
   985:           C       VGG:POTENTIAL IN R-  SPACE
   986:           C        RHO4:LOCAL PSEUDOPOTENTIAL in R- SPACE
   987: V------>        do ig=1,nxyz
   988: |         c      jg=i2g(ig)
   989: |         c      VG(jg)=VGG(jg)+rho4(jg)*fdump(ig)
   990: |         c      VG(ig)=VGG(ig)+rho4(ig)
   991: |               VG(ig)=VGG(ig)+Vloc(ig)
   992: |               enddo
   993: |         C
   994: |                  DO 300 I=1,NXYZ
   995: |                  fac=dt*dreal( vg(i) )
   996: V------     300    RHO2(I)=dcmplx( dcos(fac),-dsin(fac) )*RHO1(I)
   997:           C From R-space to G-space
   998:           c *** for Sugino FFT
   999:           c         CALL FFT3FX(NRX,NRY,NRZ,NXYZ,RHO2,RHO1,
  1000:           c     & WSAVEX,WSAVEY,WSAVEZ,IFACX,IFACY,IFACZ,LX1,LX2,LY1,LY2,LZ1,LZ2)
  1001:           c *** for Kokubo ASL FFT
  1002:           c         CALL FFT3FX_ASL(NRX,NRY,NRZ,NXYZ,RHO2,RHO1,WSAVE_XYZ,IFAC_XYZ)
  1003:           c *** for Kokubo FFTW
  1004:           c         call FFT3FX_fftw(NXYZ,RHO2,plancfp,plancbp)
  1005:           c *** for Kokubo fftw ASL compatible
  1006:                    CALL FFT3FX_fftwASL(NRX,NRY,NRZ,NXYZ,RHO2,RHO1
  1007:                &   ,plancfp,plancbp)
  1008:           C
  1009:           c         DO 110 IG=1,NG2
  1010:           *VDIR NODEP(RHO2)
  1011:           !ocl norecurrence(RHO2)
  1012: V------>           DO 110 IG=1,NXYZ
  1013: |                  JG=J2G(IG)
  1014: V------ G   110    P(IG)=RHO2(JG)
  1015:           C
  1016:                 return
  1017:                 end


NEC Fortran Compiler (3.4.2) for Vector Engine   Thu Jul 28 08:27:42 2022
FILE NAME: tmevl10_Avec_v4.f

PROCEDURE NAME: S1T
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

  1023:                 subroutine S1T(dt, NXYZ,NRX,NRY,NRZ, NG2, NG2Q, NJ,
  1024:                &     P, HP, YLM, G2,J2G,RHO1, RHO2, TPIBA, WORK2, VPJ,
  1025:                &     VPP,VPP2,OMEGA, NTAUQ, NTYQ, NTYPE, LREQ, TAU, NUMTY,
  1026:           c *** for Sugino FFT
  1027:           c     &     NIDN, IOVP, MXOFL, WSAVEX, WSAVEY, WSAVEZ,
  1028:           c     &     IFACX, IFACY, IFACZ, LX1, LX2, LY1, LY2, LZ1, LZ2,
  1029:           c *** for Kokubo ASL FFT
  1030:           c     &     NIDN, IOVP, MXOFL, WSAVE_XYZ, IFAC_XYZ,
  1031:           c *** for Kokubo FFTW
  1032:                &     NIDN, IOVP, MXOFL, plancfp,plancbp,
  1033:                &     VG,VGG,fdump,Vloc,TPIBA2,EXTAU,NP,NGNL,NGcont)
  1034:                 implicit double precision(a-h,o-z)
  1035:           c      COMPLEX*16  P(NG2Q), HP(NG2Q,3)
  1036:                 COMPLEX*16  P(NG2Q), HP(NG2Q)
  1037:           cc      DIMENSION IOWF(MBLK),IOVP(2,NTYQ)
  1038:           C
  1039:           c      REAL*8 YLM(NG2Q,4),OUT(NBNDQ,3),EE(NBNDQ)
  1040:           c      REAL*8 YLM(NG2Q,4)
  1041:           c      REAL*8 YLM(NG2Q,9)
  1042:                 REAL*8 YLM(NGcont,16)
  1043:                 COMPLEX*16 RHO1(NXYZ),RHO2(NXYZ),
  1044:           c     &    VG(NXYZ),VGG(NXYZ),WORK2(NG2Q,3),EXTAU(NXYZ,NTAUQ)
  1045:           c     &    VG(NXYZ),WORK2(NG2Q,3),EXTAU(NXYZ,NTAUQ)
  1046:           c     &    VG(NXYZ),WORK2(NG2Q,3),EXTAU(NXYZ/6,NTAUQ)
  1047:           c     &    VG(NXYZ),WORK2(NG2Q,5),EXTAU(NXYZ/6,5,NTAUQ)
  1048:                &    VG(NXYZ),WORK2(NG2Q),EXTAU(NGcont,5,NTAUQ)
  1049:                 dimension VGG(NXYZ)
  1050:           c *** for Sugino FFT
  1051:           c      COMPLEX*16 WSAVEX(NRX),WSAVEY(NRY),WSAVEZ(NRZ)
  1052:           c      DIMENSION IFACX(30),IFACY(30),IFACZ(30)
  1053:           c      DIMENSION LX1(NXYZ),LX2(NXYZ),LY1(NXYZ),
  1054:           c     &          LY2(NXYZ),LZ1(NXYZ),LZ2(NXYZ)
  1055:           c *** for Kokubo ASL FFT
  1056:           c      COMPLEX*16 WSAVE_XYZ(NRX+NRY+NRZ)
  1057:           c      DIMENSION IFAC_XYZ(60)
  1058:           c *** for Kokubo FFTW
  1059:                 integer*8 plancfp,plancbp
  1060:                 DIMENSION J2G(NG2Q),G2(4,NG2Q)
  1061:                 DIMENSION TAU(3,NTAUQ),NUMTY(NTYQ),NIDN(NTAUQ,NTYQ), MXOFL(NTYQ)
  1062:           c      DIMENSION VPJ(NG2Q,3,2,NTYQ),VPP(3,2,NTYQ),VPP2(4,3,NTYQ)
  1063:           c      DIMENSION VPJ(NG2Q/3,3,2,NTYQ),VPP(3,3,NTYQ),VPP2(4,3,NTYQ)
  1064:           c      DIMENSION VPJ(NG2Q/3,3,3,NTYQ),VPP(3,3,NTYQ),VPP2(9,3,NTYQ)
  1065:                 DIMENSION VPJ(NGcont,3,4,NTYQ),VPP(3,4,NTYQ),VPP2(16,3,NTYQ)
  1066:                 dimension fdump(NXYZ)
  1067:           c      complex*16 rho4(NXYZ) ! but used as real
  1068:                 dimension Vloc(NXYZ)
  1069:                 dimension NGNL(NTYQ)
  1070:                 parameter ( ntyq2=4 )
  1071:           c      COMMON/SAITO2/IBUN(3,NTYQ2)
  1072:                 COMMON/SAITO2/IBUN(4,NTYQ2)
  1073:           c
  1074:           c ** First: operate local potential term
  1075: V------>           DO 101 JG=1,NXYZ
  1076: V------     101    RHO1(JG)=(0.D0,0.D0)
  1077:           *VDIR NODEP(RHO1)
  1078:           !ocl norecurrence(RHO1)
  1079:           c         DO 100 IG=1,NG2
  1080: V------>           DO 100 IG=1,NXYZ
  1081: |                  JG=J2G(IG)
  1082: V------ C   100    RHO1(JG)=P(IG)
  1083:           C From G-space to R-space
  1084:           c *** for Sugino FFT
  1085:           c         CALL FFT3BX(NRX,NRY,NRZ,NXYZ,RHO1,RHO2,
  1086:           c     & WSAVEX,WSAVEY,WSAVEZ,IFACX,IFACY,IFACZ,LX1,LX2,LY1,LY2,LZ1,LZ2)
  1087:           c *** for Kokubo ASL FFT
  1088:           c       CALL FFT3BX_ASL(NRX,NRY,NRZ,NXYZ,RHO1,RHO2,WSAVE_XYZ,IFAC_XYZ)
  1089:           c *** for Kokubo FFTW
  1090:           c       call FFT3BX_fftw(NXYZ,RHO1,plancfp,plancbp)
  1091:           c *** for Kokubo fftw ASL compatible
  1092:                  CALL FFT3BX_fftwASL(NRX,NRY,NRZ,NXYZ,RHO1,RHO2
  1093:                &  ,plancfp,plancbp)
  1094:           C
  1095:           C        RHO2:WAVEFN IN REAL SPACE
  1096:           C        VG:POTENTIAL IN REAL SPACE
  1097:           C       VGG:POTENTIAL IN R-  SPACE
  1098:           C        RHO4:LOCAL PSEUDOPOTENTIAL in R- SPACE
  1099: V------>        do ig=1,nxyz
  1100: |         c      jg=i2g(ig)
  1101: |         c      VG(jg)=VGG(jg)+rho4(jg)*fdump(ig)
  1102: |         c      VG(ig)=VGG(ig)+rho4(ig)
  1103: |               VG(ig)=VGG(ig)+Vloc(ig)
  1104: |               enddo
  1105: |         C
  1106: |         C
  1107: |         C
  1108: |                  DO 300 I=1,NXYZ
  1109: |                  fac=dt*dreal( vg(i) )
  1110: V------     300    RHO2(I)=dcmplx( dcos(fac),-dsin(fac) )*RHO1(I)
  1111:           C From R-space to G-space
  1112:           c *** for Sugino FFT
  1113:           c         CALL FFT3FX(NRX,NRY,NRZ,NXYZ,RHO2,RHO1,
  1114:           c     & WSAVEX,WSAVEY,WSAVEZ,IFACX,IFACY,IFACZ,LX1,LX2,LY1,LY2,LZ1,LZ2)
  1115:           c *** for Kokubo ASL FFT
  1116:           c       CALL FFT3FX_ASL(NRX,NRY,NRZ,NXYZ,RHO2,RHO1,WSAVE_XYZ,IFAC_XYZ)
  1117:           c *** for Kokubo FFTW
  1118:           c       call FFT3FX_fftw(NXYZ,RHO2,plancfp,plancbp)
  1119:           c *** for Kokubo fftw ASL compatible
  1120:                  CALL FFT3FX_fftwASL(NRX,NRY,NRZ,NXYZ,RHO2,RHO1
  1121:                & ,plancfp,plancbp)
  1122:           C
  1123:           c         DO 110 IG=1,NG2
  1124:           *VDIR NODEP(RHO2)
  1125:           !ocl norecurrence(RHO2)
  1126: V------>           DO 110 IG=1,NXYZ
  1127: |                  JG=J2G(IG)
  1128: V------ G   110    P(IG)=RHO2(JG)
  1129:           C
  1130:           c *** second: operate  nonlocal pseudopotential terms
  1131: +------>        do 1 ity=ntype,1,-1
  1132: |                if ( numty(ity).lt.0 ) goto 1 ! skip Hydrogen
  1133: |+----->         do 2 it=numty(ity),1,-1
  1134: ||               itseq=nidn(it,ity)  ! seq # of atomic site
  1135: ||+---->          do 3 il=mxofl(ity),1,-1
  1136: |||               call zero(hp,ng2q)
  1137: |||               if ( IBUN(il,ity).ne.1 ) then
  1138: |||       c NON PARTITIONING !
  1139: |||       c         call exnlp( dt,NG2Q, NG2, G2,
  1140: |||                if ( il.eq.1 ) then
  1141: |||                l=il
  1142: |||                call exnlp( dt,NG2Q, NXYZ, G2,
  1143: |||            &   VPJ(1,1,il,ity), VPP(1,il,ity), VPP2(1,1,ity),
  1144: |||       c     &   l,YLM, EXTAU(1,itseq), WORK2(1,1), WORK2(1,2),WORK2(1,3),
  1145: |||       c     &   l,YLM, EXTAU(1,NP,itseq), WORK2(1,1), WORK2(1,2),WORK2(1,3),
  1146: |||            &   l,YLM, EXTAU(1,NP,itseq), WORK2,
  1147: |||       cc     &   WORK2(1,4),WORK2(1,5),
  1148: |||            &   P, HP, TPIBA,  OMEGA, TAU(1,itseq) ,NGNL(ity),NGcont )
  1149: |||                elseif ( il.eq.2 ) then
  1150: |||+--->           do l=4,2,-1
  1151: ||||               call exnlp( dt,NG2Q, NXYZ, G2,
  1152: ||||           &   VPJ(1,1,il,ity), VPP(1,il,ity), VPP2(l,1,ity),
  1153: ||||      c     &   l,YLM, EXTAU(1,itseq), WORK2(1,1), WORK2(1,2),WORK2(1,3),
  1154: ||||      ccc     &   l,YLM, EXTAU(1,NP,itseq), WORK2(1,1), WORK2(1,2),WORK2(1,3),
  1155: ||||           &   l,YLM, EXTAU(1,NP,itseq), WORK2,
  1156: ||||      ccc     &   WORK2(1,4),WORK2(1,5),
  1157: ||||           &   P, HP, TPIBA,  OMEGA, TAU(1,itseq) ,NGNL(ity),NGcont )
  1158: |||+---            enddo
  1159: |||                elseif ( il.eq.3 ) then
  1160: |||+--->           do l=9,5,-1
  1161: ||||               call exnlp( dt,NG2Q, NXYZ, G2,
  1162: ||||           &   VPJ(1,1,il,ity), VPP(1,il,ity), VPP2(l,1,ity),
  1163: ||||      c     &   l,YLM, EXTAU(1,itseq), WORK2(1,1), WORK2(1,2),WORK2(1,3),
  1164: ||||      ccc     &   l,YLM, EXTAU(1,NP,itseq), WORK2(1,1), WORK2(1,2),WORK2(1,3),
  1165: ||||           &   l,YLM, EXTAU(1,NP,itseq), WORK2,
  1166: ||||      ccc     &   WORK2(1,4),WORK2(1,5),
  1167: ||||           &   P, HP, TPIBA,  OMEGA, TAU(1,itseq) ,NGNL(ity),NGcont )
  1168: |||+---            enddo
  1169: |||                elseif ( il.eq.4 ) then
  1170: |||+--->           do l=16,10,-1
  1171: ||||               call exnlp( dt,NG2Q, NXYZ, G2,
  1172: ||||           &   VPJ(1,1,il,ity), VPP(1,il,ity), VPP2(l,1,ity),
  1173: ||||      c     &   l,YLM, EXTAU(1,itseq), WORK2(1,1), WORK2(1,2),WORK2(1,3),
  1174: ||||      ccc     &   l,YLM, EXTAU(1,NP,itseq), WORK2(1,1), WORK2(1,2),WORK2(1,3),
  1175: ||||           &   l,YLM, EXTAU(1,NP,itseq), WORK2,
  1176: ||||      ccc     &   WORK2(1,4),WORK2(1,5),
  1177: ||||           &   P, HP, TPIBA,  OMEGA, TAU(1,itseq) ,NGNL(ity),NGcont )
  1178: |||+---            enddo
  1179: |||                endif
  1180: |||               else
  1181: |||       c PARTITIONING !
  1182: |||*--->           do ip=3,2,-1
  1183: ||||      c         call exnlp( dt,NG2Q, NG2, G2,
  1184: ||||               if ( il.eq.1 ) then
  1185: ||||               l=il
  1186: ||||               call exnlp( dt,NG2Q, NXYZ, G2,
  1187: ||||           &   VPJ(1,ip,il,ity), VPP(ip,il,ity), VPP2(1,ip,ity),
  1188: ||||      c     &   l,YLM, EXTAU(1,itseq), WORK2(1,1), WORK2(1,2),WORK2(1,3),
  1189: ||||      ccc     &   l,YLM, EXTAU(1,NP,itseq), WORK2(1,1), WORK2(1,2),WORK2(1,3),
  1190: ||||           &   l,YLM, EXTAU(1,NP,itseq), WORK2,
  1191: ||||      ccc     &   WORK2(1,4),WORK2(1,5),
  1192: ||||           &   P, HP, TPIBA,  OMEGA, TAU(1,itseq) ,NGNL(ity),NGcont )
  1193: ||||               elseif ( il.eq.2 ) then
  1194: ||||+-->           do l=4,2,-1
  1195: |||||              call exnlp( dt,NG2Q, NXYZ, G2,
  1196: |||||          &   VPJ(1,ip,il,ity), VPP(ip,il,ity), VPP2(l,ip,ity),
  1197: |||||     c     &   l,YLM, EXTAU(1,itseq), WORK2(1,1), WORK2(1,2),WORK2(1,3),
  1198: |||||     ccc     &   l,YLM, EXTAU(1,NP,itseq), WORK2(1,1), WORK2(1,2),WORK2(1,3),
  1199: |||||          &   l,YLM, EXTAU(1,NP,itseq), WORK2,
  1200: |||||     ccc     &   WORK2(1,4),WORK2(1,5),
  1201: |||||          &   P, HP, TPIBA,  OMEGA, TAU(1,itseq) ,NGNL(ity),NGcont )
  1202: ||||+--            enddo
  1203: ||||               elseif ( il.eq.3 ) then
  1204: ||||+-->           do l=9,5,-1
  1205: |||||              call exnlp( dt,NG2Q, NXYZ, G2,
  1206: |||||          &   VPJ(1,ip,il,ity), VPP(ip,il,ity), VPP2(l,ip,ity),
  1207: |||||     c     &   l,YLM, EXTAU(1,itseq), WORK2(1,1), WORK2(1,2),WORK2(1,3),
  1208: |||||     ccc     &   l,YLM, EXTAU(1,NP,itseq), WORK2(1,1), WORK2(1,2),WORK2(1,3),
  1209: |||||          &   l,YLM, EXTAU(1,NP,itseq), WORK2,
  1210: |||||     ccc     &   WORK2(1,4),WORK2(1,5),
  1211: |||||          &   P, HP, TPIBA,  OMEGA, TAU(1,itseq) ,NGNL(ity),NGcont )
  1212: ||||+--            enddo
  1213: ||||               elseif ( il.eq.4 ) then
  1214: ||||+-->           do l=16,10,-1
  1215: |||||              call exnlp( dt,NG2Q, NXYZ, G2,
  1216: |||||          &   VPJ(1,ip,il,ity), VPP(ip,il,ity), VPP2(l,ip,ity),
  1217: |||||     c     &   l,YLM, EXTAU(1,itseq), WORK2(1,1), WORK2(1,2),WORK2(1,3),
  1218: |||||     ccc     &   l,YLM, EXTAU(1,NP,itseq), WORK2(1,1), WORK2(1,2),WORK2(1,3),
  1219: |||||          &   l,YLM, EXTAU(1,NP,itseq), WORK2,
  1220: |||||     ccc     &   WORK2(1,4),WORK2(1,5),
  1221: |||||          &   P, HP, TPIBA,  OMEGA, TAU(1,itseq) ,NGNL(ity),NGcont )
  1222: ||||+--            enddo
  1223: ||||               endif
  1224: |||*---            enddo
  1225: |||               endif
  1226: ||+----       3   continue
  1227: |+-----       2  continue
  1228: +------       1 continue
  1229:           c *** Last: operate kinetic energy term
  1230:           c      do ig=1,ng2
  1231: V------>        do ig=1,nxyz
  1232: |                fac=dt*0.5d0*g2(4,ig)*TPIBA2  ! 0.5d0*g2(4,ig) = Ekin (Hr)
  1233: |                P(ig)=dcmplx( dcos(fac),-dsin(fac) )*P(ig)
  1234: V------         enddo
  1235:           c
  1236:                 return
  1237:                 end


NEC Fortran Compiler (3.4.2) for Vector Engine   Thu Jul 28 08:27:42 2022
FILE NAME: tmevl10_Avec_v4.f

PROCEDURE NAME: EXKIN
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

  1239:                 subroutine exkin(dt,ng2,ng2q,P,G2,TPIBA2,GDUMP,GMHF)
  1240:                 implicit double precision(a-h,o-z)
  1241:                 COMPLEX*16  P(NG2Q)
  1242:                 DIMENSION G2(4,NG2Q),GDUMP(NG2Q)
  1243:           ccc      dthalf=0.5d0*dt
  1244:                 dtqrt=0.25d0*dt*TPIBA2
  1245: V------>        do ig=1,ng2
  1246: |         c      fac=dtqrt*( GDUMP(ig) - GMHF ) ! note:0.5d0*g2(4,ig)*TPIBA2=Ekin(Hr)
  1247: |               fac=dtqrt*GDUMP(ig) ! note:0.5d0*g2(4,ig)*TPIBA2=Ekin(Hr)
  1248: |               P(ig)=dcmplx( dcos(fac),-dsin(fac) )*P(ig)
  1249: V------         enddo
  1250:                 return
  1251:                 end


NEC Fortran Compiler (3.4.2) for Vector Engine   Thu Jul 28 08:27:42 2022
FILE NAME: tmevl10_Avec_v4.f

PROCEDURE NAME: EXKIN_
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

  1252:                 subroutine exkin_(dt,ng2,ng2q,P,G2,TPIBA2,GDUMP,GMHF,
  1253:                &                  mxbnd,nbegin,nend)
  1254:                 implicit double precision(a-h,o-z)
  1255:                 COMPLEX*16  P(NG2Q,mxbnd)
  1256:                 DIMENSION G2(4,NG2Q),GDUMP(NG2Q)
  1257:           ccc      dthalf=0.5d0*dt
  1258:                 dtqrt=0.25d0*dt*TPIBA2
  1259: +------>        do ib=nbegin,nend
  1260: |                iib=ib-nbegin+1
  1261: |V----->        do ig=1,ng2
  1262: ||        c      fac=dtqrt*( GDUMP(ig) - GMHF ) ! note:0.5d0*g2(4,ig)*TPIBA2=Ekin(Hr)
  1263: ||              fac=dtqrt*GDUMP(ig) ! note:0.5d0*g2(4,ig)*TPIBA2=Ekin(Hr)
  1264: ||              P(ig,iib)=dcmplx( dcos(fac),-dsin(fac) )*P(ig,iib)
  1265: |V-----         enddo
  1266: +------         enddo
  1267:                 return
  1268:                 end


NEC Fortran Compiler (3.4.2) for Vector Engine   Thu Jul 28 08:27:42 2022
FILE NAME: tmevl10_Avec_v4.f

PROCEDURE NAME: S2
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

  1275:                 subroutine S2(dt, NXYZ,NRX,NRY,NRZ, NG2, NG2Q, NJ,
  1276:                &     P, HP, YLM, G2,J2G,RHO1, RHO2, TPIBA, WORK2, VPJ,
  1277:                &     VPP,VPP2,OMEGA, NTAUQ, NTYQ, NTYPE, LREQ, TAU, NUMTY,
  1278:           c *** for Sugino FFT
  1279:           c     &     NIDN, IOVP, MXOFL, WSAVEX, WSAVEY, WSAVEZ,
  1280:           c     &     IFACX, IFACY, IFACZ, LX1, LX2, LY1, LY2, LZ1, LZ2,
  1281:           c *** for Kokubo ASL FFT
  1282:           c     &     NIDN, IOVP, MXOFL, WSAVE_XYZ, IFAC_XYZ,
  1283:           c *** for Kokubo FFTW
  1284:                &     NIDN, IOVP, MXOFL, plancfp,plancbp,
  1285:                &     VG,VGG,fdump,Vloc,EXTAU,NP,NGNL,NGcont)
  1286:                 implicit double precision(a-h,o-z)
  1287:           c      COMPLEX*16  P(NG2Q), HP(NG2Q,3)
  1288:                 COMPLEX*16  P(NG2Q), HP(NG2Q)
  1289:           cc      DIMENSION IOWF(MBLK),IOVP(2,NTYQ)
  1290:           C
  1291:           c      REAL*8 YLM(NG2Q,4),OUT(NBNDQ,3),EE(NBNDQ)
  1292:           c      REAL*8 YLM(NG2Q,4)
  1293:           c      REAL*8 YLM(NG2Q,9)
  1294:                 REAL*8 YLM(NGcont,16)
  1295:                 COMPLEX*16 RHO1(NXYZ),RHO2(NXYZ),
  1296:           c     &    VG(NXYZ),VGG(NXYZ),WORK2(NG2Q,3),EXTAU(NXYZ,NTAUQ)
  1297:           c     &    VG(NXYZ),WORK2(NG2Q,3),EXTAU(NXYZ,NTAUQ)
  1298:           c     &    VG(NXYZ),WORK2(NG2Q,3),EXTAU(NXYZ/6,NTAUQ)
  1299:           c     &    VG(NXYZ),WORK2(NG2Q,5),EXTAU(NXYZ/6,5,NTAUQ)
  1300:                &    VG(NXYZ),WORK2(NG2Q),EXTAU(NGcont,5,NTAUQ)
  1301:                 dimension VGG(NXYZ)
  1302:           c *** for Sugino FFT
  1303:           c      COMPLEX*16 WSAVEX(NRX),WSAVEY(NRY),WSAVEZ(NRZ)
  1304:           c      DIMENSION IFACX(30),IFACY(30),IFACZ(30)
  1305:           c      DIMENSION LX1(NXYZ),LX2(NXYZ),LY1(NXYZ),
  1306:           c     &          LY2(NXYZ),LZ1(NXYZ),LZ2(NXYZ)
  1307:           c *** for Kokubo ASL FFT
  1308:           c      COMPLEX*16 WSAVE_XYZ(NRX+NRY+NRZ)
  1309:           c      DIMENSION IFAC_XYZ(60)
  1310:           c *** for Kokubo FFTW
  1311:                 integer*8 plancfp,plancbp
  1312:                 DIMENSION J2G(NG2Q),G2(4,NG2Q)
  1313:                 DIMENSION TAU(3,NTAUQ),NUMTY(NTYQ),NIDN(NTAUQ,NTYQ), MXOFL(NTYQ)
  1314:           c      DIMENSION VPJ(NG2Q,3,2,NTYQ),VPP(3,2,NTYQ),VPP2(4,3,NTYQ)
  1315:           c      DIMENSION VPJ(NG2Q/3,3,2,NTYQ),VPP(3,3,NTYQ),VPP2(4,3,NTYQ)
  1316:           c      DIMENSION VPJ(NG2Q/3,3,3,NTYQ),VPP(3,3,NTYQ),VPP2(9,3,NTYQ)
  1317:                 DIMENSION VPJ(NGcont,3,4,NTYQ),VPP(3,4,NTYQ),VPP2(16,3,NTYQ)
  1318:                 dimension fdump(NXYZ)
  1319:           c      complex*16 rho4(NXYZ)  ! but used as real
  1320:                 dimension Vloc(NXYZ)
  1321:                 dimension NGNL(NTYQ)
  1322:                 parameter ( ntyq2=4 )
  1323:           c      COMMON/SAITO2/IBUN(3,NTYQ2)
  1324:                 COMMON/SAITO2/IBUN(4,NTYQ2)
  1325:           c *** first: operate kinetic energy term
  1326:           c      do ig=1,ng2
  1327:           c       fac=dt*0.25d0*g2(4,ig)  ! 0.5d0*g2(4,ig) = Ekin (Hr)
  1328:           c       P(ig)=dcmplx( dcos(fac),-dsin(fac) )*P(ig)
  1329:           c      enddo
  1330:           c *** second: operate  nonlocal pseudopotential terms
  1331:           c ***  temp check for G2 & YLM
  1332:           c         write(6,*)' in sub. S2 G2 beyond NG2! '
  1333:           c         write(6,*)( G2(4,ig),ig=ng2+1,nxyz,500 )
  1334:           c         write(6,*)' in sub. S2 YLM beyond NG2! '
  1335:           c         write(6,*)( YLM(ig,4),ig=ng2+1,nxyz,500 )
  1336:           c         write(6,*)' in sub. S2 VPJ beyond NG2! '
  1337:           c         write(6,*)( VPJ(ig,3,2,1),ig=ng2+1,nxyz,500 )
  1338:           c ***  temp check for YLM : end
  1339:                 dthalf=0.5d0*dt
  1340: +------>        do 1 ity=ntype,1,-1
  1341: |                if ( numty(ity).lt.0 ) goto 1 ! skip Hydrogen
  1342: |+----->         do 2 it=numty(ity),1,-1
  1343: ||               itseq=nidn(it,ity)  ! seq # of atomic site
  1344: ||        cc        call zero(hp,ng2q)
  1345: ||+---->          do 3 il=mxofl(ity),1,-1
  1346: |||               if ( IBUN(il,ity).ne.1 ) then
  1347: |||       c NON PARTITIONING !
  1348: |||       c         call exnlp( dthalf,NG2Q, NG2, G2,
  1349: |||                if ( il.eq.1 ) then
  1350: |||                l=il
  1351: |||                call exnlp( dthalf,NG2Q, NXYZ, G2,
  1352: |||            &   VPJ(1,1,il,ity), VPP(1,il,ity), VPP2(l,1,ity),
  1353: |||       c     &   l,YLM, EXTAU(1,itseq), WORK2(1,1), WORK2(1,2),WORK2(1,3),
  1354: |||       c     &   l,YLM, EXTAU(1,NP,itseq), WORK2(1,1), WORK2(1,2),WORK2(1,3),
  1355: |||            &   l,YLM, EXTAU(1,NP,itseq), WORK2,
  1356: |||       ccc     &   WORK2(1,4),WORK2(1,5),
  1357: |||            &   P, HP, TPIBA,  OMEGA, TAU(1,itseq) ,NGNL(ity),NGcont )
  1358: |||                elseif ( il.eq.2 ) then
  1359: |||+--->           do l=4,2,-1
  1360: ||||               call exnlp( dthalf,NG2Q, NXYZ, G2,
  1361: ||||           &   VPJ(1,1,il,ity), VPP(1,il,ity), VPP2(l,1,ity),
  1362: ||||      c     &   l,YLM, EXTAU(1,itseq), WORK2(1,1), WORK2(1,2),WORK2(1,3),
  1363: ||||      c     &   l,YLM, EXTAU(1,NP,itseq), WORK2(1,1), WORK2(1,2),WORK2(1,3),
  1364: ||||           &   l,YLM, EXTAU(1,NP,itseq), WORK2,
  1365: ||||      c     &   WORK2(1,4),WORK2(1,5),
  1366: ||||           &   P, HP, TPIBA,  OMEGA, TAU(1,itseq) ,NGNL(ity),NGcont )
  1367: |||+---            enddo
  1368: |||                elseif ( il.eq.3 ) then
  1369: |||+--->           do l=9,5,-1
  1370: ||||               call exnlp( dthalf,NG2Q, NXYZ, G2,
  1371: ||||           &   VPJ(1,1,il,ity), VPP(1,il,ity), VPP2(l,1,ity),
  1372: ||||      c     &   l,YLM, EXTAU(1,itseq), WORK2(1,1), WORK2(1,2),WORK2(1,3),
  1373: ||||      ccc     &   l,YLM, EXTAU(1,NP,itseq), WORK2(1,1), WORK2(1,2),WORK2(1,3),
  1374: ||||           &   l,YLM, EXTAU(1,NP,itseq), WORK2,
  1375: ||||      ccc     &   WORK2(1,4),WORK2(1,5),
  1376: ||||           &   P, HP, TPIBA,  OMEGA, TAU(1,itseq) ,NGNL(ity),NGcont )
  1377: |||+---            enddo
  1378: |||                elseif ( il.eq.4 ) then
  1379: |||+--->           do l=16,10,-1
  1380: ||||               call exnlp( dthalf,NG2Q, NXYZ, G2,
  1381: ||||           &   VPJ(1,1,il,ity), VPP(1,il,ity), VPP2(l,1,ity),
  1382: ||||      c     &   l,YLM, EXTAU(1,itseq), WORK2(1,1), WORK2(1,2),WORK2(1,3),
  1383: ||||      ccc     &   l,YLM, EXTAU(1,NP,itseq), WORK2(1,1), WORK2(1,2),WORK2(1,3),
  1384: ||||           &   l,YLM, EXTAU(1,NP,itseq), WORK2,
  1385: ||||      ccc     &   WORK2(1,4),WORK2(1,5),
  1386: ||||           &   P, HP, TPIBA,  OMEGA, TAU(1,itseq) ,NGNL(ity),NGcont )
  1387: |||+---            enddo
  1388: |||                endif
  1389: |||               else
  1390: |||       c PARTITIONING !
  1391: |||*--->           do ip=3,2,-1
  1392: ||||      c         call exnlp( dthalf,NG2Q, NG2, G2,
  1393: ||||               if ( il.eq.1 ) then
  1394: ||||               l=il
  1395: ||||               call exnlp( dthalf,NG2Q, NXYZ, G2,
  1396: ||||           &   VPJ(1,ip,il,ity), VPP(ip,il,ity), VPP2(l,ip,ity),
  1397: ||||      c     &   l,YLM, EXTAU(1,itseq), WORK2(1,1), WORK2(1,2),WORK2(1,3),
  1398: ||||      ccc     &   l,YLM, EXTAU(1,NP,itseq), WORK2(1,1), WORK2(1,2),WORK2(1,3),
  1399: ||||           &   l,YLM, EXTAU(1,NP,itseq), WORK2,
  1400: ||||      ccc     &   WORK2(1,4),WORK2(1,5),
  1401: ||||           &   P, HP, TPIBA,  OMEGA, TAU(1,itseq) ,NGNL(ity),NGcont )
  1402: ||||               elseif ( il.eq.2 ) then
  1403: ||||+-->           do l=4,2,-1
  1404: |||||              call exnlp( dthalf,NG2Q, NXYZ, G2,
  1405: |||||          &   VPJ(1,ip,il,ity), VPP(ip,il,ity), VPP2(l,ip,ity),
  1406: |||||     c     &   l,YLM, EXTAU(1,itseq), WORK2(1,1), WORK2(1,2),WORK2(1,3),
  1407: |||||     c     &   l,YLM, EXTAU(1,NP,itseq), WORK2(1,1), WORK2(1,2),WORK2(1,3),
  1408: |||||          &   l,YLM, EXTAU(1,NP,itseq), WORK2,
  1409: |||||     cccc     &   WORK2(1,4),WORK2(1,5),
  1410: |||||          &   P, HP, TPIBA,  OMEGA, TAU(1,itseq) ,NGNL(ity),NGcont )
  1411: ||||+--            enddo
  1412: ||||               elseif ( il.eq.3 ) then
  1413: ||||+-->           do l=9,5,-1
  1414: |||||              call exnlp( dthalf,NG2Q, NXYZ, G2,
  1415: |||||          &   VPJ(1,ip,il,ity), VPP(ip,il,ity), VPP2(l,ip,ity),
  1416: |||||     c     &   l,YLM, EXTAU(1,itseq), WORK2(1,1), WORK2(1,2),WORK2(1,3),
  1417: |||||     ccc     &   l,YLM, EXTAU(1,NP,itseq), WORK2(1,1), WORK2(1,2),WORK2(1,3),
  1418: |||||          &   l,YLM, EXTAU(1,NP,itseq), WORK2,
  1419: |||||     ccc     &   WORK2(1,4),WORK2(1,5),
  1420: |||||          &   P, HP, TPIBA,  OMEGA, TAU(1,itseq) ,NGNL(ity),NGcont )
  1421: ||||+--            enddo
  1422: ||||               elseif ( il.eq.4 ) then
  1423: ||||+-->           do l=16,10,-1
  1424: |||||              call exnlp( dthalf,NG2Q, NXYZ, G2,
  1425: |||||          &   VPJ(1,ip,il,ity), VPP(ip,il,ity), VPP2(l,ip,ity),
  1426: |||||     c     &   l,YLM, EXTAU(1,itseq), WORK2(1,1), WORK2(1,2),WORK2(1,3),
  1427: |||||     ccc     &   l,YLM, EXTAU(1,NP,itseq), WORK2(1,1), WORK2(1,2),WORK2(1,3),
  1428: |||||          &   l,YLM, EXTAU(1,NP,itseq), WORK2,
  1429: |||||     ccc     &   WORK2(1,4),WORK2(1,5),
  1430: |||||          &   P, HP, TPIBA,  OMEGA, TAU(1,itseq) ,NGNL(ity),NGcont )
  1431: ||||+--            enddo
  1432: ||||               endif
  1433: |||*---            enddo
  1434: |||               endif
  1435: ||+----       3   continue
  1436: |+-----       2  continue
  1437: +------       1 continue
  1438:           c ****
  1439:           c *****  temp check : orthonormality
  1440:           c        temp=0
  1441:           c        do ig=1,nxyz
  1442:           c        temp=temp+dble( dconjg(P(IG))*P(IG) )
  1443:           c        enddo
  1444:           c        write(6,*)' in sub S2 after non-local:  norm = ',temp
  1445:           c *** temp check:end
  1446:           c ** third: operate local potential term
  1447: V------>           DO 101 JG=1,NXYZ
  1448: |         c  101    RHO1(JG)=(0.D0,0.D0)
  1449: V------     101    RHO2(JG)=(0.D0,0.D0)
  1450:           *VDIR NODEP(RHO1)
  1451:           !ocl norecurrence(RHO1)
  1452:           c         DO 100 IG=1,NG2
  1453: V------>           DO 100 IG=1,NXYZ
  1454: |                  JG=J2G(IG)
  1455: V------ C   100    RHO1(JG)=P(IG)
  1456:           c **** temp check
  1457:           c       sum=0
  1458:           c       do ig=1,nxyz
  1459:           c       sum=sum+dreal( dconjg( RHO1(ig) )*RHO1(ig) )
  1460:           c       enddo
  1461:           c       write(6,*)' in sub. S2: before FFT : norm = ',sum
  1462:           c **** temp check : end
  1463:           c ****  temp check
  1464:           C
  1465:           C
  1466:           c ****  temp check : end
  1467:           C From G-space to R-space
  1468:           c *** for Sugino FFT
  1469:           c         CALL FFT3BX(NRX,NRY,NRZ,NXYZ,RHO1,RHO2,
  1470:           c     & WSAVEX,WSAVEY,WSAVEZ,IFACX,IFACY,IFACZ,LX1,LX2,LY1,LY2,LZ1,LZ2)
  1471:           c *** for Kokubo ASL FFT
  1472:           c      CALL FFT3BX_ASL(NRX,NRY,NRZ,NXYZ,RHO1,RHO2,WSAVE_XYZ,IFAC_XYZ)
  1473:           c *** for Kokubo FFTW
  1474:           c      call FFT3BX_fftw(NXYZ,RHO1,plancfp,plancbp)
  1475:           c *** for Kokubo fftw ASL compatible
  1476:                 CALL FFT3BX_fftwASL(NRX,NRY,NRZ,NXYZ,RHO1,RHO2
  1477:                &,plancfp,plancbp)
  1478:           c **** temp check
  1479:           c       sum=0
  1480:           c       do ig=1,nxyz
  1481:           c       sum=sum+dreal( dconjg( RHO1(ig) )*RHO1(ig) )
  1482:           c       enddo
  1483:           c       write(6,*)' in sub. S2: after FFT : norm = ',
  1484:           c     & sum/dfloat(NXYZ)
  1485:           c **** temp check : end
  1486:           C
  1487:           C        RHO1:WAVEFN IN REAL SPACE
  1488:           C        VG:POTENTIAL IN REAL SPACE
  1489:           C       VGG: HXC POTENTIAL IN R-  SPACE
  1490:           C       RHO4:LOCAL PSEUDOPOTENTIAL in R- SPACE
  1491: V------>        do ig=1,nxyz
  1492: |         c      jg=i2g(ig)
  1493: |         c      VG(jg)=VGG(jg)+rho4(jg)*fdump(ig)
  1494: |         c      VG(ig)=VGG(ig)+rho4(ig)
  1495: |               VG(ig)=VGG(ig)+Vloc(ig)
  1496: |               enddo
  1497: |         C
  1498: |         C
  1499: |         c *** temp check
  1500: |         c       write(6,*)' VG in sub. S2 '
  1501: |         c       write(6,*)( VG(ig),ig=1,1500,100 )
  1502: |         c *** temp check ; end
  1503: |         C
  1504: |         c **** temp check
  1505: |         c       sum=0
  1506: |         c       do ig=1,nxyz
  1507: |         c       sum=sum+dreal( dconjg( RHO1(ig) )*RHO1(ig) )
  1508: |         c       enddo
  1509: |         c       write(6,*)' in sub. S2: before exp(Vlocal) : norm = ',
  1510: |         c     & sum/dfloat(NXYZ)
  1511: |         c **** temp check : end
  1512: |                  DO 300 I=1,NXYZ
  1513: |                  fac=dt*dreal( vg(i) )
  1514: V------     300    RHO2(I)=dcmplx( dcos(fac),-dsin(fac) )*RHO1(I)
  1515:           c **** temp check
  1516:           c       sum=0
  1517:           c       do ig=1,nxyz
  1518:           c       sum=sum+dreal( dconjg( RHO2(ig) )*RHO2(ig) )
  1519:           c       enddo
  1520:           c       write(6,*)' in sub. S2: after exp(Vlocal) : norm = ',
  1521:           c     & sum/dfloat(NXYZ)
  1522:           c **** temp check : end
  1523:           C From R-space to G-space
  1524:           c *** for Sugino FFT
  1525:           c         CALL FFT3FX(NRX,NRY,NRZ,NXYZ,RHO2,RHO1,
  1526:           c     & WSAVEX,WSAVEY,WSAVEZ,IFACX,IFACY,IFACZ,LX1,LX2,LY1,LY2,LZ1,LZ2)
  1527:           c *** for Kokubo ASL FFT
  1528:           c      CALL FFT3FX_ASL(NRX,NRY,NRZ,NXYZ,RHO2,RHO1,WSAVE_XYZ,IFAC_XYZ)
  1529:           c *** for Kokubo FFTW
  1530:           c      call FFT3FX_fftw(NXYZ,RHO2,plancfp,plancbp)
  1531:           c *** for Kokubo fftw ASL compatible
  1532:                 CALL FFT3FX_fftwASL(NRX,NRY,NRZ,NXYZ,RHO2,RHO1
  1533:                &  ,plancfp,plancbp)
  1534:           C
  1535:           c         DO 110 IG=1,NG2
  1536:           *VDIR NODEP(RHO2)
  1537:           !ocl norecurrence(RHO2)
  1538: V------>           DO 110 IG=1,NXYZ
  1539: |                  JG=J2G(IG)
  1540: V------ G   110    P(IG)=RHO2(JG)
  1541:           c ****
  1542:           c *****  temp check : orthonormality
  1543:           c        temp=0
  1544:           c        do ig=1,nxyz
  1545:           c        temp=temp+dble( dconjg(P(IG))*P(IG) )
  1546:           c        enddo
  1547:           c        write(6,*)' in sub S2 after local pot:  norm = ',temp
  1548:           c *** temp check:end
  1549:           C
  1550:           c ** fourth: operate nonlocal potential terms
  1551: +------>        do 4 ity=1,ntype
  1552: |                if ( numty(ity).lt.0 ) goto 4 ! skip Hydrogen
  1553: |+----->         do 5 it=1,numty(ity)
  1554: ||               itseq=nidn(it,ity)  ! seq # of atomic site
  1555: ||+---->          do 6 il=1,mxofl(ity)
  1556: |||       cc        call zero(hp,ng2q)
  1557: |||               if ( IBUN(il,ity).ne.1 ) then
  1558: |||       c NON PARTITIONING !
  1559: |||       c         call exnlp( dthalf,NG2Q, NG2, G2,
  1560: |||                if ( il.eq.1 ) then
  1561: |||                l=il
  1562: |||                call exnlp( dthalf,NG2Q, NXYZ, G2,
  1563: |||            &   VPJ(1,1,il,ity), VPP(1,il,ity), VPP2(l,1,ity),
  1564: |||       c     &   l,YLM, EXTAU(1,itseq), WORK2(1,1), WORK2(1,2),WORK2(1,3),
  1565: |||       ccc     &   l,YLM, EXTAU(1,NP,itseq), WORK2(1,1), WORK2(1,2),WORK2(1,3),
  1566: |||            &   l,YLM, EXTAU(1,NP,itseq), WORK2,
  1567: |||       ccc     &   WORK2(1,4),WORK2(1,5),
  1568: |||            &   P, HP, TPIBA,  OMEGA, TAU(1,itseq) ,NGNL(ity),NGcont )
  1569: |||                elseif ( il.eq.2 ) then
  1570: |||+--->           do l=2,4
  1571: ||||               call exnlp( dthalf,NG2Q, NXYZ, G2,
  1572: ||||           &   VPJ(1,1,il,ity), VPP(1,il,ity), VPP2(l,1,ity),
  1573: ||||      c     &   l,YLM, EXTAU(1,itseq), WORK2(1,1), WORK2(1,2),WORK2(1,3),
  1574: ||||      ccc     &   l,YLM, EXTAU(1,NP,itseq), WORK2(1,1), WORK2(1,2),WORK2(1,3),
  1575: ||||           &   l,YLM, EXTAU(1,NP,itseq), WORK2,
  1576: ||||      ccc     &   WORK2(1,4),WORK2(1,5),
  1577: ||||           &   P, HP, TPIBA,  OMEGA, TAU(1,itseq) ,NGNL(ity),NGcont )
  1578: |||+---            enddo
  1579: |||                elseif ( il.eq.3 ) then
  1580: |||+--->           do l=5,9
  1581: ||||               call exnlp( dthalf,NG2Q, NXYZ, G2,
  1582: ||||           &   VPJ(1,1,il,ity), VPP(1,il,ity), VPP2(l,1,ity),
  1583: ||||      c     &   l,YLM, EXTAU(1,itseq), WORK2(1,1), WORK2(1,2),WORK2(1,3),
  1584: ||||      ccc     &   l,YLM, EXTAU(1,NP,itseq), WORK2(1,1), WORK2(1,2),WORK2(1,3),
  1585: ||||           &   l,YLM, EXTAU(1,NP,itseq), WORK2,
  1586: ||||      cccc     &   WORK2(1,4),WORK2(1,5),
  1587: ||||           &   P, HP, TPIBA,  OMEGA, TAU(1,itseq) ,NGNL(ity),NGcont )
  1588: |||+---            enddo
  1589: |||                elseif ( il.eq.4 ) then
  1590: |||+--->           do l=10,16
  1591: ||||               call exnlp( dthalf,NG2Q, NXYZ, G2,
  1592: ||||           &   VPJ(1,1,il,ity), VPP(1,il,ity), VPP2(l,1,ity),
  1593: ||||      c     &   l,YLM, EXTAU(1,itseq), WORK2(1,1), WORK2(1,2),WORK2(1,3),
  1594: ||||      ccc     &   l,YLM, EXTAU(1,NP,itseq), WORK2(1,1), WORK2(1,2),WORK2(1,3),
  1595: ||||           &   l,YLM, EXTAU(1,NP,itseq), WORK2,
  1596: ||||      cccc     &   WORK2(1,4),WORK2(1,5),
  1597: ||||           &   P, HP, TPIBA,  OMEGA, TAU(1,itseq) ,NGNL(ity),NGcont )
  1598: |||+---            enddo
  1599: |||                endif
  1600: |||               else
  1601: |||       c PARTITIONING !
  1602: |||*--->           do ip=2,3
  1603: ||||      c         call exnlp( dthalf,NG2Q, NG2, G2,
  1604: ||||               if ( il.eq.1 ) then
  1605: ||||               l=il
  1606: ||||               call exnlp( dthalf,NG2Q, NXYZ, G2,
  1607: ||||           &   VPJ(1,ip,il,ity), VPP(ip,il,ity), VPP2(l,ip,ity),
  1608: ||||      c     &   l,YLM, EXTAU(1,itseq), WORK2(1,1), WORK2(1,2),WORK2(1,3),
  1609: ||||      ccc     &   l,YLM, EXTAU(1,NP,itseq), WORK2(1,1), WORK2(1,2),WORK2(1,3),
  1610: ||||           &   l,YLM, EXTAU(1,NP,itseq), WORK2,
  1611: ||||      cccc     &   WORK2(1,4),WORK2(1,5),
  1612: ||||           &   P, HP, TPIBA,  OMEGA, TAU(1,itseq) ,NGNL(ity),NGcont )
  1613: ||||               elseif ( il.eq.2 ) then
  1614: ||||+-->           do l=2,4
  1615: |||||              call exnlp( dthalf,NG2Q, NXYZ, G2,
  1616: |||||          &   VPJ(1,ip,il,ity), VPP(ip,il,ity), VPP2(l,ip,ity),
  1617: |||||     c     &   l,YLM, EXTAU(1,itseq), WORK2(1,1), WORK2(1,2),WORK2(1,3),
  1618: |||||     ccc     &   l,YLM, EXTAU(1,NP,itseq), WORK2(1,1), WORK2(1,2),WORK2(1,3),
  1619: |||||          &   l,YLM, EXTAU(1,NP,itseq), WORK2,
  1620: |||||     ccc     &   WORK2(1,4),WORK2(1,5),
  1621: |||||          &   P, HP, TPIBA,  OMEGA, TAU(1,itseq) ,NGNL(ity),NGcont )
  1622: ||||+--            enddo
  1623: ||||               elseif ( il.eq.3 ) then
  1624: ||||+-->           do l=5,9
  1625: |||||              call exnlp( dthalf,NG2Q, NXYZ, G2,
  1626: |||||          &   VPJ(1,ip,il,ity), VPP(ip,il,ity), VPP2(l,ip,ity),
  1627: |||||     c     &   l,YLM, EXTAU(1,itseq), WORK2(1,1), WORK2(1,2),WORK2(1,3),
  1628: |||||     ccc     &   l,YLM, EXTAU(1,NP,itseq), WORK2(1,1), WORK2(1,2),WORK2(1,3),
  1629: |||||          &   l,YLM, EXTAU(1,NP,itseq), WORK2,
  1630: |||||     ccc     &   WORK2(1,4),WORK2(1,5),
  1631: |||||          &   P, HP, TPIBA,  OMEGA, TAU(1,itseq) ,NGNL(ity),NGcont )
  1632: ||||+--            enddo
  1633: ||||               elseif ( il.eq.4 ) then
  1634: ||||+-->           do l=10,16
  1635: |||||              call exnlp( dthalf,NG2Q, NXYZ, G2,
  1636: |||||          &   VPJ(1,ip,il,ity), VPP(ip,il,ity), VPP2(l,ip,ity),
  1637: |||||     c     &   l,YLM, EXTAU(1,itseq), WORK2(1,1), WORK2(1,2),WORK2(1,3),
  1638: |||||     ccc     &   l,YLM, EXTAU(1,NP,itseq), WORK2(1,1), WORK2(1,2),WORK2(1,3),
  1639: |||||          &   l,YLM, EXTAU(1,NP,itseq), WORK2,
  1640: |||||     ccc     &   WORK2(1,4),WORK2(1,5),
  1641: |||||          &   P, HP, TPIBA,  OMEGA, TAU(1,itseq) ,NGNL(ity),NGcont )
  1642: ||||+--            enddo
  1643: ||||               endif
  1644: |||*---            enddo
  1645: |||               endif
  1646: ||+----       6   continue
  1647: |+-----       5  continue
  1648: +------       4 continue
  1649:           c ****
  1650:           c *****  temp check : orthonormality
  1651:           c        temp=0
  1652:           c        do ig=1,nxyz
  1653:           c        temp=temp+dble( dconjg(P(IG))*P(IG) )
  1654:           c        enddo
  1655:           c        write(6,*)' in sub S2 after non-local again:  norm = ',temp
  1656:           c *** temp check:end
  1657:           c ** last: operate kinetic energy term
  1658:           c      do ig=1,ng2
  1659:           c       fac=dt*0.25d0*g2(4,ig)  ! 0.5d0*g2(4,ig) = Ekin (Hr)
  1660:           c       P(ig)=dcmplx( dcos(fac),-dsin(fac) )*P(ig)
  1661:           c      enddo
  1662:           c *******
  1663:           c ***  check norm
  1664:           c      write(6,*)' in sub. S2 : check norm of WF '
  1665:           c      snorm=0
  1666:           c      do ig=1,ng2
  1667:           c      snorm=snorm+dble( dconjg( p(ig) )*p(ig)  )
  1668:           c      enddo
  1669:           c      write(6,*)' norm = ',snorm
  1670:           c ***  check norm :end
  1671:                 return
  1672:                 end


NEC Fortran Compiler (3.4.2) for Vector Engine   Thu Jul 28 08:27:42 2022
FILE NAME: tmevl10_Avec_v4.f

PROCEDURE NAME: S2_
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

  1673:                 subroutine S2_(dt, NXYZ,NRX,NRY,NRZ, NG2, NG2Q, NJ,
  1674:                &     P, HP, YLM, G2,J2G,RHO1, RHO2, TPIBA, WORK2, VPJ,
  1675:                &     VPP,VPP2,OMEGA, NTAUQ, NTYQ, NTYPE, LREQ, TAU, NUMTY,
  1676:           c *** for Sugino FFT
  1677:           c     &     NIDN, IOVP, MXOFL, WSAVEX, WSAVEY, WSAVEZ,
  1678:           c     &     IFACX, IFACY, IFACZ, LX1, LX2, LY1, LY2, LZ1, LZ2,
  1679:           c *** for Kokubo ASL FFT
  1680:           c     &     NIDN, IOVP, MXOFL, WSAVE_XYZ, IFAC_XYZ,
  1681:           c *** for Kokubo FFTW
  1682:                &     NIDN, IOVP, MXOFL, plancfp,plancbp,
  1683:                &     VG,VGG,fdump,Vloc,EXTAU,NP,NGNL,
  1684:                &     mxbnd,nbegin,nend,NGcont)
  1685:                 implicit double precision(a-h,o-z)
  1686:           c      COMPLEX*16  P(NG2Q), HP(NG2Q,3)
  1687:                 COMPLEX*16  P(NG2Q,mxbnd), HP(NG2Q)
  1688:           cc      DIMENSION IOWF(MBLK),IOVP(2,NTYQ)
  1689:           C
  1690:           c      REAL*8 YLM(NG2Q,4),OUT(NBNDQ,3),EE(NBNDQ)
  1691:           c      REAL*8 YLM(NG2Q,4)
  1692:           c      REAL*8 YLM(NG2Q,9)
  1693:                 REAL*8 YLM(NGcont,16)
  1694:                 COMPLEX*16 RHO1(NXYZ),RHO2(NXYZ),
  1695:           c     &    VG(NXYZ),VGG(NXYZ),WORK2(NG2Q,3),EXTAU(NXYZ,NTAUQ)
  1696:           c     &    VG(NXYZ),WORK2(NG2Q,3),EXTAU(NXYZ,NTAUQ)
  1697:           c     &    VG(NXYZ),WORK2(NG2Q,3),EXTAU(NXYZ/6,NTAUQ)
  1698:           c     &    VG(NXYZ),WORK2(NG2Q,5),EXTAU(NXYZ/6,5,NTAUQ)
  1699:                &    VG(NXYZ),WORK2(NG2Q),EXTAU(NGcont,5,NTAUQ)
  1700:                 dimension VGG(NXYZ)
  1701:           c *** for Sugino FFT
  1702:           c      COMPLEX*16 WSAVEX(NRX),WSAVEY(NRY),WSAVEZ(NRZ)
  1703:           c      DIMENSION IFACX(30),IFACY(30),IFACZ(30)
  1704:           c      DIMENSION LX1(NXYZ),LX2(NXYZ),LY1(NXYZ),
  1705:           c     &          LY2(NXYZ),LZ1(NXYZ),LZ2(NXYZ)
  1706:           c *** for Kokubo ASL FFT
  1707:           c      COMPLEX*16 WSAVE_XYZ(NRX+NRY+NRZ)
  1708:           c      DIMENSION IFAC_XYZ(60)
  1709:           c *** for Kokubo FFTW
  1710:                 integer*8 plancfp,plancbp
  1711:                 DIMENSION J2G(NG2Q),G2(4,NG2Q)
  1712:                 DIMENSION TAU(3,NTAUQ),NUMTY(NTYQ),NIDN(NTAUQ,NTYQ), MXOFL(NTYQ)
  1713:           c      DIMENSION VPJ(NG2Q,3,2,NTYQ),VPP(3,2,NTYQ),VPP2(4,3,NTYQ)
  1714:           c      DIMENSION VPJ(NG2Q/3,3,2,NTYQ),VPP(3,3,NTYQ),VPP2(4,3,NTYQ)
  1715:           c      DIMENSION VPJ(NG2Q/3,3,3,NTYQ),VPP(3,3,NTYQ),VPP2(9,3,NTYQ)
  1716:                 DIMENSION VPJ(NGcont,3,4,NTYQ),VPP(3,4,NTYQ),VPP2(16,3,NTYQ)
  1717:                 dimension fdump(NXYZ)
  1718:           c      complex*16 rho4(NXYZ)  ! but used as real
  1719:                 dimension Vloc(NXYZ)
  1720:                 dimension NGNL(NTYQ)
  1721:                 parameter ( ntyq2=4 )
  1722:           c      COMMON/SAITO2/IBUN(3,NTYQ2)
  1723:                 COMMON/SAITO2/IBUN(4,NTYQ2)
  1724:                 COMPLEX*16 RHO1_(NXYZ,mxbnd),RHO2_(NXYZ,mxbnd)
  1725:                 complex*16, allocatable, save, dimension(:,:) :: work2_
  1726:                 complex*16, allocatable, save, dimension(:) :: cfac_
  1727:                 integer, allocatable, save, dimension(:) :: ngnl_
  1728:                 logical, save :: first = .true.
  1729:           c *** first: operate kinetic energy term
  1730:           c      do ig=1,ng2
  1731:           c       fac=dt*0.25d0*g2(4,ig)  ! 0.5d0*g2(4,ig) = Ekin (Hr)
  1732:           c       P(ig)=dcmplx( dcos(fac),-dsin(fac) )*P(ig)
  1733:           c      enddo
  1734:           c *** second: operate  nonlocal pseudopotential terms
  1735:           c ***  temp check for G2 & YLM
  1736:           c         write(6,*)' in sub. S2 G2 beyond NG2! '
  1737:           c         write(6,*)( G2(4,ig),ig=ng2+1,nxyz,500 )
  1738:           c         write(6,*)' in sub. S2 YLM beyond NG2! '
  1739:           c         write(6,*)( YLM(ig,4),ig=ng2+1,nxyz,500 )
  1740:           c         write(6,*)' in sub. S2 VPJ beyond NG2! '
  1741:           c         write(6,*)( VPJ(ig,3,2,1),ig=ng2+1,nxyz,500 )
  1742:           c ***  temp check for YLM : end
  1743:           ! ==============================================================================
  1744:                 if(first) then
  1745:                    loopcnt = 0
  1746: +------>           do ity = ntype, 1, -1
  1747: |                     if(numty(ity) .lt. 0) cycle
  1748: |+----->              do it = numty(ity), 1, -1
  1749: ||+---->                 do il = mxofl(ity), 1, -1
  1750: |||                         if(ibun(il,ity) .ne. 1) then
  1751: |||                            if(il .eq. 1) then
  1752: |||                               loopcnt = loopcnt + 1
  1753: |||                            else if(il .eq. 2) then
  1754: |||*--->                          do l = 4, 2, -1
  1755: ||||                                 loopcnt = loopcnt + 1
  1756: |||*---                           end do
  1757: |||                            else if(il .eq. 3) then
  1758: |||*--->                          do l = 9, 5, -1
  1759: ||||                                 loopcnt = loopcnt + 1
  1760: |||*---                           end do
  1761: |||                            else if(il .eq. 4) then
  1762: |||+--->                          do l =16,10, -1
  1763: ||||                                 loopcnt = loopcnt + 1
  1764: |||+---                           end do
  1765: |||                            end if
  1766: |||                         else
  1767: |||*--->                       do ip = 3, 2, -1
  1768: ||||                              if(il .eq. 1) then
  1769: ||||                                loopcnt = loopcnt + 1
  1770: ||||                              else if(il .eq. 2) then
  1771: ||||*-->                             do l = 4, 2, -1
  1772: |||||                                   loopcnt = loopcnt + 1
  1773: ||||*--                              end do
  1774: ||||                              else if(il .eq. 3) then
  1775: ||||*-->                             do l = 9, 5, -1
  1776: |||||                                   loopcnt = loopcnt + 1
  1777: ||||*--                              end do
  1778: ||||                              else if(il .eq. 4) then
  1779: ||||+-->                             do l =16,10, -1
  1780: |||||                                   loopcnt = loopcnt + 1
  1781: ||||+--                              end do
  1782: ||||                              end if
  1783: |||*---                        end do
  1784: |||                         end if
  1785: ||+----                  end do
  1786: |+-----               end do
  1787: +------            end do
  1788:                    allocate(work2_(NGcont,loopcnt))
  1789:                    allocate(cfac_(loopcnt))
  1790:                    allocate(ngnl_(loopcnt))
  1791:                    first = .false.
  1792:                 endif
  1793:           ! ==============================================================================
  1794:                 loopcnt = 0
  1795:                 dthalf=0.5d0*dt
  1796: +------>        do 1 ity=ntype,1,-1
  1797: |                if ( numty(ity).lt.0 ) goto 1 ! skip Hydrogen
  1798: |+----->         do 2 it=numty(ity),1,-1
  1799: ||               itseq=nidn(it,ity)  ! seq # of atomic site
  1800: ||+---->          do 3 il=mxofl(ity),1,-1
  1801: |||               if ( IBUN(il,ity).ne.1 ) then
  1802: |||                if ( il.eq.1 ) then
  1803: |||                l=il
  1804: |||                loopcnt = loopcnt + 1
  1805: |||                call exnlp_only_make(dthalf,ng2q,nxyz,g2,
  1806: |||            &   vpj(1,1,il,ity),vpp(1,il,ity),vpp2(l,1,ity),
  1807: |||            &   l,ylm,extau(1,np,itseq),work2_(1,loopcnt),
  1808: |||            &   tpiba,omega,tau(1,itseq),ngnl(ity),cfac_(loopcnt),NGcont)
  1809: |||                ngnl_(loopcnt) = ngnl(ity)
  1810: |||                elseif ( il.eq.2 ) then
  1811: |||+--->           do l=4,2,-1
  1812: ||||               loopcnt = loopcnt + 1
  1813: ||||               call exnlp_only_make(dthalf,ng2q,nxyz,g2,
  1814: ||||           &   vpj(1,1,il,ity),vpp(1,il,ity),vpp2(l,1,ity),
  1815: ||||           &   l,ylm,extau(1,np,itseq),work2_(1,loopcnt),
  1816: ||||           &   tpiba,omega,tau(1,itseq),ngnl(ity),cfac_(loopcnt),NGcont)
  1817: ||||               ngnl_(loopcnt) = ngnl(ity)
  1818: |||+---            enddo
  1819: |||                elseif ( il.eq.3 ) then
  1820: |||+--->           do l=9,5,-1
  1821: ||||               loopcnt = loopcnt + 1
  1822: ||||               call exnlp_only_make(dthalf,ng2q,nxyz,g2,
  1823: ||||           &   vpj(1,1,il,ity),vpp(1,il,ity),vpp2(l,1,ity),
  1824: ||||           &   l,ylm,extau(1,np,itseq),work2_(1,loopcnt),
  1825: ||||           &   tpiba,omega,tau(1,itseq),ngnl(ity),cfac_(loopcnt),NGcont)
  1826: ||||               ngnl_(loopcnt) = ngnl(ity)
  1827: |||+---            enddo
  1828: |||                elseif ( il.eq.4 ) then
  1829: |||+--->           do l=16,10,-1
  1830: ||||               loopcnt = loopcnt + 1
  1831: ||||               call exnlp_only_make(dthalf,ng2q,nxyz,g2,
  1832: ||||           &   vpj(1,1,il,ity),vpp(1,il,ity),vpp2(l,1,ity),
  1833: ||||           &   l,ylm,extau(1,np,itseq),work2_(1,loopcnt),
  1834: ||||           &   tpiba,omega,tau(1,itseq),ngnl(ity),cfac_(loopcnt),NGcont)
  1835: ||||               ngnl_(loopcnt) = ngnl(ity)
  1836: |||+---            enddo
  1837: |||                endif
  1838: |||               else
  1839: |||*--->           do ip=3,2,-1
  1840: ||||               if ( il.eq.1 ) then
  1841: ||||               l=il
  1842: ||||               loopcnt = loopcnt + 1
  1843: ||||               call exnlp_only_make(dthalf,ng2q,nxyz,g2,
  1844: ||||           &   vpj(1,ip,il,ity),vpp(ip,il,ity),vpp2(l,ip,ity),
  1845: ||||           &   l,ylm,extau(1,np,itseq),work2_(1,loopcnt),
  1846: ||||           &   tpiba,omega,tau(1,itseq),ngnl(ity),cfac_(loopcnt),NGcont)
  1847: ||||               ngnl_(loopcnt) = ngnl(ity)
  1848: ||||               elseif ( il.eq.2 ) then
  1849: ||||+-->           do l=4,2,-1
  1850: |||||              loopcnt = loopcnt + 1
  1851: |||||              call exnlp_only_make(dthalf,ng2q,nxyz,g2,
  1852: |||||          &   vpj(1,ip,il,ity),vpp(ip,il,ity),vpp2(l,ip,ity),
  1853: |||||          &   l,ylm,extau(1,np,itseq),work2_(1,loopcnt),
  1854: |||||          &   tpiba,omega,tau(1,itseq),ngnl(ity),cfac_(loopcnt),NGcont)
  1855: |||||              ngnl_(loopcnt) = ngnl(ity)
  1856: ||||+--            enddo
  1857: ||||               elseif ( il.eq.3 ) then
  1858: ||||+-->           do l=9,5,-1
  1859: |||||              loopcnt = loopcnt + 1
  1860: |||||              call exnlp_only_make(dthalf,ng2q,nxyz,g2,
  1861: |||||          &   vpj(1,ip,il,ity),vpp(ip,il,ity),vpp2(l,ip,ity),
  1862: |||||          &   l,ylm,extau(1,np,itseq),work2_(1,loopcnt),
  1863: |||||          &   tpiba,omega,tau(1,itseq),ngnl(ity),cfac_(loopcnt),NGcont)
  1864: |||||              ngnl_(loopcnt) = ngnl(ity)
  1865: ||||+--            enddo
  1866: ||||               elseif ( il.eq.4 ) then
  1867: ||||+-->           do l=16,10,-1
  1868: |||||              loopcnt = loopcnt + 1
  1869: |||||              call exnlp_only_make(dthalf,ng2q,nxyz,g2,
  1870: |||||          &   vpj(1,ip,il,ity),vpp(ip,il,ity),vpp2(l,ip,ity),
  1871: |||||          &   l,ylm,extau(1,np,itseq),work2_(1,loopcnt),
  1872: |||||          &   tpiba,omega,tau(1,itseq),ngnl(ity),cfac_(loopcnt),NGcont)
  1873: |||||              ngnl_(loopcnt) = ngnl(ity)
  1874: ||||+--            enddo
  1875: ||||               endif
  1876: |||*---            enddo
  1877: |||               endif
  1878: ||+----       3   continue
  1879: |+-----       2  continue
  1880: +------       1 continue
  1881:                 call exnlp_gemm(ng2q,work2_,p,omega,ngnl_,
  1882:                &     mxbnd,nbegin,nend,loopcnt,cfac_,NGcont)
  1883:           c ****
  1884:           c *****  temp check : orthonormality
  1885:           c        temp=0
  1886:           c        do ig=1,nxyz
  1887:           c        temp=temp+dble( dconjg(P(IG))*P(IG) )
  1888:           c        enddo
  1889:           c        write(6,*)' in sub S2 after non-local:  norm = ',temp
  1890:           c *** temp check:end
  1891:           c ** third: operate local potential term
  1892:           ! ==============================================================================
  1893: W------>        do ib=nbegin,nend
  1894: |                iib=ib-nbegin+1
  1895: |         ! ==============================================================================
  1896: |*----->           DO 101 JG=1,NXYZ
  1897: ||        c  101    RHO1(JG)=(0.D0,0.D0)
  1898: |*-----     101    RHO2_(JG,iib)=(0.D0,0.D0)
  1899: |         ! ==============================================================================
  1900: W------         enddo
  1901:           ! ==============================================================================
  1902:           ! ==============================================================================
  1903: +------>        do ib=nbegin,nend
  1904: |                iib=ib-nbegin+1
  1905: |         ! ==============================================================================
  1906: |         *VDIR NODEP(RHO1)
  1907: |         !ocl norecurrence(RHO1)
  1908: |         c         DO 100 IG=1,NG2
  1909: |V----->           DO 100 IG=1,NXYZ
  1910: ||                 JG=J2G(IG)
  1911: |V----- C   100    RHO1_(JG,iib)=P(IG,iib)
  1912: |         ! ==============================================================================
  1913: +------         enddo
  1914:           ! ==============================================================================
  1915:           c **** temp check
  1916:           c       sum=0
  1917:           c       do ig=1,nxyz
  1918:           c       sum=sum+dreal( dconjg( RHO1(ig) )*RHO1(ig) )
  1919:           c       enddo
  1920:           c       write(6,*)' in sub. S2: before FFT : norm = ',sum
  1921:           c **** temp check : end
  1922:           c ****  temp check
  1923:           C
  1924:           C
  1925:           c ****  temp check : end
  1926:           C From G-space to R-space
  1927:           c *** for Sugino FFT
  1928:           c         CALL FFT3BX(NRX,NRY,NRZ,NXYZ,RHO1,RHO2,
  1929:           c     & WSAVEX,WSAVEY,WSAVEZ,IFACX,IFACY,IFACZ,LX1,LX2,LY1,LY2,LZ1,LZ2)
  1930:           c *** for Kokubo ASL FFT
  1931:           ! ==============================================================================
  1932: +------>        do ib=nbegin,nend
  1933: |                iib=ib-nbegin+1
  1934: |         ! ==============================================================================   for KOKUBO ASL
  1935: |         c      CALL FFT3BX_ASL(NRX,NRY,NRZ,NXYZ,RHO1_(1,iib),RHO2_(1,iib),
  1936: |         c     &                WSAVE_XYZ,IFAC_XYZ)
  1937: |         c    for KOKUBO fftw ASL compativle
  1938: |               CALL FFT3BX_fftwASL(NRX,NRY,NRZ,NXYZ,RHO1_(1,iib),RHO2_(1,iib),
  1939: |              &                plancfp,plancbp)
  1940: |         c
  1941: |         ! ==============================================================================
  1942: +------         enddo
  1943:           ! ==============================================================================
  1944:           c *** for Kokubo FFTW
  1945:           c      call FFT3BX_fftw(NXYZ,RHO1,plancfp,plancbp)
  1946:           c **** temp check
  1947:           c       sum=0
  1948:           c       do ig=1,nxyz
  1949:           c       sum=sum+dreal( dconjg( RHO1(ig) )*RHO1(ig) )
  1950:           c       enddo
  1951:           c       write(6,*)' in sub. S2: after FFT : norm = ',
  1952:           c     & sum/dfloat(NXYZ)
  1953:           c **** temp check : end
  1954:           C
  1955:           C        RHO1:WAVEFN IN REAL SPACE
  1956:           C        VG:POTENTIAL IN REAL SPACE
  1957:           C       VGG: HXC POTENTIAL IN R-  SPACE
  1958:           C       RHO4:LOCAL PSEUDOPOTENTIAL in R- SPACE
  1959: V------>        do ig=1,nxyz
  1960: |         c      jg=i2g(ig)
  1961: |         c      VG(jg)=VGG(jg)+rho4(jg)*fdump(ig)
  1962: |         c      VG(ig)=VGG(ig)+rho4(ig)
  1963: |               VG(ig)=VGG(ig)+Vloc(ig)
  1964: V------         enddo
  1965:           C
  1966:           C
  1967:           c *** temp check
  1968:           c       write(6,*)' VG in sub. S2 '
  1969:           c       write(6,*)( VG(ig),ig=1,1500,100 )
  1970:           c *** temp check ; end
  1971:           C
  1972:           c **** temp check
  1973:           c       sum=0
  1974:           c       do ig=1,nxyz
  1975:           c       sum=sum+dreal( dconjg( RHO1(ig) )*RHO1(ig) )
  1976:           c       enddo
  1977:           c       write(6,*)' in sub. S2: before exp(Vlocal) : norm = ',
  1978:           c     & sum/dfloat(NXYZ)
  1979:           c **** temp check : end
  1980:           ! ==============================================================================
  1981: +------>        do ib=nbegin,nend
  1982: |                iib=ib-nbegin+1
  1983: |         ! ==============================================================================
  1984: |V----->           DO 300 I=1,NXYZ
  1985: ||                 fac=dt*dreal( vg(i) )
  1986: |V-----     300    RHO2_(I,iib)=dcmplx( dcos(fac),-dsin(fac) )*RHO1_(I,iib)
  1987: |         ! ==============================================================================
  1988: +------         enddo
  1989:           ! ==============================================================================
  1990:           c **** temp check
  1991:           c       sum=0
  1992:           c       do ig=1,nxyz
  1993:           c       sum=sum+dreal( dconjg( RHO2(ig) )*RHO2(ig) )
  1994:           c       enddo
  1995:           c       write(6,*)' in sub. S2: after exp(Vlocal) : norm = ',
  1996:           c     & sum/dfloat(NXYZ)
  1997:           c **** temp check : end
  1998:           C From R-space to G-space
  1999:           c *** for Sugino FFT
  2000:           c         CALL FFT3FX(NRX,NRY,NRZ,NXYZ,RHO2,RHO1,
  2001:           c     & WSAVEX,WSAVEY,WSAVEZ,IFACX,IFACY,IFACZ,LX1,LX2,LY1,LY2,LZ1,LZ2)
  2002:           c *** for Kokubo ASL FFT
  2003:           ! ==============================================================================
  2004: +------>        do ib=nbegin,nend
  2005: |                iib=ib-nbegin+1
  2006: |         ! ==============================================================================  for KOKUBO ASL
  2007: |         c      CALL FFT3FX_ASL(NRX,NRY,NRZ,NXYZ,RHO2_(1,iib),RHO1_(1,iib),
  2008: |         c     &                WSAVE_XYZ,IFAC_XYZ)
  2009: |         !==  for KOKUBO fftw ASL compativle
  2010: |               CALL FFT3FX_fftwASL(NRX,NRY,NRZ,NXYZ,RHO2_(1,iib),RHO1_(1,iib),
  2011: |              &                plancfp,plancbp)
  2012: |         ! ==============================================================================
  2013: +------         enddo
  2014:           ! ==============================================================================
  2015:           c *** for Kokubo FFTW
  2016:           c      call FFT3FX_fftw(NXYZ,RHO2,plancfp,plancbp)
  2017:           C
  2018:           c         DO 110 IG=1,NG2
  2019:           ! ==============================================================================
  2020: +------>        do ib=nbegin,nend
  2021: |                iib=ib-nbegin+1
  2022: |         ! ==============================================================================
  2023: |         *VDIR NODEP(RHO2)
  2024: |         !ocl norecurrence(RHO2)
  2025: |V----->           DO 110 IG=1,NXYZ
  2026: ||                 JG=J2G(IG)
  2027: |V----- G   110    P(IG,iib)=RHO2_(JG,iib)
  2028: |         ! ==============================================================================
  2029: +------         enddo
  2030:           ! ==============================================================================
  2031:           c ****
  2032:           c *****  temp check : orthonormality
  2033:           c        temp=0
  2034:           c        do ig=1,nxyz
  2035:           c        temp=temp+dble( dconjg(P(IG))*P(IG) )
  2036:           c        enddo
  2037:           c        write(6,*)' in sub S2 after local pot:  norm = ',temp
  2038:           c *** temp check:end
  2039:           C
  2040:           c ** fourth: operate nonlocal potential terms
  2041:                 loopcnt = 0
  2042: +------>        do 4 ity=1,ntype
  2043: |                if ( numty(ity).lt.0 ) goto 4 ! skip Hydrogen
  2044: |+----->         do 5 it=1,numty(ity)
  2045: ||               itseq=nidn(it,ity)  ! seq # of atomic site
  2046: ||+---->          do 6 il=1,mxofl(ity)
  2047: |||               if ( IBUN(il,ity).ne.1 ) then
  2048: |||                if ( il.eq.1 ) then
  2049: |||                l=il
  2050: |||                loopcnt = loopcnt + 1
  2051: |||                call exnlp_only_make(dthalf,ng2q,nxyz,g2,
  2052: |||            &   vpj(1,1,il,ity),vpp(1,il,ity),vpp2(l,1,ity),
  2053: |||            &   l,ylm,extau(1,np,itseq),work2_(1,loopcnt),
  2054: |||            &   tpiba,omega,tau(1,itseq),ngnl(ity),cfac_(loopcnt),NGcont)
  2055: |||                ngnl_(loopcnt) = ngnl(ity)
  2056: |||                elseif ( il.eq.2 ) then
  2057: |||+--->           do l=2,4
  2058: ||||               loopcnt = loopcnt + 1
  2059: ||||               call exnlp_only_make(dthalf,ng2q,nxyz,g2,
  2060: ||||           &   vpj(1,1,il,ity),vpp(1,il,ity),vpp2(l,1,ity),
  2061: ||||           &   l,ylm,extau(1,np,itseq),work2_(1,loopcnt),
  2062: ||||           &   tpiba,omega,tau(1,itseq),ngnl(ity),cfac_(loopcnt),NGcont)
  2063: ||||               ngnl_(loopcnt) = ngnl(ity)
  2064: |||+---            enddo
  2065: |||                elseif ( il.eq.3 ) then
  2066: |||+--->           do l=5,9
  2067: ||||               loopcnt = loopcnt + 1
  2068: ||||               call exnlp_only_make(dthalf,ng2q,nxyz,g2,
  2069: ||||           &   vpj(1,1,il,ity),vpp(1,il,ity),vpp2(l,1,ity),
  2070: ||||           &   l,ylm,extau(1,np,itseq),work2_(1,loopcnt),
  2071: ||||           &   tpiba,omega,tau(1,itseq),ngnl(ity),cfac_(loopcnt),NGcont)
  2072: ||||               ngnl_(loopcnt) = ngnl(ity)
  2073: |||+---            enddo
  2074: |||                elseif ( il.eq.4 ) then
  2075: |||+--->           do l=10,16
  2076: ||||               loopcnt = loopcnt + 1
  2077: ||||               call exnlp_only_make(dthalf,ng2q,nxyz,g2,
  2078: ||||           &   vpj(1,1,il,ity),vpp(1,il,ity),vpp2(l,1,ity),
  2079: ||||           &   l,ylm,extau(1,np,itseq),work2_(1,loopcnt),
  2080: ||||           &   tpiba,omega,tau(1,itseq),ngnl(ity),cfac_(loopcnt),NGcont)
  2081: ||||               ngnl_(loopcnt) = ngnl(ity)
  2082: |||+---            enddo
  2083: |||                endif
  2084: |||               else
  2085: |||*--->           do ip=2,3
  2086: ||||               if ( il.eq.1 ) then
  2087: ||||               l=il
  2088: ||||               loopcnt = loopcnt + 1
  2089: ||||               call exnlp_only_make(dthalf,ng2q,nxyz,g2,
  2090: ||||           &   vpj(1,ip,il,ity),vpp(ip,il,ity),vpp2(l,ip,ity),
  2091: ||||           &   l,ylm,extau(1,np,itseq),work2_(1,loopcnt),
  2092: ||||           &   tpiba,omega,tau(1,itseq),ngnl(ity),cfac_(loopcnt),NGcont)
  2093: ||||               ngnl_(loopcnt) = ngnl(ity)
  2094: ||||               elseif ( il.eq.2 ) then
  2095: ||||+-->           do l=2,4
  2096: |||||              loopcnt = loopcnt + 1
  2097: |||||              call exnlp_only_make(dthalf,ng2q,nxyz,g2,
  2098: |||||          &   vpj(1,ip,il,ity),vpp(ip,il,ity),vpp2(l,ip,ity),
  2099: |||||          &   l,ylm,extau(1,np,itseq),work2_(1,loopcnt),
  2100: |||||          &   tpiba,omega,tau(1,itseq),ngnl(ity),cfac_(loopcnt),NGcont)
  2101: |||||              ngnl_(loopcnt) = ngnl(ity)
  2102: ||||+--            enddo
  2103: ||||               elseif ( il.eq.3 ) then
  2104: ||||+-->           do l=5,9
  2105: |||||              loopcnt = loopcnt + 1
  2106: |||||              call exnlp_only_make(dthalf,ng2q,nxyz,g2,
  2107: |||||          &   vpj(1,ip,il,ity),vpp(ip,il,ity),vpp2(l,ip,ity),
  2108: |||||          &   l,ylm,extau(1,np,itseq),work2_(1,loopcnt),
  2109: |||||          &   tpiba,omega,tau(1,itseq),ngnl(ity),cfac_(loopcnt),NGcont)
  2110: |||||              ngnl_(loopcnt) = ngnl(ity)
  2111: ||||+--            enddo
  2112: ||||               elseif ( il.eq.4 ) then
  2113: ||||+-->           do l=10,16
  2114: |||||              loopcnt = loopcnt + 1
  2115: |||||              call exnlp_only_make(dthalf,ng2q,nxyz,g2,
  2116: |||||          &   vpj(1,ip,il,ity),vpp(ip,il,ity),vpp2(l,ip,ity),
  2117: |||||          &   l,ylm,extau(1,np,itseq),work2_(1,loopcnt),
  2118: |||||          &   tpiba,omega,tau(1,itseq),ngnl(ity),cfac_(loopcnt),NGcont)
  2119: |||||              ngnl_(loopcnt) = ngnl(ity)
  2120: ||||+--            enddo
  2121: ||||               endif
  2122: |||*---            enddo
  2123: |||               endif
  2124: ||+----       6   continue
  2125: |+-----       5  continue
  2126: +------       4 continue
  2127:                 call exnlp_gemm(ng2q,work2_,p,omega,ngnl_,
  2128:                &     mxbnd,nbegin,nend,loopcnt,cfac_,NGcont)
  2129:           c ****
  2130:           c *****  temp check : orthonormality
  2131:           c        temp=0
  2132:           c        do ig=1,nxyz
  2133:           c        temp=temp+dble( dconjg(P(IG))*P(IG) )
  2134:           c        enddo
  2135:           c        write(6,*)' in sub S2 after non-local again:  norm = ',temp
  2136:           c *** temp check:end
  2137:           c ** last: operate kinetic energy term
  2138:           c      do ig=1,ng2
  2139:           c       fac=dt*0.25d0*g2(4,ig)  ! 0.5d0*g2(4,ig) = Ekin (Hr)
  2140:           c       P(ig)=dcmplx( dcos(fac),-dsin(fac) )*P(ig)
  2141:           c      enddo
  2142:           c *******
  2143:           c ***  check norm
  2144:           c      write(6,*)' in sub. S2 : check norm of WF '
  2145:           c      snorm=0
  2146:           c      do ig=1,ng2
  2147:           c      snorm=snorm+dble( dconjg( p(ig) )*p(ig)  )
  2148:           c      enddo
  2149:           c      write(6,*)' norm = ',snorm
  2150:           c ***  check norm :end
  2151:                 return
  2152:                 end


NEC Fortran Compiler (3.4.2) for Vector Engine   Thu Jul 28 08:27:42 2022
FILE NAME: tmevl10_Avec_v4.f

PROCEDURE NAME: EXNLP
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

  2157:                 subroutine exnlp(dt, NG2Q, NG2, G2, VPJ, VPP, VPP2,
  2158:           c     &   l,YLM, EXTAU, WORK1,WORK2,WORK3,WORK4,WORK5,
  2159:                &   l,YLM, EXTAU, WORK1,
  2160:                &   COEF, DCOEF, TPIBA,  OMEGA, TAU ,NGNL,NGcont)
  2161:                 implicit double precision(a-h,o-z)
  2162:                 include 'mpif.h'
  2163:           c      dimension G2(4,ng2q),vpj(ng2q),ylm(ng2q,4),
  2164:           c      dimension G2(4,ng2q),vpj(ng2q),ylm(ng2q,9),
  2165:                 dimension G2(4,ng2q),vpj(NGcont),ylm(NGcont,16),
  2166:           c     &          tau(3),VPP2(4)
  2167:                &          tau(3)
  2168:           c      complex*16 coef(ng2q),dcoef(ng2q,3),EXTAU(ng2q)
  2169:           c      complex*16 coef(ng2q),dcoef(ng2q,3),EXTAU(ng2q/6)
  2170:                 complex*16 coef(ng2q),dcoef(ng2q),EXTAU(NGcont)
  2171:           c     & ,work1(ng2q),work2(ng2q),work3(ng2q),work4(ng2q),work5(ng2q)
  2172:                & ,work1(ng2q)
  2173:           c     &  ,cfac,cfac1,cfac2,cfac3,ct1,ct2,ct3,y00,y11,y12,y13
  2174:           c     &  ,cfac,cfac1,cfac2,cfac3,ct1,ct2,ct3
  2175:                &  ,cfac,ct1
  2176:                 call MPI_COMM_RANK(MPI_COMM_WORLD,my_rank,ierr)
  2177:                 IF ( L.gt.16 ) THEN
  2178:                  if ( my_rank.eq.0 ) then
  2179:                   write(6,*)' in sub. exnlp !!! '
  2180:                   write(6,*)'ILL-ORBITAL IS INDICATED OR MORE THAN TWO PARTIONING'
  2181:                   write(6,*)'   ------> STOPPING'
  2182:                  endif
  2183:                  STOP
  2184:                 ENDIF
  2185:           c
  2186:                 PI=4.D0*ATAN(1.D0)
  2187:                 FPI=4.D0*PI
  2188:                 FPISQ=FPI**2
  2189:           c  ***  lth - orbital **
  2190:                 fac=dt*vpp2/vpp
  2191:                 cfac=1.d0/vpp2*( dcmplx( dcos(fac),-dsin(fac) )
  2192:                &                -dcmplx(      1.d0, 0.d0     ) )
  2193:           C
  2194:                  fac=1.d0
  2195:                  if ( l.eq.2 .or. l.eq.3 ) fac=dsqrt(2.d0)
  2196:                  if ( l.eq.1 )  lylm=1
  2197:                  if ( l.eq.2 )  lylm=3
  2198:                  if ( l.eq.3 )  lylm=4
  2199:                  if ( l.eq.4 )  lylm=2
  2200:                  if ( l.ge.5 )  lylm=l  !  this is NOT 1 but l!!
  2201:           c *** temp check
  2202:           c       if (my_rank.eq.0 ) then
  2203:           c         write(6,*)' l = ',l
  2204:           c         if (l.ge.5 ) then
  2205:           c           write(6,*)' YLM '
  2206:           c           write(6,*)(YLM(ig,l),ig=1,100,10)
  2207:           c         endif
  2208:           c       endif
  2209:           c *** temp check : end
  2210:           c       if ( l.ge.6 .and. I.le.9) fac=dsqrt(2.d0)
  2211:           c ****************
  2212:                  CT1=(0.D0,0.D0)
  2213: V------>         DO IG=1,NGNL
  2214: |                 WORK1(IG)=fac*YLM(IG,lylm)*EXTAU(IG)*VPJ(IG)
  2215: |                 CT1=CT1+COEF(IG)*WORK1(IG)
  2216: V------          enddo
  2217:                  CT1=cfac*CT1/OMEGA
  2218:           c       DO IG=1,NGNL
  2219:           c        DCOEF(IG,1)=CT1*DCONJG(WORK1(IG))
  2220:           c        coef(ig)=coef(ig)+dcoef(ig)
  2221:           c       enddo
  2222: V------>         DO IG=1,NGNL
  2223: |                 coef(ig)=coef(ig)+CT1*DCONJG(WORK1(IG))
  2224: V------          enddo
  2225:           c *** temp check
  2226:           c       if (my_rank.eq.0 ) then
  2227:           c        if (l.ge.5 ) then
  2228:           c          sum=0
  2229:           c          do ig=1,NGNL
  2230:           c           sum=sum+ dreal( dconjg(coef(ig))*coef(ig) )
  2231:           c          enddo
  2232:           c         write(6,*)' l=',l,'norm=',sum
  2233:           c        endif
  2234:           c       endif
  2235:           c *** temp check : end
  2236:           c
  2237:                 return
  2238:                 end


NEC Fortran Compiler (3.4.2) for Vector Engine   Thu Jul 28 08:27:42 2022
FILE NAME: tmevl10_Avec_v4.f

PROCEDURE NAME: EXNLP_
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

  2239:                 subroutine exnlp_(dt, NG2Q, NG2, G2, VPJ, VPP, VPP2,
  2240:           c     &   l,YLM, EXTAU, WORK1,WORK2,WORK3,WORK4,WORK5,
  2241:                &   l,YLM, EXTAU, WORK1,
  2242:                &   COEF, DCOEF, TPIBA,  OMEGA, TAU ,NGNL,
  2243:                &   mxbnd,nbegin,nend,NGcont)
  2244:                 implicit double precision(a-h,o-z)
  2245:                 include 'mpif.h'
  2246:           c      dimension G2(4,ng2q),vpj(ng2q),ylm(ng2q,4),
  2247:           c      dimension G2(4,ng2q),vpj(ng2q),ylm(ng2q,9),
  2248:                 dimension G2(4,ng2q),vpj(NGcont),ylm(NGcont,16),
  2249:           c     &          tau(3),VPP2(4)
  2250:                &          tau(3)
  2251:           c      complex*16 coef(ng2q),dcoef(ng2q,3),EXTAU(ng2q)
  2252:           c      complex*16 coef(ng2q),dcoef(ng2q,3),EXTAU(ng2q/6)
  2253:                 complex*16 coef(ng2q,mxbnd),dcoef(ng2q),EXTAU(NGcont)
  2254:           c     & ,work1(ng2q),work2(ng2q),work3(ng2q),work4(ng2q),work5(ng2q)
  2255:                & ,work1(ng2q)
  2256:           c     &  ,cfac,cfac1,cfac2,cfac3,ct1,ct2,ct3,y00,y11,y12,y13
  2257:           c     &  ,cfac,cfac1,cfac2,cfac3,ct1,ct2,ct3
  2258:                &  ,cfac,ct1
  2259:                 call MPI_COMM_RANK(MPI_COMM_WORLD,my_rank,ierr)
  2260:                 IF ( L.gt.16 ) THEN
  2261:                  if ( my_rank.eq.0 ) then
  2262:                   write(6,*)' in sub. exnlp !!! '
  2263:                   write(6,*)'ILL-ORBITAL IS INDICATED OR MORE THAN TWO PARTIONING'
  2264:                   write(6,*)'   ------> STOPPING'
  2265:                  endif
  2266:                  STOP
  2267:                 ENDIF
  2268:           c
  2269:                 PI=4.D0*ATAN(1.D0)
  2270:                 FPI=4.D0*PI
  2271:                 FPISQ=FPI**2
  2272:           c  ***  lth - orbital **
  2273:                 fac=dt*vpp2/vpp
  2274:                 cfac=1.d0/vpp2*( dcmplx( dcos(fac),-dsin(fac) )
  2275:                &                -dcmplx(      1.d0, 0.d0     ) )
  2276:           C
  2277:                  fac=1.d0
  2278:                  if ( l.eq.2 .or. l.eq.3 ) fac=dsqrt(2.d0)
  2279:                  if ( l.eq.1 )  lylm=1
  2280:                  if ( l.eq.2 )  lylm=3
  2281:                  if ( l.eq.3 )  lylm=4
  2282:                  if ( l.eq.4 )  lylm=2
  2283:                  if ( l.ge.5 )  lylm=l  ! This is NOT 1 but l!!
  2284:           c *** temp check
  2285:           c       if (my_rank.eq.0 ) then
  2286:           c         write(6,*)' l = ',l
  2287:           c         if (l.ge.5 ) then
  2288:           c           write(6,*)' YLM '
  2289:           c           write(6,*)(YLM(ig,l),ig=1,100,10)
  2290:           c         endif
  2291:           c       endif
  2292:           c *** temp check : end
  2293:           c       if ( l.ge.6 .and. I.le.9) fac=dsqrt(2.d0)
  2294:           c ****************
  2295: V------>         DO IG=1,NGNL
  2296: |                 WORK1(IG)=fac*YLM(IG,lylm)*EXTAU(IG)*VPJ(IG)
  2297: V------          enddo
  2298:           ! ==============================================================================
  2299: +------>        do ib=nbegin,nend
  2300: |                iib=ib-nbegin+1
  2301: |         ! ==============================================================================
  2302: |                CT1=(0.D0,0.D0)
  2303: |V----->         DO IG=1,NGNL
  2304: ||                CT1=CT1+COEF(IG,iib)*WORK1(IG)
  2305: |V-----          enddo
  2306: |                CT1=cfac*CT1/OMEGA
  2307: |         c       DO IG=1,NGNL
  2308: |         c        DCOEF(IG,1)=CT1*DCONJG(WORK1(IG))
  2309: |         c        coef(ig)=coef(ig)+dcoef(ig)
  2310: |         c       enddo
  2311: |V----->         DO IG=1,NGNL
  2312: ||                coef(ig,iib)=coef(ig,iib)+CT1*DCONJG(WORK1(IG))
  2313: |V-----          enddo
  2314: |         ! ==============================================================================
  2315: +------         enddo
  2316:           ! ==============================================================================
  2317:           c *** temp check
  2318:           c       if (my_rank.eq.0 ) then
  2319:           c        if (l.ge.5 ) then
  2320:           c          sum=0
  2321:           c          do ig=1,NGNL
  2322:           c           sum=sum+ dreal( dconjg(coef(ig))*coef(ig) )
  2323:           c          enddo
  2324:           c         write(6,*)' l=',l,'norm=',sum
  2325:           c        endif
  2326:           c       endif
  2327:           c *** temp check : end
  2328:           c
  2329:                 return
  2330:                 end


NEC Fortran Compiler (3.4.2) for Vector Engine   Thu Jul 28 08:27:42 2022
FILE NAME: tmevl10_Avec_v4.f

PROCEDURE NAME: EXNLP_ONLY_MAKE
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

  2332:                 subroutine exnlp_only_make(dt, ng2q, ng2, g2, vpj, vpp, vpp2,
  2333:                &   l, ylm, extau, work1, tpiba, omega, tau, ngnl, cfac,NGcont)
  2334:                 implicit double precision(a-h,o-z)
  2335:           c      dimension g2(4,ng2q), vpj(ng2q), ylm(ng2q,9), tau(3)
  2336:                 dimension g2(4,ng2q), vpj(NGcont), ylm(NGcont,16), tau(3)
  2337:                 complex*16 extau(NGcont), work1(NGcont), cfac
  2338:                 pi = 4.d0*atan(1.d0)
  2339:                 fpi = 4.d0*pi
  2340:                 fpisq = fpi**2
  2341:                 fac = dt*vpp2/vpp
  2342:                 cfac = 1.d0/vpp2*(dcmplx(dcos(fac),-dsin(fac))
  2343:                &                 -dcmplx( 1.d0,    0.d0      ))
  2344:                 fac = 1.d0
  2345:                 if (l .eq. 2 .or. l .eq. 3) fac = dsqrt(2.d0)
  2346:                 if (l .eq. 1)  lylm =1
  2347:                 if (l .eq. 2)  lylm =3
  2348:                 if (l .eq. 3)  lylm =4
  2349:                 if (l .eq. 4)  lylm =2
  2350:                 if (l .ge. 5)  lylm = l  ! This is not 1 but l !!
  2351: V------>        do ig = 1, ngnl
  2352: |                  work1(ig) = fac*ylm(ig,lylm)*extau(ig)*vpj(ig)
  2353: V------         end do
  2354:                 return
  2355:                 end subroutine exnlp_only_make


NEC Fortran Compiler (3.4.2) for Vector Engine   Thu Jul 28 08:27:42 2022
FILE NAME: tmevl10_Avec_v4.f

PROCEDURE NAME: EXNLP_GEMM
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

  2357:                 subroutine exnlp_gemm(ng2q, work1, coef, omega, ngnl,
  2358:                &   mxbnd, nbegin, nend, loopcnt, cfac,NGcont)
  2359:                 implicit double precision(a-h,o-z)
  2360:                 complex*16 coef(ng2q,mxbnd), work1(NGcont,loopcnt),
  2361:                &           cfac(loopcnt), ct1(mxbnd)
  2362:                 integer ngnl(loopcnt)
  2363: +------>        do ia = 1, loopcnt
  2364: |V----->           do iib = 1, nend-nbegin+1
  2365: ||                    ct1(iib) = (0.d0,0.d0)
  2366: |V-----            end do
  2367: |+----->           do iib = 1, nend-nbegin+1
  2368: ||V---->              do ig = 1, ngnl(ia)
  2369: |||                      ct1(iib) = ct1(iib) + coef(ig,iib)*work1(ig,ia)
  2370: ||V----               end do
  2371: |+-----            end do
  2372: |V----->           do iib = 1, nend-nbegin+1
  2373: ||                    ct1(iib) = cfac(ia)*ct1(iib)/omega
  2374: |V-----            end do
  2375: |+----->           do iib = 1, nend-nbegin+1
  2376: ||V---->              do ig = 1, ngnl(ia)
  2377: |||                      coef(ig,iib) = coef(ig,iib)
  2378: |||            &         + ct1(iib)*dconjg(work1(ig,ia))
  2379: ||V----               end do
  2380: |+-----            end do
  2381: +------         end do
  2382:                 return
  2383:                 end


NEC Fortran Compiler (3.4.2) for Vector Engine   Thu Jul 28 08:27:42 2022
FILE NAME: tmevl10_Avec_v4.f

PROCEDURE NAME: HLOCAL
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

  2385:                 SUBROUTINE HLOCAL( NRX, NRY, NRZ, NXYZ, NG2, NG2Q, NBND,
  2386:                &                   COEF, DCOEF, RHO1, RHO2, VG, J2G,
  2387:           c *** for Sugino FFT
  2388:           c     &                   WSAVEX, WSAVEY, WSAVEZ, IFACX, IFACY, IFACZ,
  2389:           c     &                   LX1, LX2, LY1, LY2, LZ1, LZ2                )
  2390:           c *** for Kokubo ASL FFT
  2391:           c     &                   WSAVE_XYZ, IFAC_XYZ              )
  2392:           c *** for Kokubo FFTW
  2393:                &                   plancfp,plancbp              )
  2394:           C
  2395:                 IMPLICIT REAL*8 (A-H,O-Z)
  2396:                 COMPLEX*16 RHO1(NXYZ),RHO2(NXYZ),
  2397:           c     &           COEF(NG2Q,NBND),DCOEF(NG2Q,NBND),
  2398:                &           COEF(NG2Q),DCOEF(NG2Q),
  2399:                &           VG(NXYZ)
  2400:           c *** for Sugino FFT
  2401:           c      COMPLEX*16 WSAVEX(NRX),WSAVEY(NRY),WSAVEZ(NRZ)
  2402:           c      DIMENSION IFACX(30),IFACY(30),IFACZ(30)
  2403:           c      DIMENSION LX1(NXYZ),LX2(NXYZ),LY1(NXYZ),
  2404:           c     &          LY2(NXYZ),LZ1(NXYZ),LZ2(NXYZ)
  2405:           c *** for Kokubo FFT
  2406:           c      COMPLEX*16 WSAVE_XYZ(NRX+NRY+NRZ)
  2407:           c      DIMENSION IFAC_XYZ(60)
  2408:           c *** for Kokubo FFTW
  2409:                 integer*8 plancfp,plancbp
  2410:                 DIMENSION J2G(NG2Q)
  2411:           C
  2412:           C     MAIN LOOP
  2413:           C
  2414:           c      DO 1010 IB=1,NBND
  2415:           C
  2416: V------>           DO 101 JG=1,NXYZ
  2417: V------     101    RHO1(JG)=(0.D0,0.D0)
  2418:           *VDIR NODEP(RHO1)
  2419:           !ocl norecurrence(RHO1)
  2420: V------>           DO 100 IG=1,NG2
  2421: |                  JG=J2G(IG)
  2422: |         c  100    RHO1(JG)=COEF(IG,IB)
  2423: V------ C   100    RHO1(JG)=COEF(IG)
  2424:           C
  2425:           c *** for Sugino FFT
  2426:           c         CALL FFT3BX(NRX,NRY,NRZ,NXYZ,RHO1,RHO2,
  2427:           c     & WSAVEX,WSAVEY,WSAVEZ,IFACX,IFACY,IFACZ,LX1,LX2,LY1,LY2,LZ1,LZ2)
  2428:           c *** for Kokubo ASL FFT
  2429:           c      CALL FFT3BX_ASL(NRX,NRY,NRZ,NXYZ,RHO1,RHO2,WSAVE_XYZ,IFAC_XYZ)
  2430:           c *** for Kokubo FFTW
  2431:           c      call FFT3BX_fftw(NXYZ,RHO1,plancfp,plancbp)
  2432:           c *** for Kokubo fftw ASL compatible
  2433:                 CALL FFT3BX_fftwASL(NRX,NRY,NRZ,NXYZ,RHO1,RHO2,plancfp,plancbp)
  2434:           C
  2435:           C        RHO1:WAVEFN IN REAL SPACE
  2436:           C        VG:POTENTIAL IN REAL SPACE
  2437:           C
  2438: V------>           DO 300 I=1,NXYZ
  2439: V------     300    RHO2(I)=VG(I)*RHO1(I)
  2440:           c *** for Sugino FFT
  2441:           c         CALL FFT3FX(NRX,NRY,NRZ,NXYZ,RHO2,RHO1,
  2442:           c     & WSAVEX,WSAVEY,WSAVEZ,IFACX,IFACY,IFACZ,LX1,LX2,LY1,LY2,LZ1,LZ2)
  2443:           c *** for Kokubo ASL FFT
  2444:           c      CALL FFT3FX_ASL(NRX,NRY,NRZ,NXYZ,RHO2,RHO1,WSAVE_XYZ,IFAC_XYZ)
  2445:           c *** for Kokubo FFTW
  2446:           c      call FFT3FX_fftw(NXYZ,RHO2,plancfp,plancbp)
  2447:           c *** for Kokubo fftw ASL compatible
  2448:                 CALL FFT3FX_fftwASL(NRX,NRY,NRZ,NXYZ,RHO2,RHO1,plancfp,plancbp)
  2449:           C
  2450:           *VDIR NODEP(RHO2)
  2451:           !ocl norecurrence(RHO2)
  2452: V------>           DO 110 IG=1,NG2
  2453: |                  JG=J2G(IG)
  2454: |         c  110    DCOEF(IG,IB)=RHO2(JG)
  2455: V------ G   110    DCOEF(IG)=RHO2(JG)
  2456:           C
  2457:           c 1010 CONTINUE
  2458:           C
  2459:           C      CALL CLOCK(TIM1)
  2460:           C     WRITE(6,*) ' NBND = ',NBND
  2461:           C     WRITE(6,*) ' HLOCAL: CPTIME=',TIM1
  2462:           C     WRITE(6,*) ' REAL CPU_TIME : ',(TIM1-TIM0)/DBLE(NBND)
  2463:                 RETURN
  2464:                 END


NEC Fortran Compiler (3.4.2) for Vector Engine   Thu Jul 28 08:27:42 2022
FILE NAME: tmevl10_Avec_v4.f

PROCEDURE NAME: NONLOC
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

  2466:                 SUBROUTINE NONLOC( NXYZ, NG2, NG2Q, NBND,
  2467:                &                   COEF, DCOEF, YLM, G2, RHO2, RHOA, TPIBA,
  2468:                &                   WORK2, VPJ, VPP, OMEGA, NTAUQ, NTYQ,
  2469:                &     NTYPE, LREQ, TAU, NUMTY, NIDN, IOVP, MXOFL,GDUMP,NGNL,NGcont)
  2470:           C
  2471:           C                                   (1990-04-12) OSAMU SUGINO
  2472:           C        INPUT  COEF
  2473:           C
  2474:                 IMPLICIT REAL*8 (A-H,O-Z)
  2475:           c      REAL*8 RHOA(NXYZ),YLM(NG2Q,4)
  2476:           c      REAL*8 RHOA(NXYZ),YLM(NG2Q,9)
  2477:                 REAL*8 RHOA(NXYZ),YLM(NGcont,16)
  2478:                 COMPLEX*16 RHO2(NXYZ),
  2479:                &           COEF(NG2Q),DCOEF(NG2Q),
  2480:           c     &           WORK2(NG2Q,3)
  2481:           c     &           WORK2(NG2Q,5)
  2482:                &           WORK2(NG2Q,7)
  2483:                 DIMENSION G2(4,NG2Q),GDUMP(NG2Q)
  2484:                 DIMENSION TAU(3,NTAUQ),NUMTY(NTYQ),NIDN(NTAUQ,NTYQ), MXOFL(NTYQ)
  2485:           c      DIMENSION VPJ(NG2Q,3,2,NTYQ),VPP(3,2,NTYQ),IOVP(2,NTYQ)
  2486:           c      DIMENSION VPJ(NG2Q/3,3,3,NTYQ),VPP(3,3,NTYQ),IOVP(2,NTYQ)
  2487:                 DIMENSION VPJ(NGcont,3,4,NTYQ),VPP(3,4,NTYQ),IOVP(2,NTYQ)
  2488:                 dimension NGNL(NTYQ)
  2489:                 PI=4.D0*ATAN(1.D0)
  2490:                 TPI=2.D0*PI
  2491:                 FPI=4.D0*PI
  2492:                 TPIBA2=TPIBA**2
  2493:           C
  2494: V------>           DO 581 IG=1,NG2
  2495: |         c         RHOA(IG)=G2(4,IG)*0.5D0*TPIBA2
  2496: |                  RHOA(IG)=GDUMP(IG)*0.5D0*TPIBA2
  2497: |           581    CONTINUE
  2498: |                  DO 584 IG=1,NG2
  2499: |           584    DCOEF(IG)=DCOEF(IG)+RHOA(IG)*COEF(IG)
  2500: |         C
  2501: |         c **  temp check
  2502: |         c      miya=13
  2503: |         c      if ( miya.eq.13 ) then
  2504: |         c      write(6,*)' in sub. NONLOC before calling get YLM '
  2505: |         c      write(6,*)' TPIBA = ',TPIBA
  2506: |         c      write(6,*)' G2(4,ig ) '
  2507: |         c      write(6,*) ( G2(4,ig),ig=1,1500,100 )
  2508: |         c      stop ' check end '
  2509: |         c      endif
  2510: |         c **  temp check : end
  2511: |                  DO 588 IG=1,NG2
  2512: V------     588    RHOA(IG)=SQRT(G2(4,IG))*TPIBA
  2513:                    NG26=NGcont
  2514:                    CALL GETYLM(NG2Q,NG26,G2,RHOA,YLM,TPIBA,NGcont)
  2515:           c  ************************************
  2516:                    CALL SEPPOT( NG2Q, NG2, NBND, G2,
  2517:                &   VPJ, VPP, YLM, RHO2, WORK2(1,1), WORK2(1,2),WORK2(1,3),
  2518:                &   WORK2(1,4),WORK2(1,5),WORK2(1,6),WORK2(1,7),
  2519:                &   COEF, DCOEF, TPIBA, IOVP, OMEGA,
  2520:                &                NTAUQ, NTYQ, LREQ, TAU, NTYPE, NUMTY, NIDN,
  2521:                &                MXOFL,NGNL,NGcont                       )
  2522:             580 CONTINUE
  2523:           C     CALL CLOCK(TIM1)
  2524:           C     WRITE(6,*) ' NBND = ',NBND
  2525:           C     WRITE(6,*) ' NONLOC CPTIME:',TIM1-TIM0
  2526:           C     WRITE(6,*) ' REAL CPU_TIME : ',(TIM1-TIM0)/DBLE(NBND)
  2527:                 RETURN
  2528:                 END


NEC Fortran Compiler (3.4.2) for Vector Engine   Thu Jul 28 08:27:42 2022
FILE NAME: tmevl10_Avec_v4.f

PROCEDURE NAME: GETYLM
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

  2530:                 SUBROUTINE GETYLM(NG2Q,NG2,G2K,RHOA,YLM,TPIBA,NGcont)
  2531:                 IMPLICIT REAL*8(A-H,O-Z)
  2532:           c      DIMENSION G2K(4,NG2Q),YLM(NG2Q,4),RHOA(NG2Q)
  2533:           c      DIMENSION G2K(4,NG2Q),YLM(NG2Q,9),RHOA(NG2Q)
  2534:           c      DIMENSION G2K(4,NG2Q),YLM(NG2Q,16),RHOA(NG2Q)
  2535:                 DIMENSION G2K(4,NG2Q),YLM(NGcont,16),RHOA(NG2Q)
  2536:           C                                      __
  2537:           c *** temp check
  2538:           c      if (NG2.gt.NG2Q/6 ) then
  2539:           c       write(6,*)' *** WARN in GETYLM !!! NG2 =',NG2
  2540:           cc       stop
  2541:           c      endif
  2542:           c *** temp check : end
  2543:           cC   note: F20,F21,F22 are xsqr(2) of those in cg and sd codes
  2544:                 PI=4.D0*ATAN(1.D0)
  2545:                 F00=SQRT( 1.D0 / ( 4.D0*PI) )
  2546:                 F10=SQRT( 3.D0 / ( 4.D0*PI) )
  2547:                 F11=SQRT( 3.D0 / ( 8.D0*PI) )
  2548:                 F20=SQRT( 5.d0 / (16.d0*PI) )
  2549:                 F22=SQRT(15.d0 / (16.d0*PI) ) ! x sqr2
  2550:                 F21=SQRT(15.d0 / ( 4.d0*PI) ) ! x sqr2
  2551:                 F30=SQRT( 7.D0 / (16.d0*PI) )
  2552:                 F31=SQRT(21.d0 / (32.D0*PI) ) ! x sqr2
  2553:                 F32=SQRT(105.D0/ (16.D0*PI) ) ! x sqr2
  2554:                 F33=SQRT(35.D0 / (32.D0*PI) ) ! x sqr2
  2555:           c ***
  2556:           c      PI=4.D0*ATAN(1.D0)
  2557:           c      F00=SQRT( 1.D0 / ( 4.D0*PI) )
  2558:           c      F10=SQRT( 3.D0 / ( 4.D0*PI) )
  2559:           c      F11=SQRT( 3.D0 / ( 8.D0*PI) )
  2560:           c      F20=SQRT( 5.d0 / (16.d0*PI) )
  2561:           c      F22=SQRT(15.d0 / (32.d0*PI) )
  2562:           c      F21=SQRT(15.d0 / ( 8.d0*PI) )
  2563:           c      F30=SQRT( 7.D0 / (16.d0*PI) )
  2564:           c      F31=SQRT(21.d0 / (64.D0*PI) )
  2565:           c      F32=SQRT(105.D0/ (32.D0*PI) )
  2566:           c      F33=SQRT(35.D0 / (64.D0*PI) )
  2567:                 IF(RHOA(1).EQ.0.D0) THEN
  2568:                    YLM(1,1)=F00
  2569:                    YLM(1,2)=F10
  2570:                    YLM(1,3)=0.D0
  2571:                    YLM(1,4)=0.D0
  2572:                    YLM(1,5)=F20*2.D0
  2573:                    YLM(1,6)=0.D0
  2574:                    YLM(1,7)=0.D0
  2575:                    YLM(1,8)=0.D0
  2576:                    YLM(1,9)=0.D0
  2577:                    YLM(1,10)=F30*2.D0
  2578:                    YLM(1,11)=0.D0
  2579:                    YLM(1,12)=0.D0
  2580:                    YLM(1,13)=0.D0
  2581:                    YLM(1,14)=0.D0
  2582:                    YLM(1,15)=0.D0
  2583:                    YLM(1,16)=0.D0
  2584:                    ISTA=2
  2585:                 ELSE
  2586:                    ISTA=1
  2587:                 ENDIF
  2588:           c **  temp check
  2589:           c      miya=13
  2590:           c      if ( miya.eq.13 ) then
  2591:           c      write(6,*)' in sub. GETYLM ISTA = ',ISTA
  2592:           c      write(6,*)' TPIBA = ',TPIBA
  2593:           c      write(6,*)' RHOA '
  2594:           c      write(6,*)( RHOA(ig),ig=1,1500,100 )
  2595:           cccc      stop  'checking '
  2596:           c      endi
  2597:           c **  temp check : end
  2598: V------>        DO 10 IG=ISTA,NG2
  2599: |               R=RHOA(IG)/TPIBA
  2600: |               R2=R*R
  2601: |               R3=R2*R
  2602: |         c***  temp check
  2603: |         c     G2LEN=G2k(1,IG)**2+G2k(2,ig)**2+G2k(3,ig)**2 !This gives the same answer
  2604: |         c     R=dsqrt(G2LEN)
  2605: |         c **  temp check : end
  2606: |               YLM(IG,1)=F00
  2607: |               YLM(IG,2)=F10*G2K(3,IG)/R
  2608: |               YLM(IG,3)=F11*G2K(1,IG)/R
  2609: |               YLM(IG,4)=F11*G2K(2,IG)/R
  2610: |               YLM(IG,5)=F20*( (3.D0*G2K(3,IG)**2 )/R2 - 1.D0 )
  2611: |               YLM(IG,6)=F22*( G2K(1,IG)**2 - G2K(2,IG)**2 )/R2
  2612: |               YLM(IG,7)=F21*( G2K(1,IG)*G2K(2,IG) )/R2
  2613: |               YLM(IG,8)=F21*( G2K(3,IG)*G2K(1,IG) )/R2
  2614: |               YLM(IG,9)=F21*( G2K(2,IG)*G2K(3,IG) )/R2
  2615: |               YLM(IG,10)=F30*( 5*G2K(3,IG)**2/R2 -3.D0 )*G2K(3,IG) /R
  2616: |               YLM(IG,11)=F33*G2K(1,IG)*( G2K(1,IG)**2 -3*G2K(2,IG)**2 ) /R3
  2617: |               YLM(IG,12)=F33*G2K(2,IG)*( 3*G2K(1,IG)**2 -G2K(2,IG)**2 ) /R3
  2618: |               YLM(IG,13)=F32*G2K(3,IG)*( G2K(1,IG)**2 -G2K(2,IG)**2 ) /R3
  2619: |               YLM(IG,14)=F32*2*G2K(1,IG)*G2K(2,IG)*G2K(3,IG) /R3
  2620: |               YLM(IG,15)=F31*G2K(1,IG)*( 5*G2K(3,IG)**2 -R2 ) /R3
  2621: |               YLM(IG,16)=F31*G2K(2,IG)*( 5*G2K(3,IG)**2 -R2 ) /R3
  2622: V------      10 CONTINUE
  2623:                 RETURN
  2624:                 END


NEC Fortran Compiler (3.4.2) for Vector Engine   Thu Jul 28 08:27:42 2022
FILE NAME: tmevl10_Avec_v4.f

PROCEDURE NAME: SEPPOT
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

  2626:                 SUBROUTINE SEPPOT( NG2Q, NG2, NBND, G2K, VPJ, VPP,
  2627:           c     &                   YLM, EXTAU, WORK1, WORK2, WORK3, COEF, DCOEF,
  2628:                &  YLM, EXTAU, WORK1, WORK2, WORK3, WORK4, WORK5,WORK6,WORK7,
  2629:                & COEF, DCOEF,
  2630:                &                   TPIBA, IOVP, OMEGA, NTAUQ, NTYQ, LREQ,
  2631:                &                   TAU, NTYPE, NUMTY, NIDN, MXOFL,NGNL,NGcont )
  2632:           C
  2633:           C               PARTITIONED POTENTIAL (1992-02-28) OSAMU SUGINO
  2634:           C
  2635:                 IMPLICIT REAL*8(A-H,O-Z)
  2636:                 include 'mpif.h'
  2637:           c      DIMENSION G2K(4,NG2Q),YLM(NG2Q,4)
  2638:           c      DIMENSION G2K(4,NG2Q),YLM(NG2Q,9)
  2639:                 DIMENSION G2K(4,NG2Q),YLM(NGcont,16)
  2640:           c      COMPLEX*16 COEF(NG2Q,NBND),DCOEF(NG2Q,NBND),
  2641:                 COMPLEX*16 COEF(NG2Q),DCOEF(NG2Q),
  2642:           c     &           WORK1(NG2Q),WORK2(NG2Q),WORK3(NG2Q),EXTAU(NG2Q)
  2643:                & WORK1(NG2Q),WORK2(NG2Q),WORK3(NG2Q),WORK4(NG2Q),WORK5(NG2Q),
  2644:                & WORK6(NG2Q),WORK7(NG2Q),EXTAU(NG2Q)
  2645:                 COMPLEX*16 Y00,Y11,Y12,Y13,Y21,Y22,Y23,Y24,Y25
  2646:                &  ,Y31,Y32,Y33,Y34,Y35,Y36,Y37
  2647:                &          ,CT1,CT2,CT3,CT4,CT5,CT6,CT7
  2648:                 DIMENSION TAU(3,NTAUQ),NUMTY(NTYQ),NIDN(NTAUQ,NTYQ),
  2649:           c     &          VPJ(NG2Q,3),VPP(3),IOVP(2,NTYQ), MXOFL(NTYQ)
  2650:           c     &  VPJ(NG2Q,3,2,NTYQ),VPP(3,2,NTYQ),IOVP(2,NTYQ), MXOFL(NTYQ)
  2651:           c     &  VPJ(NG2Q/3,3,2,NTYQ),VPP(3,2,NTYQ),IOVP(2,NTYQ), MXOFL(NTYQ)
  2652:           c     &  VPJ(NG2Q/3,3,3,NTYQ),VPP(3,3,NTYQ),IOVP(2,NTYQ), MXOFL(NTYQ)
  2653:                &  VPJ(NGcont,3,4,NTYQ),VPP(3,4,NTYQ),IOVP(2,NTYQ), MXOFL(NTYQ)
  2654:                 dimension NGNL(NTYQ)
  2655:                 PARAMETER(NTYQ2=4)
  2656:           c      COMMON/SAITO2/IBUN(3,NTYQ2)
  2657:                 COMMON/SAITO2/IBUN(4,NTYQ2)
  2658:           CC      CALL CLOCK(TIM1)
  2659:           c
  2660:                 call MPI_COMM_RANK(MPI_COMM_WORLD,my_rank,ierr)
  2661:           c
  2662:           c *** temp check
  2663:           c      if ( my_ranl.eq.0 ) then
  2664:           c       sum=0
  2665:           c       do ig=1,ng2q
  2666:           c        sum=sum+dreal( dconjg(coef(ig))*coef(ig))
  2667:           c       enddo
  2668:           c      write(6,*)'in sub. SEPPOT: coef norm = ',sum
  2669:           c      endif
  2670:           c *** temp check: end
  2671:                 PI=4.D0*ATAN(1.D0)
  2672:                 FPI=4.D0*PI
  2673:                 FPISQ=FPI**2
  2674:           C
  2675:           CCCC  LMAX=LREQ-1
  2676:           C
  2677: +------>        DO 10 ITY=1,NTYPE
  2678: |         C ****
  2679: |                     IF(NUMTY(ITY).LE.0) GOTO 10
  2680: |         C ****
  2681: |               NATM=ABS(NUMTY(ITY))
  2682: |               LMAX = MXOFL(ITY)
  2683: |         C
  2684: |+----->        DO 20 IATM=1,NATM
  2685: ||              ITAU=NIDN(IATM,ITY)
  2686: ||        c        DO 22 IG=1,NG2
  2687: ||V---->          DO 22 IG=1,NGNL(ITY)
  2688: |||               TEMP=TPIBA*(G2K(1,IG)*TAU(1,ITAU)+G2K(2,IG)*TAU(2,ITAU)
  2689: |||            &             +G2K(3,IG)*TAU(3,ITAU))
  2690: |||               EXTAU(IG)=DCMPLX(COS(TEMP),SIN(TEMP))
  2691: ||V----      22   CONTINUE
  2692: ||        C
  2693: ||+---->        DO 30 LI=1,LMAX
  2694: |||             L=LI-1
  2695: |||       ccc      READ(82,REC=IOVP(LI,ITY)) VPP, VPJ
  2696: |||       C
  2697: |||             IF(L.EQ.0.AND.IBUN(1,ITY).NE.1) THEN
  2698: |||       C             NO PARTITIONING
  2699: |||       c         DO 50 IG=1,NG2
  2700: |||V--->           DO 50 IG=1,NGNL(ITY)
  2701: ||||               Y00=DCMPLX(YLM(IG,1),0.D0)
  2702: ||||         50    WORK1(IG)=Y00*EXTAU(IG)*VPJ(IG,1,LI,ITY)
  2703: ||||      c         DO 52 IB=1,NBND
  2704: ||||                  CT1=(0.D0,0.D0)
  2705: ||||      c            DO 54 IG=1,NG2
  2706: ||||                  DO 54 IG=1,NGNL(ITY)
  2707: ||||      c   54       CT1=CT1+COEF(IG,IB)*WORK1(IG)
  2708: |||V---      54       CT1=CT1+COEF(IG)*WORK1(IG)
  2709: |||                   CT1=CT1/VPP(1,LI,ITY)/OMEGA
  2710: |||       c            DO 56 IG=1,NG2
  2711: |||V--->              DO 56 IG=1,NGNL(ITY)
  2712: ||||      c   56       DCOEF(IG,IB)=DCOEF(IG,IB)+CT1*DCONJG(WORK1(IG))
  2713: |||V---      56       DCOEF(IG)=DCOEF(IG)+CT1*DCONJG(WORK1(IG))
  2714: |||       c   52    CONTINUE
  2715: |||             ELSEIF(L.EQ.0) THEN
  2716: |||       C             PARTITIONING
  2717: |||+--->           DO 1200 IP=2,3
  2718: ||||      c         DO 1050 IG=1,NG2
  2719: ||||V-->           DO 1050 IG=1,NGNL(ITY)
  2720: |||||                Y00=DCMPLX(YLM(IG,1),0.D0)
  2721: |||||      1050      WORK1(IG)=Y00*EXTAU(IG)*VPJ(IG,IP,LI,ITY)
  2722: |||||     c         DO 1052 IB=1,NBND
  2723: |||||                 CT1=(0.D0,0.D0)
  2724: |||||     c            DO 1054 IG=1,NG2
  2725: |||||                 DO 1054 IG=1,NGNL(ITY)
  2726: |||||     c 1054       CT1=CT1+COEF(IG,IB)*WORK1(IG)
  2727: ||||V--    1054       CT1=CT1+COEF(IG)*WORK1(IG)
  2728: ||||                  CT1=CT1/VPP(IP,LI,ITY)/OMEGA
  2729: ||||      c            DO 1056 IG=1,NG2
  2730: ||||V-->              DO 1056 IG=1,NGNL(ITY)
  2731: |||||     c 1056         DCOEF(IG,IB)=DCOEF(IG,IB)+CT1*DCONJG(WORK1(IG))
  2732: ||||V--    1056         DCOEF(IG)=DCOEF(IG)+CT1*DCONJG(WORK1(IG))
  2733: ||||      c 1052    CONTINUE
  2734: |||+---    1200    CONTINUE
  2735: |||       c +*** temp check for lowest band
  2736: |||       c          if(my_rank.eq.0 ) then
  2737: |||       c          write(6,*)'ity iatm li = ',ity,iatm,li
  2738: |||       c          sum=0
  2739: |||       c          do ig=1,NGNL(ITY)
  2740: |||       c           sum=sum+dreal(DCONJG(DCOEF(IG))*COEF(IG))
  2741: |||       c          enddo
  2742: |||       c          write(6,*)'sum =',sum
  2743: |||       c          endif
  2744: |||       c *** temp check : end
  2745: |||             ELSEIF(L.EQ.1.AND.IBUN(2,ITY).NE.1) THEN
  2746: |||       C             NO PARTITIONING
  2747: |||       c         DO 60 IG=1,NG2
  2748: |||V--->           DO 60 IG=1,NGNL(ITY)
  2749: ||||               Y11=DCMPLX( YLM(IG,2), 0.D0)
  2750: ||||               Y12=DCMPLX(-YLM(IG,3),YLM(IG,4))
  2751: ||||               Y13=DCMPLX( YLM(IG,3),YLM(IG,4))
  2752: ||||               WORK1(IG)=EXTAU(IG)*Y11*VPJ(IG,1,LI,ITY)
  2753: ||||               WORK2(IG)=EXTAU(IG)*Y12*VPJ(IG,1,LI,ITY)
  2754: ||||               WORK3(IG)=EXTAU(IG)*Y13*VPJ(IG,1,LI,ITY)
  2755: ||||         60    CONTINUE
  2756: ||||      c         DO 62 IB=1,NBND
  2757: ||||                  CT1=(0.D0,0.D0)
  2758: ||||                  CT2=(0.D0,0.D0)
  2759: ||||                  CT3=(0.D0,0.D0)
  2760: ||||      c            DO 64 IG=1,NG2
  2761: ||||                  DO 64 IG=1,NGNL(ITY)
  2762: ||||      c            CT1=CT1+COEF(IG,IB)*WORK1(IG)
  2763: ||||      c            CT2=CT2+COEF(IG,IB)*WORK2(IG)
  2764: ||||      c            CT3=CT3+COEF(IG,IB)*WORK3(IG)
  2765: ||||                  CT1=CT1+COEF(IG)*WORK1(IG)
  2766: ||||                  CT2=CT2+COEF(IG)*WORK2(IG)
  2767: ||||                  CT3=CT3+COEF(IG)*WORK3(IG)
  2768: |||V---      64       CONTINUE
  2769: |||                   CT1=CT1/VPP(1,LI,ITY)/OMEGA
  2770: |||                   CT2=CT2/VPP(1,LI,iTY)/OMEGA
  2771: |||                   CT3=CT3/VPP(1,LI,ITY)/OMEGA
  2772: |||       c            DO 66 IG=1,NG2
  2773: |||V--->              DO 66 IG=1,NGNL(ITY)
  2774: ||||      c            DCOEF(IG,IB)=DCOEF(IG,IB)
  2775: ||||                  DCOEF(IG)=DCOEF(IG)
  2776: ||||           &           +CT1*DCONJG(WORK1(IG))
  2777: ||||           &           +CT2*DCONJG(WORK2(IG))
  2778: ||||           &           +CT3*DCONJG(WORK3(IG))
  2779: |||V---      66       CONTINUE
  2780: |||       c   62    CONTINUE
  2781: |||             ELSEIF(L.EQ.1) THEN
  2782: |||       C             PARTITIONING
  2783: |||+--->           DO 1261 IP=2,3
  2784: ||||      c         DO 61 IG=1,NG2
  2785: ||||V-->           DO 61 IG=1,NGNL(ITY)
  2786: |||||              Y11=DCMPLX( YLM(IG,2), 0.D0)
  2787: |||||              Y12=DCMPLX(-YLM(IG,3),YLM(IG,4))
  2788: |||||              Y13=DCMPLX( YLM(IG,3),YLM(IG,4))
  2789: |||||              WORK1(IG)=EXTAU(IG)*Y11*VPJ(IG,IP,LI,ITY)
  2790: |||||              WORK2(IG)=EXTAU(IG)*Y12*VPJ(IG,IP,LI,ITY)
  2791: |||||              WORK3(IG)=EXTAU(IG)*Y13*VPJ(IG,IP,LI,ITY)
  2792: |||||        61    CONTINUE
  2793: |||||     c         DO 63 IB=1,NBND
  2794: |||||                 CT1=(0.D0,0.D0)
  2795: |||||                 CT2=(0.D0,0.D0)
  2796: |||||                 CT3=(0.D0,0.D0)
  2797: |||||     c            DO 65 IG=1,NG2
  2798: |||||                 DO 65 IG=1,NGNL(ITY)
  2799: |||||     c            CT1=CT1+COEF(IG,IB)*WORK1(IG)
  2800: |||||     c            CT2=CT2+COEF(IG,IB)*WORK2(IG)
  2801: |||||     c            CT3=CT3+COEF(IG,IB)*WORK3(IG)
  2802: |||||                 CT1=CT1+COEF(IG)*WORK1(IG)
  2803: |||||                 CT2=CT2+COEF(IG)*WORK2(IG)
  2804: |||||                 CT3=CT3+COEF(IG)*WORK3(IG)
  2805: ||||V--      65       CONTINUE
  2806: ||||                  CT1=CT1/VPP(IP,LI,ITY)/OMEGA
  2807: ||||                  CT2=CT2/VPP(IP,LI,ITY)/OMEGA
  2808: ||||                  CT3=CT3/VPP(IP,LI,iTY)/OMEGA
  2809: ||||      c            DO 67 IG=1,NG2
  2810: ||||V-->              DO 67 IG=1,NGNL(ITY)
  2811: |||||     c            DCOEF(IG,IB)=DCOEF(IG,IB)
  2812: |||||                 DCOEF(IG)=DCOEF(IG)
  2813: |||||          &           +CT1*DCONJG(WORK1(IG))
  2814: |||||          &           +CT2*DCONJG(WORK2(IG))
  2815: |||||          &           +CT3*DCONJG(WORK3(IG))
  2816: ||||V--      67       CONTINUE
  2817: ||||      c   63    CONTINUE
  2818: ||||      c +*** temp check for lowest band
  2819: ||||      c          if (my_rank.eq.0 ) then
  2820: ||||      c          write(6,*)'ity iatm li = ',ity,iatm,li
  2821: ||||      c          sum=0
  2822: ||||      c          do ig=1,NGNL(ITY)
  2823: ||||      c           sum=sum+dreal(DCONJG(DCOEF(IG))*COEF(IG))
  2824: ||||      c          enddo
  2825: ||||      c          write(6,*)'sum =',sum
  2826: ||||      c          endif
  2827: ||||      c *** temp check : end
  2828: |||+---    1261    CONTINUE
  2829: |||             ELSEIF(L.EQ.2.AND.IBUN(3,ITY).NE.1) THEN
  2830: |||       c *** temp check
  2831: |||       c         if (my_rank.eq.0 ) then
  2832: |||       c         write(6,*)' in SEPPOT'
  2833: |||       c         write(6,*)' NGNL for d-',NGNL(ITY)
  2834: |||       c         write(6,*)' YLM 5 '
  2835: |||       c         write(6,*)(YLM(IG,5),IG=1,100,10)
  2836: |||       c         write(6,*)' EXTAU '
  2837: |||       c         write(6,*)(EXTAU(IG),IG=1,100,10)
  2838: |||       c         write(6,*)' VPJ( partition 1'
  2839: |||       c         write(6,*)( VPJ(IG,1,li,ity),IG=1,100,10)
  2840: |||       c         endif
  2841: |||       c *** temp check: end
  2842: |||       C         NO PARTITIONING need 1/sq2 because of YLM definition
  2843: |||                wari=1.d0/dsqrt(2.d0) ! I am sceptical on this!
  2844: |||       c         wari=1.d0
  2845: |||V--->           DO 81 IG=1,NGNL(ITY)
  2846: ||||               Y21=DCMPLX( YLM(IG,5), 0.D0)
  2847: ||||               Y22=DCMPLX( YLM(IG,6), YLM(IG,7))*wari
  2848: ||||               Y23=DCMPLX( YLM(IG,6),-YLM(IG,7))*wari
  2849: ||||               Y24=DCMPLX(-YLM(IG,8),-YLM(IG,9))*wari
  2850: ||||               Y25=DCMPLX( YLM(IG,8),-YLM(IG,9))*wari
  2851: ||||               WORK1(IG)=EXTAU(IG)*Y21*VPJ(IG,1,LI,ITY)
  2852: ||||               WORK2(IG)=EXTAU(IG)*Y22*VPJ(IG,1,LI,ITY)
  2853: ||||               WORK3(IG)=EXTAU(IG)*Y23*VPJ(IG,1,LI,ITY)
  2854: ||||               WORK4(IG)=EXTAU(IG)*Y24*VPJ(IG,1,LI,ITY)
  2855: ||||               WORK5(IG)=EXTAU(IG)*Y25*VPJ(IG,1,LI,ITY)
  2856: ||||         81    CONTINUE
  2857: ||||      c *** temp check
  2858: ||||      c         if (my_rank.eq.0) then
  2859: ||||      c         write(6,*)' work1 '
  2860: ||||      c         write(6,*)(work1(ig),ig=1,100,10)
  2861: ||||      c         write(6,*)' work2 '
  2862: ||||      c         write(6,*)(work2(ig),ig=1,100,10)
  2863: ||||      c         write(6,*)' work3 '
  2864: ||||      c         write(6,*)(work3(ig),ig=1,100,10)
  2865: ||||      c         write(6,*)' work4 '
  2866: ||||      c         write(6,*)(work4(ig),ig=1,100,10)
  2867: ||||      c         write(6,*)' work4 '
  2868: ||||      c         write(6,*)(work5(ig),ig=1,100,10)
  2869: ||||      c         endif
  2870: ||||      c *** temp check : end
  2871: ||||      c *** temp check
  2872: ||||      c         write(6,*)'IN SEPPOT VPJ for d',VPJ(100,1,3,ITY)
  2873: ||||      c         write(6,*)'IN SEPPOT YLM 5',YLM(100,5)
  2874: ||||      c         write(6,*)'IN SEPPOT WORK 5',WORK5(100)
  2875: ||||      c *** temp check : end
  2876: ||||      cccc         DO 82 IB=1,NBND
  2877: ||||                  CT1=(0.D0,0.D0)
  2878: ||||                  CT2=(0.D0,0.D0)
  2879: ||||                  CT3=(0.D0,0.D0)
  2880: ||||                  CT4=(0.D0,0.D0)
  2881: ||||                  CT5=(0.D0,0.D0)
  2882: ||||                  DO 83 IG=1,NGNL(ITY)
  2883: ||||      c            CT1=CT1+COEF(IG,IB)*WORK1(IG)
  2884: ||||      c            CT2=CT2+COEF(IG,IB)*WORK2(IG)
  2885: ||||      c            CT3=CT3+COEF(IG,IB)*WORK3(IG)
  2886: ||||      c            CT4=CT4+COEF(IG,IB)*WORK4(IG)
  2887: ||||      c            CT5=CT5+COEF(IG,IB)*WORK5(IG)
  2888: ||||                  CT1=CT1+COEF(IG)*WORK1(IG)
  2889: ||||                  CT2=CT2+COEF(IG)*WORK2(IG)
  2890: ||||                  CT3=CT3+COEF(IG)*WORK3(IG)
  2891: ||||                  CT4=CT4+COEF(IG)*WORK4(IG)
  2892: ||||                  CT5=CT5+COEF(IG)*WORK5(IG)
  2893: |||V---      83       CONTINUE
  2894: |||       c *** temp check
  2895: |||       c      if ( my_ranl.eq.0 ) then
  2896: |||       c       sum=0
  2897: |||       c       do ig=1,ng2q
  2898: |||       c        sum=sum+dreal( dconjg(coef(ig))*coef(ig))
  2899: |||       c       enddo
  2900: |||       c      write(6,*)'again. SEPPOT: coef norm = ',sum
  2901: |||       c      endif
  2902: |||       c *** temp check: end
  2903: |||       c *** temp check
  2904: |||       c            if (my_rank.eq.0 ) then
  2905: |||       c             write(6,*)' before dev. by VPP'
  2906: |||       c             write(6,*)'CT1=',CT1
  2907: |||       c             write(6,*)'CT2=',CT2
  2908: |||       c             write(6,*)'CT3=',CT3
  2909: |||       c             write(6,*)'CT4=',CT4
  2910: |||       c             write(6,*)'CT5=',CT5
  2911: |||       c            endif
  2912: |||       c *** temp check : end
  2913: |||                   CT1=CT1/VPP(1,LI,ITY)/OMEGA
  2914: |||                   CT2=CT2/VPP(1,LI,ITY)/OMEGA
  2915: |||                   CT3=CT3/VPP(1,LI,ITY)/OMEGA
  2916: |||                   CT4=CT4/VPP(1,LI,ITY)/OMEGA
  2917: |||                   CT5=CT5/VPP(1,LI,ITY)/OMEGA
  2918: |||       c *** temp check
  2919: |||       c            if (my_rank.eq.0 ) then
  2920: |||       c             write(6,*)' after dev. by VPP'
  2921: |||       c             write(6,*)'CT1=',CT1
  2922: |||       c             write(6,*)'CT2=',CT2
  2923: |||       c             write(6,*)'CT3=',CT3
  2924: |||       c             write(6,*)'CT4=',CT4
  2925: |||       c             write(6,*)'CT5=',CT5
  2926: |||       c            endif
  2927: |||       c *** temp check : end
  2928: |||V--->              DO 84 IG=1,NGNL(ITY)
  2929: ||||      c            DCOEF(IG,IB)=DCOEF(IG,IB)
  2930: ||||                  DCOEF(IG)=DCOEF(IG)
  2931: ||||           &           +CT1*DCONJG(WORK1(IG))
  2932: ||||           &           +CT2*DCONJG(WORK2(IG))
  2933: ||||           &           +CT3*DCONJG(WORK3(IG))
  2934: ||||           &           +CT4*DCONJG(WORK4(IG))
  2935: ||||           &           +CT5*DCONJG(WORK5(IG))
  2936: |||V---      84       CONTINUE
  2937: |||       cccc   82    CONTINUE
  2938: |||       c +*** temp check for lowest band
  2939: |||       c          if (my_rank.eq.0 ) then
  2940: |||       c          write(6,*)'ity iatm li = ',ity,iatm,li
  2941: |||       c          sum=0
  2942: |||       c          do ig=1,NGNL(ITY)
  2943: |||       c           sum=sum+dreal(DCONJG(DCOEF(IG))*COEF(IG))
  2944: |||       c          enddo
  2945: |||       c          write(6,*)'sum =',sum
  2946: |||       c          endif
  2947: |||       c *** temp check : end
  2948: |||             ELSEIF(L.EQ.2) THEN
  2949: |||       C             PARTITIONING
  2950: |||       c  **** need factor 1/sq2 because of YLM definition
  2951: |||                wari=1.d0/dsqrt(2.d0) ! I am sceptical on this
  2952: |||       c         wari=1.d0
  2953: |||+--->           DO 1262 IP=2,3
  2954: ||||V-->           DO 71 IG=1,NGNL(ITY)
  2955: |||||              Y21=DCMPLX( YLM(IG,5), 0.D0)
  2956: |||||              Y22=DCMPLX( YLM(IG,6), YLM(IG,7))*wari
  2957: |||||              Y23=DCMPLX( YLM(IG,6),-YLM(IG,7))*wari
  2958: |||||              Y24=DCMPLX(-YLM(IG,8),-YLM(IG,9))*wari
  2959: |||||              Y25=DCMPLX( YLM(IG,8),-YLM(IG,9))*wari
  2960: |||||              WORK1(IG)=EXTAU(IG)*Y21*VPJ(IG,IP,LI,ITY)
  2961: |||||              WORK2(IG)=EXTAU(IG)*Y22*VPJ(IG,IP,LI,ITY)
  2962: |||||              WORK3(IG)=EXTAU(IG)*Y23*VPJ(IG,IP,LI,ITY)
  2963: |||||              WORK4(IG)=EXTAU(IG)*Y24*VPJ(IG,IP,LI,ITY)
  2964: |||||              WORK5(IG)=EXTAU(IG)*Y25*VPJ(IG,IP,LI,ITY)
  2965: |||||        71    CONTINUE
  2966: |||||     ccc         DO 72 IB=1,NBND
  2967: |||||                 CT1=(0.D0,0.D0)
  2968: |||||                 CT2=(0.D0,0.D0)
  2969: |||||                 CT3=(0.D0,0.D0)
  2970: |||||                 CT4=(0.D0,0.D0)
  2971: |||||                 CT5=(0.D0,0.D0)
  2972: |||||                 DO 73 IG=1,NGNL(ITY)
  2973: |||||     c            CT1=CT1+COEF(IG,IB)*WORK1(IG)
  2974: |||||     c            CT2=CT2+COEF(IG,IB)*WORK2(IG)
  2975: |||||     c            CT3=CT3+COEF(IG,IB)*WORK3(IG)
  2976: |||||     c            CT4=CT4+COEF(IG,IB)*WORK4(IG)
  2977: |||||     c            CT5=CT5+COEF(IG,IB)*WORK5(IG)
  2978: |||||                 CT1=CT1+COEF(IG)*WORK1(IG)
  2979: |||||                 CT2=CT2+COEF(IG)*WORK2(IG)
  2980: |||||                 CT3=CT3+COEF(IG)*WORK3(IG)
  2981: |||||                 CT4=CT4+COEF(IG)*WORK4(IG)
  2982: |||||                 CT5=CT5+COEF(IG)*WORK5(IG)
  2983: ||||V--      73       CONTINUE
  2984: ||||                  CT1=CT1/VPP(IP,LI,ITY)/OMEGA
  2985: ||||                  CT2=CT2/VPP(IP,LI,ITY)/OMEGA
  2986: ||||                  CT3=CT3/VPP(IP,LI,ITY)/OMEGA
  2987: ||||                  CT4=CT4/VPP(IP,LI,ITY)/OMEGA
  2988: ||||                  CT5=CT5/VPP(IP,LI,ITY)/OMEGA
  2989: ||||V-->              DO 74 IG=1,NGNL(ITY)
  2990: |||||     c            DCOEF(IG,IB)=DCOEF(IG,IB)
  2991: |||||                 DCOEF(IG)=DCOEF(IG)
  2992: |||||          &           +CT1*DCONJG(WORK1(IG))
  2993: |||||          &           +CT2*DCONJG(WORK2(IG))
  2994: |||||          &           +CT3*DCONJG(WORK3(IG))
  2995: |||||          &           +CT4*DCONJG(WORK4(IG))
  2996: |||||          &           +CT5*DCONJG(WORK5(IG))
  2997: ||||V--      74       CONTINUE
  2998: ||||      ccc   72    CONTINUE
  2999: |||+---    1262    CONTINUE
  3000: |||             ELSEIF(L.EQ.3.AND.IBUN(4,ITY).NE.1) THEN
  3001: |||       C             NO PARTITIONING
  3002: |||                wari=1.d0/dsqrt(2.d0)
  3003: |||       c         DO 91 IG=1,NG2
  3004: |||V--->           DO 91 IG=1,NGNL(ITY)
  3005: ||||               Y31=DCMPLX( YLM(IG,10), 0.D0)
  3006: ||||               Y32=DCMPLX(-YLM(IG,11),-YLM(IG,12))*wari
  3007: ||||               Y33=DCMPLX( YLM(IG,11),-YLM(IG,12))*wari
  3008: ||||               Y34=DCMPLX( YLM(IG,13), YLM(IG,14))*wari
  3009: ||||               Y35=DCMPLX( YLM(IG,13),-YLM(IG,14))*wari
  3010: ||||               Y36=DCMPLX(-YLM(IG,15),-YLM(IG,16))*wari
  3011: ||||               Y37=DCMPLX( YLM(IG,15),-YLM(IG,16))*wari
  3012: ||||               WORK1(IG)=EXTAU(IG)*Y31*VPJ(IG,1,LI,ITY)
  3013: ||||               WORK2(IG)=EXTAU(IG)*Y32*VPJ(IG,1,LI,ITY)
  3014: ||||               WORK3(IG)=EXTAU(IG)*Y33*VPJ(IG,1,LI,ITY)
  3015: ||||               WORK4(IG)=EXTAU(IG)*Y34*VPJ(IG,1,LI,ITY)
  3016: ||||               WORK5(IG)=EXTAU(IG)*Y35*VPJ(IG,1,LI,ITY)
  3017: ||||               WORK6(IG)=EXTAU(IG)*Y36*VPJ(IG,1,LI,ITY)
  3018: ||||               WORK7(IG)=EXTAU(IG)*Y37*VPJ(IG,1,LI,ITY)
  3019: |||V---      91    CONTINUE
  3020: |||       c         DO 92 IB=1,NBND
  3021: |||                   CT1=(0.D0,0.D0)
  3022: |||                   CT2=(0.D0,0.D0)
  3023: |||                   CT3=(0.D0,0.D0)
  3024: |||                   CT4=(0.D0,0.D0)
  3025: |||                   CT5=(0.D0,0.D0)
  3026: |||                   CT6=(0.D0,0.D0)
  3027: |||                   CT7=(0.D0,0.D0)
  3028: |||       c            DO 93 IG=1,NG2
  3029: |||V--->              DO 93 IG=1,NGNL(ITY)
  3030: ||||                  CT1=CT1+COEF(IG)*WORK1(IG)
  3031: ||||                  CT2=CT2+COEF(IG)*WORK2(IG)
  3032: ||||                  CT3=CT3+COEF(IG)*WORK3(IG)
  3033: ||||                  CT4=CT4+COEF(IG)*WORK4(IG)
  3034: ||||                  CT5=CT5+COEF(IG)*WORK5(IG)
  3035: ||||                  CT6=CT6+COEF(IG)*WORK6(IG)
  3036: ||||                  CT7=CT7+COEF(IG)*WORK7(IG)
  3037: |||V---      93       CONTINUE
  3038: |||                   CT1=CT1/VPP(1,LI,ITY)/OMEGA
  3039: |||                   CT2=CT2/VPP(1,LI,ITY)/OMEGA
  3040: |||                   CT3=CT3/VPP(1,LI,ITY)/OMEGA
  3041: |||                   CT4=CT4/VPP(1,LI,ITY)/OMEGA
  3042: |||                   CT5=CT5/VPP(1,LI,ITY)/OMEGA
  3043: |||                   CT6=CT6/VPP(1,LI,ITY)/OMEGA
  3044: |||                   CT7=CT7/VPP(1,LI,ITY)/OMEGA
  3045: |||       c            DO 94 IG=1,NG2
  3046: |||V--->              DO 94 IG=1,NGNL(ITY)
  3047: ||||                  DCOEF(IG)=DCOEF(IG)
  3048: ||||           &           +CT1*DCONJG(WORK1(IG))
  3049: ||||           &           +CT2*DCONJG(WORK2(IG))
  3050: ||||           &           +CT3*DCONJG(WORK3(IG))
  3051: ||||           &           +CT4*DCONJG(WORK4(IG))
  3052: ||||           &           +CT5*DCONJG(WORK5(IG))
  3053: ||||           &           +CT6*DCONJG(WORK6(IG))
  3054: ||||           &           +CT7*DCONJG(WORK7(IG))
  3055: |||V---      94       CONTINUE
  3056: |||       c   92    CONTINUE
  3057: |||             ELSEIF(L.EQ.3) then
  3058: |||       C             PARTITIONING
  3059: |||                wari=1.d0/dsqrt(2.d0)
  3060: |||+--->           DO 2262 IP=2,3
  3061: ||||      c         DO 101 IG=1,NG2
  3062: ||||V-->           DO 101 IG=1,NGNL(ITY)
  3063: |||||              Y31=DCMPLX( YLM(IG,10), 0.D0)
  3064: |||||              Y32=DCMPLX(-YLM(IG,11),-YLM(IG,12))*wari
  3065: |||||              Y33=DCMPLX( YLM(IG,11),-YLM(IG,12))*wari
  3066: |||||              Y34=DCMPLX( YLM(IG,13), YLM(IG,14))*wari
  3067: |||||              Y35=DCMPLX( YLM(IG,13),-YLM(IG,14))*wari
  3068: |||||              Y36=DCMPLX(-YLM(IG,15),-YLM(IG,16))*wari
  3069: |||||              Y37=DCMPLX( YLM(IG,15),-YLM(IG,16))*wari
  3070: |||||              WORK1(IG)=EXTAU(IG)*Y31*VPJ(IG,IP,LI,ITY)
  3071: |||||              WORK2(IG)=EXTAU(IG)*Y32*VPJ(IG,IP,LI,ITY)
  3072: |||||              WORK3(IG)=EXTAU(IG)*Y33*VPJ(IG,IP,LI,ITY)
  3073: |||||              WORK4(IG)=EXTAU(IG)*Y34*VPJ(IG,IP,LI,ITY)
  3074: |||||              WORK5(IG)=EXTAU(IG)*Y35*VPJ(IG,IP,LI,ITY)
  3075: |||||              WORK6(IG)=EXTAU(IG)*Y36*VPJ(IG,IP,LI,ITY)
  3076: |||||              WORK7(IG)=EXTAU(IG)*Y37*VPJ(IG,IP,LI,ITY)
  3077: ||||V--     101    CONTINUE
  3078: ||||      c         DO 102 IB=1,NBND
  3079: ||||                  CT1=(0.D0,0.D0)
  3080: ||||                  CT2=(0.D0,0.D0)
  3081: ||||                  CT3=(0.D0,0.D0)
  3082: ||||                  CT4=(0.D0,0.D0)
  3083: ||||                  CT5=(0.D0,0.D0)
  3084: ||||                  CT6=(0.D0,0.D0)
  3085: ||||                  CT7=(0.D0,0.D0)
  3086: ||||      c            DO 103 IG=1,NG2
  3087: ||||V-->              DO 103 IG=1,NGNL(ITY)
  3088: |||||                 CT1=CT1+COEF(IG)*WORK1(IG)
  3089: |||||                 CT2=CT2+COEF(IG)*WORK2(IG)
  3090: |||||                 CT3=CT3+COEF(IG)*WORK3(IG)
  3091: |||||                 CT4=CT4+COEF(IG)*WORK4(IG)
  3092: |||||                 CT5=CT5+COEF(IG)*WORK5(IG)
  3093: |||||                 CT6=CT6+COEF(IG)*WORK6(IG)
  3094: |||||                 CT7=CT7+COEF(IG)*WORK7(IG)
  3095: ||||V--     103       CONTINUE
  3096: ||||                  CT1=CT1/VPP(IP,LI,ITY)/OMEGA
  3097: ||||                  CT2=CT2/VPP(IP,LI,ITY)/OMEGA
  3098: ||||                  CT3=CT3/VPP(IP,LI,ITY)/OMEGA
  3099: ||||                  CT4=CT4/VPP(IP,LI,ITY)/OMEGA
  3100: ||||                  CT5=CT5/VPP(IP,LI,ITY)/OMEGA
  3101: ||||                  CT6=CT6/VPP(IP,LI,ITY)/OMEGA
  3102: ||||                  CT7=CT7/VPP(IP,LI,ITY)/OMEGA
  3103: ||||      c            DO 104 IG=1,NG2
  3104: ||||V-->              DO 104 IG=1,NGNL(ITY)
  3105: |||||                 DCOEF(IG)=DCOEF(IG)
  3106: |||||          &           +CT1*DCONJG(WORK1(IG))
  3107: |||||          &           +CT2*DCONJG(WORK2(IG))
  3108: |||||          &           +CT3*DCONJG(WORK3(IG))
  3109: |||||          &           +CT4*DCONJG(WORK4(IG))
  3110: |||||          &           +CT5*DCONJG(WORK5(IG))
  3111: |||||          &           +CT6*DCONJG(WORK6(IG))
  3112: |||||          &           +CT7*DCONJG(WORK7(IG))
  3113: ||||V--     104    CONTINUE
  3114: ||||      c  102    CONTINUE
  3115: |||+---    2262 CONTINUE
  3116: |||             ELSE
  3117: |||              if ( my_rank.eq.0 ) then
  3118: |||              write(6,*)' in sub. SEPPOT '
  3119: |||              write(6,*)' ILL ORB IS INDICATED OR MORE THAN TWO PARTIONING '
  3120: |||              endif
  3121: |||              stop
  3122: |||             ENDIF
  3123: |||       c *** temp check
  3124: |||       c      if (my_rank.eq.0 ) then
  3125: |||       c       write(6,*)' ITY IATM LI =',ITY,IATM,LI
  3126: |||       c        sum=0
  3127: |||       c        do ig=1,ngnl(ity)
  3128: |||       c         sum=sum+dreal( DCONJG( DCOEF(IG) )*COEF(IG) )
  3129: |||       c        enddo
  3130: |||       c      write(6,*)' sum = ',sum
  3131: |||       c      endif
  3132: |||       c *** temp check: end
  3133: ||+----      30 CONTINUE
  3134: |+-----      20 CONTINUE
  3135: +------      10 CONTINUE
  3136:           C     CALL CLOCK(TIM2)
  3137:           C     WRITE(6,*) ' SEPPOT USED TIME=',TIM2-TIM1
  3138:           C     STOP
  3139:                 RETURN
  3140:                 END


NEC Fortran Compiler (3.4.2) for Vector Engine   Thu Jul 28 08:27:42 2022
FILE NAME: tmevl10_Avec_v4.f

PROCEDURE NAME: ZERO
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

  3143:                 subroutine zero(a,m)
  3144:                 complex*16 a(m)
  3145: V------>        do 1 i=1,m
  3146: V------       1 a(i)=dcmplx(0.d0,0.d0)
  3147:                 return
  3148:                 end


